/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2010, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.713.2.1 2010/08/18 18:35:30 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static FuncCall *makeOverlaps(List *largs, List *rargs,
							  int location, core_yyscan_t yyscanner);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);



/* Line 189 of yacc.c  */
#line 217 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     ARRAY = 285,
     AS = 286,
     ASC = 287,
     ASSERTION = 288,
     ASSIGNMENT = 289,
     ASYMMETRIC = 290,
     AT = 291,
     AUTHORIZATION = 292,
     BACKWARD = 293,
     BEFORE = 294,
     BEGIN_P = 295,
     BETWEEN = 296,
     BIGINT = 297,
     BINARY = 298,
     BIT = 299,
     BOOLEAN_P = 300,
     BOTH = 301,
     BY = 302,
     CACHE = 303,
     CALLED = 304,
     CASCADE = 305,
     CASCADED = 306,
     CASE = 307,
     CAST = 308,
     CATALOG_P = 309,
     CHAIN = 310,
     CHAR_P = 311,
     CHARACTER = 312,
     CHARACTERISTICS = 313,
     CHECK = 314,
     CHECKPOINT = 315,
     CLASS = 316,
     CLOSE = 317,
     CLUSTER = 318,
     COALESCE = 319,
     COLLATE = 320,
     COLUMN = 321,
     COMMENT = 322,
     COMMENTS = 323,
     COMMIT = 324,
     COMMITTED = 325,
     CONCURRENTLY = 326,
     CONFIGURATION = 327,
     CONNECTION = 328,
     CONSTRAINT = 329,
     CONSTRAINTS = 330,
     CONTENT_P = 331,
     CONTINUE_P = 332,
     CONVERSION_P = 333,
     COPY = 334,
     COST = 335,
     CREATE = 336,
     CREATEDB = 337,
     CREATEROLE = 338,
     CREATEUSER = 339,
     CROSS = 340,
     CSV = 341,
     CURRENT_P = 342,
     CURRENT_CATALOG = 343,
     CURRENT_DATE = 344,
     CURRENT_ROLE = 345,
     CURRENT_SCHEMA = 346,
     CURRENT_TIME = 347,
     CURRENT_TIMESTAMP = 348,
     CURRENT_USER = 349,
     CURSOR = 350,
     CYCLE = 351,
     DATA_P = 352,
     DATABASE = 353,
     DAY_P = 354,
     DEALLOCATE = 355,
     DEC = 356,
     DECIMAL_P = 357,
     DECLARE = 358,
     DEFAULT = 359,
     DEFAULTS = 360,
     DEFERRABLE = 361,
     DEFERRED = 362,
     DEFINER = 363,
     DELETE_P = 364,
     DELIMITER = 365,
     DELIMITERS = 366,
     DESC = 367,
     DICTIONARY = 368,
     DISABLE_P = 369,
     DISCARD = 370,
     DISTINCT = 371,
     DO = 372,
     DOCUMENT_P = 373,
     DOMAIN_P = 374,
     DOUBLE_P = 375,
     DROP = 376,
     EACH = 377,
     ELSE = 378,
     ENABLE_P = 379,
     ENCODING = 380,
     ENCRYPTED = 381,
     END_P = 382,
     ENUM_P = 383,
     ESCAPE = 384,
     EXCEPT = 385,
     EXCLUDE = 386,
     EXCLUDING = 387,
     EXCLUSIVE = 388,
     EXECUTE = 389,
     EXISTS = 390,
     EXPLAIN = 391,
     EXTERNAL = 392,
     EXTRACT = 393,
     FALSE_P = 394,
     FAMILY = 395,
     FETCH = 396,
     FIRST_P = 397,
     FLOAT_P = 398,
     FOLLOWING = 399,
     FOR = 400,
     FORCE = 401,
     FOREIGN = 402,
     FORWARD = 403,
     FREEZE = 404,
     FROM = 405,
     FULL = 406,
     FUNCTION = 407,
     FUNCTIONS = 408,
     GLOBAL = 409,
     GRANT = 410,
     GRANTED = 411,
     GREATEST = 412,
     GROUP_P = 413,
     HANDLER = 414,
     HAVING = 415,
     HEADER_P = 416,
     HOLD = 417,
     HOUR_P = 418,
     IDENTITY_P = 419,
     IF_P = 420,
     ILIKE = 421,
     IMMEDIATE = 422,
     IMMUTABLE = 423,
     IMPLICIT_P = 424,
     IN_P = 425,
     INCLUDING = 426,
     INCREMENT = 427,
     INDEX = 428,
     INDEXES = 429,
     INHERIT = 430,
     INHERITS = 431,
     INITIALLY = 432,
     INLINE_P = 433,
     INNER_P = 434,
     INOUT = 435,
     INPUT_P = 436,
     INSENSITIVE = 437,
     INSERT = 438,
     INSTEAD = 439,
     INT_P = 440,
     INTEGER = 441,
     INTERSECT = 442,
     INTERVAL = 443,
     INTO = 444,
     INVOKER = 445,
     IS = 446,
     ISNULL = 447,
     ISOLATION = 448,
     JOIN = 449,
     KEY = 450,
     LABEL = 451,
     LANGUAGE = 452,
     LARGE_P = 453,
     LAST_P = 454,
     LC_COLLATE_P = 455,
     LC_CTYPE_P = 456,
     LEADING = 457,
     LEAST = 458,
     LEFT = 459,
     LEVEL = 460,
     LIKE = 461,
     LIMIT = 462,
     LISTEN = 463,
     LOAD = 464,
     LOCAL = 465,
     LOCALTIME = 466,
     LOCALTIMESTAMP = 467,
     LOCATION = 468,
     LOCK_P = 469,
     LOGIN_P = 470,
     MAPPING = 471,
     MATCH = 472,
     MAXVALUE = 473,
     MINUTE_P = 474,
     MINVALUE = 475,
     MODE = 476,
     MONTH_P = 477,
     MOVE = 478,
     NAME_P = 479,
     NAMES = 480,
     NATIONAL = 481,
     NATURAL = 482,
     NCHAR = 483,
     NEXT = 484,
     NO = 485,
     NOCREATEDB = 486,
     NOCREATEROLE = 487,
     NOCREATEUSER = 488,
     NOINHERIT = 489,
     NOLOGIN_P = 490,
     NONE = 491,
     NOSUPERUSER = 492,
     NOT = 493,
     NOTHING = 494,
     NOTIFY = 495,
     NOTNULL = 496,
     NOWAIT = 497,
     NULL_P = 498,
     NULLIF = 499,
     NULLS_P = 500,
     NUMERIC = 501,
     OBJECT_P = 502,
     OF = 503,
     OFF = 504,
     OFFSET = 505,
     OIDS = 506,
     ON = 507,
     ONLY = 508,
     OPERATOR = 509,
     OPTION = 510,
     OPTIONS = 511,
     OR = 512,
     ORDER = 513,
     OUT_P = 514,
     OUTER_P = 515,
     OVER = 516,
     OVERLAPS = 517,
     OVERLAY = 518,
     OWNED = 519,
     OWNER = 520,
     PARSER = 521,
     PARTIAL = 522,
     PARTITION = 523,
     PASSWORD = 524,
     PLACING = 525,
     PLANS = 526,
     POSITION = 527,
     PRECEDING = 528,
     PRECISION = 529,
     PRESERVE = 530,
     PREPARE = 531,
     PREPARED = 532,
     PRIMARY = 533,
     PRIOR = 534,
     PRIVILEGES = 535,
     PROCEDURAL = 536,
     PROCEDURE = 537,
     QUOTE = 538,
     RANGE = 539,
     READ = 540,
     REAL = 541,
     REASSIGN = 542,
     RECHECK = 543,
     RECURSIVE = 544,
     REFERENCES = 545,
     REINDEX = 546,
     RELATIVE_P = 547,
     RELEASE = 548,
     RENAME = 549,
     REPEATABLE = 550,
     REPLACE = 551,
     REPLICA = 552,
     RESET = 553,
     RESTART = 554,
     RESTRICT = 555,
     RETURNING = 556,
     RETURNS = 557,
     REVOKE = 558,
     RIGHT = 559,
     ROLE = 560,
     ROLLBACK = 561,
     ROW = 562,
     ROWS = 563,
     RULE = 564,
     SAVEPOINT = 565,
     SCHEMA = 566,
     SCROLL = 567,
     SEARCH = 568,
     SECOND_P = 569,
     SECURITY = 570,
     SELECT = 571,
     SEQUENCE = 572,
     SEQUENCES = 573,
     SERIALIZABLE = 574,
     SERVER = 575,
     SESSION = 576,
     SESSION_USER = 577,
     SET = 578,
     SETOF = 579,
     SHARE = 580,
     SHOW = 581,
     SIMILAR = 582,
     SIMPLE = 583,
     SMALLINT = 584,
     SOME = 585,
     STABLE = 586,
     STANDALONE_P = 587,
     START = 588,
     STATEMENT = 589,
     STATISTICS = 590,
     STDIN = 591,
     STDOUT = 592,
     STORAGE = 593,
     STRICT_P = 594,
     STRIP_P = 595,
     SUBSTRING = 596,
     SUPERUSER_P = 597,
     SYMMETRIC = 598,
     SYSID = 599,
     SYSTEM_P = 600,
     TABLE = 601,
     TABLES = 602,
     TABLESPACE = 603,
     TEMP = 604,
     TEMPLATE = 605,
     TEMPORARY = 606,
     TEXT_P = 607,
     THEN = 608,
     TIME = 609,
     TIMESTAMP = 610,
     TO = 611,
     TRAILING = 612,
     TRANSACTION = 613,
     TREAT = 614,
     TRIGGER = 615,
     TRIM = 616,
     TRUE_P = 617,
     TRUNCATE = 618,
     TRUSTED = 619,
     TYPE_P = 620,
     UNBOUNDED = 621,
     UNCOMMITTED = 622,
     UNENCRYPTED = 623,
     UNION = 624,
     UNIQUE = 625,
     UNKNOWN = 626,
     UNLISTEN = 627,
     UNTIL = 628,
     UPDATE = 629,
     USER = 630,
     USING = 631,
     VACUUM = 632,
     VALID = 633,
     VALIDATOR = 634,
     VALUE_P = 635,
     VALUES = 636,
     VARCHAR = 637,
     VARIADIC = 638,
     VARYING = 639,
     VERBOSE = 640,
     VERSION_P = 641,
     VIEW = 642,
     VOLATILE = 643,
     WHEN = 644,
     WHERE = 645,
     WHITESPACE_P = 646,
     WINDOW = 647,
     WITH = 648,
     WITHOUT = 649,
     WORK = 650,
     WRAPPER = 651,
     WRITE = 652,
     XML_P = 653,
     XMLATTRIBUTES = 654,
     XMLCONCAT = 655,
     XMLELEMENT = 656,
     XMLFOREST = 657,
     XMLPARSE = 658,
     XMLPI = 659,
     XMLROOT = 660,
     XMLSERIALIZE = 661,
     YEAR_P = 662,
     YES_P = 663,
     ZONE = 664,
     NULLS_FIRST = 665,
     NULLS_LAST = 666,
     WITH_TIME = 667,
     POSTFIXOP = 668,
     UMINUS = 669
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 146 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 706 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 731 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  685
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   64212

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  432
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  517
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2101
/* YYNRULES -- Number of states.  */
#define YYNSTATES  3861

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   669

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   421,     2,     2,
     426,   427,   419,   417,   430,   418,   428,   420,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   431,   429,
     414,   413,   415,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   424,     2,   425,   422,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   416,   423
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   218,
     224,   226,   227,   230,   231,   234,   235,   238,   241,   245,
     249,   251,   253,   255,   257,   259,   261,   263,   265,   267,
     269,   271,   273,   277,   281,   284,   286,   289,   292,   295,
     299,   303,   309,   315,   316,   320,   326,   332,   337,   341,
     347,   351,   357,   363,   370,   372,   374,   378,   384,   391,
     396,   398,   399,   402,   403,   405,   407,   409,   411,   413,
     415,   418,   422,   426,   430,   434,   438,   442,   446,   450,
     453,   459,   462,   465,   468,   471,   475,   479,   483,   485,
     489,   491,   495,   497,   499,   502,   505,   508,   510,   512,
     514,   516,   518,   520,   522,   526,   533,   535,   537,   539,
     541,   543,   544,   546,   548,   551,   555,   560,   564,   567,
     570,   572,   575,   579,   584,   588,   591,   596,   598,   600,
     602,   604,   606,   609,   612,   615,   618,   623,   628,   633,
     638,   640,   644,   647,   651,   656,   663,   670,   677,   683,
     689,   696,   703,   708,   716,   719,   726,   731,   735,   739,
     744,   749,   753,   757,   761,   766,   771,   775,   779,   783,
     787,   791,   795,   800,   805,   809,   812,   816,   820,   824,
     827,   830,   834,   837,   839,   841,   842,   845,   846,   850,
     853,   854,   856,   860,   864,   866,   872,   876,   879,   882,
     893,   900,   902,   904,   906,   908,   910,   912,   916,   919,
     920,   922,   924,   928,   932,   934,   936,   940,   944,   948,
     952,   957,   959,   960,   963,   964,   968,   969,   971,   972,
     974,   978,   981,   983,   985,   987,   991,   992,   994,   998,
    1000,  1012,  1023,  1025,  1027,  1030,  1033,  1036,  1039,  1040,
    1042,  1043,  1047,  1048,  1050,  1054,  1056,  1060,  1062,  1064,
    1066,  1068,  1070,  1074,  1079,  1082,  1083,  1087,  1089,  1091,
    1094,  1096,  1100,  1105,  1110,  1113,  1119,  1121,  1124,  1127,
    1130,  1134,  1138,  1142,  1143,  1145,  1147,  1149,  1151,  1153,
    1155,  1159,  1161,  1167,  1175,  1184,  1194,  1206,  1210,  1211,
    1213,  1217,  1219,  1222,  1225,  1228,  1229,  1231,  1235,  1239,
    1246,  1251,  1252,  1254,  1256,  1259,  1262,  1263,  1267,  1271,
    1274,  1276,  1278,  1281,  1284,  1289,  1290,  1293,  1296,  1299,
    1300,  1304,  1309,  1314,  1315,  1318,  1319,  1324,  1325,  1333,
    1339,  1343,  1344,  1346,  1350,  1352,  1355,  1359,  1360,  1366,
    1371,  1373,  1374,  1376,  1379,  1382,  1384,  1387,  1391,  1394,
    1397,  1400,  1403,  1407,  1411,  1413,  1417,  1419,  1420,  1422,
    1425,  1427,  1429,  1433,  1440,  1451,  1453,  1454,  1456,  1459,
    1462,  1463,  1466,  1469,  1471,  1472,  1478,  1486,  1488,  1489,
    1496,  1499,  1500,  1504,  1510,  1518,  1525,  1534,  1542,  1549,
    1556,  1561,  1562,  1564,  1568,  1573,  1575,  1579,  1581,  1584,
    1587,  1590,  1593,  1595,  1597,  1608,  1611,  1612,  1615,  1618,
    1620,  1621,  1626,  1633,  1639,  1644,  1649,  1658,  1660,  1662,
    1664,  1672,  1682,  1691,  1707,  1728,  1730,  1732,  1734,  1738,
    1740,  1742,  1744,  1748,  1750,  1754,  1755,  1757,  1758,  1760,
    1762,  1767,  1768,  1770,  1774,  1775,  1777,  1779,  1781,  1783,
    1785,  1787,  1790,  1791,  1793,  1796,  1798,  1801,  1802,  1805,
    1807,  1810,  1813,  1820,  1829,  1838,  1843,  1849,  1854,  1859,
    1864,  1868,  1876,  1885,  1892,  1899,  1906,  1913,  1917,  1919,
    1923,  1927,  1929,  1931,  1933,  1935,  1937,  1939,  1943,  1947,
    1951,  1953,  1957,  1961,  1963,  1964,  1966,  1970,  1984,  1986,
    1990,  1995,  2001,  2006,  2014,  2017,  2019,  2020,  2023,  2024,
    2026,  2027,  2034,  2043,  2052,  2054,  2058,  2064,  2070,  2078,
    2088,  2096,  2106,  2112,  2119,  2126,  2131,  2133,  2135,  2137,
    2139,  2141,  2143,  2145,  2147,  2151,  2155,  2159,  2163,  2165,
    2169,  2171,  2174,  2177,  2181,  2187,  2190,  2193,  2194,  2201,
    2209,  2217,  2225,  2234,  2243,  2250,  2259,  2269,  2279,  2287,
    2298,  2306,  2315,  2324,  2333,  2342,  2344,  2346,  2348,  2350,
    2352,  2354,  2356,  2358,  2360,  2362,  2364,  2366,  2368,  2370,
    2373,  2376,  2378,  2381,  2385,  2389,  2393,  2397,  2402,  2407,
    2411,  2415,  2419,  2424,  2429,  2433,  2438,  2443,  2445,  2447,
    2449,  2450,  2458,  2466,  2477,  2479,  2481,  2484,  2489,  2495,
    2497,  2501,  2504,  2507,  2510,  2513,  2515,  2518,  2521,  2526,
    2530,  2533,  2536,  2539,  2543,  2546,  2549,  2555,  2561,  2567,
    2569,  2573,  2575,  2578,  2582,  2583,  2585,  2589,  2592,  2599,
    2606,  2616,  2620,  2621,  2625,  2626,  2632,  2635,  2636,  2640,
    2644,  2648,  2656,  2664,  2675,  2677,  2679,  2681,  2696,  2698,
    2699,  2701,  2702,  2704,  2705,  2708,  2709,  2711,  2715,  2720,
    2725,  2732,  2734,  2737,  2738,  2740,  2742,  2743,  2745,  2747,
    2748,  2758,  2771,  2779,  2782,  2783,  2787,  2790,  2792,  2796,
    2800,  2803,  2805,  2809,  2813,  2817,  2820,  2823,  2825,  2827,
    2829,  2831,  2834,  2836,  2838,  2840,  2842,  2847,  2853,  2855,
    2859,  2863,  2865,  2868,  2873,  2879,  2881,  2883,  2885,  2887,
    2891,  2895,  2898,  2901,  2904,  2907,  2909,  2912,  2915,  2917,
    2919,  2921,  2925,  2928,  2929,  2932,  2934,  2938,  2944,  2946,
    2949,  2951,  2952,  2958,  2966,  2972,  2980,  2986,  2994,  2998,
    3004,  3010,  3016,  3018,  3022,  3025,  3027,  3030,  3032,  3035,
    3047,  3058,  3069,  3072,  3075,  3076,  3086,  3089,  3090,  3095,
    3100,  3105,  3107,  3109,  3111,  3112,  3120,  3127,  3134,  3141,
    3148,  3156,  3166,  3176,  3183,  3190,  3197,  3204,  3211,  3220,
    3229,  3236,  3243,  3250,  3256,  3262,  3271,  3280,  3289,  3298,
    3305,  3307,  3308,  3311,  3312,  3320,  3327,  3334,  3341,  3348,
    3355,  3362,  3370,  3377,  3384,  3391,  3398,  3406,  3414,  3422,
    3432,  3442,  3449,  3456,  3463,  3472,  3481,  3490,  3497,  3502,
    3507,  3512,  3520,  3525,  3530,  3535,  3541,  3547,  3552,  3557,
    3571,  3573,  3575,  3579,  3583,  3585,  3587,  3589,  3591,  3593,
    3595,  3597,  3598,  3600,  3602,  3604,  3606,  3608,  3610,  3611,
    3618,  3627,  3631,  3634,  3635,  3638,  3641,  3644,  3647,  3651,
    3655,  3658,  3661,  3664,  3667,  3671,  3674,  3680,  3685,  3689,
    3693,  3697,  3699,  3701,  3702,  3706,  3709,  3712,  3714,  3718,
    3721,  3723,  3724,  3733,  3744,  3748,  3753,  3758,  3759,  3762,
    3768,  3771,  3772,  3776,  3780,  3784,  3788,  3792,  3796,  3800,
    3804,  3808,  3812,  3816,  3820,  3824,  3829,  3833,  3837,  3839,
    3840,  3846,  3853,  3858,  3861,  3862,  3867,  3871,  3877,  3884,
    3889,  3896,  3903,  3909,  3917,  3919,  3920,  3927,  3939,  3951,
    3963,  3977,  3987,  3999,  4010,  4015,  4018,  4024,  4027,  4028,
    4033,  4039,  4045,  4050,  4057,  4059,  4063,  4065,  4067,  4069,
    4071,  4074,  4079,  4081,  4083,  4085,  4086,  4088,  4089,  4091,
    4092,  4096,  4097,  4100,  4105,  4109,  4115,  4117,  4119,  4121,
    4123,  4125,  4127,  4129,  4131,  4135,  4138,  4140,  4142,  4144,
    4146,  4148,  4149,  4155,  4159,  4160,  4162,  4164,  4166,  4168,
    4172,  4181,  4185,  4186,  4189,  4193,  4196,  4200,  4206,  4208,
    4213,  4216,  4218,  4222,  4225,  4228,  4229,  4236,  4239,  4240,
    4246,  4250,  4251,  4254,  4257,  4260,  4264,  4266,  4270,  4272,
    4275,  4277,  4278,  4286,  4288,  4292,  4294,  4296,  4300,  4306,
    4309,  4311,  4315,  4323,  4325,  4326,  4330,  4333,  4336,  4339,
    4340,  4343,  4346,  4348,  4350,  4354,  4358,  4360,  4363,  4368,
    4373,  4376,  4380,  4386,  4392,  4394,  4396,  4406,  4408,  4411,
    4416,  4421,  4426,  4429,  4433,  4435,  4439,  4444,  4447,  4448,
    4452,  4456,  4461,  4466,  4471,  4476,  4479,  4481,  4483,  4484,
    4486,  4488,  4489,  4491,  4497,  4499,  4500,  4502,  4503,  4507,
    4509,  4513,  4518,  4522,  4525,  4528,  4530,  4532,  4534,  4535,
    4538,  4543,  4549,  4552,  4556,  4558,  4560,  4562,  4564,  4568,
    4569,  4571,  4573,  4575,  4577,  4579,  4583,  4584,  4587,  4588,
    4590,  4594,  4596,  4597,  4599,  4602,  4607,  4612,  4615,  4616,
    4619,  4623,  4626,  4627,  4629,  4633,  4635,  4638,  4640,  4643,
    4649,  4656,  4662,  4664,  4667,  4669,  4674,  4678,  4683,  4689,
    4694,  4700,  4705,  4711,  4714,  4719,  4721,  4724,  4727,  4730,
    4732,  4734,  4735,  4740,  4743,  4745,  4748,  4751,  4756,  4758,
    4762,  4764,  4767,  4771,  4773,  4776,  4777,  4780,  4785,  4786,
    4788,  4792,  4795,  4798,  4802,  4808,  4815,  4818,  4822,  4826,
    4831,  4832,  4834,  4836,  4838,  4840,  4842,  4845,  4851,  4853,
    4855,  4857,  4859,  4862,  4866,  4870,  4871,  4873,  4875,  4877,
    4879,  4881,  4884,  4887,  4890,  4893,  4896,  4898,  4902,  4903,
    4905,  4907,  4909,  4911,  4917,  4920,  4922,  4924,  4926,  4928,
    4934,  4937,  4940,  4943,  4945,  4949,  4953,  4956,  4958,  4959,
    4963,  4964,  4970,  4973,  4979,  4982,  4984,  4987,  4991,  4992,
    4994,  4996,  4998,  5000,  5002,  5004,  5008,  5012,  5016,  5020,
    5024,  5028,  5032,  5033,  5035,  5040,  5042,  5046,  5052,  5055,
    5058,  5062,  5066,  5070,  5074,  5078,  5082,  5086,  5090,  5094,
    5098,  5101,  5104,  5108,  5112,  5115,  5119,  5125,  5130,  5137,
    5141,  5147,  5152,  5159,  5164,  5171,  5177,  5185,  5189,  5192,
    5197,  5200,  5204,  5208,  5213,  5217,  5222,  5226,  5231,  5237,
    5244,  5251,  5259,  5266,  5274,  5281,  5289,  5293,  5298,  5303,
    5310,  5313,  5317,  5322,  5324,  5328,  5331,  5334,  5338,  5342,
    5346,  5350,  5354,  5358,  5362,  5366,  5370,  5374,  5377,  5380,
    5386,  5393,  5400,  5408,  5412,  5417,  5419,  5421,  5424,  5429,
    5431,  5433,  5435,  5438,  5441,  5444,  5446,  5451,  5457,  5464,
    5473,  5480,  5488,  5496,  5502,  5504,  5506,  5511,  5513,  5518,
    5520,  5525,  5527,  5532,  5534,  5536,  5538,  5540,  5542,  5544,
    5551,  5556,  5561,  5566,  5571,  5578,  5584,  5590,  5596,  5601,
    5608,  5613,  5618,  5623,  5628,  5634,  5642,  5650,  5660,  5665,
    5672,  5678,  5686,  5694,  5702,  5705,  5709,  5713,  5717,  5722,
    5723,  5728,  5730,  5734,  5738,  5740,  5742,  5744,  5747,  5750,
    5751,  5754,  5755,  5757,  5761,  5765,  5768,  5771,  5772,  5779,
    5781,  5782,  5786,  5787,  5790,  5793,  5794,  5796,  5801,  5804,
    5807,  5810,  5813,  5816,  5821,  5825,  5831,  5833,  5835,  5837,
    5839,  5841,  5843,  5845,  5847,  5849,  5851,  5853,  5855,  5857,
    5859,  5861,  5866,  5868,  5873,  5875,  5880,  5882,  5885,  5887,
    5890,  5892,  5896,  5898,  5902,  5904,  5908,  5910,  5914,  5918,
    5922,  5925,  5927,  5931,  5935,  5936,  5938,  5940,  5942,  5944,
    5946,  5948,  5950,  5952,  5957,  5961,  5964,  5968,  5969,  5973,
    5977,  5980,  5983,  5985,  5986,  5989,  5992,  5996,  5999,  6001,
    6003,  6007,  6013,  6015,  6018,  6023,  6026,  6027,  6029,  6030,
    6032,  6035,  6038,  6041,  6045,  6051,  6053,  6056,  6057,  6060,
    6062,  6063,  6065,  6067,  6069,  6073,  6077,  6079,  6083,  6087,
    6090,  6092,  6094,  6096,  6100,  6102,  6105,  6107,  6111,  6113,
    6115,  6117,  6119,  6121,  6123,  6125,  6128,  6130,  6132,  6134,
    6136,  6138,  6141,  6147,  6150,  6154,  6161,  6163,  6165,  6167,
    6169,  6171,  6173,  6175,  6178,  6181,  6183,  6185,  6187,  6189,
    6191,  6193,  6195,  6197,  6199,  6201,  6203,  6205,  6207,  6209,
    6211,  6213,  6215,  6217,  6219,  6221,  6223,  6225,  6227,  6229,
    6231,  6233,  6235,  6237,  6239,  6241,  6243,  6245,  6247,  6249,
    6251,  6253,  6255,  6257,  6259,  6261,  6263,  6265,  6267,  6269,
    6271,  6273,  6275,  6277,  6279,  6281,  6283,  6285,  6287,  6289,
    6291,  6293,  6295,  6297,  6299,  6301,  6303,  6305,  6307,  6309,
    6311,  6313,  6315,  6317,  6319,  6321,  6323,  6325,  6327,  6329,
    6331,  6333,  6335,  6337,  6339,  6341,  6343,  6345,  6347,  6349,
    6351,  6353,  6355,  6357,  6359,  6361,  6363,  6365,  6367,  6369,
    6371,  6373,  6375,  6377,  6379,  6381,  6383,  6385,  6387,  6389,
    6391,  6393,  6395,  6397,  6399,  6401,  6403,  6405,  6407,  6409,
    6411,  6413,  6415,  6417,  6419,  6421,  6423,  6425,  6427,  6429,
    6431,  6433,  6435,  6437,  6439,  6441,  6443,  6445,  6447,  6449,
    6451,  6453,  6455,  6457,  6459,  6461,  6463,  6465,  6467,  6469,
    6471,  6473,  6475,  6477,  6479,  6481,  6483,  6485,  6487,  6489,
    6491,  6493,  6495,  6497,  6499,  6501,  6503,  6505,  6507,  6509,
    6511,  6513,  6515,  6517,  6519,  6521,  6523,  6525,  6527,  6529,
    6531,  6533,  6535,  6537,  6539,  6541,  6543,  6545,  6547,  6549,
    6551,  6553,  6555,  6557,  6559,  6561,  6563,  6565,  6567,  6569,
    6571,  6573,  6575,  6577,  6579,  6581,  6583,  6585,  6587,  6589,
    6591,  6593,  6595,  6597,  6599,  6601,  6603,  6605,  6607,  6609,
    6611,  6613,  6615,  6617,  6619,  6621,  6623,  6625,  6627,  6629,
    6631,  6633,  6635,  6637,  6639,  6641,  6643,  6645,  6647,  6649,
    6651,  6653,  6655,  6657,  6659,  6661,  6663,  6665,  6667,  6669,
    6671,  6673,  6675,  6677,  6679,  6681,  6683,  6685,  6687,  6689,
    6691,  6693,  6695,  6697,  6699,  6701,  6703,  6705,  6707,  6709,
    6711,  6713,  6715,  6717,  6719,  6721,  6723,  6725,  6727,  6729,
    6731,  6733,  6735,  6737,  6739,  6741,  6743,  6745,  6747,  6749,
    6751,  6753,  6755,  6757,  6759,  6761,  6763,  6765,  6767,  6769,
    6771,  6773,  6775,  6777,  6779,  6781,  6783,  6785,  6787,  6789,
    6791,  6793,  6795,  6797,  6799,  6801,  6803,  6805,  6807,  6809,
    6811,  6813,  6815,  6817,  6819,  6821,  6823,  6825,  6827,  6829,
    6831,  6833,  6835,  6837,  6839,  6841,  6843,  6845,  6847,  6849,
    6851,  6853,  6855,  6857,  6859,  6861,  6863,  6865,  6867,  6869,
    6871,  6873,  6875,  6877,  6879,  6881,  6883,  6885,  6887,  6889,
    6891,  6893,  6895,  6897,  6899,  6901,  6903,  6905,  6907,  6909,
    6911,  6913,  6915,  6917,  6919,  6921,  6923,  6925,  6927,  6929,
    6931,  6933,  6935,  6937,  6939,  6941,  6943,  6945,  6947,  6949,
    6951,  6953,  6955,  6957,  6959,  6961,  6963,  6965,  6967,  6969,
    6971,  6973,  6975,  6977,  6979,  6981,  6983,  6985,  6987,  6989,
    6991,  6993
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     433,     0,    -1,   434,    -1,   434,   429,   435,    -1,   435,
      -1,   737,    -1,   738,    -1,   654,    -1,   743,    -1,   564,
      -1,   578,    -1,   688,    -1,   451,    -1,   709,    -1,   710,
      -1,   711,    -1,   544,    -1,   476,    -1,   445,    -1,   443,
      -1,   746,    -1,   745,    -1,   582,    -1,   447,    -1,   446,
      -1,   753,    -1,   474,    -1,   486,    -1,   748,    -1,   632,
      -1,   471,    -1,   487,    -1,   537,    -1,   598,    -1,   699,
      -1,   747,    -1,   742,    -1,   562,    -1,   573,    -1,   669,
      -1,   450,    -1,   611,    -1,   617,    -1,   618,    -1,   551,
      -1,   454,    -1,   543,    -1,   502,    -1,   559,    -1,   583,
      -1,   436,    -1,   442,    -1,   579,    -1,   733,    -1,   770,
      -1,   789,    -1,   600,    -1,   776,    -1,   475,    -1,   696,
      -1,   599,    -1,   701,    -1,   563,    -1,   577,    -1,   453,
      -1,   621,    -1,   622,    -1,   623,    -1,   557,    -1,   720,
      -1,   625,    -1,   561,    -1,   597,    -1,   448,    -1,   449,
      -1,   581,    -1,   741,    -1,   768,    -1,   759,    -1,   635,
      -1,   639,    -1,   650,    -1,   659,    -1,   771,    -1,   723,
      -1,   732,    -1,   778,    -1,   721,    -1,   765,    -1,   624,
      -1,   703,    -1,   692,    -1,   691,    -1,   693,    -1,   706,
      -1,   640,    -1,   651,    -1,   713,    -1,   793,    -1,   725,
      -1,   630,    -1,   724,    -1,   782,    -1,   750,    -1,   468,
      -1,   458,    -1,   470,    -1,   730,    -1,    -1,    81,   305,
     940,   437,   438,    -1,   393,    -1,    -1,   438,   441,    -1,
      -1,   439,   440,    -1,    -1,   269,   939,    -1,   269,   243,
      -1,   126,   269,   939,    -1,   368,   269,   939,    -1,   342,
      -1,   237,    -1,   175,    -1,   234,    -1,    82,    -1,   231,
      -1,    83,    -1,   232,    -1,    84,    -1,   233,    -1,   215,
      -1,   235,    -1,    73,   207,   941,    -1,   378,   373,   939,
      -1,   375,   929,    -1,   440,    -1,   344,   938,    -1,    19,
     929,    -1,   305,   929,    -1,   170,   305,   929,    -1,   170,
     158,   929,    -1,    81,   375,   940,   437,   438,    -1,    24,
     305,   940,   437,   439,    -1,    -1,   170,    98,   931,    -1,
      24,   305,   940,   444,   469,    -1,    24,   375,   940,   437,
     439,    -1,    24,   375,   940,   469,    -1,   121,   305,   929,
      -1,   121,   305,   165,   135,   929,    -1,   121,   375,   929,
      -1,   121,   375,   165,   135,   929,    -1,    81,   158,   940,
     437,   438,    -1,    24,   158,   940,   452,   375,   929,    -1,
      18,    -1,   121,    -1,   121,   158,   929,    -1,   121,   158,
     165,   135,   929,    -1,    81,   311,   455,    37,   940,   456,
      -1,    81,   311,   942,   456,    -1,   942,    -1,    -1,   456,
     457,    -1,    -1,   502,    -1,   659,    -1,   543,    -1,   583,
      -1,   639,    -1,   730,    -1,   323,   459,    -1,   323,   210,
     459,    -1,   323,   321,   459,    -1,   460,   356,   461,    -1,
     460,   413,   461,    -1,   460,   356,   104,    -1,   460,   413,
     104,    -1,   460,   150,    87,    -1,   354,   409,   465,    -1,
     358,   728,    -1,   321,    58,    31,   358,   728,    -1,    54,
     939,    -1,   311,   939,    -1,   225,   466,    -1,   305,   467,
      -1,   321,    37,   467,    -1,   321,    37,   104,    -1,   398,
     255,   877,    -1,   942,    -1,   460,   428,   942,    -1,   462,
      -1,   461,   430,   462,    -1,   464,    -1,   549,    -1,   285,
     367,    -1,   285,    70,    -1,   295,   285,    -1,   319,    -1,
     362,    -1,   139,    -1,   252,    -1,   467,    -1,   939,    -1,
       3,    -1,   864,   939,   866,    -1,   864,   426,   938,   427,
     939,   866,    -1,   549,    -1,   104,    -1,   210,    -1,   939,
      -1,   104,    -1,    -1,   942,    -1,   939,    -1,   298,   460,
      -1,   298,   354,   409,    -1,   298,   358,   193,   205,    -1,
     298,   321,    37,    -1,   298,    22,    -1,   323,   459,    -1,
     468,    -1,   326,   460,    -1,   326,   354,   409,    -1,   326,
     358,   193,   205,    -1,   326,   321,    37,    -1,   326,    22,
      -1,   323,    75,   472,   473,    -1,    22,    -1,   927,    -1,
     107,    -1,   167,    -1,    60,    -1,   115,    22,    -1,   115,
     349,    -1,   115,   351,    -1,   115,   271,    -1,    24,   346,
     836,   477,    -1,    24,   173,   928,   477,    -1,    24,   317,
     928,   477,    -1,    24,   387,   928,   477,    -1,   478,    -1,
     477,   430,   478,    -1,    18,   510,    -1,    18,    66,   510,
      -1,    24,   707,   942,   479,    -1,    24,   707,   942,   121,
     238,   243,    -1,    24,   707,   942,   323,   238,   243,    -1,
      24,   707,   942,   323,   335,   941,    -1,    24,   707,   942,
     323,   482,    -1,    24,   707,   942,   298,   482,    -1,    24,
     707,   942,   323,   338,   942,    -1,   121,   707,   165,   135,
     942,   480,    -1,   121,   707,   942,   480,    -1,    24,   707,
     942,   708,   365,   844,   481,    -1,    18,   519,    -1,   121,
      74,   165,   135,   930,   480,    -1,   121,    74,   930,   480,
      -1,   323,   393,   251,    -1,   323,   394,   251,    -1,   323,
     393,   315,   196,    -1,   323,   394,   315,   196,    -1,    63,
     252,   930,    -1,   323,   394,    63,    -1,   124,   360,   930,
      -1,   124,    25,   360,   930,    -1,   124,   297,   360,   930,
      -1,   124,   360,    22,    -1,   124,   360,   375,    -1,   114,
     360,   930,    -1,   114,   360,    22,    -1,   114,   360,   375,
      -1,   124,   309,   930,    -1,   124,    25,   309,   930,    -1,
     124,   297,   309,   930,    -1,   114,   309,   930,    -1,   175,
     928,    -1,   230,   175,   928,    -1,   265,   356,   940,    -1,
     323,   348,   930,    -1,   323,   482,    -1,   298,   482,    -1,
     323,   104,   868,    -1,   121,   104,    -1,    50,    -1,   300,
      -1,    -1,   376,   868,    -1,    -1,   426,   484,   427,    -1,
     393,   482,    -1,    -1,   485,    -1,   484,   430,   485,    -1,
     944,   413,   604,    -1,   944,    -1,   944,   428,   944,   413,
     604,    -1,   944,   428,   944,    -1,    62,   790,    -1,    62,
      22,    -1,    79,   493,   928,   521,   494,   488,   489,   495,
     437,   490,    -1,    79,   794,   356,   489,   437,   490,    -1,
     150,    -1,   356,    -1,   939,    -1,   336,    -1,   337,    -1,
     491,    -1,   426,   497,   427,    -1,   491,   492,    -1,    -1,
      43,    -1,   251,    -1,   110,   744,   939,    -1,   243,   744,
     939,    -1,    86,    -1,   161,    -1,   283,   744,   939,    -1,
     129,   744,   939,    -1,   146,   283,   522,    -1,   146,   283,
     419,    -1,   146,   238,   243,   522,    -1,    43,    -1,    -1,
     393,   251,    -1,    -1,   496,   111,   939,    -1,    -1,   376,
      -1,    -1,   498,    -1,   497,   430,   498,    -1,   944,   499,
      -1,   464,    -1,   549,    -1,   419,    -1,   426,   500,   427,
      -1,    -1,   501,    -1,   500,   430,   501,    -1,   464,    -1,
      81,   503,   346,   928,   426,   504,   427,   532,   533,   534,
     535,    -1,    81,   503,   346,   928,   248,   628,   505,   533,
     534,   535,    -1,   351,    -1,   349,    -1,   210,   351,    -1,
     210,   349,    -1,   154,   351,    -1,   154,   349,    -1,    -1,
     506,    -1,    -1,   426,   507,   427,    -1,    -1,   508,    -1,
     506,   430,   508,    -1,   509,    -1,   507,   430,   509,    -1,
     510,    -1,   516,    -1,   519,    -1,   511,    -1,   519,    -1,
     942,   844,   512,    -1,   942,   393,   256,   512,    -1,   512,
     513,    -1,    -1,    74,   930,   514,    -1,   514,    -1,   515,
      -1,   238,   243,    -1,   243,    -1,   370,   685,   536,    -1,
     278,   195,   685,   536,    -1,    59,   426,   868,   427,    -1,
     104,   869,    -1,   290,   928,   521,   524,   528,    -1,   106,
      -1,   238,   106,    -1,   177,   107,    -1,   177,   167,    -1,
     206,   928,   517,    -1,   517,   171,   518,    -1,   517,   132,
     518,    -1,    -1,   105,    -1,    75,    -1,   174,    -1,   338,
      -1,    68,    -1,    22,    -1,    74,   930,   520,    -1,   520,
      -1,    59,   426,   868,   427,   594,    -1,   370,   426,   522,
     427,   685,   536,   594,    -1,   278,   195,   426,   522,   427,
     685,   536,   594,    -1,   131,   663,   426,   525,   427,   685,
     536,   527,   594,    -1,   147,   195,   426,   522,   427,   290,
     928,   521,   524,   528,   594,    -1,   426,   522,   427,    -1,
      -1,   523,    -1,   522,   430,   523,    -1,   942,    -1,   217,
     151,    -1,   217,   267,    -1,   217,   328,    -1,    -1,   526,
      -1,   525,   430,   526,    -1,   665,   393,   695,    -1,   665,
     393,   254,   426,   695,   427,    -1,   390,   426,   868,   427,
      -1,    -1,   529,    -1,   530,    -1,   529,   530,    -1,   530,
     529,    -1,    -1,   252,   374,   531,    -1,   252,   109,   531,
      -1,   230,    17,    -1,   300,    -1,    50,    -1,   323,   243,
      -1,   323,   104,    -1,   176,   426,   927,   427,    -1,    -1,
     393,   482,    -1,   393,   251,    -1,   394,   251,    -1,    -1,
     252,    69,   121,    -1,   252,    69,   109,   308,    -1,   252,
      69,   275,   308,    -1,    -1,   348,   930,    -1,    -1,   376,
     173,   348,   930,    -1,    -1,    81,   503,   346,   538,    31,
     793,   542,    -1,   928,   539,   533,   534,   535,    -1,   426,
     540,   427,    -1,    -1,   541,    -1,   540,   430,   541,    -1,
     942,    -1,   393,    97,    -1,   393,   230,    97,    -1,    -1,
      81,   503,   317,   928,   545,    -1,    24,   317,   928,   546,
      -1,   546,    -1,    -1,   547,    -1,   546,   547,    -1,    48,
     549,    -1,    96,    -1,   230,    96,    -1,   172,   548,   549,
      -1,   218,   549,    -1,   220,   549,    -1,   230,   218,    -1,
     230,   220,    -1,   264,    47,   628,    -1,   333,   437,   549,
      -1,   299,    -1,   299,   437,   549,    -1,    47,    -1,    -1,
       4,    -1,   418,     4,    -1,   941,    -1,   549,    -1,   550,
     430,   549,    -1,    81,   670,   552,   558,   197,   467,    -1,
      81,   670,   552,   558,   197,   467,   159,   553,   554,   556,
      -1,   364,    -1,    -1,   930,    -1,   930,   629,    -1,   178,
     553,    -1,    -1,   379,   553,    -1,   230,   379,    -1,   555,
      -1,    -1,   121,   558,   197,   467,   480,    -1,   121,   558,
     197,   165,   135,   467,   480,    -1,   281,    -1,    -1,    81,
     348,   930,   560,   213,   939,    -1,   265,   930,    -1,    -1,
     121,   348,   930,    -1,   121,   348,   165,   135,   930,    -1,
      81,   147,    97,   396,   930,   556,   565,    -1,   121,   147,
      97,   396,   930,   480,    -1,   121,   147,    97,   396,   165,
     135,   930,   480,    -1,    24,   147,    97,   396,   930,   555,
     567,    -1,    24,   147,    97,   396,   930,   555,    -1,    24,
     147,    97,   396,   930,   567,    -1,   256,   426,   566,   427,
      -1,    -1,   570,    -1,   566,   430,   570,    -1,   256,   426,
     568,   427,    -1,   569,    -1,   568,   430,   569,    -1,   570,
      -1,   323,   570,    -1,    18,   570,    -1,   121,   571,    -1,
     571,   572,    -1,   944,    -1,   939,    -1,    81,   320,   930,
     574,   576,   147,    97,   396,   930,   565,    -1,   365,   939,
      -1,    -1,   386,   939,    -1,   386,   243,    -1,   575,    -1,
      -1,   121,   320,   930,   480,    -1,   121,   320,   165,   135,
     930,   480,    -1,    24,   320,   930,   575,   567,    -1,    24,
     320,   930,   575,    -1,    24,   320,   930,   567,    -1,    81,
     375,   216,   145,   580,   320,   930,   565,    -1,    94,    -1,
     375,    -1,   940,    -1,   121,   375,   216,   145,   580,   320,
     930,    -1,   121,   375,   216,   165,   135,   145,   580,   320,
     930,    -1,    24,   375,   216,   145,   580,   320,   930,   567,
      -1,    81,   360,   930,   584,   585,   252,   928,   587,   590,
     134,   282,   936,   426,   591,   427,    -1,    81,    74,   360,
     930,    20,   585,   252,   928,   593,   594,   145,   122,   307,
     590,   134,   282,   936,   426,   591,   427,    -1,    39,    -1,
      20,    -1,   586,    -1,   585,   257,   586,    -1,   183,    -1,
     109,    -1,   374,    -1,   374,   248,   522,    -1,   363,    -1,
     145,   588,   589,    -1,    -1,   122,    -1,    -1,   307,    -1,
     334,    -1,   389,   426,   868,   427,    -1,    -1,   592,    -1,
     591,   430,   592,    -1,    -1,   938,    -1,     4,    -1,   939,
      -1,     6,    -1,     7,    -1,   942,    -1,   150,   928,    -1,
      -1,   595,    -1,   595,   596,    -1,   596,    -1,   596,   595,
      -1,    -1,   238,   106,    -1,   106,    -1,   177,   167,    -1,
     177,   107,    -1,   121,   360,   930,   252,   928,   480,    -1,
     121,   360,   165,   135,   930,   252,   928,   480,    -1,    81,
      33,   930,    59,   426,   868,   427,   594,    -1,   121,    33,
     930,   480,    -1,    81,    21,   936,   605,   601,    -1,    81,
      21,   936,   606,    -1,    81,   254,   695,   601,    -1,    81,
     365,   628,   601,    -1,    81,   365,   628,    -1,    81,   365,
     628,    31,   426,   842,   427,    -1,    81,   365,   628,    31,
     128,   426,   609,   427,    -1,    81,   352,   313,   266,   628,
     601,    -1,    81,   352,   313,   113,   628,   601,    -1,    81,
     352,   313,   350,   628,   601,    -1,    81,   352,   313,    72,
     628,   601,    -1,   426,   602,   427,    -1,   603,    -1,   602,
     430,   603,    -1,   944,   413,   604,    -1,   944,    -1,   679,
      -1,   948,    -1,   894,    -1,   549,    -1,   939,    -1,   426,
     899,   427,    -1,   426,   419,   427,    -1,   426,   607,   427,
      -1,   608,    -1,   607,   430,   608,    -1,     3,   413,   604,
      -1,   610,    -1,    -1,   939,    -1,   610,   430,   939,    -1,
      81,   254,    61,   628,   614,   145,   365,   844,   376,   932,
     615,    31,   612,    -1,   613,    -1,   612,   430,   613,    -1,
     254,   938,   695,   616,    -1,   254,   938,   695,   694,   616,
      -1,   152,   938,   936,   671,    -1,   152,   938,   426,   899,
     427,   936,   671,    -1,   338,   844,    -1,   104,    -1,    -1,
     140,   628,    -1,    -1,   288,    -1,    -1,    81,   254,   140,
     628,   376,   932,    -1,    24,   254,   140,   628,   376,   932,
      18,   612,    -1,    24,   254,   140,   628,   376,   932,   121,
     619,    -1,   620,    -1,   619,   430,   620,    -1,   254,   938,
     426,   899,   427,    -1,   152,   938,   426,   899,   427,    -1,
     121,   254,    61,   628,   376,   932,   480,    -1,   121,   254,
      61,   165,   135,   628,   376,   932,   480,    -1,   121,   254,
     140,   628,   376,   932,   480,    -1,   121,   254,   140,   165,
     135,   628,   376,   932,   480,    -1,   121,   264,    47,   929,
     480,    -1,   287,   264,    47,   929,   356,   930,    -1,   121,
     626,   165,   135,   627,   480,    -1,   121,   626,   627,   480,
      -1,   346,    -1,   317,    -1,   387,    -1,   173,    -1,   365,
      -1,   119,    -1,    78,    -1,   311,    -1,   352,   313,   266,
      -1,   352,   313,   113,    -1,   352,   313,   350,    -1,   352,
     313,    72,    -1,   628,    -1,   627,   430,   628,    -1,   942,
      -1,   942,   629,    -1,   428,   933,    -1,   629,   428,   933,
      -1,   363,   803,   837,   631,   480,    -1,    77,   164,    -1,
     299,   164,    -1,    -1,    67,   252,   633,   628,   191,   634,
      -1,    67,   252,    21,   936,   605,   191,   634,    -1,    67,
     252,   152,   936,   671,   191,   634,    -1,    67,   252,   254,
     695,   694,   191,   634,    -1,    67,   252,    74,   930,   252,
     628,   191,   634,    -1,    67,   252,   309,   930,   252,   628,
     191,   634,    -1,    67,   252,   309,   930,   191,   634,    -1,
      67,   252,   360,   930,   252,   628,   191,   634,    -1,    67,
     252,   254,    61,   628,   376,   932,   191,   634,    -1,    67,
     252,   254,   140,   628,   376,   932,   191,   634,    -1,    67,
     252,   198,   247,   549,   191,   634,    -1,    67,   252,    53,
     426,   844,    31,   844,   427,   191,   634,    -1,    67,   252,
     558,   197,   628,   191,   634,    -1,    67,   252,   352,   313,
     266,   628,   191,   634,    -1,    67,   252,   352,   313,   113,
     628,   191,   634,    -1,    67,   252,   352,   313,   350,   628,
     191,   634,    -1,    67,   252,   352,   313,    72,   628,   191,
     634,    -1,    66,    -1,    98,    -1,   311,    -1,   173,    -1,
     317,    -1,   346,    -1,   119,    -1,   365,    -1,   387,    -1,
      78,    -1,   348,    -1,   305,    -1,   939,    -1,   243,    -1,
     141,   636,    -1,   223,   636,    -1,   790,    -1,   637,   790,
      -1,   229,   638,   790,    -1,   279,   638,   790,    -1,   142,
     638,   790,    -1,   199,   638,   790,    -1,    15,   941,   638,
     790,    -1,   292,   941,   638,   790,    -1,   941,   638,   790,
      -1,    22,   638,   790,    -1,   148,   638,   790,    -1,   148,
     941,   638,   790,    -1,   148,    22,   638,   790,    -1,    38,
     638,   790,    -1,    38,   941,   638,   790,    -1,    38,    22,
     638,   790,    -1,   150,    -1,   170,    -1,   637,    -1,    -1,
     155,   641,   252,   644,   356,   645,   647,    -1,   303,   641,
     252,   644,   150,   645,   480,    -1,   303,   155,   255,   145,
     641,   252,   644,   150,   645,   480,    -1,   642,    -1,    22,
      -1,    22,   280,    -1,    22,   426,   522,   427,    -1,    22,
     280,   426,   522,   427,    -1,   643,    -1,   642,   430,   643,
      -1,   316,   521,    -1,   290,   521,    -1,    81,   521,    -1,
     942,   521,    -1,   927,    -1,   346,   927,    -1,   317,   927,
      -1,   147,    97,   396,   929,    -1,   147,   320,   929,    -1,
     152,   648,    -1,    98,   929,    -1,   197,   929,    -1,   198,
     247,   550,    -1,   311,   929,    -1,   348,   929,    -1,    22,
     347,   170,   311,   929,    -1,    22,   318,   170,   311,   929,
      -1,    22,   153,   170,   311,   929,    -1,   646,    -1,   645,
     430,   646,    -1,   940,    -1,   158,   940,    -1,   393,   155,
     255,    -1,    -1,   649,    -1,   648,   430,   649,    -1,   936,
     671,    -1,   155,   642,   356,   929,   652,   653,    -1,   303,
     642,   150,   929,   653,   480,    -1,   303,    19,   255,   145,
     642,   150,   929,   653,   480,    -1,   393,    19,   255,    -1,
      -1,   156,    47,   940,    -1,    -1,    24,   104,   280,   655,
     657,    -1,   655,   656,    -1,    -1,   170,   311,   929,    -1,
     145,   305,   929,    -1,   145,   375,   929,    -1,   155,   641,
     252,   658,   356,   645,   647,    -1,   303,   641,   252,   658,
     150,   645,   480,    -1,   303,   155,   255,   145,   641,   252,
     658,   150,   645,   480,    -1,   347,    -1,   153,    -1,   318,
      -1,    81,   660,   173,   661,   662,   252,   928,   663,   426,
     664,   427,   483,   535,   840,    -1,   370,    -1,    -1,    71,
      -1,    -1,   934,    -1,    -1,   376,   932,    -1,    -1,   665,
      -1,   664,   430,   665,    -1,   942,   666,   667,   668,    -1,
     871,   666,   667,   668,    -1,   426,   868,   427,   666,   667,
     668,    -1,   628,    -1,   376,   628,    -1,    -1,    32,    -1,
     112,    -1,    -1,   410,    -1,   411,    -1,    -1,    81,   670,
     152,   936,   673,   302,   678,   681,   685,    -1,    81,   670,
     152,   936,   673,   302,   346,   426,   687,   427,   681,   685,
      -1,    81,   670,   152,   936,   673,   681,   685,    -1,   257,
     296,    -1,    -1,   426,   672,   427,    -1,   426,   427,    -1,
     675,    -1,   672,   430,   675,    -1,   426,   674,   427,    -1,
     426,   427,    -1,   680,    -1,   674,   430,   680,    -1,   676,
     677,   679,    -1,   677,   676,   679,    -1,   677,   679,    -1,
     676,   679,    -1,   679,    -1,   170,    -1,   259,    -1,   180,
      -1,   170,   259,    -1,   383,    -1,   943,    -1,   679,    -1,
     844,    -1,   943,   629,   421,   365,    -1,   324,   943,   629,
     421,   365,    -1,   675,    -1,   675,   104,   868,    -1,   675,
     413,   868,    -1,   683,    -1,   681,   683,    -1,    49,   252,
     243,   181,    -1,   302,   243,   252,   243,   181,    -1,   339,
      -1,   168,    -1,   331,    -1,   388,    -1,   137,   315,   108,
      -1,   137,   315,   190,    -1,   315,   108,    -1,   315,   190,
      -1,    80,   549,    -1,   308,   549,    -1,   469,    -1,    31,
     684,    -1,   197,   467,    -1,   392,    -1,   682,    -1,   939,
      -1,   939,   430,   939,    -1,   393,   601,    -1,    -1,   677,
     679,    -1,   686,    -1,   687,   430,   686,    -1,    24,   152,
     649,   689,   690,    -1,   682,    -1,   689,   682,    -1,   300,
      -1,    -1,   121,   152,   936,   671,   480,    -1,   121,   152,
     165,   135,   936,   671,   480,    -1,   121,    21,   936,   605,
     480,    -1,   121,    21,   165,   135,   936,   605,   480,    -1,
     121,   254,   695,   694,   480,    -1,   121,   254,   165,   135,
     695,   694,   480,    -1,   426,   844,   427,    -1,   426,   844,
     430,   844,   427,    -1,   426,   236,   430,   844,   427,    -1,
     426,   844,   430,   236,   427,    -1,   891,    -1,   942,   428,
     695,    -1,   117,   697,    -1,   698,    -1,   697,   698,    -1,
     939,    -1,   197,   467,    -1,    81,    53,   426,   844,    31,
     844,   427,   393,   152,   649,   700,    -1,    81,    53,   426,
     844,    31,   844,   427,   394,   152,   700,    -1,    81,    53,
     426,   844,    31,   844,   427,   393,   180,   700,    -1,    31,
     169,    -1,    31,    34,    -1,    -1,   121,    53,   702,   426,
     844,    31,   844,   427,   480,    -1,   165,   135,    -1,    -1,
     291,   704,   928,   705,    -1,   291,   345,   930,   705,    -1,
     291,    98,   930,   705,    -1,   173,    -1,   346,    -1,   146,
      -1,    -1,    24,    21,   936,   605,   294,   356,   930,    -1,
      24,    78,   628,   294,   356,   930,    -1,    24,    98,   931,
     294,   356,   931,    -1,    24,   152,   649,   294,   356,   930,
      -1,    24,   158,   940,   294,   356,   940,    -1,    24,   558,
     197,   930,   294,   356,   930,    -1,    24,   254,    61,   628,
     376,   932,   294,   356,   930,    -1,    24,   254,   140,   628,
     376,   932,   294,   356,   930,    -1,    24,   311,   930,   294,
     356,   930,    -1,    24,   346,   836,   294,   356,   930,    -1,
      24,   317,   928,   294,   356,   930,    -1,    24,   387,   928,
     294,   356,   930,    -1,    24,   173,   928,   294,   356,   930,
      -1,    24,   346,   836,   294,   707,   930,   356,   930,    -1,
      24,   360,   930,   252,   928,   294,   356,   930,    -1,    24,
     305,   940,   294,   356,   940,    -1,    24,   375,   940,   294,
     356,   940,    -1,    24,   348,   930,   294,   356,   930,    -1,
      24,   348,   930,   323,   482,    -1,    24,   348,   930,   298,
     482,    -1,    24,   352,   313,   266,   628,   294,   356,   930,
      -1,    24,   352,   313,   113,   628,   294,   356,   930,    -1,
      24,   352,   313,   350,   628,   294,   356,   930,    -1,    24,
     352,   313,    72,   628,   294,   356,   930,    -1,    24,   365,
     628,   294,   356,   930,    -1,    66,    -1,    -1,   323,    97,
      -1,    -1,    24,    21,   936,   605,   323,   311,   930,    -1,
      24,   119,   628,   323,   311,   930,    -1,    24,   152,   649,
     323,   311,   930,    -1,    24,   346,   836,   323,   311,   930,
      -1,    24,   317,   928,   323,   311,   930,    -1,    24,   387,
     928,   323,   311,   930,    -1,    24,   365,   628,   323,   311,
     930,    -1,    24,    21,   936,   605,   265,   356,   940,    -1,
      24,    78,   628,   265,   356,   940,    -1,    24,    98,   931,
     265,   356,   940,    -1,    24,   119,   628,   265,   356,   940,
      -1,    24,   152,   649,   265,   356,   940,    -1,    24,   558,
     197,   930,   265,   356,   940,    -1,    24,   198,   247,   549,
     265,   356,   940,    -1,    24,   254,   695,   694,   265,   356,
     940,    -1,    24,   254,    61,   628,   376,   932,   265,   356,
     940,    -1,    24,   254,   140,   628,   376,   932,   265,   356,
     940,    -1,    24,   311,   930,   265,   356,   940,    -1,    24,
     365,   628,   265,   356,   940,    -1,    24,   348,   930,   265,
     356,   940,    -1,    24,   352,   313,   113,   628,   265,   356,
     940,    -1,    24,   352,   313,    72,   628,   265,   356,   940,
      -1,    24,   147,    97,   396,   930,   265,   356,   940,    -1,
      24,   320,   930,   265,   356,   940,    -1,    24,    98,   931,
     712,    -1,    24,   311,   930,   712,    -1,    24,   346,   836,
     712,    -1,    24,   346,   836,    24,   707,   942,   712,    -1,
      24,   317,   928,   712,    -1,    24,   387,   928,   712,    -1,
      24,   152,   649,   712,    -1,    24,    21,   936,   605,   712,
      -1,    24,   198,   247,   938,   712,    -1,    24,   365,   628,
     712,    -1,   315,   196,   356,   939,    -1,    81,   670,   309,
     930,    31,   252,   718,   356,   928,   840,   117,   719,   714,
      -1,   239,    -1,   716,    -1,   426,   715,   427,    -1,   715,
     429,   717,    -1,   717,    -1,   793,    -1,   771,    -1,   782,
      -1,   776,    -1,   721,    -1,   716,    -1,    -1,   316,    -1,
     374,    -1,   109,    -1,   183,    -1,   184,    -1,    23,    -1,
      -1,   121,   309,   930,   252,   928,   480,    -1,   121,   309,
     165,   135,   930,   252,   928,   480,    -1,   240,   942,   722,
      -1,   430,   939,    -1,    -1,   208,   942,    -1,   372,   942,
      -1,   372,   419,    -1,    14,   726,    -1,    40,   726,   729,
      -1,   333,   358,   729,    -1,    69,   726,    -1,   127,   726,
      -1,   306,   726,    -1,   310,   942,    -1,   293,   310,   942,
      -1,   293,   942,    -1,   306,   726,   356,   310,   942,    -1,
     306,   726,   356,   942,    -1,   276,   358,   939,    -1,    69,
     277,   939,    -1,   306,   277,   939,    -1,   395,    -1,   358,
      -1,    -1,   193,   205,   463,    -1,   285,   253,    -1,   285,
     397,    -1,   727,    -1,   728,   430,   727,    -1,   728,   727,
      -1,   728,    -1,    -1,    81,   503,   387,   928,   521,    31,
     793,   731,    -1,    81,   257,   296,   503,   387,   928,   521,
      31,   793,   731,    -1,   393,    59,   255,    -1,   393,    51,
      59,   255,    -1,   393,   210,    59,   255,    -1,    -1,   209,
     935,    -1,    81,    98,   931,   437,   734,    -1,   734,   735,
      -1,    -1,   348,   736,   930,    -1,   348,   736,   104,    -1,
     213,   736,   939,    -1,   213,   736,   104,    -1,   350,   736,
     930,    -1,   350,   736,   104,    -1,   125,   736,   939,    -1,
     125,   736,   938,    -1,   125,   736,   104,    -1,   200,   736,
     939,    -1,   200,   736,   104,    -1,   201,   736,   939,    -1,
     201,   736,   104,    -1,    73,   207,   736,   941,    -1,   265,
     736,   930,    -1,   265,   736,   104,    -1,   413,    -1,    -1,
      24,    98,   931,   437,   739,    -1,    24,    98,   931,   323,
     348,   930,    -1,    24,    98,   931,   469,    -1,   739,   740,
      -1,    -1,    73,   207,   736,   941,    -1,   121,    98,   931,
      -1,   121,    98,   165,   135,   931,    -1,    81,   119,   628,
     744,   844,   512,    -1,    24,   119,   628,   479,    -1,    24,
     119,   628,   121,   238,   243,    -1,    24,   119,   628,   323,
     238,   243,    -1,    24,   119,   628,    18,   519,    -1,    24,
     119,   628,   121,    74,   930,   480,    -1,    31,    -1,    -1,
      24,   352,   313,   113,   628,   601,    -1,    24,   352,   313,
      72,   628,    18,   216,   145,   929,   393,   627,    -1,    24,
     352,   313,    72,   628,    24,   216,   145,   929,   393,   627,
      -1,    24,   352,   313,    72,   628,    24,   216,   296,   628,
     393,   628,    -1,    24,   352,   313,    72,   628,    24,   216,
     145,   929,   296,   628,   393,   628,    -1,    24,   352,   313,
      72,   628,   121,   216,   145,   929,    -1,    24,   352,   313,
      72,   628,   121,   216,   165,   135,   145,   929,    -1,    81,
     614,    78,   628,   145,   939,   356,   939,   150,   628,    -1,
      63,   755,   928,   749,    -1,    63,   755,    -1,    63,   755,
     934,   252,   928,    -1,   376,   934,    -1,    -1,   377,   756,
     757,   755,    -1,   377,   756,   757,   755,   928,    -1,   377,
     756,   757,   755,   753,    -1,   377,   426,   751,   427,    -1,
     377,   426,   751,   427,   928,   758,    -1,   752,    -1,   751,
     430,   752,    -1,   754,    -1,   385,    -1,   149,    -1,   151,
      -1,   754,   755,    -1,   754,   755,   928,   758,    -1,    27,
      -1,    26,    -1,   385,    -1,    -1,   151,    -1,    -1,   149,
      -1,    -1,   426,   929,   427,    -1,    -1,   136,   760,    -1,
     136,   754,   755,   760,    -1,   136,   385,   760,    -1,   136,
     426,   761,   427,   760,    -1,   793,    -1,   771,    -1,   782,
      -1,   776,    -1,   789,    -1,   537,    -1,   768,    -1,   762,
      -1,   761,   430,   762,    -1,   763,   764,    -1,   942,    -1,
     754,    -1,   385,    -1,   464,    -1,   549,    -1,    -1,   276,
     930,   766,    31,   767,    -1,   426,   899,   427,    -1,    -1,
     793,    -1,   771,    -1,   782,    -1,   776,    -1,   134,   930,
     769,    -1,    81,   503,   346,   538,    31,   134,   930,   769,
      -1,   426,   896,   427,    -1,    -1,   100,   930,    -1,   100,
     276,   930,    -1,   100,    22,    -1,   100,   276,    22,    -1,
     183,   189,   928,   772,   775,    -1,   793,    -1,   426,   773,
     427,   793,    -1,   104,   381,    -1,   774,    -1,   773,   430,
     774,    -1,   942,   920,    -1,   301,   925,    -1,    -1,   109,
     150,   838,   777,   841,   775,    -1,   376,   829,    -1,    -1,
     214,   803,   837,   779,   781,    -1,   170,   780,   221,    -1,
      -1,    16,   325,    -1,   307,   325,    -1,   307,   133,    -1,
     325,   374,   133,    -1,   325,    -1,   325,   307,   133,    -1,
     133,    -1,    16,   133,    -1,   242,    -1,    -1,   374,   838,
     323,   783,   828,   841,   775,    -1,   784,    -1,   783,   430,
     784,    -1,   785,    -1,   786,    -1,   787,   413,   922,    -1,
     426,   788,   427,   413,   924,    -1,   942,   920,    -1,   787,
      -1,   788,   430,   787,    -1,   103,   790,   791,    95,   792,
     145,   793,    -1,   930,    -1,    -1,   791,   230,   312,    -1,
     791,   312,    -1,   791,    43,    -1,   791,   182,    -1,    -1,
     393,   162,    -1,   394,   162,    -1,   795,    -1,   794,    -1,
     426,   795,   427,    -1,   426,   794,   427,    -1,   797,    -1,
     796,   807,    -1,   796,   806,   822,   811,    -1,   796,   806,
     810,   823,    -1,   798,   796,    -1,   798,   796,   807,    -1,
     798,   796,   806,   822,   811,    -1,   798,   796,   806,   810,
     823,    -1,   797,    -1,   794,    -1,   316,   805,   925,   801,
     828,   840,   820,   821,   879,    -1,   827,    -1,   346,   836,
      -1,   796,   369,   804,   796,    -1,   796,   187,   804,   796,
      -1,   796,   130,   804,   796,    -1,   393,   799,    -1,   393,
     289,   799,    -1,   800,    -1,   799,   430,   800,    -1,   930,
     758,    31,   794,    -1,   189,   802,    -1,    -1,   351,   803,
     928,    -1,   349,   803,   928,    -1,   210,   351,   803,   928,
      -1,   210,   349,   803,   928,    -1,   154,   351,   803,   928,
      -1,   154,   349,   803,   928,    -1,   346,   928,    -1,   928,
      -1,   346,    -1,    -1,    22,    -1,   116,    -1,    -1,   116,
      -1,   116,   252,   426,   896,   427,    -1,    22,    -1,    -1,
     807,    -1,    -1,   258,    47,   808,    -1,   809,    -1,   808,
     430,   809,    -1,   868,   376,   894,   668,    -1,   868,   667,
     668,    -1,   812,   813,    -1,   813,   812,    -1,   812,    -1,
     813,    -1,   810,    -1,    -1,   207,   814,    -1,   207,   814,
     430,   815,    -1,   141,   819,   816,   818,   253,    -1,   250,
     815,    -1,   250,   817,   818,    -1,   868,    -1,    22,    -1,
     868,    -1,   941,    -1,   426,   868,   427,    -1,    -1,   870,
      -1,   307,    -1,   308,    -1,   142,    -1,   229,    -1,   158,
      47,   896,    -1,    -1,   160,   868,    -1,    -1,   824,    -1,
     145,   285,   253,    -1,   822,    -1,    -1,   825,    -1,   824,
     825,    -1,   145,   374,   826,   781,    -1,   145,   325,   826,
     781,    -1,   248,   927,    -1,    -1,   381,   924,    -1,   827,
     430,   924,    -1,   150,   829,    -1,    -1,   830,    -1,   829,
     430,   830,    -1,   836,    -1,   836,   832,    -1,   839,    -1,
     839,   832,    -1,   839,    31,   426,   842,   427,    -1,   839,
      31,   942,   426,   842,   427,    -1,   839,   942,   426,   842,
     427,    -1,   794,    -1,   794,   832,    -1,   831,    -1,   426,
     831,   427,   832,    -1,   426,   831,   427,    -1,   830,    85,
     194,   830,    -1,   830,   833,   194,   830,   835,    -1,   830,
     194,   830,   835,    -1,   830,   227,   833,   194,   830,    -1,
     830,   227,   194,   830,    -1,    31,   942,   426,   929,   427,
      -1,    31,   942,    -1,   942,   426,   929,   427,    -1,   942,
      -1,   151,   834,    -1,   204,   834,    -1,   304,   834,    -1,
     179,    -1,   260,    -1,    -1,   376,   426,   929,   427,    -1,
     252,   868,    -1,   928,    -1,   928,   419,    -1,   253,   928,
      -1,   253,   426,   928,   427,    -1,   836,    -1,   837,   430,
     836,    -1,   836,    -1,   836,   942,    -1,   836,    31,   942,
      -1,   871,    -1,   390,   868,    -1,    -1,   390,   868,    -1,
     390,    87,   248,   930,    -1,    -1,   843,    -1,   842,   430,
     843,    -1,   942,   844,    -1,   846,   845,    -1,   324,   846,
     845,    -1,   846,    30,   424,   938,   425,    -1,   324,   846,
      30,   424,   938,   425,    -1,   846,    30,    -1,   324,   846,
      30,    -1,   845,   424,   425,    -1,   845,   424,   938,   425,
      -1,    -1,   848,    -1,   850,    -1,   852,    -1,   856,    -1,
     863,    -1,   864,   866,    -1,   864,   426,   938,   427,   866,
      -1,   850,    -1,   853,    -1,   857,    -1,   863,    -1,   943,
     849,    -1,   943,   629,   849,    -1,   426,   896,   427,    -1,
      -1,   185,    -1,   186,    -1,   329,    -1,    42,    -1,   286,
      -1,   143,   851,    -1,   120,   274,    -1,   102,   849,    -1,
     101,   849,    -1,   246,   849,    -1,    45,    -1,   426,   938,
     427,    -1,    -1,   854,    -1,   855,    -1,   854,    -1,   855,
      -1,    44,   861,   426,   896,   427,    -1,    44,   861,    -1,
     858,    -1,   859,    -1,   858,    -1,   859,    -1,   860,   426,
     938,   427,   862,    -1,   860,   862,    -1,    57,   861,    -1,
      56,   861,    -1,   382,    -1,   226,    57,   861,    -1,   226,
      56,   861,    -1,   228,   861,    -1,   384,    -1,    -1,    57,
     323,   942,    -1,    -1,   355,   426,   938,   427,   865,    -1,
     355,   865,    -1,   354,   426,   938,   427,   865,    -1,   354,
     865,    -1,   188,    -1,   412,   409,    -1,   394,   354,   409,
      -1,    -1,   407,    -1,   222,    -1,    99,    -1,   163,    -1,
     219,    -1,   867,    -1,   407,   356,   222,    -1,    99,   356,
     163,    -1,    99,   356,   219,    -1,    99,   356,   867,    -1,
     163,   356,   219,    -1,   163,   356,   867,    -1,   219,   356,
     867,    -1,    -1,   314,    -1,   314,   426,   938,   427,    -1,
     870,    -1,   868,    11,   844,    -1,   868,    36,   354,   409,
     868,    -1,   417,   868,    -1,   418,   868,    -1,   868,   417,
     868,    -1,   868,   418,   868,    -1,   868,   419,   868,    -1,
     868,   420,   868,    -1,   868,   421,   868,    -1,   868,   422,
     868,    -1,   868,   414,   868,    -1,   868,   415,   868,    -1,
     868,   413,   868,    -1,   868,   893,   868,    -1,   893,   868,
      -1,   868,   893,    -1,   868,    28,   868,    -1,   868,   257,
     868,    -1,   238,   868,    -1,   868,   206,   868,    -1,   868,
     206,   868,   129,   868,    -1,   868,   238,   206,   868,    -1,
     868,   238,   206,   868,   129,   868,    -1,   868,   166,   868,
      -1,   868,   166,   868,   129,   868,    -1,   868,   238,   166,
     868,    -1,   868,   238,   166,   868,   129,   868,    -1,   868,
     327,   356,   868,    -1,   868,   327,   356,   868,   129,   868,
      -1,   868,   238,   327,   356,   868,    -1,   868,   238,   327,
     356,   868,   129,   868,    -1,   868,   191,   243,    -1,   868,
     192,    -1,   868,   191,   238,   243,    -1,   868,   241,    -1,
     889,   262,   889,    -1,   868,   191,   362,    -1,   868,   191,
     238,   362,    -1,   868,   191,   139,    -1,   868,   191,   238,
     139,    -1,   868,   191,   371,    -1,   868,   191,   238,   371,
      -1,   868,   191,   116,   150,   868,    -1,   868,   191,   238,
     116,   150,   868,    -1,   868,   191,   248,   426,   899,   427,
      -1,   868,   191,   238,   248,   426,   899,   427,    -1,   868,
      41,   921,   869,    28,   869,    -1,   868,   238,    41,   921,
     869,    28,   869,    -1,   868,    41,   343,   869,    28,   869,
      -1,   868,   238,    41,   343,   869,    28,   869,    -1,   868,
     170,   911,    -1,   868,   238,   170,   911,    -1,   868,   895,
     890,   794,    -1,   868,   895,   890,   426,   868,   427,    -1,
     370,   794,    -1,   868,   191,   118,    -1,   868,   191,   238,
     118,    -1,   870,    -1,   869,    11,   844,    -1,   417,   869,
      -1,   418,   869,    -1,   869,   417,   869,    -1,   869,   418,
     869,    -1,   869,   419,   869,    -1,   869,   420,   869,    -1,
     869,   421,   869,    -1,   869,   422,   869,    -1,   869,   414,
     869,    -1,   869,   415,   869,    -1,   869,   413,   869,    -1,
     869,   893,   869,    -1,   893,   869,    -1,   869,   893,    -1,
     869,   191,   116,   150,   869,    -1,   869,   191,   238,   116,
     150,   869,    -1,   869,   191,   248,   426,   899,   427,    -1,
     869,   191,   238,   248,   426,   899,   427,    -1,   869,   191,
     118,    -1,   869,   191,   238,   118,    -1,   917,    -1,   937,
      -1,    10,   920,    -1,   426,   868,   427,   920,    -1,   912,
      -1,   871,    -1,   794,    -1,   135,   794,    -1,    30,   794,
      -1,    30,   900,    -1,   889,    -1,   936,   426,   427,   882,
      -1,   936,   426,   897,   427,   882,    -1,   936,   426,   383,
     898,   427,   882,    -1,   936,   426,   897,   430,   383,   898,
     427,   882,    -1,   936,   426,   897,   807,   427,   882,    -1,
     936,   426,    22,   897,   806,   427,   882,    -1,   936,   426,
     116,   897,   806,   427,   882,    -1,   936,   426,   419,   427,
     882,    -1,    89,    -1,    92,    -1,    92,   426,   938,   427,
      -1,    93,    -1,    93,   426,   938,   427,    -1,   211,    -1,
     211,   426,   938,   427,    -1,   212,    -1,   212,   426,   938,
     427,    -1,    90,    -1,    94,    -1,   322,    -1,   375,    -1,
      88,    -1,    91,    -1,    53,   426,   868,    31,   844,   427,
      -1,   138,   426,   902,   427,    -1,   263,   426,   904,   427,
      -1,   272,   426,   906,   427,    -1,   341,   426,   907,   427,
      -1,   359,   426,   868,    31,   844,   427,    -1,   361,   426,
      46,   910,   427,    -1,   361,   426,   202,   910,   427,    -1,
     361,   426,   357,   910,   427,    -1,   361,   426,   910,   427,
      -1,   244,   426,   868,   430,   868,   427,    -1,    64,   426,
     896,   427,    -1,   157,   426,   896,   427,    -1,   203,   426,
     896,   427,    -1,   400,   426,   896,   427,    -1,   401,   426,
     224,   944,   427,    -1,   401,   426,   224,   944,   430,   874,
     427,    -1,   401,   426,   224,   944,   430,   896,   427,    -1,
     401,   426,   224,   944,   430,   874,   430,   896,   427,    -1,
     402,   426,   875,   427,    -1,   403,   426,   877,   868,   878,
     427,    -1,   404,   426,   224,   944,   427,    -1,   404,   426,
     224,   944,   430,   868,   427,    -1,   405,   426,   868,   430,
     872,   873,   427,    -1,   406,   426,   877,   868,    31,   846,
     427,    -1,   386,   868,    -1,   386,   230,   380,    -1,   430,
     332,   408,    -1,   430,   332,   230,    -1,   430,   332,   230,
     380,    -1,    -1,   399,   426,   875,   427,    -1,   876,    -1,
     875,   430,   876,    -1,   868,    31,   944,    -1,   868,    -1,
     118,    -1,    76,    -1,   275,   391,    -1,   340,   391,    -1,
      -1,   392,   880,    -1,    -1,   881,    -1,   880,   430,   881,
      -1,   942,    31,   883,    -1,   261,   883,    -1,   261,   942,
      -1,    -1,   426,   884,   885,   806,   886,   427,    -1,   942,
      -1,    -1,   268,    47,   896,    -1,    -1,   284,   887,    -1,
     308,   887,    -1,    -1,   888,    -1,    41,   888,    28,   888,
      -1,   366,   273,    -1,   366,   144,    -1,    87,   307,    -1,
     868,   273,    -1,   868,   144,    -1,   307,   426,   896,   427,
      -1,   307,   426,   427,    -1,   426,   896,   430,   868,   427,
      -1,    29,    -1,   330,    -1,    22,    -1,     8,    -1,   892,
      -1,   417,    -1,   418,    -1,   419,    -1,   420,    -1,   421,
      -1,   422,    -1,   414,    -1,   415,    -1,   413,    -1,     8,
      -1,   254,   426,   695,   427,    -1,   891,    -1,   254,   426,
     695,   427,    -1,   891,    -1,   254,   426,   695,   427,    -1,
     206,    -1,   238,   206,    -1,   166,    -1,   238,   166,    -1,
     868,    -1,   896,   430,   868,    -1,   898,    -1,   897,   430,
     898,    -1,   868,    -1,   677,    13,   868,    -1,   844,    -1,
     899,   430,   844,    -1,   424,   896,   425,    -1,   424,   901,
     425,    -1,   424,   425,    -1,   900,    -1,   901,   430,   900,
      -1,   903,   150,   868,    -1,    -1,     3,    -1,   407,    -1,
     222,    -1,    99,    -1,   163,    -1,   219,    -1,   314,    -1,
     939,    -1,   868,   905,   908,   909,    -1,   868,   905,   908,
      -1,   270,   868,    -1,   869,   170,   869,    -1,    -1,   868,
     908,   909,    -1,   868,   909,   908,    -1,   868,   908,    -1,
     868,   909,    -1,   896,    -1,    -1,   150,   868,    -1,   145,
     868,    -1,   868,   150,   896,    -1,   150,   896,    -1,   896,
      -1,   794,    -1,   426,   896,   427,    -1,    52,   916,   913,
     915,   127,    -1,   914,    -1,   913,   914,    -1,   389,   868,
     353,   868,    -1,   123,   868,    -1,    -1,   868,    -1,    -1,
     942,    -1,   942,   919,    -1,   428,   933,    -1,   428,   419,
      -1,   424,   868,   425,    -1,   424,   868,   431,   868,   425,
      -1,   918,    -1,   919,   918,    -1,    -1,   920,   918,    -1,
      35,    -1,    -1,   868,    -1,   104,    -1,   922,    -1,   923,
     430,   922,    -1,   426,   923,   427,    -1,   926,    -1,   925,
     430,   926,    -1,   868,    31,   944,    -1,   868,     3,    -1,
     868,    -1,   419,    -1,   928,    -1,   927,   430,   928,    -1,
     942,    -1,   942,   919,    -1,   930,    -1,   929,   430,   930,
      -1,   942,    -1,   942,    -1,   942,    -1,   944,    -1,   942,
      -1,   939,    -1,   943,    -1,   942,   919,    -1,   938,    -1,
       4,    -1,   939,    -1,     6,    -1,     7,    -1,   936,   939,
      -1,   936,   426,   897,   427,   939,    -1,   847,   939,    -1,
     864,   939,   866,    -1,   864,   426,   938,   427,   939,   866,
      -1,   362,    -1,   139,    -1,   243,    -1,     9,    -1,     5,
      -1,   942,    -1,   938,    -1,   417,   938,    -1,   418,   938,
      -1,     3,    -1,   945,    -1,   946,    -1,     3,    -1,   945,
      -1,   947,    -1,     3,    -1,   945,    -1,   946,    -1,   947,
      -1,   948,    -1,    14,    -1,    15,    -1,    16,    -1,    17,
      -1,    18,    -1,    19,    -1,    20,    -1,    21,    -1,    23,
      -1,    24,    -1,    25,    -1,    33,    -1,    34,    -1,    36,
      -1,    38,    -1,    39,    -1,    40,    -1,    47,    -1,    48,
      -1,    49,    -1,    50,    -1,    51,    -1,    54,    -1,    55,
      -1,    58,    -1,    60,    -1,    61,    -1,    62,    -1,    63,
      -1,    67,    -1,    68,    -1,    69,    -1,    70,    -1,    72,
      -1,    73,    -1,    75,    -1,    76,    -1,    77,    -1,    78,
      -1,    79,    -1,    80,    -1,    82,    -1,    83,    -1,    84,
      -1,    86,    -1,    87,    -1,    95,    -1,    96,    -1,    97,
      -1,    98,    -1,    99,    -1,   100,    -1,   103,    -1,   105,
      -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,   111,
      -1,   113,    -1,   114,    -1,   115,    -1,   118,    -1,   119,
      -1,   120,    -1,   121,    -1,   122,    -1,   124,    -1,   125,
      -1,   126,    -1,   128,    -1,   129,    -1,   131,    -1,   132,
      -1,   133,    -1,   134,    -1,   136,    -1,   137,    -1,   140,
      -1,   142,    -1,   144,    -1,   146,    -1,   148,    -1,   152,
      -1,   153,    -1,   154,    -1,   156,    -1,   159,    -1,   161,
      -1,   162,    -1,   163,    -1,   164,    -1,   165,    -1,   167,
      -1,   168,    -1,   169,    -1,   171,    -1,   172,    -1,   173,
      -1,   174,    -1,   175,    -1,   176,    -1,   178,    -1,   181,
      -1,   182,    -1,   183,    -1,   184,    -1,   190,    -1,   193,
      -1,   195,    -1,   196,    -1,   197,    -1,   198,    -1,   199,
      -1,   200,    -1,   201,    -1,   205,    -1,   208,    -1,   209,
      -1,   210,    -1,   213,    -1,   214,    -1,   215,    -1,   216,
      -1,   217,    -1,   218,    -1,   219,    -1,   220,    -1,   221,
      -1,   222,    -1,   223,    -1,   224,    -1,   225,    -1,   229,
      -1,   230,    -1,   231,    -1,   232,    -1,   233,    -1,   234,
      -1,   235,    -1,   237,    -1,   239,    -1,   240,    -1,   242,
      -1,   245,    -1,   247,    -1,   248,    -1,   249,    -1,   251,
      -1,   254,    -1,   255,    -1,   256,    -1,   264,    -1,   265,
      -1,   266,    -1,   267,    -1,   268,    -1,   269,    -1,   271,
      -1,   273,    -1,   276,    -1,   277,    -1,   275,    -1,   279,
      -1,   280,    -1,   281,    -1,   282,    -1,   283,    -1,   284,
      -1,   285,    -1,   287,    -1,   288,    -1,   289,    -1,   291,
      -1,   292,    -1,   293,    -1,   294,    -1,   295,    -1,   296,
      -1,   297,    -1,   298,    -1,   299,    -1,   300,    -1,   302,
      -1,   303,    -1,   305,    -1,   306,    -1,   308,    -1,   309,
      -1,   310,    -1,   311,    -1,   312,    -1,   313,    -1,   314,
      -1,   315,    -1,   317,    -1,   318,    -1,   319,    -1,   320,
      -1,   321,    -1,   323,    -1,   325,    -1,   326,    -1,   328,
      -1,   331,    -1,   332,    -1,   333,    -1,   334,    -1,   335,
      -1,   336,    -1,   337,    -1,   338,    -1,   339,    -1,   340,
      -1,   342,    -1,   344,    -1,   345,    -1,   347,    -1,   348,
      -1,   349,    -1,   350,    -1,   351,    -1,   352,    -1,   358,
      -1,   360,    -1,   363,    -1,   364,    -1,   365,    -1,   366,
      -1,   367,    -1,   368,    -1,   371,    -1,   372,    -1,   373,
      -1,   374,    -1,   377,    -1,   378,    -1,   379,    -1,   380,
      -1,   384,    -1,   386,    -1,   387,    -1,   388,    -1,   391,
      -1,   394,    -1,   395,    -1,   396,    -1,   397,    -1,   398,
      -1,   407,    -1,   408,    -1,   409,    -1,    41,    -1,    42,
      -1,    44,    -1,    45,    -1,    56,    -1,    57,    -1,    64,
      -1,   101,    -1,   102,    -1,   135,    -1,   138,    -1,   143,
      -1,   157,    -1,   180,    -1,   185,    -1,   186,    -1,   188,
      -1,   203,    -1,   226,    -1,   228,    -1,   236,    -1,   244,
      -1,   246,    -1,   259,    -1,   263,    -1,   272,    -1,   274,
      -1,   286,    -1,   307,    -1,   324,    -1,   329,    -1,   341,
      -1,   354,    -1,   355,    -1,   359,    -1,   361,    -1,   381,
      -1,   382,    -1,   399,    -1,   400,    -1,   401,    -1,   402,
      -1,   403,    -1,   404,    -1,   405,    -1,   406,    -1,    37,
      -1,    43,    -1,    71,    -1,    85,    -1,    91,    -1,   149,
      -1,   151,    -1,   166,    -1,   179,    -1,   191,    -1,   192,
      -1,   194,    -1,   204,    -1,   206,    -1,   227,    -1,   241,
      -1,   260,    -1,   261,    -1,   262,    -1,   304,    -1,   327,
      -1,   385,    -1,    22,    -1,    26,    -1,    27,    -1,    28,
      -1,    29,    -1,    30,    -1,    31,    -1,    32,    -1,    35,
      -1,    46,    -1,    52,    -1,    53,    -1,    59,    -1,    65,
      -1,    66,    -1,    74,    -1,    81,    -1,    88,    -1,    89,
      -1,    90,    -1,    92,    -1,    93,    -1,    94,    -1,   104,
      -1,   106,    -1,   112,    -1,   116,    -1,   117,    -1,   123,
      -1,   127,    -1,   130,    -1,   139,    -1,   141,    -1,   145,
      -1,   147,    -1,   150,    -1,   155,    -1,   158,    -1,   160,
      -1,   170,    -1,   177,    -1,   187,    -1,   189,    -1,   202,
      -1,   207,    -1,   211,    -1,   212,    -1,   238,    -1,   243,
      -1,   250,    -1,   252,    -1,   253,    -1,   257,    -1,   258,
      -1,   270,    -1,   278,    -1,   290,    -1,   301,    -1,   316,
      -1,   322,    -1,   330,    -1,   343,    -1,   346,    -1,   353,
      -1,   356,    -1,   357,    -1,   362,    -1,   369,    -1,   370,
      -1,   375,    -1,   376,    -1,   383,    -1,   389,    -1,   390,
      -1,   392,    -1,   393,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   625,   625,   632,   639,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   753,   763,
     774,   775,   784,   785,   789,   790,   794,   799,   803,   808,
     813,   817,   821,   825,   829,   833,   837,   841,   845,   850,
     854,   858,   862,   866,   871,   878,   880,   884,   888,   892,
     896,   910,   928,   939,   940,   944,   962,   974,   995,  1002,
    1021,  1028,  1045,  1063,  1074,  1075,  1087,  1094,  1111,  1123,
    1135,  1136,  1140,  1141,  1149,  1150,  1151,  1152,  1153,  1154,
    1168,  1174,  1180,  1189,  1197,  1205,  1212,  1219,  1227,  1238,
    1246,  1254,  1262,  1270,  1281,  1289,  1297,  1304,  1314,  1315,
    1322,  1323,  1326,  1328,  1332,  1333,  1334,  1335,  1339,  1340,
    1341,  1347,  1359,  1363,  1367,  1382,  1405,  1406,  1407,  1411,
    1412,  1413,  1417,  1418,  1422,  1429,  1436,  1443,  1450,  1460,
    1461,  1466,  1472,  1478,  1484,  1490,  1500,  1510,  1511,  1515,
    1516,  1524,  1539,  1545,  1551,  1557,  1575,  1583,  1591,  1599,
    1610,  1611,  1616,  1624,  1632,  1641,  1649,  1657,  1666,  1675,
    1684,  1693,  1703,  1716,  1726,  1734,  1744,  1754,  1761,  1768,
    1775,  1782,  1790,  1798,  1806,  1814,  1822,  1829,  1836,  1844,
    1851,  1858,  1866,  1874,  1882,  1890,  1898,  1906,  1914,  1922,
    1930,  1940,  1941,  1945,  1946,  1947,  1951,  1952,  1956,  1959,
    1960,  1964,  1965,  1970,  1974,  1978,  1983,  1998,  2004,  2031,
    2053,  2067,  2068,  2077,  2078,  2079,  2082,  2083,  2088,  2089,
    2093,  2097,  2101,  2105,  2109,  2113,  2117,  2121,  2125,  2129,
    2133,  2142,  2146,  2150,  2154,  2158,  2162,  2166,  2167,  2172,
    2176,  2183,  2190,  2191,  2192,  2193,  2194,  2198,  2202,  2210,
    2221,  2235,  2259,  2260,  2261,  2262,  2263,  2264,  2265,  2269,
    2270,  2274,  2275,  2279,  2283,  2290,  2294,  2301,  2302,  2303,
    2307,  2308,  2311,  2322,  2333,  2334,  2338,  2346,  2347,  2366,
    2373,  2380,  2390,  2400,  2409,  2418,  2447,  2454,  2461,  2468,
    2487,  2497,  2498,  2499,  2503,  2504,  2505,  2506,  2507,  2508,
    2517,  2525,  2529,  2543,  2556,  2569,  2585,  2605,  2606,  2610,
    2611,  2614,  2620,  2624,  2632,  2637,  2643,  2644,  2648,  2653,
    2660,  2661,  2671,  2673,  2675,  2677,  2680,  2683,  2686,  2690,
    2691,  2692,  2693,  2694,  2697,  2698,  2703,  2704,  2705,  2706,
    2709,  2710,  2711,  2712,  2715,  2716,  2719,  2720,  2730,  2755,
    2767,  2768,  2772,  2773,  2777,  2793,  2794,  2795,  2808,  2820,
    2829,  2830,  2833,  2834,  2837,  2841,  2845,  2849,  2853,  2857,
    2861,  2865,  2869,  2873,  2877,  2881,  2887,  2888,  2892,  2893,
    2898,  2901,  2902,  2914,  2926,  2941,  2942,  2950,  2951,  2955,
    2956,  2960,  2961,  2965,  2966,  2970,  2978,  2989,  2990,  3000,
    3010,  3011,  3024,  3031,  3047,  3064,  3072,  3089,  3098,  3106,
    3117,  3118,  3122,  3126,  3134,  3138,  3142,  3149,  3153,  3158,
    3163,  3170,  3177,  3182,  3192,  3206,  3207,  3212,  3213,  3217,
    3218,  3228,  3236,  3253,  3262,  3270,  3286,  3298,  3299,  3300,
    3310,  3318,  3335,  3354,  3374,  3398,  3399,  3403,  3405,  3427,
    3429,  3431,  3433,  3435,  3440,  3445,  3455,  3456,  3460,  3461,
    3465,  3466,  3470,  3471,  3472,  3476,  3482,  3483,  3484,  3485,
    3486,  3490,  3491,  3495,  3497,  3506,  3513,  3523,  3527,  3528,
    3532,  3533,  3538,  3548,  3570,  3589,  3612,  3622,  3633,  3643,
    3653,  3664,  3700,  3707,  3716,  3725,  3734,  3745,  3748,  3749,
    3752,  3756,  3763,  3764,  3765,  3766,  3767,  3770,  3771,  3774,
    3777,  3778,  3786,  3793,  3794,  3797,  3799,  3816,  3831,  3832,
    3836,  3845,  3854,  3863,  3873,  3882,  3883,  3886,  3887,  3890,
    3904,  3909,  3919,  3928,  3940,  3941,  3945,  3953,  3965,  3974,
    3986,  3995,  4016,  4026,  4044,  4053,  4065,  4066,  4067,  4068,
    4069,  4070,  4071,  4072,  4073,  4074,  4075,  4076,  4080,  4081,
    4084,  4085,  4088,  4090,  4103,  4114,  4115,  4116,  4141,  4150,
    4159,  4168,  4177,  4186,  4195,  4205,  4214,  4223,  4232,  4241,
    4250,  4259,  4267,  4275,  4283,  4294,  4295,  4296,  4297,  4298,
    4299,  4300,  4301,  4302,  4303,  4304,  4305,  4309,  4310,  4320,
    4326,  4334,  4342,  4350,  4358,  4366,  4374,  4382,  4390,  4398,
    4406,  4414,  4422,  4430,  4438,  4446,  4454,  4464,  4465,  4468,
    4469,  4479,  4495,  4509,  4535,  4537,  4539,  4541,  4548,  4557,
    4558,  4561,  4568,  4575,  4582,  4596,  4604,  4612,  4620,  4628,
    4636,  4644,  4652,  4660,  4668,  4676,  4684,  4692,  4700,  4712,
    4713,  4716,  4726,  4740,  4741,  4745,  4746,  4751,  4767,  4780,
    4790,  4802,  4803,  4806,  4807,  4817,  4827,  4828,  4832,  4836,
    4840,  4851,  4864,  4878,  4895,  4896,  4897,  4909,  4928,  4929,
    4933,  4934,  4938,  4939,  4943,  4944,  4947,  4948,  4956,  4966,
    4976,  4988,  4989,  4990,  4993,  4994,  4995,  4998,  4999,  5000,
    5016,  5028,  5041,  5056,  5057,  5060,  5061,  5065,  5066,  5074,
    5075,  5079,  5080,  5095,  5104,  5113,  5122,  5131,  5143,  5144,
    5145,  5146,  5147,  5153,  5157,  5172,  5173,  5179,  5189,  5193,
    5198,  5208,  5209,  5216,  5220,  5224,  5228,  5232,  5236,  5240,
    5244,  5248,  5252,  5256,  5260,  5264,  5272,  5276,  5280,  5284,
    5290,  5291,  5298,  5299,  5302,  5314,  5318,  5333,  5344,  5345,
    5350,  5351,  5366,  5376,  5389,  5399,  5412,  5422,  5435,  5443,
    5445,  5447,  5452,  5454,  5467,  5476,  5477,  5481,  5485,  5497,
    5508,  5519,  5532,  5533,  5534,  5538,  5549,  5550,  5564,  5572,
    5582,  5595,  5596,  5599,  5600,  5610,  5619,  5627,  5635,  5644,
    5652,  5660,  5669,  5678,  5686,  5695,  5704,  5713,  5722,  5731,
    5740,  5748,  5756,  5764,  5773,  5782,  5790,  5798,  5806,  5814,
    5824,  5825,  5828,  5829,  5839,  5848,  5856,  5865,  5873,  5881,
    5889,  5905,  5914,  5922,  5930,  5938,  5947,  5955,  5963,  5972,
    5981,  5990,  5998,  6006,  6014,  6022,  6030,  6038,  6054,  6062,
    6070,  6078,  6087,  6095,  6103,  6112,  6121,  6129,  6139,  6151,
    6168,  6169,  6170,  6175,  6181,  6190,  6191,  6192,  6193,  6194,
    6198,  6199,  6202,  6203,  6204,  6205,  6209,  6210,  6211,  6216,
    6226,  6247,  6257,  6258,  6261,  6270,  6276,  6295,  6302,  6309,
    6316,  6323,  6330,  6337,  6345,  6353,  6361,  6369,  6377,  6384,
    6391,  6400,  6401,  6402,  6406,  6409,  6412,  6419,  6421,  6423,
    6428,  6430,  6442,  6453,  6467,  6473,  6479,  6485,  6495,  6511,
    6521,  6522,  6526,  6530,  6534,  6538,  6542,  6546,  6550,  6554,
    6558,  6562,  6566,  6570,  6574,  6578,  6582,  6586,  6596,  6597,
    6608,  6615,  6626,  6637,  6638,  6642,  6656,  6663,  6680,  6692,
    6701,  6709,  6717,  6726,  6737,  6738,  6749,  6759,  6769,  6779,
    6789,  6799,  6807,  6828,  6851,  6859,  6868,  6879,  6880,  6892,
    6906,  6920,  6932,  6944,  6961,  6962,  6966,  6967,  6968,  6969,
    6973,  6985,  7000,  7001,  7005,  7006,  7009,  7010,  7013,  7014,
    7018,  7019,  7032,  7039,  7049,  7056,  7066,  7067,  7068,  7069,
    7070,  7071,  7072,  7076,  7080,  7087,  7094,  7095,  7096,  7100,
    7101,  7102,  7112,  7122,  7123,  7127,  7128,  7129,  7130,  7140,
    7148,  7165,  7166,  7176,  7182,  7188,  7194,  7210,  7219,  7225,
    7231,  7240,  7242,  7247,  7258,  7259,  7270,  7283,  7284,  7295,
    7306,  7307,  7310,  7311,  7312,  7313,  7314,  7315,  7316,  7317,
    7320,  7321,  7332,  7349,  7350,  7354,  7355,  7359,  7367,  7395,
    7406,  7407,  7417,  7428,  7431,  7432,  7433,  7434,  7435,  7438,
    7439,  7440,  7488,  7489,  7493,  7494,  7508,  7509,  7516,  7524,
    7532,  7540,  7548,  7556,  7567,  7568,  7595,  7610,  7611,  7630,
    7634,  7638,  7653,  7660,  7670,  7671,  7674,  7686,  7696,  7704,
    7709,  7714,  7719,  7724,  7729,  7734,  7739,  7746,  7747,  7750,
    7751,  7752,  7759,  7760,  7761,  7762,  7766,  7767,  7771,  7775,
    7776,  7779,  7788,  7801,  7802,  7803,  7804,  7808,  7809,  7813,
    7815,  7825,  7830,  7833,  7838,  7839,  7847,  7857,  7858,  7859,
    7867,  7871,  7872,  7875,  7876,  7881,  7882,  7886,  7887,  7891,
    7892,  7896,  7897,  7901,  7902,  7906,  7914,  7925,  7926,  7931,
    7937,  7955,  7956,  7960,  7961,  7971,  7975,  7980,  7987,  7995,
    8002,  8012,  8022,  8050,  8057,  8061,  8087,  8091,  8103,  8116,
    8130,  8141,  8156,  8162,  8167,  8173,  8180,  8181,  8182,  8183,
    8187,  8188,  8200,  8201,  8206,  8213,  8220,  8227,  8238,  8239,
    8252,  8256,  8263,  8273,  8278,  8279,  8284,  8285,  8293,  8298,
    8302,  8308,  8329,  8334,  8341,  8346,  8352,  8357,  8366,  8368,
    8371,  8375,  8376,  8377,  8378,  8379,  8380,  8385,  8415,  8416,
    8417,  8418,  8429,  8435,  8443,  8444,  8450,  8455,  8460,  8465,
    8470,  8475,  8480,  8485,  8491,  8497,  8503,  8510,  8532,  8541,
    8545,  8553,  8557,  8565,  8577,  8598,  8602,  8608,  8612,  8625,
    8644,  8667,  8669,  8671,  8673,  8675,  8677,  8682,  8683,  8687,
    8688,  8695,  8704,  8712,  8721,  8732,  8740,  8741,  8742,  8746,
    8748,  8750,  8752,  8754,  8756,  8758,  8763,  8768,  8774,  8782,
    8787,  8794,  8801,  8805,  8809,  8839,  8840,  8842,  8864,  8866,
    8868,  8870,  8872,  8874,  8876,  8878,  8880,  8882,  8884,  8887,
    8889,  8891,  8894,  8896,  8898,  8901,  8903,  8916,  8918,  8931,
    8933,  8946,  8948,  8962,  8975,  8988,  9001,  9024,  9031,  9038,
    9045,  9052,  9056,  9063,  9070,  9077,  9084,  9091,  9098,  9102,
    9110,  9114,  9124,  9131,  9138,  9151,  9164,  9183,  9204,  9214,
    9221,  9237,  9242,  9260,  9262,  9264,  9266,  9268,  9270,  9272,
    9274,  9276,  9278,  9280,  9282,  9284,  9286,  9288,  9290,  9292,
    9296,  9301,  9305,  9309,  9314,  9331,  9332,  9333,  9348,  9360,
    9362,  9364,  9374,  9384,  9394,  9402,  9420,  9433,  9446,  9459,
    9472,  9485,  9502,  9515,  9538,  9559,  9569,  9582,  9599,  9612,
    9622,  9635,  9645,  9658,  9671,  9684,  9697,  9710,  9723,  9736,
    9738,  9751,  9769,  9783,  9799,  9821,  9837,  9850,  9863,  9876,
    9880,  9887,  9895,  9903,  9907,  9911,  9915,  9919,  9923,  9927,
    9936,  9940,  9944,  9949,  9963,  9965,  9969,  9971,  9973,  9976,
    9979,  9982,  9983,  9986,  9994, 10004, 10005, 10008, 10009, 10010,
   10017, 10018, 10022, 10023, 10028, 10036, 10038, 10052, 10055, 10082,
   10083, 10086, 10087, 10098, 10116, 10123, 10132, 10149, 10194, 10202,
   10210, 10218, 10226, 10247, 10248, 10249, 10252, 10253, 10254, 10257,
   10258, 10261, 10262, 10263, 10264, 10265, 10266, 10267, 10268, 10269,
   10272, 10274, 10279, 10281, 10286, 10288, 10290, 10292, 10294, 10296,
   10308, 10312, 10319, 10323, 10329, 10333, 10344, 10345, 10348, 10352,
   10356, 10362, 10363, 10368, 10372, 10379, 10380, 10381, 10382, 10383,
   10384, 10385, 10386, 10396, 10400, 10407, 10414, 10415, 10431, 10435,
   10440, 10444, 10459, 10464, 10468, 10471, 10474, 10475, 10476, 10479,
   10486, 10496, 10510, 10511, 10515, 10526, 10527, 10530, 10531, 10534,
   10538, 10545, 10549, 10553, 10560, 10570, 10571, 10575, 10576, 10579,
   10580, 10591, 10592, 10601, 10602, 10610, 10621, 10622, 10625, 10641,
   10649, 10657, 10679, 10680, 10691, 10699, 10727, 10729, 10734, 10737,
   10740, 10742, 10744, 10746, 10756, 10758, 10769, 10773, 10777, 10781,
   10785, 10794, 10801, 10826, 10830, 10836, 10853, 10857, 10861, 10867,
   10868, 10869, 10871, 10872, 10873, 10889, 10890, 10891, 10896, 10897,
   10898, 10904, 10905, 10906, 10907, 10908, 10928, 10929, 10930, 10931,
   10932, 10933, 10934, 10935, 10936, 10937, 10938, 10939, 10940, 10941,
   10942, 10943, 10944, 10945, 10946, 10947, 10948, 10949, 10950, 10951,
   10952, 10953, 10954, 10955, 10956, 10957, 10958, 10959, 10960, 10961,
   10962, 10963, 10964, 10965, 10966, 10967, 10968, 10969, 10970, 10971,
   10972, 10973, 10974, 10975, 10976, 10977, 10978, 10979, 10980, 10981,
   10982, 10983, 10984, 10985, 10986, 10987, 10988, 10989, 10990, 10991,
   10992, 10993, 10994, 10995, 10996, 10997, 10998, 10999, 11000, 11001,
   11002, 11003, 11004, 11005, 11006, 11007, 11008, 11009, 11010, 11011,
   11012, 11013, 11014, 11015, 11016, 11017, 11018, 11019, 11020, 11021,
   11022, 11023, 11024, 11025, 11026, 11027, 11028, 11029, 11030, 11031,
   11032, 11033, 11034, 11035, 11036, 11037, 11038, 11039, 11040, 11041,
   11042, 11043, 11044, 11045, 11046, 11047, 11048, 11049, 11050, 11051,
   11052, 11053, 11054, 11055, 11056, 11057, 11058, 11059, 11060, 11061,
   11062, 11063, 11064, 11065, 11066, 11067, 11068, 11069, 11070, 11071,
   11072, 11073, 11074, 11075, 11076, 11077, 11078, 11079, 11080, 11081,
   11082, 11083, 11084, 11085, 11086, 11087, 11088, 11089, 11090, 11091,
   11092, 11093, 11094, 11095, 11096, 11097, 11098, 11099, 11100, 11101,
   11102, 11103, 11104, 11105, 11106, 11107, 11108, 11109, 11110, 11111,
   11112, 11113, 11114, 11115, 11116, 11117, 11118, 11119, 11120, 11121,
   11122, 11123, 11124, 11125, 11126, 11127, 11128, 11129, 11130, 11131,
   11132, 11133, 11134, 11135, 11136, 11137, 11138, 11139, 11140, 11141,
   11142, 11143, 11144, 11145, 11146, 11147, 11148, 11149, 11150, 11151,
   11152, 11153, 11154, 11155, 11156, 11157, 11158, 11159, 11160, 11161,
   11162, 11163, 11164, 11165, 11166, 11167, 11168, 11169, 11170, 11171,
   11172, 11173, 11174, 11175, 11176, 11177, 11178, 11179, 11193, 11194,
   11195, 11196, 11197, 11198, 11199, 11200, 11201, 11202, 11203, 11204,
   11205, 11206, 11207, 11208, 11209, 11210, 11211, 11212, 11213, 11214,
   11215, 11216, 11217, 11218, 11219, 11220, 11221, 11222, 11223, 11224,
   11225, 11226, 11227, 11228, 11229, 11230, 11231, 11232, 11233, 11234,
   11235, 11236, 11237, 11238, 11252, 11253, 11254, 11255, 11256, 11257,
   11258, 11259, 11260, 11261, 11262, 11263, 11264, 11265, 11266, 11267,
   11268, 11269, 11270, 11271, 11272, 11273, 11283, 11284, 11285, 11286,
   11287, 11288, 11289, 11290, 11291, 11292, 11293, 11294, 11295, 11296,
   11297, 11298, 11299, 11300, 11301, 11302, 11303, 11304, 11305, 11306,
   11307, 11308, 11309, 11310, 11311, 11312, 11313, 11314, 11315, 11316,
   11317, 11318, 11319, 11320, 11321, 11322, 11323, 11324, 11325, 11326,
   11327, 11328, 11329, 11330, 11331, 11332, 11333, 11334, 11335, 11336,
   11337, 11338, 11339, 11340, 11341, 11342, 11343, 11344, 11345, 11346,
   11347, 11348, 11349, 11350, 11351, 11352, 11353, 11354, 11355, 11356,
   11357, 11358
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE",
  "CALLED", "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN",
  "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS",
  "CLOSE", "CLUSTER", "COALESCE", "COLLATE", "COLUMN", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CREATEDB", "CREATEROLE",
  "CREATEUSER", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH",
  "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD",
  "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE",
  "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSWORD", "PLACING", "PLANS",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept", "stmtblock",
  "stmtmulti", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "AlterUserStmt", "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "DropGroupStmt",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "ColId_or_Sconst", "VariableResetStmt", "SetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem", "ClosePortalStmt",
  "CopyStmt", "copy_from", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "CreateAsStmt",
  "create_as_target", "OptCreateAs", "CreateAsList", "CreateAsElement",
  "opt_with_data", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt", "create_generic_options",
  "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "AlterSecLabelStmt", "SecLabelItem", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "DropRuleStmt",
  "NotifyStmt", "notify_payload", "ListenStmt", "UnlistenStmt",
  "TransactionStmt", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty", "ViewStmt",
  "opt_check_option", "LoadStmt", "CreatedbStmt", "createdb_opt_list",
  "createdb_opt_item", "opt_equal", "AlterDatabaseStmt",
  "AlterDatabaseSetStmt", "alterdb_opt_list", "alterdb_opt_item",
  "DropdbStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "vacuum_option_list", "vacuum_option_elem", "AnalyzeStmt",
  "analyze_keyword", "opt_verbose", "opt_full", "opt_freeze",
  "opt_name_list", "ExplainStmt", "ExplainableStmt", "explain_option_list",
  "explain_option_elem", "explain_option_name", "explain_option_arg",
  "PrepareStmt", "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "opt_select_fetch_first_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "SignedIconst", "ColId",
  "type_function_name", "ColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,    61,    60,    62,   668,    43,    45,    42,
      47,    37,    94,   669,    91,    93,    40,    41,    46,    59,
      44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   432,   433,   434,   434,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   436,
     437,   437,   438,   438,   439,   439,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   441,   441,   441,   441,   441,
     441,   442,   443,   444,   444,   445,   446,   447,   448,   448,
     449,   449,   450,   451,   452,   452,   453,   453,   454,   454,
     455,   455,   456,   456,   457,   457,   457,   457,   457,   457,
     458,   458,   458,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   460,   460,
     461,   461,   462,   462,   463,   463,   463,   463,   464,   464,
     464,   464,   465,   465,   465,   465,   465,   465,   465,   466,
     466,   466,   467,   467,   468,   468,   468,   468,   468,   469,
     469,   470,   470,   470,   470,   470,   471,   472,   472,   473,
     473,   474,   475,   475,   475,   475,   476,   476,   476,   476,
     477,   477,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   478,   478,   478,   478,   478,   478,   478,   478,   478,
     478,   479,   479,   480,   480,   480,   481,   481,   482,   483,
     483,   484,   484,   485,   485,   485,   485,   486,   486,   487,
     487,   488,   488,   489,   489,   489,   490,   490,   491,   491,
     492,   492,   492,   492,   492,   492,   492,   492,   492,   492,
     492,   493,   493,   494,   494,   495,   495,   496,   496,   497,
     497,   498,   499,   499,   499,   499,   499,   500,   500,   501,
     502,   502,   503,   503,   503,   503,   503,   503,   503,   504,
     504,   505,   505,   506,   506,   507,   507,   508,   508,   508,
     509,   509,   510,   511,   512,   512,   513,   513,   513,   514,
     514,   514,   514,   514,   514,   514,   515,   515,   515,   515,
     516,   517,   517,   517,   518,   518,   518,   518,   518,   518,
     519,   519,   520,   520,   520,   520,   520,   521,   521,   522,
     522,   523,   524,   524,   524,   524,   525,   525,   526,   526,
     527,   527,   528,   528,   528,   528,   528,   529,   530,   531,
     531,   531,   531,   531,   532,   532,   533,   533,   533,   533,
     534,   534,   534,   534,   535,   535,   536,   536,   537,   538,
     539,   539,   540,   540,   541,   542,   542,   542,   543,   544,
     545,   545,   546,   546,   547,   547,   547,   547,   547,   547,
     547,   547,   547,   547,   547,   547,   548,   548,   549,   549,
     549,   550,   550,   551,   551,   552,   552,   553,   553,   554,
     554,   555,   555,   556,   556,   557,   557,   558,   558,   559,
     560,   560,   561,   561,   562,   563,   563,   564,   564,   564,
     565,   565,   566,   566,   567,   568,   568,   569,   569,   569,
     569,   570,   571,   572,   573,   574,   574,   575,   575,   576,
     576,   577,   577,   578,   578,   578,   579,   580,   580,   580,
     581,   581,   582,   583,   583,   584,   584,   585,   585,   586,
     586,   586,   586,   586,   587,   587,   588,   588,   589,   589,
     590,   590,   591,   591,   591,   592,   592,   592,   592,   592,
     592,   593,   593,   594,   594,   594,   594,   594,   595,   595,
     596,   596,   597,   597,   598,   599,   600,   600,   600,   600,
     600,   600,   600,   600,   600,   600,   600,   601,   602,   602,
     603,   603,   604,   604,   604,   604,   604,   605,   605,   606,
     607,   607,   608,   609,   609,   610,   610,   611,   612,   612,
     613,   613,   613,   613,   613,   614,   614,   615,   615,   616,
     616,   617,   618,   618,   619,   619,   620,   620,   621,   621,
     622,   622,   623,   624,   625,   625,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   627,   627,
     628,   628,   629,   629,   630,   631,   631,   631,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   633,   633,   633,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   634,   634,   635,
     635,   636,   636,   636,   636,   636,   636,   636,   636,   636,
     636,   636,   636,   636,   636,   636,   636,   637,   637,   638,
     638,   639,   640,   640,   641,   641,   641,   641,   641,   642,
     642,   643,   643,   643,   643,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   645,
     645,   646,   646,   647,   647,   648,   648,   649,   650,   651,
     651,   652,   652,   653,   653,   654,   655,   655,   656,   656,
     656,   657,   657,   657,   658,   658,   658,   659,   660,   660,
     661,   661,   662,   662,   663,   663,   664,   664,   665,   665,
     665,   666,   666,   666,   667,   667,   667,   668,   668,   668,
     669,   669,   669,   670,   670,   671,   671,   672,   672,   673,
     673,   674,   674,   675,   675,   675,   675,   675,   676,   676,
     676,   676,   676,   677,   678,   679,   679,   679,   680,   680,
     680,   681,   681,   682,   682,   682,   682,   682,   682,   682,
     682,   682,   682,   682,   682,   682,   683,   683,   683,   683,
     684,   684,   685,   685,   686,   687,   687,   688,   689,   689,
     690,   690,   691,   691,   692,   692,   693,   693,   694,   694,
     694,   694,   695,   695,   696,   697,   697,   698,   698,   699,
     699,   699,   700,   700,   700,   701,   702,   702,   703,   703,
     703,   704,   704,   705,   705,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     707,   707,   708,   708,   709,   709,   709,   709,   709,   709,
     709,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   711,   711,
     711,   711,   711,   711,   711,   711,   711,   711,   712,   713,
     714,   714,   714,   715,   715,   716,   716,   716,   716,   716,
     717,   717,   718,   718,   718,   718,   719,   719,   719,   720,
     720,   721,   722,   722,   723,   724,   724,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   726,   726,   726,   727,   727,   727,   728,   728,   728,
     729,   729,   730,   730,   731,   731,   731,   731,   732,   733,
     734,   734,   735,   735,   735,   735,   735,   735,   735,   735,
     735,   735,   735,   735,   735,   735,   735,   735,   736,   736,
     737,   737,   738,   739,   739,   740,   741,   741,   742,   743,
     743,   743,   743,   743,   744,   744,   745,   746,   746,   746,
     746,   746,   746,   747,   748,   748,   748,   749,   749,   750,
     750,   750,   750,   750,   751,   751,   752,   752,   752,   752,
     753,   753,   754,   754,   755,   755,   756,   756,   757,   757,
     758,   758,   759,   759,   759,   759,   760,   760,   760,   760,
     760,   760,   760,   761,   761,   762,   763,   763,   763,   764,
     764,   764,   765,   766,   766,   767,   767,   767,   767,   768,
     768,   769,   769,   770,   770,   770,   770,   771,   772,   772,
     772,   773,   773,   774,   775,   775,   776,   777,   777,   778,
     779,   779,   780,   780,   780,   780,   780,   780,   780,   780,
     781,   781,   782,   783,   783,   784,   784,   785,   786,   787,
     788,   788,   789,   790,   791,   791,   791,   791,   791,   792,
     792,   792,   793,   793,   794,   794,   795,   795,   795,   795,
     795,   795,   795,   795,   796,   796,   797,   797,   797,   797,
     797,   797,   798,   798,   799,   799,   800,   801,   801,   802,
     802,   802,   802,   802,   802,   802,   802,   803,   803,   804,
     804,   804,   805,   805,   805,   805,   806,   806,   807,   808,
     808,   809,   809,   810,   810,   810,   810,   811,   811,   812,
     812,   812,   813,   813,   814,   814,   815,   816,   816,   816,
     817,   818,   818,   819,   819,   820,   820,   821,   821,   822,
     822,   823,   823,   824,   824,   825,   825,   826,   826,   827,
     827,   828,   828,   829,   829,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   831,   831,   831,   831,
     831,   831,   832,   832,   832,   832,   833,   833,   833,   833,
     834,   834,   835,   835,   836,   836,   836,   836,   837,   837,
     838,   838,   838,   839,   840,   840,   841,   841,   841,   842,
     842,   843,   844,   844,   844,   844,   844,   844,   845,   845,
     845,   846,   846,   846,   846,   846,   846,   846,   847,   847,
     847,   847,   848,   848,   849,   849,   850,   850,   850,   850,
     850,   850,   850,   850,   850,   850,   850,   851,   851,   852,
     852,   853,   853,   854,   855,   856,   856,   857,   857,   858,
     859,   860,   860,   860,   860,   860,   860,   861,   861,   862,
     862,   863,   863,   863,   863,   864,   865,   865,   865,   866,
     866,   866,   866,   866,   866,   866,   866,   866,   866,   866,
     866,   866,   866,   867,   867,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   869,   869,   869,   869,   869,   869,   869,
     869,   869,   869,   869,   869,   869,   869,   869,   869,   869,
     869,   869,   869,   869,   869,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   872,   872,   873,   873,   873,   873,
     874,   875,   875,   876,   876,   877,   877,   878,   878,   878,
     879,   879,   880,   880,   881,   882,   882,   882,   883,   884,
     884,   885,   885,   886,   886,   886,   887,   887,   888,   888,
     888,   888,   888,   889,   889,   889,   890,   890,   890,   891,
     891,   892,   892,   892,   892,   892,   892,   892,   892,   892,
     893,   893,   894,   894,   895,   895,   895,   895,   895,   895,
     896,   896,   897,   897,   898,   898,   899,   899,   900,   900,
     900,   901,   901,   902,   902,   903,   903,   903,   903,   903,
     903,   903,   903,   904,   904,   905,   906,   906,   907,   907,
     907,   907,   907,   907,   908,   909,   910,   910,   910,   911,
     911,   912,   913,   913,   914,   915,   915,   916,   916,   917,
     917,   918,   918,   918,   918,   919,   919,   920,   920,   921,
     921,   922,   922,   923,   923,   924,   925,   925,   926,   926,
     926,   926,   927,   927,   928,   928,   929,   929,   930,   931,
     932,   933,   934,   935,   936,   936,   937,   937,   937,   937,
     937,   937,   937,   937,   937,   937,   937,   937,   937,   938,
     939,   940,   941,   941,   941,   942,   942,   942,   943,   943,
     943,   944,   944,   944,   944,   944,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     948,   948
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     5,
       1,     0,     2,     0,     2,     0,     2,     2,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     2,     1,     2,     2,     2,     3,
       3,     5,     5,     0,     3,     5,     5,     4,     3,     5,
       3,     5,     5,     6,     1,     1,     3,     5,     6,     4,
       1,     0,     2,     0,     1,     1,     1,     1,     1,     1,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       5,     2,     2,     2,     2,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     6,     1,     1,     1,     1,
       1,     0,     1,     1,     2,     3,     4,     3,     2,     2,
       1,     2,     3,     4,     3,     2,     4,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     4,     4,     4,     4,
       1,     3,     2,     3,     4,     6,     6,     6,     5,     5,
       6,     6,     4,     7,     2,     6,     4,     3,     3,     4,
       4,     3,     3,     3,     4,     4,     3,     3,     3,     3,
       3,     3,     4,     4,     3,     2,     3,     3,     3,     2,
       2,     3,     2,     1,     1,     0,     2,     0,     3,     2,
       0,     1,     3,     3,     1,     5,     3,     2,     2,    10,
       6,     1,     1,     1,     1,     1,     1,     3,     2,     0,
       1,     1,     3,     3,     1,     1,     3,     3,     3,     3,
       4,     1,     0,     2,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      11,    10,     1,     1,     2,     2,     2,     2,     0,     1,
       0,     3,     0,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     3,     4,     2,     0,     3,     1,     1,     2,
       1,     3,     4,     4,     2,     5,     1,     2,     2,     2,
       3,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       3,     1,     5,     7,     8,     9,    11,     3,     0,     1,
       3,     1,     2,     2,     2,     0,     1,     3,     3,     6,
       4,     0,     1,     1,     2,     2,     0,     3,     3,     2,
       1,     1,     2,     2,     4,     0,     2,     2,     2,     0,
       3,     4,     4,     0,     2,     0,     4,     0,     7,     5,
       3,     0,     1,     3,     1,     2,     3,     0,     5,     4,
       1,     0,     1,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     1,     3,     1,     0,     1,     2,
       1,     1,     3,     6,    10,     1,     0,     1,     2,     2,
       0,     2,     2,     1,     0,     5,     7,     1,     0,     6,
       2,     0,     3,     5,     7,     6,     8,     7,     6,     6,
       4,     0,     1,     3,     4,     1,     3,     1,     2,     2,
       2,     2,     1,     1,    10,     2,     0,     2,     2,     1,
       0,     4,     6,     5,     4,     4,     8,     1,     1,     1,
       7,     9,     8,    15,    20,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     3,     0,     1,     0,     1,     1,
       4,     0,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     2,     0,     1,     2,     1,     2,     0,     2,     1,
       2,     2,     6,     8,     8,     4,     5,     4,     4,     4,
       3,     7,     8,     6,     6,     6,     6,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       1,     3,     3,     1,     0,     1,     3,    13,     1,     3,
       4,     5,     4,     7,     2,     1,     0,     2,     0,     1,
       0,     6,     8,     8,     1,     3,     5,     5,     7,     9,
       7,     9,     5,     6,     6,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     3,
       1,     2,     2,     3,     5,     2,     2,     0,     6,     7,
       7,     7,     8,     8,     6,     8,     9,     9,     7,    10,
       7,     8,     8,     8,     8,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     2,     3,     3,     3,     3,     4,     4,     3,
       3,     3,     4,     4,     3,     4,     4,     1,     1,     1,
       0,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     3,     2,     2,     5,     5,     5,     1,
       3,     1,     2,     3,     0,     1,     3,     2,     6,     6,
       9,     3,     0,     3,     0,     5,     2,     0,     3,     3,
       3,     7,     7,    10,     1,     1,     1,    14,     1,     0,
       1,     0,     1,     0,     2,     0,     1,     3,     4,     4,
       6,     1,     2,     0,     1,     1,     0,     1,     1,     0,
       9,    12,     7,     2,     0,     3,     2,     1,     3,     3,
       2,     1,     3,     3,     3,     2,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     4,     5,     1,     3,
       3,     1,     2,     4,     5,     1,     1,     1,     1,     3,
       3,     2,     2,     2,     2,     1,     2,     2,     1,     1,
       1,     3,     2,     0,     2,     1,     3,     5,     1,     2,
       1,     0,     5,     7,     5,     7,     5,     7,     3,     5,
       5,     5,     1,     3,     2,     1,     2,     1,     2,    11,
      10,    10,     2,     2,     0,     9,     2,     0,     4,     4,
       4,     1,     1,     1,     0,     7,     6,     6,     6,     6,
       7,     9,     9,     6,     6,     6,     6,     6,     8,     8,
       6,     6,     6,     5,     5,     8,     8,     8,     8,     6,
       1,     0,     2,     0,     7,     6,     6,     6,     6,     6,
       6,     7,     6,     6,     6,     6,     7,     7,     7,     9,
       9,     6,     6,     6,     8,     8,     8,     6,     4,     4,
       4,     7,     4,     4,     4,     5,     5,     4,     4,    13,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     0,     6,
       8,     3,     2,     0,     2,     2,     2,     2,     3,     3,
       2,     2,     2,     2,     3,     2,     5,     4,     3,     3,
       3,     1,     1,     0,     3,     2,     2,     1,     3,     2,
       1,     0,     8,    10,     3,     4,     4,     0,     2,     5,
       2,     0,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     3,     3,     1,     0,
       5,     6,     4,     2,     0,     4,     3,     5,     6,     4,
       6,     6,     5,     7,     1,     0,     6,    11,    11,    11,
      13,     9,    11,    10,     4,     2,     5,     2,     0,     4,
       5,     5,     4,     6,     1,     3,     1,     1,     1,     1,
       2,     4,     1,     1,     1,     0,     1,     0,     1,     0,
       3,     0,     2,     4,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     1,     1,     1,     1,
       1,     0,     5,     3,     0,     1,     1,     1,     1,     3,
       8,     3,     0,     2,     3,     2,     3,     5,     1,     4,
       2,     1,     3,     2,     2,     0,     6,     2,     0,     5,
       3,     0,     2,     2,     2,     3,     1,     3,     1,     2,
       1,     0,     7,     1,     3,     1,     1,     3,     5,     2,
       1,     3,     7,     1,     0,     3,     2,     2,     2,     0,
       2,     2,     1,     1,     3,     3,     1,     2,     4,     4,
       2,     3,     5,     5,     1,     1,     9,     1,     2,     4,
       4,     4,     2,     3,     1,     3,     4,     2,     0,     3,
       3,     4,     4,     4,     4,     2,     1,     1,     0,     1,
       1,     0,     1,     5,     1,     0,     1,     0,     3,     1,
       3,     4,     3,     2,     2,     1,     1,     1,     0,     2,
       4,     5,     2,     3,     1,     1,     1,     1,     3,     0,
       1,     1,     1,     1,     1,     3,     0,     2,     0,     1,
       3,     1,     0,     1,     2,     4,     4,     2,     0,     2,
       3,     2,     0,     1,     3,     1,     2,     1,     2,     5,
       6,     5,     1,     2,     1,     4,     3,     4,     5,     4,
       5,     4,     5,     2,     4,     1,     2,     2,     2,     1,
       1,     0,     4,     2,     1,     2,     2,     4,     1,     3,
       1,     2,     3,     1,     2,     0,     2,     4,     0,     1,
       3,     2,     2,     3,     5,     6,     2,     3,     3,     4,
       0,     1,     1,     1,     1,     1,     2,     5,     1,     1,
       1,     1,     2,     3,     3,     0,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     3,     0,     1,
       1,     1,     1,     5,     2,     1,     1,     1,     1,     5,
       2,     2,     2,     1,     3,     3,     2,     1,     0,     3,
       0,     5,     2,     5,     2,     1,     2,     3,     0,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     0,     1,     4,     1,     3,     5,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     3,     3,     2,     3,     5,     4,     6,     3,
       5,     4,     6,     4,     6,     5,     7,     3,     2,     4,
       2,     3,     3,     4,     3,     4,     3,     4,     5,     6,
       6,     7,     6,     7,     6,     7,     3,     4,     4,     6,
       2,     3,     4,     1,     3,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     5,
       6,     6,     7,     3,     4,     1,     1,     2,     4,     1,
       1,     1,     2,     2,     2,     1,     4,     5,     6,     8,
       6,     7,     7,     5,     1,     1,     4,     1,     4,     1,
       4,     1,     4,     1,     1,     1,     1,     1,     1,     6,
       4,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     5,     7,     7,     9,     4,     6,
       5,     7,     7,     7,     2,     3,     3,     3,     4,     0,
       4,     1,     3,     3,     1,     1,     1,     2,     2,     0,
       2,     0,     1,     3,     3,     2,     2,     0,     6,     1,
       0,     3,     0,     2,     2,     0,     1,     4,     2,     2,
       2,     2,     2,     4,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     4,     1,     4,     1,     2,     1,     2,
       1,     3,     1,     3,     1,     3,     1,     3,     3,     3,
       2,     1,     3,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     3,     2,     3,     0,     3,     3,
       2,     2,     1,     0,     2,     2,     3,     2,     1,     1,
       3,     5,     1,     2,     4,     2,     0,     1,     0,     1,
       2,     2,     2,     3,     5,     1,     2,     0,     2,     1,
       0,     1,     1,     1,     3,     3,     1,     3,     3,     2,
       1,     1,     1,     3,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     5,     2,     3,     6,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     108,   993,   488,  1073,  1072,   993,   231,     0,  1075,     0,
     993,   322,   794,     0,     0,     0,     0,     0,   488,   993,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,     0,     0,     0,     0,     0,   993,     0,  1205,     0,
       0,     0,     0,  1198,     0,     0,  1077,     0,     0,     0,
       0,     2,     4,    50,    51,    19,    18,    24,    23,    73,
      74,    40,    12,    64,    45,   105,   104,   106,    30,    26,
      58,    17,    27,    31,    47,    32,    46,    16,    44,    68,
      48,    71,    37,    62,     9,    38,    63,    10,    52,    75,
      22,    49,    72,    33,    60,    56,    41,    42,    43,    65,
      66,    67,    89,    70,   100,    29,    79,    80,    95,    81,
      96,     7,    82,    39,    11,    92,    91,    93,    59,    34,
      61,    90,    94,    13,    14,    15,    97,    69,    87,    84,
     101,    99,   107,    85,    53,     5,     6,    76,    36,     8,
      21,    20,    35,    28,   103,    25,  1075,    78,    88,    77,
      54,    83,    57,    86,   102,    55,    98,  1175,  1162,  1207,
    1174,     0,  1177,   992,   991,   977,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   487,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1001,  1695,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
     298,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,
    1958,  1959,  1960,  1961,  1723,  1724,  1725,  1726,  1727,  1728,
    1729,  1962,  1963,  1730,  1731,  1732,  1733,  1734,  1964,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1965,  1966,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1967,  1782,
    1783,  1968,  1784,  1785,  1969,  1786,  1787,  1788,  1789,  1790,
    1791,  1792,  1970,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1971,
    1809,  1810,  1811,  1812,  1972,  1973,  1974,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1975,  1822,  1823,  1824,
    1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,
    1835,  1836,  1837,  1838,  1976,  1977,  1839,  1840,  1841,  1842,
    1843,  1844,  1845,  1978,  1846,  1847,  1848,  1849,  1979,  1850,
    1980,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1981,  1982,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1983,  1865,  1984,
    1868,  1866,  1867,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1985,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,
    1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1986,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1987,  1907,  1908,  1909,  1988,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1989,  1920,
    1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1990,  1991,
    1929,  1992,  1930,  1993,  1931,  1932,  1933,  1934,  1935,  1936,
    1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1994,  1995,
    1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  1955,  1956,
    1957,   297,  1153,  1668,  1696,  1697,  1074,  1055,   488,     0,
     980,   321,     0,     0,     0,     0,     0,     0,     0,   615,
       0,     0,     0,     0,     0,     0,     0,     0,   161,     0,
       0,   343,   342,     0,     0,     0,   768,     0,     0,     0,
       0,   476,  1115,  1866,  1113,  1154,     0,   232,   235,   233,
     234,  1690,     0,   864,   865,   867,     0,     0,   877,   642,
       0,   641,     0,     0,     0,   639,     0,     0,     0,     0,
     643,   637,     0,   636,     0,     0,     0,   640,     0,   638,
       0,     0,   981,  1112,   348,     0,     0,  1091,  1075,  1082,
    1092,  1087,  1089,  1088,  1090,  1086,  1689,  1707,   710,   710,
     710,   710,   707,   708,   710,   710,   710,  1880,     0,     0,
     689,     0,   691,  1692,   710,   715,   398,   398,   398,     0,
     714,   719,   398,     0,   974,  1008,  1673,  1197,     0,   690,
     973,  1929,  1104,     0,     0,   881,     0,   882,     0,  1895,
     985,   218,  1905,  1990,  1929,   214,   188,  1711,     0,     0,
     714,     0,   982,   983,  1204,  1202,     0,  1728,  1741,  1825,
     211,  1891,  1896,  1905,  1990,  1929,  1954,   170,     0,   225,
    1905,  1990,  1929,   221,  1001,     0,  1178,  1284,  1664,     0,
     976,   975,  1290,     0,  1076,     0,  1079,     0,  1249,  1878,
    1182,  1184,  1081,  1175,     0,     1,   108,  1070,  1201,  1201,
       0,  1201,     0,  1167,  1175,  1170,  1174,     0,  1695,  2004,
    2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,
    2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,
    2025,     0,     0,  1674,  1696,  1700,     0,   650,   111,  1669,
     757,     0,     0,     0,     0,     0,  1691,     0,     0,  1569,
    1732,  1784,  1579,  1577,  1578,  1571,  1572,  1573,  1574,  1575,
    1576,     0,   862,  1570,     0,   111,     0,     0,     0,     0,
       0,     0,     0,     0,  1829,   111,     0,     0,     0,     0,
     997,  1000,   978,  1058,     0,  1664,     0,     0,   675,     0,
     684,   676,   681,     0,   678,     0,     0,   686,     0,   677,
     679,   680,   685,     0,     0,   682,   683,     0,     0,   989,
     398,     0,     0,     0,     0,     0,   111,  1045,     0,   347,
     346,   111,   345,   344,  1732,  1784,     0,   793,   111,     0,
     163,   516,   491,     0,     0,   580,  1829,   111,     0,     0,
       0,     0,   771,     0,     0,   475,   488,  1116,  1114,     0,
    1128,   868,   213,   212,   866,  1798,     0,   285,     0,     0,
    1798,  1036,     0,  1798,     0,  1798,   156,  1666,  1732,  1784,
    1798,     0,     0,  1798,   148,  1798,     0,  1798,   285,  1798,
     492,     0,  1798,     0,  1798,  1829,   150,     0,  1798,   285,
     648,     0,  1109,     0,  1084,  1994,  1098,  1097,     0,  1093,
    1101,  1096,     0,   710,   709,     0,   710,     0,   710,     0,
     710,     0,   710,     0,     0,     0,   710,  1693,  1694,   692,
       0,   716,     0,     0,   723,   722,   721,     0,     0,     0,
     724,     0,  1288,  1131,     0,   971,   988,     0,     0,     0,
     884,   884,   884,   984,   217,   215,     0,     0,     0,     0,
       0,     0,   990,     0,     0,  1677,  1679,  1680,  1580,  1647,
       0,  1959,  1960,  1961,  1638,     0,  1962,  1963,  1964,  1497,
    1484,  1493,  1498,  1485,  1487,  1494,  1965,  1966,  1770,  1967,
    1968,  1687,  1969,  1970,  1972,  1973,  1974,  1975,  1489,  1491,
    1976,  1977,     0,  1688,  1979,  1980,  1855,  1982,  1983,  1985,
    1986,  1495,  1988,  1989,  1990,  1991,  1992,  1993,  1686,     0,
    1496,  1995,  1997,  1998,  1999,  2000,  2001,  2002,  2003,     0,
       0,  1661,     0,  1471,     0,  1318,  1319,  1341,  1342,  1320,
    1347,  1348,  1360,  1321,     0,  1660,  1385,  1470,  1475,     0,
    1469,  1465,  1188,  1656,     0,  1466,  1676,  1678,  1639,   181,
     227,     0,   228,  1662,  1905,   171,   210,   183,   209,   184,
     182,     0,  1730,   172,     0,   179,     0,     0,     0,     0,
     224,   222,     0,   979,     0,  1286,  1285,     0,     0,  1645,
    1665,   657,     0,  1291,     0,  1068,  1069,  1067,     0,  1064,
    1066,  1078,  1075,  1652,  1651,  1653,     0,  1183,     0,     0,
       0,  1165,  1164,     3,  1081,  1199,  1200,     0,     0,     0,
       0,     0,     0,     0,     0,  1242,  1215,  1216,  1218,  1239,
    1243,     0,  1171,  1250,     0,     0,  1675,     0,     0,     0,
     651,     0,     0,     0,     0,   110,  1034,   220,  1032,   938,
       0,     0,     0,     0,     0,  1039,     0,     0,     0,     0,
     826,     0,     0,     0,     0,     0,     0,   827,   825,   828,
     835,   848,   851,   944,     0,   747,   154,   155,     0,     0,
       0,   911,     0,     0,   911,     0,     0,     0,     0,     0,
       0,     0,   237,   240,   468,     0,     0,  1692,   470,     0,
       0,     0,     0,     0,     0,     0,   115,     0,     0,     0,
     939,     0,   455,   467,     0,     0,     0,     0,     0,   464,
       0,   111,   238,   449,   452,   942,     0,     0,     0,   525,
     524,   911,   911,     0,   236,   940,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   947,     0,
       0,     0,   115,   147,     0,     0,   239,   943,     0,     0,
     995,   996,     0,   999,     0,  1054,     0,     0,     0,     0,
       0,     0,  1732,  1784,     0,     0,     0,     0,     0,     0,
     324,   304,   305,   111,   303,     0,     0,   577,     0,  1698,
    1329,  1358,  1336,  1358,  1358,  1325,  1325,  1338,  1326,  1327,
    1365,     0,  1358,  1325,  1330,     0,  1328,  1368,  1368,  1353,
       0,  1310,  1311,  1312,  1313,  1339,  1340,  1314,  1345,  1346,
    1315,  1382,  1325,  1699,     0,  1011,  1044,     0,     0,   113,
     616,     0,     0,   578,     0,   113,     0,   159,     0,   520,
       0,     0,     0,     0,     0,     0,   536,   535,     0,     0,
     579,     0,   113,   451,     0,   441,   398,     0,   770,   773,
       0,     0,     0,  1157,  1159,  1158,     0,  1156,     0,  1298,
       0,   285,   283,   284,   575,   876,     0,     0,     0,     0,
     285,     0,     0,  1798,     0,  1798,     0,     0,   285,   285,
       0,     0,     0,     0,   521,     0,   647,   645,   644,   646,
       0,     0,     0,     0,     0,  1798,   285,     0,     0,   635,
    1590,     0,     0,     0,     0,   199,   200,   198,  1099,   201,
    1100,  1095,  1083,     0,   700,     0,   704,     0,   695,     0,
     701,     0,   696,   693,   694,     0,   699,     0,     0,   399,
     401,     0,     0,  1755,     0,  1789,  1817,  1818,  1896,  1901,
       0,  1924,     0,   725,   752,   720,     0,     0,  1125,  1118,
       0,     0,  1141,   972,  1596,     0,     0,     0,   883,   880,
     879,   878,   216,   189,     0,     0,     0,   754,  1895,   987,
       0,  1467,     0,  1473,  1474,  1357,  1344,  1637,     0,     0,
    1352,  1351,     0,     0,     0,     0,  1334,  1333,  1332,  1472,
    1604,     0,  1331,     0,     0,     0,     0,  1358,  1358,  1356,
    1404,     0,  1335,     0,     0,  1617,     0,  1623,     0,     0,
       0,  1364,     0,  1362,     0,     0,  1440,     0,     0,     0,
       0,     0,     0,     0,  1388,  1389,  1471,  1590,     0,  1683,
       0,     0,  1350,     0,  1382,  1659,  1580,     0,     0,     0,
       0,  1650,  1588,     0,     0,  1418,  1586,     0,  1420,     0,
       0,     0,  1579,  1577,  1578,  1571,  1572,  1573,  1574,  1575,
    1576,  1584,  1401,     0,     0,  1400,     0,     0,  1252,     0,
    1681,  1640,   229,   230,   226,     0,     0,   186,   185,     0,
     203,   207,   208,   178,   206,     0,   202,  1536,  1535,   187,
     177,   175,   173,   190,   192,   193,   176,   174,   223,     0,
       0,  1701,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  1642,  1641,
    1671,  1702,  1703,  1704,  1705,  1646,     0,     0,   285,  1292,
       0,  1252,  1143,  1145,  1146,     0,  1647,  1062,     0,  1059,
    1655,     0,  1185,     0,     0,  1071,  1181,  1180,  1208,  1209,
     786,  1179,  1233,  1234,  1229,     0,  1248,  1248,  1225,  1219,
    1224,  1222,     0,  1226,  1385,  1241,  1169,  1213,  1214,  1217,
    1168,     0,  1244,  1242,  1218,     0,     0,     0,     0,     0,
     945,     0,     0,   652,     0,     0,     0,     0,  1924,   219,
    1030,     0,     0,     0,     0,   756,   755,     0,     0,   775,
       0,     0,     0,  1042,   391,     0,   282,     0,     0,     0,
       0,     0,     0,     0,   833,     0,     0,     0,     0,   834,
     831,   832,  1896,   850,     0,   849,   847,   808,   810,   809,
       0,   812,   796,     0,   797,     0,     0,   807,   815,   813,
       0,     0,     0,  1778,   242,   254,     0,   910,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   275,     0,
       0,     0,     0,   280,     0,     0,     0,   279,     0,   469,
       0,   946,     0,     0,     0,     0,     0,   863,     0,     0,
     142,   145,     0,     0,   454,   466,     0,   458,   459,   456,
     460,   461,     0,     0,     0,     0,     0,     0,   453,     0,
       0,   518,   517,   523,     0,     0,     0,     0,     0,     0,
     904,   903,     0,     0,     0,     0,     0,     0,     0,     0,
     527,   528,     0,   529,     0,   146,     0,     0,     0,     0,
       0,     0,   197,   994,   998,  1057,  1672,  1056,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   309,  1698,     0,
     600,   576,     0,  1310,     0,  1306,  1302,  1371,  1372,  1373,
    1370,  1383,  1369,     0,  1316,  1374,  1325,  1322,     0,  1009,
     365,   484,   152,     0,     0,     0,   588,   591,     0,   109,
     163,   348,     0,   162,   164,   166,   167,   168,   165,   169,
     515,   519,     0,   490,     0,     0,     0,     0,     0,   540,
     539,   543,   541,     0,   537,     0,     0,     0,   141,   448,
     450,     0,     0,   350,   429,     0,     0,     0,   772,     0,
       0,     0,     0,     0,     0,     0,  1155,     0,  1262,  1127,
    1253,  1264,  1255,  1257,  1293,     0,  1664,     0,  1125,     0,
     854,     0,  1037,  1798,   285,     0,   852,   157,  1667,     0,
       0,     0,     0,     0,   856,   632,   149,     0,   285,   285,
     493,     0,   285,   151,     0,     0,     0,   485,   285,   649,
    1111,     0,   441,  1085,  1094,   697,   706,   705,   703,   702,
     698,     0,   717,     0,   397,     0,     0,     0,   731,     0,
       0,   730,   745,   732,     0,   734,   727,   726,   735,     0,
       0,   754,  1120,     0,  1121,  1647,     0,  1117,     0,  1138,
       0,  1136,     0,  1289,  1140,  1129,  1103,     0,  1102,  1106,
    1108,  1107,  1105,     0,     0,     0,   714,     0,     0,   285,
     986,     0,  1648,  1600,     0,  1601,     0,     0,     0,  1636,
    1632,     0,     0,     0,     0,     0,  1605,  1608,  1609,  1610,
    1607,  1611,  1606,     0,     0,  1612,     0,     0,     0,     0,
       0,  1355,  1354,     0,     0,     0,     0,     0,     0,     0,
    1443,  1475,     0,     0,  1564,     0,  1590,  1622,     0,     0,
    1366,     0,     0,     0,     0,     0,     0,     0,  1590,  1628,
       0,     0,     0,  1534,     0,  1531,     0,     0,     0,     0,
    1647,     0,     0,     0,     0,  1684,  1386,  1402,  1658,     0,
    1649,     0,     0,  1409,     0,  1629,  1436,     0,  1441,  1424,
       0,  1417,     0,  1422,  1426,  1405,  1650,  1589,     0,  1587,
       0,     0,  1403,     0,  1398,  1396,  1397,  1390,  1391,  1392,
    1393,  1394,  1395,  1399,  1568,  1566,  1567,     0,     0,     0,
    1421,  1791,  1825,     0,  1198,  1198,  1187,  1196,  1657,     0,
    1295,     0,     0,     0,     0,  1547,     0,  1594,     0,  1592,
    1674,  1663,     0,     0,  1382,     0,  1287,  1643,     0,   655,
     656,   654,  1150,     0,     0,  1298,     0,  1149,  1081,  1065,
    1061,  1060,  1654,  1080,  1186,     0,   784,   785,     0,   789,
       0,     0,  1227,  1240,     0,  1141,  1141,     0,  1231,  1232,
    1223,  1173,  1172,   598,   597,     0,     0,     0,   922,   886,
     653,   923,   887,     0,  1031,     0,  1033,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     285,  1040,   924,   281,  1041,   915,     0,     0,     0,   498,
     499,     0,   829,   830,   925,   888,     0,   916,   811,  1325,
     795,     0,     0,   806,     0,   805,  1325,  1325,   889,   153,
     243,   365,   913,   261,   274,   269,   270,   268,  1798,   285,
    1798,   285,     0,     0,     0,     0,   271,   266,   267,   263,
     276,   277,   897,     0,   291,   294,   278,   257,     0,   262,
     258,     0,   241,     0,     0,  1670,     0,     0,   858,     0,
       0,   144,   900,     0,   124,   126,   128,     0,   122,   130,
     125,   127,   129,   123,   131,   121,     0,   120,     0,     0,
       0,   114,   931,   893,   457,   462,   895,   465,   918,   463,
    1710,  1771,  1906,     0,   505,   507,     0,   512,   937,   913,
     894,     0,   917,   933,   902,     0,     0,     0,     0,     0,
       0,     0,  1046,     0,     0,     0,   932,   909,   920,     0,
     901,   896,   919,     0,     0,   195,   194,   196,     0,     0,
       0,     0,     0,     0,     0,     0,   688,   664,   687,     0,
       0,     0,     0,     0,     0,     0,   658,   323,   301,   302,
       0,     0,   300,   306,     0,   599,     0,     0,  1307,  1303,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1323,
       0,     0,  1029,  1029,  1029,  1029,  1029,  1029,  1029,  1010,
    1038,   483,   501,     0,     0,     0,     0,   135,   112,     0,
     621,   587,     0,     0,   398,   158,     0,     0,     0,   489,
     586,   584,   583,   585,     0,     0,     0,   604,     0,  1299,
       0,     0,     0,   447,   352,     0,     0,   349,   353,   357,
     358,   359,     0,   442,   444,     0,     0,   433,     0,     0,
       0,   800,     0,   818,   801,     0,     0,     0,   838,   843,
     839,   821,     0,   473,  1160,  1161,     0,  1175,     0,  1264,
       0,  1263,  1275,     0,     0,  1281,  1279,     0,  1281,     0,
    1281,     0,  1256,     0,  1258,  1275,     0,  1665,  1751,  1296,
    1126,   285,     0,     0,   495,   285,     0,   285,     0,   285,
     285,     0,   969,   522,     0,   572,     0,     0,   285,   634,
    1591,     0,   718,   400,     0,     0,     0,     0,   729,     0,
     471,   733,     0,   744,   739,   741,     0,   748,     0,     0,
    1123,  1124,  1139,  1132,  1134,  1133,     0,     0,  1130,  1597,
     633,     0,     0,   285,     0,   749,  1203,  1598,  1599,     0,
       0,     0,     0,  1633,     0,     0,  1510,  1486,  1488,  1324,
    1500,     0,  1337,  1511,  1512,  1490,  1492,     0,  1581,     0,
       0,  1501,  1445,  1446,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1458,  1457,  1502,
    1563,     0,     0,  1620,  1621,  1503,  1367,  1368,  1368,     0,
       0,  1627,     0,     0,     0,  1508,  1513,     0,     0,  1518,
       0,  1539,     0,     0,     0,  1468,  1591,  1359,  1360,     0,
       0,     0,     0,     0,     0,     0,     0,  1442,  1425,  1419,
       0,  1423,  1427,     0,     0,     0,     0,  1411,  1437,  1407,
       0,     0,  1413,     0,  1438,  1198,  1198,  1198,  1198,  1195,
       0,     0,  1251,     0,  1236,  1207,  1207,     0,  1547,     0,
    1476,     0,  1547,     0,     0,   180,     0,   204,   191,     0,
       0,     0,  1144,  1125,  1147,  1063,  1210,     0,  1582,   789,
     787,   788,  1212,     0,     0,  1247,  1246,  1245,  1220,   921,
     885,   914,   948,  1029,   759,   760,     0,   758,     0,     0,
       0,   390,   774,     0,     0,     0,     0,  1043,   482,     0,
     481,   477,   497,   823,     0,  1325,   798,   803,   804,     0,
     362,     0,     0,     0,   244,     0,     0,   256,     0,   252,
     272,   264,   273,   265,   288,     0,     0,     0,   259,   260,
     927,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     928,     0,     0,   117,   116,     0,   134,     0,   509,   510,
     508,   504,     0,   511,   513,   941,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   926,   890,
     659,     0,     0,   660,   668,     0,     0,   661,     0,     0,
       0,     0,     0,     0,   670,   326,     0,   329,   336,   310,
     314,  1045,  1045,     0,   315,  1045,   311,  1045,   308,  1855,
    1571,  1572,   595,   602,   592,   594,   596,   593,     0,   601,
     567,     0,     0,     0,  1308,     0,  1376,  1377,  1378,  1379,
    1380,  1381,     0,  1375,  1382,     0,  1029,  1028,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   376,     0,
       0,   370,     0,     0,   843,   364,   367,   368,     0,   494,
     137,     0,     0,   138,   136,     0,   589,   590,     0,   348,
       0,     0,   542,   545,   538,     0,   603,   605,   581,     0,
    1301,   501,  1112,     0,   438,     0,   429,   383,   425,     0,
     440,     0,   427,   426,   428,     0,   435,  1007,     0,   775,
     799,     0,     0,     0,   836,   840,   837,     0,     0,   814,
       0,   822,   792,   964,   965,   962,   963,     0,     0,  1152,
    1266,  1273,     0,  1254,     0,  1280,  1276,     0,  1277,     0,
       0,  1278,     0,     0,  1273,     0,     0,     0,   855,     0,
     285,   853,     0,   628,     0,   630,   857,   285,   285,   530,
       0,   486,   444,     0,     0,     0,   728,   746,     0,   742,
       0,     0,   711,   751,  1119,  1122,  1137,  1135,   754,     0,
     712,   753,  1602,  1343,     0,  1635,  1631,     0,  1603,     0,
    1615,  1614,  1444,  1616,     0,  1463,     0,     0,  1455,  1453,
    1454,  1447,  1448,  1449,  1450,  1451,  1452,  1456,  1625,  1624,
    1618,  1619,  1363,  1361,     0,  1505,  1506,  1507,  1626,  1514,
       0,  1533,  1532,     0,     0,     0,  1520,     0,     0,  1529,
       0,  1565,  1349,  1382,  1387,     0,     0,  1410,  1630,  1428,
       0,     0,     0,  1406,     0,     0,     0,     0,  1415,  1581,
       0,     0,     0,     0,     0,     0,  1190,  1189,  1294,     0,
    1238,     0,     0,  1206,     0,  1547,  1483,  1550,  1545,  1546,
    1595,  1477,  1682,     0,  1593,  1547,     0,  1644,     0,  1151,
    1142,     0,  1211,  1228,  1221,     0,   765,   766,   764,     0,
       0,     0,   567,     0,     0,   406,     0,   783,   783,     0,
       0,   843,   936,   478,   824,     0,   816,     0,   249,   912,
       0,     0,     0,   248,     0,   285,   285,   292,   293,   296,
       0,     0,     0,     0,     0,   622,   608,     0,     0,   623,
     624,     0,     0,   860,   861,   859,   132,   118,   119,   133,
     506,   898,     0,     0,     0,     0,     0,   935,   908,   934,
     906,   905,   907,   899,   532,     0,   662,     0,     0,   663,
     674,   672,   671,   673,   665,   327,   111,     0,   307,     0,
     334,     0,   332,   331,   333,     0,     0,     0,     0,     0,
       0,   569,     0,     0,   574,   563,   565,     0,     0,     0,
    1304,  1309,  1384,  1317,   562,     0,  1020,  1019,  1018,  1022,
    1021,  1024,  1023,  1015,  1014,  1027,  1026,  1013,  1012,  1017,
    1016,     0,     0,   374,   378,   379,   377,   369,   843,   398,
     437,     0,   140,   139,     0,     0,     0,     0,   547,   551,
     582,     0,  1300,   526,  1110,   445,     0,     0,   355,   360,
     361,     0,   433,   380,     0,   429,   354,   443,     0,     0,
     439,     0,  1002,     0,     0,   802,   819,   820,     0,     0,
     843,   842,     0,   480,  1265,     0,     0,  1267,     0,     0,
    1269,  1271,     0,     0,     0,     0,     0,  1668,  1547,  1297,
     285,   496,   285,   285,   970,   573,     0,   738,   737,   736,
     472,     0,   740,   285,     0,  1634,  1499,  1509,  1613,     0,
       0,  1464,     0,     0,  1504,  1996,     0,     0,  1537,  1538,
    1519,     0,  1840,  1524,     0,     0,     0,  1685,  1434,  1432,
    1429,     0,  1430,     0,     0,  1412,  1408,     0,  1414,  1439,
    1194,  1193,  1192,  1191,     0,     0,  1541,  1547,  1547,  1478,
    1552,  1549,     0,  1480,  1382,  1148,     0,  1035,     0,     0,
       0,   392,     0,   843,     0,     0,     0,   781,   786,   786,
       0,   843,   437,   817,   245,   246,   247,   250,   287,   255,
     251,     0,   929,   891,     0,     0,   614,     0,     0,     0,
       0,   930,   892,     0,     0,     0,  1051,     0,     0,   666,
     667,   309,     0,   330,   339,     0,   337,   312,   317,     0,
     319,   318,   313,   316,   571,   570,   568,   564,   566,  1305,
       0,   874,   874,     0,   567,  1025,     0,     0,   366,   437,
     405,     0,   371,     0,   502,     0,  1007,   350,   501,   546,
       0,     0,     0,   606,   446,   351,     0,     0,   435,     0,
       0,     0,   433,     0,   430,     0,   434,     0,     0,     0,
       0,     0,   841,     0,   845,     0,   813,   790,  1295,     0,
     484,     0,  1274,  1283,     0,  1270,  1268,  1259,     0,  1261,
     875,   629,   631,   531,   743,   750,   285,  1459,     0,     0,
       0,     0,  1515,     0,  1516,  1521,  1525,     0,  1522,  1523,
    1431,  1435,  1433,  1416,  1235,  1237,     0,  1176,  1481,  1482,
       0,  1207,  1547,   205,  1583,   744,     0,   285,   783,   437,
     407,  1855,   408,   782,   789,   789,     0,   437,   567,     0,
     253,   295,     0,     0,   620,   609,     0,     0,   625,     0,
       0,     0,     0,     0,   669,   299,   325,   335,     0,   320,
     874,     0,   871,   870,   561,     0,   373,   372,     0,   416,
       0,   500,     0,   618,  1003,   514,   548,   549,   544,     0,
       0,   356,   365,   341,   389,   388,   385,   384,   386,   387,
     382,   381,     0,   435,   431,   432,     0,  1004,     0,  1053,
       0,   776,   844,     0,     0,     0,   479,   474,  1272,     0,
    1260,   713,  1460,     0,  1461,     0,     0,  1527,  1526,  1540,
    1542,     0,     0,  1555,  1479,   761,     0,   762,   786,   411,
       0,   779,   778,   398,   567,   393,   286,     0,   612,   619,
     610,   620,     0,     0,  1047,     0,  1048,  1049,  1052,   338,
     869,   873,   872,     0,   402,   403,   404,     0,   375,   412,
     413,     0,   503,     0,     0,     0,     0,   363,   424,   340,
    1005,  1006,   290,     0,   843,   846,   968,  1282,  1462,  1530,
    1517,  1528,     0,     0,  1551,     0,     0,     0,     0,   789,
       0,   567,     0,   405,   394,     0,   611,   627,   626,     0,
       0,     0,     0,     0,   414,     0,   415,   436,   617,     0,
     550,     0,     0,   435,   777,   791,   967,   966,     0,  1543,
    1544,  1958,  1751,  1934,     0,  1553,  1556,  1554,  1548,   285,
     780,     0,   395,   409,   416,     0,  1050,   551,   421,     0,
     420,     0,   418,   417,   607,   554,   289,  1295,   950,   961,
     949,   951,   959,   956,   958,   957,   955,     0,  1560,  1559,
    1558,  1562,  1561,   763,     0,   567,   613,     0,   419,   423,
     422,   556,   558,   559,     0,   552,   555,   557,   560,   767,
       0,   960,   954,  1175,  1162,     0,   410,   396,     0,   533,
       0,   952,   961,  1557,     0,   553,   953,     0,   554,     0,
     534
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    50,    51,    52,    53,  1126,  1932,  1830,  2497,  2498,
      54,    55,  1187,    56,    57,    58,    59,    60,    61,    62,
    1159,    63,    64,   819,  1317,  1943,    65,  1739,   658,  1582,
    1583,  1883,  1584,  1573,  1047,  1399,  1127,  1150,    67,    68,
    1041,  1564,    69,    70,    71,  1172,  1173,  2814,  1354,  3600,
    1817,  3773,  2353,  2354,    72,    73,  2460,  1263,  2462,  2463,
    2898,   502,  1906,  3246,  3247,  2886,  2887,  3253,  3475,  3476,
      74,  1314,  2526,  2976,  2527,  3317,  2528,  3318,  2529,  3319,
    2490,  2945,  2946,  2947,  2530,  3323,  3650,  2531,  1754,   914,
    1418,  1419,  3629,  3174,  3175,  3751,  3718,  3719,  3720,  3802,
    3325,  2537,  2986,  3330,  3502,   577,  1334,  1974,  2532,  2533,
    2974,    76,    77,  1969,  1203,  1204,  1836,  2902,  2611,    78,
     836,  2800,  3540,  2491,  2492,    79,   189,    80,  1321,    81,
      82,    83,    84,  2949,  3503,  1209,  2403,  2404,  2405,  2406,
    2853,    85,  1319,  1210,  1952,    86,    87,    88,  1872,    89,
      90,    91,  1328,  1963,  1964,  3309,  3510,  3638,  3512,  3834,
    3835,  3494,  3264,  3265,  3266,    92,    93,    94,    95,  1313,
    1935,  1936,  2903,  1115,  1267,  1909,  1910,  2965,  2966,    96,
    3205,  3206,   529,  3724,  3700,    97,    98,  3209,  3210,    99,
     100,   101,   102,   103,   571,   879,   880,  2327,   104,  1678,
     105,   798,  2447,   106,   600,   894,   895,   107,   108,   609,
    2086,   611,  1432,  2613,  2614,  3052,  2051,   733,   109,   110,
    2061,  2089,   111,  1130,  1745,  1746,  3169,   112,   530,  1339,
    1977,  2296,  3660,  3176,  3438,  2259,  2772,   113,   531,  1155,
    1783,  1980,  2542,  2543,  1785,  2226,  2998,  1787,  2544,  2549,
    2550,  2551,  2994,  3002,  3534,  3535,   114,  1152,  1776,   115,
     116,   117,  1182,   751,   118,   543,   544,   119,  3622,   120,
     849,   121,   628,  1449,   122,  1798,  2815,   123,   124,   125,
    1129,   126,  3810,  3840,  3841,  3842,  3007,  3778,   127,  3812,
     925,   129,   130,   131,   165,   770,   771,   772,   132,  3332,
     133,   134,  1929,  2489,  2928,   135,   136,  1740,  2286,   137,
     138,   139,  1307,   140,   141,   142,   143,  1245,   144,  1078,
    1079,   145,   146,   497,   676,  1082,  1090,   147,   579,   888,
     889,   890,  1401,   148,   928,  2078,   580,   882,   150,   581,
    1438,  2063,  2064,  2067,   582,  1349,   153,  1442,  2072,  2075,
     583,  1681,  1682,  1683,  1684,  1685,  2243,   584,   602,   839,
    1985,   585,  1013,   158,   159,   160,   161,   680,   681,  1558,
    2216,   618,  1097,   646,   692,  3143,  1698,  1699,  1719,  1720,
    1106,  1107,  1709,  1711,  2261,  1712,  2270,  1704,  3140,  3416,
    1715,  1716,  1109,  1110,  2265,   162,  2220,  1989,  1990,  1991,
    2561,  2571,  3016,  3350,  1992,   923,   673,  1993,  2744,  1998,
    2518,  2519,  1788,  1916,  1291,  1014,  1292,  1927,  1015,  1482,
    1294,  1016,  1017,  1018,  1297,  1019,  1020,  1021,  1022,  1466,
    1522,  1023,  1024,  1501,  1924,  1925,  1390,  2129,  1026,  1027,
    3109,  3395,  3386,  2154,  2155,  1579,  3105,  3577,  3679,  3680,
    3151,  3148,  3420,  3581,  3747,  3785,  3786,  1028,  2207,  1551,
     753,  1029,  2905,  1553,  2149,  2228,  2229,  1726,  1464,  2096,
    2113,  2114,  2126,  2660,  2133,  2138,  2683,  2684,  2150,  2176,
    1030,  2099,  2100,  2644,  1468,  1031,  1069,  1070,  1461,  2172,
    1085,  1086,   678,  1032,  1033,  1433,   667,  3346,   857,   728,
    2364,  1669,   774,   615,  1034,  1035,  1036,  1037,  2615,  1178,
     493,   723,  2407,   494,   495,   725,  1674
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3302
static const int yypact[] =
{
   11515,   838,  2630, -3302, -3302,   838, -3302, 42716,   -50,   105,
     936,   121, 10391, 43123, 50042,   702,   382,   747,  7027,   838,
   50042,  2426, 33762, 38646,   916, 50042,  1170,   945, 33762, 50042,
   50449,  1062,   775, 50856, 43530, 37018,   969, 50042,   793, 51263,
   43937,   991, 44344,   945, 30933, 44344,    71,   913, 51670,  1141,
    1440,  1082, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302,   -50, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302,   151, -3302,   873,
     159,  1046,  1028, -3302, -3302, -3302, 34983, 50042, 50042,  1224,
   50042,  1431, 34983, 50042, 50042,  1274, 28017, -3302, 50042, 50042,
   50042, 50042, 44344, 50042,  1204, 50042, 50042, 52077, 50042,  1384,
     127, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, 50042,  4368,  1170,
   -3302, -3302, 50042,  1189, 34983, 50042,  1165,  1239, 50042, -3302,
   50042,  1509,   786, 50042,   950, 28437,  1319, 50042, 50042, 50042,
   50042, -3302, -3302,  1320, 50042, 50042, -3302, 52484,   -12,  1559,
    1523,   120, -3302, 44751, -3302, -3302, 44344, -3302, -3302, -3302,
   -3302, -3302, 45158,   747, -3302, -3302, 35390, 50042,  1510, -3302,
   52891, -3302,  1609, 35797, 53298, -3302, 28857,  1663, 53705, 54112,
   -3302, -3302, 54519, -3302, 54926,  1404, 55333, -3302, 55740, -3302,
    1541, 56147, -3302,  1358,   843,  1947, 25119, -3302,   -50, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302,   258,   738,   172,
     153,   248, -3302, -3302,   158,   166,   168,   258,  1736,  1736,
   -3302, 50042, -3302, -3302,   738,   506,  1369,  1369,  1369,  1561,
     -45, -3302,  1369, 50042, -3302, -3302, -3302, -3302, 44344, -3302,
    1324,  1170,  1379,  1780, 50042, -3302, 50042, -3302, 50042, 50042,
   -3302, -3302,  1796,  1447,  1656,  1417, -3302,  1606,  1610,  1617,
      75,  1170,  1535, -3302, -3302,  1645, 16705,  1170, 45565, 56554,
     272, 45158,  1170, 45972,  1461,   127,  1643, -3302,   603, -3302,
    1879,  1524,  1756,  1417,   127, 25945, -3302,  1542,   984, 44344,
   -3302, -3302, 56961,  1646, -3302,   192,  1821, 17129, -3302, 50042,
    1556, -3302,  1568,  1584,  1585, -3302, 11515, 50042,   932,   932,
    1948,   932,  1390,  1391, -3302,  1801, -3302,   913,   180, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302,  1601,   984, -3302,   204, -3302,  1134,  1619,  1278, -3302,
   -3302,   189,  1636,  2522,  1611,   427, -3302,  3002,   254, -3302,
   50042, 50042, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302,  1620, -3302, -3302,  1625,    84,  1293,  3402,   944,  2791,
      66,   212,  1806,  1345,  1922,  1119,  3147, 50042,  1858,   521,
   -3302,   592, -3302,  1710,  1835,   593, 34983,  1666, -3302, 50042,
   -3302, -3302, -3302, 34983, -3302,  1852, 29277, -3302, 50042, -3302,
   -3302, -3302, -3302,  1787, 50042, -3302, -3302,  1926, 50042, -3302,
    1369,   374,  1701,  2072, 62615, 50042,  1754,  2122,  1775, -3302,
   -3302,  1754, -3302, -3302, 50042, 50042,  1749,  1157,  1754,  2143,
    2159,  1826,  1932,   705,  1380,   140,  2057,  1754, 50042, 50042,
   50042, 50042,  2132, 34983, 50042, -3302,  1924, -3302, -3302,   732,
    1832, -3302, -3302, -3302, -3302,  2076,  1601,   700,  2077,  1791,
    2078, -3302,  1822,  2086,  1611,  2087,  1793, -3302, 57368, 57775,
    2092,  1620, 50042,  2094,  1793,  2095,  1980,  2098,   700,  2099,
   -3302,   769,  2103,  1987,  2111,  1331,  1793, 46379,  2112,   133,
   -3302, 18825, -3302,  1902, -3302,   913, -3302, -3302,   480, -3302,
   33355, -3302,  1947,   738, -3302, 50042,   738, 50042,   738, 50042,
     738, 50042,   738, 50042, 50042, 50042,   738, -3302, -3302, -3302,
   50042,  1829, 50042, 50042, -3302, -3302, -3302, 39460, 50042, 39867,
   -3302,   690, -3302,   556,  1170, -3302, -3302, 62615,  2225, 50042,
    2114,  2114,  2114, -3302, -3302, -3302,  2053, 50042,  2116,  2117,
   39460, 50042, -3302, 58182,  1838, -3302, -3302, -3302, -3302, -3302,
    1144,  2261,   218,  2262, 18825,  1842,   209,   209,  1843, -3302,
   -3302, -3302,   207,  1845,  1847, -3302,   219,   219,  2001,  1850,
    1853, -3302,   222,  1854,  2273,  2276,   231,  1857,  1861,  1864,
     310,   209, 18825, -3302,  1865,   219,  1866,  1870,  1874,  2297,
    1877, -3302,  2299,  1881,   144,   304,  1882,  1883, -3302,  1850,
   -3302,   208,  1884,  1892,  1893,  1894,  1897,  1900,  1901, 18825,
   18825, -3302, 15857, -3302,  1170, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302,   117, -3302,   237,  4162, -3302, -3302,  2067, 18825,
   -3302, -3302,    52, -3302,   238, -3302, -3302, -3302,   984, -3302,
   -3302,   214,  1905, -3302,  1373, -3302, -3302, -3302, -3302, -3302,
   -3302, 40681,  2300, -3302,   349,   592,   256,  2243, 32541, 32948,
   -3302, -3302,  2127, -3302, 50042, -3302, -3302, 18825, 30526, -3302,
     984,   115, 50042, -3302, 26358, -3302, -3302, -3302,  1231, -3302,
   -3302, -3302,   -50, -3302, 10245, -3302,  1270,  1556, 50042, 50042,
    2305, -3302, -3302, -3302,  1568, -3302, -3302,  1046,  1046, 18825,
    1046,   656,   805, 17553, 18825,  2192,  2088,   176,   981,  2194,
   -3302,  1390,  1391, -3302, 31747,  1421,   984,  1986,  1988, 34169,
    1917,  1992,  1993,  2155, 58589, -3302, -3302, -3302, -3302, -3302,
     681,   157,   691,  1994,   776, -3302, 50042,  2101,   254,  2039,
   -3302,  1999,  2000,  2115,   254,  1139, 58996, -3302, -3302, -3302,
   -3302, -3302,  2460, -3302, 14641, -3302, -3302, -3302,  2003,  1985,
   36204,  2296,  2113,    30,  1127,   205, 50042,  2189,  2011,  2013,
    1944,  1237,  1942, -3302, -3302,   361,  2109,  2060, -3302,  2004,
    2005, 61416,  2119, 29697,  2278,  2023, -3302,    50,  2026,  2029,
   -3302,   254, -3302,  2339,   254,   254,  1033,  2341,  2033,   320,
    1230,  1754,  1942,   693, -3302, -3302,  1964,  2035,   233, -3302,
    2136,  2296,   124,  1414,  1942, -3302,  2040,  2043,  1944,  1944,
   50042, 50042, 50042, 50042, 50042,  2045,  2046,  2084, -3302, 41088,
    2049, 56554, -3302, -3302,  2051,  1495,  1942, -3302,  1140,  1015,
   -3302, -3302,   127, -3302, 50042, -3302, 50042,  1601, 62615,  2148,
    1611,   254, 50042, 50042,  1620,   980,   774,  2157, 50042,  2219,
    2022, -3302, -3302,  1754, -3302, 32144,  1749, -3302,  1990, -3302,
   -3302,  2034, -3302,  2034,  2034,  1996,  1996,  1997, -3302, -3302,
   -3302,   310,  2034,  1996, -3302, 63407, -3302,  1101,  1226, -3302,
    2388,  2390, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302,   621,  1199, -3302,  2404, -3302, -3302, 62615, 50042, -3302,
    2321,  2050, 34169, -3302,  2041, -3302, 50042,   790,  1170,  2048,
   50042,  2217, 50042, 50042, 50042, 50042, -3302, -3302,   613,    68,
   -3302, 41088, -3302,   693,  2406,    12,  1369,  2290, -3302, 50042,
    2012,  2408,  2245, -3302,   972, -3302,  2131, -3302, 23467,  2055,
   34983,   700, -3302, -3302, -3302, -3302, 62615, 50042, 59403, 34983,
     700, 50042, 50042,  2315,  2091,  2335,  2096, 29697,   700,   299,
   50042, 50042, 50042, 50042, -3302, 50042, -3302, -3302, -3302, -3302,
   50042, 50042, 50042, 41088,  2336,  2340,   700, 50042, 50042, -3302,
   10245,  1312, 50042,  1947, 40274, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, 50042, -3302, 50042, -3302, 50042, -3302, 50042,
   -3302, 50042, -3302, -3302, -3302, 50042, -3302, 50042,  1328, -3302,
   -3302,  1340,   102, 50042,   154, 34983, 50042,  2227, 50042, 50042,
   50042, 50042,  2120,  1905,   990, -3302,  2097, 25532,  2178, -3302,
     182, 44344,  2241, -3302, -3302,  1367,  1233,   846, -3302, -3302,
   -3302, -3302, -3302, -3302, 39867, 38646,  2334,    79, 50042, -3302,
   18825,   984, 16281, -3302, -3302, -3302,  2065, 10245,  2104, 18825,
   -3302, -3302, 18825,  1736,  1736, 18825, -3302, -3302, -3302, -3302,
     832,  1736, -3302, 18825, 18825,  1736,  1736,  2034,  2034, -3302,
    6502, 18825, -3302, 29697, 18825, 21369, 13811, 18825,  2141,  2089,
    1736, -3302,  1736, -3302, 18825, 15433, -3302, 18825,  2275, 18825,
     256,  2280, 18825,   256,  2489,  2489,  2154,  3887,  2071, -3302,
    2182,  1736, -3302,  1736,   706, -3302,   199, 62615, 18825, 34169,
    2152,   167, 18825,  2100,  1272, -3302, 18825,   193, -3302,  2102,
   18825,  2161, 18825, 18825, 18825, 18825, 18825, 18825, 18825, 18825,
   18825, -3302, 22217,   397,   557,  2277, 46786, 16705,  2360, 13386,
   -3302,   203, -3302, -3302, -3302, 50042,  2300, -3302, -3302,  2162,
   -3302, -3302, -3302, -3302, -3302,   241, -3302, -3302, -3302, -3302,
   -3302, -3302,  2083, -3302, -3302, -3302, -3302,  2083, -3302,  2105,
    3337, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302,  2351,  2357,   700, -3302,
   50042,    94, -3302, -3302, -3302,  2121, -3302, 50042,   192, 41495,
   -3302, 17129, -3302,  1392,  1850, -3302,  2337, -3302,  2125, -3302,
    6802,  2337, -3302, -3302,   252,  2269,  2279,  2279, -3302,  2128,
   10245, -3302,  1172, 10245,  1185, -3302, -3302, -3302, -3302, -3302,
   -3302,   897, -3302,  2192,   981,  2106,  1398,  2174,  2186,  2233,
   -3302, 50042, 50042, -3302, 34169, 50042, 50042,  2195, 50042, -3302,
    2472,   497, 38646,  2236, 37425, -3302, -3302,  2124, 50042,  2176,
    2364,  2366,  2138, -3302, -3302, 50042, -3302,  2319, 50042, 18825,
    2322, 50042,   807,  2323, -3302,   808, 50042, 50042,  2316, -3302,
   -3302, -3302, 45158, -3302,  1034, -3302, -3302,  2310, -3302, -3302,
   63407, -3302, -3302,  1399, -3302, 63011, 59810, -3302, -3302,   431,
   50042, 50042, 50042,   852, -3302, -3302, 62615, -3302, 50042, 50042,
   50042, 41902, 60206, 60613,   529,   816, 50042, 42309, -3302, 50042,
   50042, 50042, 34169, -3302, 50042,   552,   758, -3302,  2191, -3302,
    2214, -3302, 50042, 50042,  2142,  1405,  2220, -3302, 50042, 50042,
    3919, -3302, 50042, 50042, -3302, -3302,   254, -3302, -3302, -3302,
   -3302, -3302, 50042, 50042,   254, 50042,   254,  1099, -3302, 34576,
   50042, -3302, -3302, -3302, 50042, 50042, 50042, 50042, 50042, 50042,
   -3302, -3302,   842,   890,  2283,  2285,  2288, 50042, 50042, 50042,
   -3302, -3302,  2266, -3302, 50042,  3919, 50042, 50042,  2231,  2234,
     156,  2304, -3302, -3302, -3302, -3302, -3302, -3302,  2401,  2564,
   50042,  2405,  2407,  2224,  2228,  2410,   242, 50042, 50042, 50042,
   50042, 50042, 50042,  2414,   242,  2363,   130,  2185,  2202,  1412,
   -3302, -3302, 18825,  2578, 62615,  2193,  2196,  2260,  2265,  2267,
   -3302,  2198,  2271,  1736, -3302, -3302,  1348, -3302,   613,  1382,
   -3302,    26,  5353,  2480, 50042,  1420, -3302,  2216, 50042,  5353,
   -3302,  1075, 38646, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302,  2483, -3302,  1170,  1749,  1749,  1749,  1749, -3302,
   -3302, -3302,  2383,  1317, -3302,  2206, 50042,  2313,  5353, -3302,
     693,    77, 50042, 36611,  1298,  2605,  1170,  2385, -3302, 15037,
    3654,  2386, 45158,  2477,  2478,  2496, -3302, 23054, 47193,  2212,
    1424, -3302, 47193, 47600, -3302,  2218,   984, 19249,  2178,  1601,
   -3302,  2616, -3302,  2513,   700,  1611, -3302,  1793, -3302, 50042,
   50042, 50042, 50042,  1620, -3302, -3302,  1793,  2397,   700,   700,
   -3302,  2398,   700,  1793,  2332,  2509, 45158, -3302,   133, -3302,
   -3302, 18825,  2229, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302,  1427, -3302, 50042, -3302,  2488,  2490,  2491,  1793,  2268,
   50042,  2232, -3302,  1793,   254,  1793,  1905,  1905,  1793, 48007,
    2646,  2511, -3302,  1428, -3302, -3302, 16705, -3302,   635, -3302,
     639,   734,  2447, -3302, -3302, -3302, -3302, 62615, -3302, -3302,
   -3302, -3302, -3302, 50042,   109,  2418,  2242, 48007,  2624,   700,
   -3302,  1436, -3302, -3302,  1175, -3302,  1187, 18825, 18825,   305,
   -3302,  7666,  1485,  2246,  2247,  1487, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302,  2248,  2526, -3302,  2251,  1497,  1502,  2252,
    2256, -3302, -3302,  3670,  2257,  8009,  2258, 21369, 21369,  1133,
   -3302, -3302, 21369,  2259, -3302,  1513,  7104,  2272,  2264,  2292,
   -3302,  2284,  2289,  8200, 17977, 18825, 17977, 17977,  9199,  2272,
    2298,  1514, 34169,  9438,  1521, -3302, 18825, 34169,  3701, 18825,
   -3302, 18825, 50042,  2302,  2303, -3302, -3302,  6502, -3302,  2294,
   -3302, 21369, 21369,  1823, 15857, -3302, -3302,  2537, -3302, -3302,
     781, -3302,  2263, -3302, -3302,  2963,   198, 18825,  2100, 18825,
    2348, 29697,  6031, 18825,  2921,  2044,  2044,   391,   391,   228,
     228,   228,  1307,  2277, -3302, -3302, -3302,  2281,  1877, 18825,
   -3302,  1439,  1450, 50042,  2156,  2253, -3302, -3302, -3302, 23467,
    2320, 18825, 18825, 18825,  2308,  2427,  2679, 10245,   558, -3302,
    2693, -3302,   127,  1736,   706, 33355, -3302, -3302, 18825, -3302,
   -3302, -3302, -3302,  1532, 26358,  2055, 17129,   984,  1568, -3302,
   -3302, -3302, -3302, -3302, -3302, 18825, -3302, -3302,   748,  1316,
   18825,  1172, -3302, -3302, 50042,  2241,  2241, 18825, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, 50042, 50042, 50042, -3302, -3302,
   -3302, -3302, -3302,  1170, -3302,  2505, -3302, 50042, 50042,  2463,
   50042,  2462,  2467, 18825,   230, 50042,  2301,  2306,  2311, 50042,
     700, -3302, -3302, 10245, -3302, -3302,  2345,  2370, 50042,  2136,
   -3302,  2550, -3302, -3302, -3302, -3302,  2495, -3302, -3302,  1199,
   -3302, 59810, 63011, -3302, 63011, -3302,  1199,  1077, -3302,  1793,
   -3302, -3302,   141, -3302, -3302, -3302, -3302, -3302,  2604,   700,
    2606,   700, 50042, 50042, 50042, 50042, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302,  1533, -3302,   583, -3302, -3302,  2548, -3302,
   -3302,  2549, -3302, 50042,  1194, -3302,   844, 62615, -3302, 61812,
   50042, -3302, -3302,  2540, -3302, -3302, -3302,  2479, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302,   764, -3302,  2481, 50042,
    2378, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   34169, 34169, 34169,  1538, -3302, -3302,  1170, -3302, -3302,   132,
   -3302,  2403, -3302, -3302, -3302,  2541,  2545,  2553,  2409,  2420,
    2424,  2429, -3302,  2430,  2434,  2436, -3302, -3302, -3302, 50042,
   -3302, -3302, -3302, 50042, 50042, -3302, -3302, -3302,   242, 62615,
    2573,   242,   242, 50042, 50042,   242, -3302, -3302, -3302,  2575,
    2579,  2602,  2603,  2607,  2610,   242, -3302, -3302, -3302, -3302,
     374, 34169, -3302,  1675, 27597, -3302,  2792,  4174,  2373,  2196,
    2375,  1736,   173,   111,    73,  2492,  1736,  2582,  2381, -3302,
    1413,  2598,  2399,  2399,  2399,  2399,  2399,  2399,  2399, -3302,
     789, -3302,  2554, 50042,   110, 50042,  1736, -3302, -3302,  2449,
   -3302, -3302, 34169, 27597,  1369,   790,  2525,   839,  2721, -3302,
   -3302, -3302, -3302, -3302, 50042, 50042,   613,  1170,  1547, -3302,
   62615, 50042, 50042,  2432,  2396, 50042,  2400,  2393, -3302, -3302,
   -3302, -3302,  1549, -3302, 62615,   477,  2580,  2574,  1141,  2473,
   50042, -3302,  1553,    80, -3302,  1170, 45158, 61020, -3302,  3264,
   -3302, -3302,   741,  2673, -3302, -3302,  1141, 14227,  1424,  2412,
   50042, -3302,  2415, 23467,  2640,  2583, -3302, 23467,  2583,  1290,
    2583,  2650, -3302, 26771, -3302,  2421, 13386,  1248,  2592, 10245,
   -3302,   700, 62615, 50042, -3302,   700,  2470,   700,  2474,   700,
     700, 50042, -3302, -3302, 50042, -3302, 50042, 41088,   700, -3302,
   10245, 50042, -3302, -3302,  2538,  2544,  2547, 50042,  1793, 34983,
   -3302,  2435, 50042,  1008, -3302, -3302,  2596, -3302,  1141, 50042,
     984,  2437, -3302, -3302, -3302, -3302,  2723,  2727, -3302, -3302,
   -3302, 50042, 39460,   417, 50042, -3302, -3302, -3302, -3302,  2438,
    1575,  9800, 18825, -3302,  2737, 62615, -3302, -3302, -3302, -3302,
   -3302, 18825, -3302, -3302, -3302, -3302, -3302, 18825, -3302, 18825,
    2716, -3302,  2857,  2857, 62615, 21369,  1122,  1866, 21369, 21369,
   21369, 21369, 21369, 21369, 21369, 21369, 21369, 22641,  1045, -3302,
   -3302, 18825, 18825,  2731,  2716, -3302, -3302,  1074,  1074, 62615,
    2450,  2272,  2453,  2454, 18825, -3302, -3302,  1576, 34169, -3302,
   18825,  7235,  1577,  2501,  9948,   984,  4526, -3302,  2831,  1170,
   18825,  1621,  1676, 18825,  1583, 18825,  2739, -3302, -3302, -3302,
    2464, -3302, -3302, 62615, 18825, 21369, 21369,  3035, -3302,  3067,
   18825,  2466,  3759, 15857, -3302,   945,   945,   945,   945, -3302,
   50042, 50042,  2212, 18825,  2733,    35,    35,  2468,  2427, 27184,
   -3302, 18825,   457, 18401,  2471,   592,  2475, -3302, -3302,  5088,
    2484, 50042, -3302,  2178, -3302, -3302, -3302,  2482, -3302,  1316,
   -3302, -3302, -3302,  4602,  2641,  1905, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302,  2399,  1793,  1793,   125,  1793,  2755,   125,
    4654, -3302, -3302, 23880, 50042, 50042,  1589, -3302, -3302, 50042,
   -3302,  1619, -3302, -3302,  2720,  1227, -3302, -3302, -3302,  2542,
     789,   800,  1944,   106, -3302,  2558, 50042, -3302, 50042, -3302,
   -3302, -3302, -3302, -3302, -3302, 34169, 27597, 34169, -3302, -3302,
   -3302,  2557,  2562,   629,   134,  2568,  2570,  2476,  2487,  2503,
   -3302,   258,  1170, -3302, -3302,  1170,  1793,  1170, -3302, -3302,
   -3302, -3302, 34576, -3302, -3302, -3302, 50042,  2761,   643,  1444,
   50042, 50042, 50042, 50042, 50042, 50042, 50042,  2136, -3302, -3302,
   -3302,  2504,   242, -3302, -3302,  2718,  2742, -3302,   242,   242,
     242,   242,   242,   242, -3302,   170,  1618, -3302, 24706, -3302,
   -3302,  2122,  2122,    89, -3302,  2122, -3302,  2122, -3302,  2482,
    1736,   361, -3302, -3302, -3302, -3302, -3302, -3302,  2202, -3302,
     163,  1736,  1366,  2512, -3302,  2514, -3302, -3302, -3302, -3302,
   -3302, -3302,  2507, -3302,   706, 50042,  2399, -3302,   291,   280,
     292,   307, 48414, 48821, 49228,  2502, 50042, 21369, -3302,   712,
     780, -3302,  2741, 50042,  2552, -3302, -3302, -3302,  2516, -3302,
    1793, 50042, 50042,  1793, -3302, 62615, -3302, -3302,  2907,   843,
   50042,  2555,  2510,  2801, -3302,  2527,  2519, -3302, -3302, 50042,
   -3302,  2554,  1358,   804, -3302, 37832,  1298, -3302,  2776, 36611,
   -3302, 50042, -3302, -3302, -3302,  2884,  2608,  2565,  1170,  2176,
   -3302, 59810, 18825, 18825, -3302,  2529, -3302,  2534,  4306, -3302,
    1749, -3302, -3302, -3302, -3302, -3302, -3302,  2599, 50042, -3302,
   47193,  2535, 50042,  1424, 23467, -3302, -3302,  1537, -3302, 23467,
    2770, -3302, 23467, 50042,  2539, 50042,   760, 50042, -3302,  2543,
     700, -3302, 50042, -3302, 50042, -3302, -3302,   700,   700, -3302,
    2648, -3302, -3302, 50042, 50042, 50042,  1793, -3302,   254, -3302,
    2814, 48007, -3302, -3302, -3302, -3302, -3302, -3302,    79,  2822,
   -3302, -3302, -3302, -3302, 18825, 10245, -3302,  2546, 10245,  5050,
   10245,  2731, -3302,   560,  2825, -3302,  1029,  2551,   560,  1142,
    1142,   410,   410,   152,   152,   152,  2857,  1045, 10245, 10245,
   -3302, -3302, -3302, -3302,  2556, -3302, -3302, -3302,  2272, -3302,
   19673, -3302, -3302,  2589,  2590,  2566, -3302, 18825, 20097,  2559,
   63407, -3302, -3302,   706,  2489, 21369, 21369,   798, -3302,   326,
   18825, 62615,  1627,   798,  1745,  1764, 18825, 18825,  4097,   402,
   18825,  5077, 50042, 50042, 50042, 50042, -3302, -3302, 10245,  2937,
    2832, 18825,  2567, -3302,  2569,  2427, -3302, 62208, -3302, -3302,
   10245, -3302, -3302, 18825, -3302,  2427,  1170, -3302,   913, -3302,
   -3302, 29697, -3302, -3302, -3302,   258, -3302, -3302, -3302,  2644,
   38646,  2847,   163, 18825,  1638, -3302,  2609, 49635, 12960,  1642,
    1644,  2552, -3302,  1917, -3302,  2636, -3302,  2760, -3302, -3302,
    2763,   258, 50042, -3302, 62615,   700,   700, -3302, -3302,  2594,
   50042, 50042,  1736,  1736, 62615,  2581, -3302,  1736,  1736,  2585,
   -3302, 50042, 50042, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, 50042, 50042, 50042, 50042,  2873, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302,  2818, -3302,   242,   242, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302,  1754,  2899, -3302, 34169,
   -3302, 39053, -3302, -3302, -3302,  1170,  1170,  2769, 31340,  1170,
    1170, -3302,  1120,  2910, -3302,  2836,   772,  2593,  1116,  2872,
   -3302, -3302, -3302, -3302,  2877,   258, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, 18825,  1287,   560, -3302, -3302, -3302, -3302,  2552,  1369,
    2652, 34169,  1793,  1793,  2654,  1141,    53, 50042,  2909,  2643,
   -3302,  1170, -3302, -3302, -3302, -3302,  2939,  1648, -3302, -3302,
   -3302,  2645,  2574,  1149,  2615,  1298, -3302, -3302,   733, 50042,
   -3302,   240, -3302,  2897,  2622, -3302, 10245, 10245,  1170, 63803,
    3264, -3302, 50042,  2871, -3302, 50042,  1652, -3302, 18825,  2625,
   -3302, -3302, 23467,  1537,  1674, 50042,  1678, 62615,  2427, -3302,
     700, -3302,   700,   700, -3302, -3302, 50042,  1793,  1793,  1793,
   -3302,  2795, -3302,   700, 48007, 10245, -3302, -3302, -3302, 21369,
    2902, -3302,  2627, 62615, -3302,  2628,  1679,  1680, -3302, -3302,
   -3302,  5676,  2675, 10245,  2725,  2633,  2634, -3302,   935,   935,
     326,  1684, -3302, 21369, 21369,   798,   798, 18825,   798, -3302,
   -3302, -3302, -3302, -3302, 18825, 18825,  2670,  2427,  2427, -3302,
    2798, -3302,  2642, -3302,   706, -3302,  2653, -3302, 48007,  2811,
   48007, -3302,  5948,  2552, 23880, 30117, 50042, -3302,   858,   858,
    2777,  2552,  2652, -3302, -3302, -3302, -3302, -3302,  2692, -3302,
   -3302, 27597, -3302, -3302, 24293, 29697, -3302,   629,  2647,  2651,
     134, -3302, -3302,  1021,   600,  2677,  1793,  2927,   242, -3302,
   -3302,  2185,  1170, -3302, -3302,  1685, -3302, -3302, -3302, 50042,
   -3302,  2510, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   34983,  3048,  3048, 50042,   163, -3302,  6235,  2838, -3302,  2652,
    2865,  2911, -3302,  1698, -3302, 50042,  2565, 36611,  2554, -3302,
     959,  2657,  2952, -3302, -3302, -3302, 37832,  2834,  2608,   177,
     177, 50042,  2574,  2780, -3302,  2785, -3302,  3036,  2839,  3037,
   50042, 23880, -3302, 63011, -3302,  1702, -3302, -3302,  2320, 50042,
      26,  1706, -3302, 10245, 50042, -3302, -3302, -3302,  1708, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302,   417,  1261, 21369, 62615,
    1712, 18825, -3302, 18825, -3302, -3302, -3302,   534, -3302, -3302,
   -3302,   935,   935,   798,  2272, 10245, 50042, -3302, -3302, -3302,
    3050,  2840,  2427, -3302, -3302,  1008,   125,   417, 49635,  2652,
   -3302,  2674, -3302, -3302,  1316,  1316, 50042,  2652,   163, 18825,
   -3302, -3302, 62615,  1611,   565, -3302, 62615, 62615, -3302, 50042,
   50042, 50042, 50042, 50042, -3302, -3302, -3302, -3302, 39053,  2510,
    3048,   273, -3302, -3302, -3302,  2957, -3302, -3302,   627,  2852,
    2759, -3302, 34169,  2969, -3302, -3302, -3302, -3302, -3302, 18825,
    2828, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302,  1713,  2608, -3302, -3302,  2856, -3302,  2860, -3302,
    1714, -3302, -3302,  4306, 63803,  3001, -3302, -3302, -3302,  1721,
   -3302, -3302,  1261,  1722, -3302,  1727,  1742,  2740, -3302,  2687,
   -3302,  3090, 18825,  1061, -3302, -3302,  2972, -3302,   858,  2734,
   29697, -3302, -3302,  1369,   163, -3302, 10245,  1746, -3302, -3302,
   -3302,  2837,  1762,  1763,  2698,  2738,  2698, -3302,  1793, -3302,
   -3302, -3302, -3302,  3010, -3302, -3302, -3302,   325, -3302,  2882,
    2883, 50042, -3302, 50042,  3105,  6348, 34983,   789, -3302, -3302,
   -3302, -3302,  2744, 23880,  3264, -3302,   882, -3302, -3302, -3302,
   -3302, -3302, 50042,  2712,  2272, 20521, 20521,  2714, 48007,  1316,
    2713,   163,  2715,  2865, -3302, 34983, -3302, -3302, -3302, 50042,
    2843,   226,   226,  3042, -3302,  2771, -3302, -3302, -3302,   629,
   -3302,  2726,  1944,  2608, -3302, -3302, -3302, -3302,  1145, -3302,
   -3302, 21793,  2846,   660,  7425, -3302, -3302, -3302, -3302,   417,
   -3302, 18825, -3302, -3302,  2852,  1611, -3302,  2643, -3302,  3129,
   -3302,   194, -3302, -3302,  2581, 38239, -3302,  2320, -3302,  1604,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302,  3128, -3302, -3302,
   -3302, -3302, -3302, -3302,  6743,   163, -3302,  3023, -3302, -3302,
   -3302, -3302, -3302, -3302,  1768, -3302, -3302, -3302, -3302, -3302,
    1555, -3302, -3302,  1593,  1585, 20945, -3302, -3302,  2876, -3302,
   38239, -3302,  1604, -3302, 34983, -3302, -3302,  2735, 38239,  1774,
   -3302
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3302, -3302, -3302,  2493, -3302,  -703,    29,  1928,  -718, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -3302, -3302,  1223, -3302, -3302,   108,  1252,  2130,
     948, -3302,  -864, -3302, -3302,  -497,   136,  -578, -3302, -3302,
   -3302, -3302, -3302, -3302, -3302,   845,  1372,  2461,  -589, -3302,
   -1146, -3302, -3302,   359, -3302, -3302, -3302,   731,  -278, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302,   -55, -3302, -3302,  -419,
   -1226,    34, -3302, -3302, -3302, -3302,   223,  -319, -1016, -3302,
   -2260, -3302,   -89, -3302, -3302, -3302,  -314, -1099,   914,  -594,
    -901,  1166,  -542, -3302,  -222, -3302,  -581,  -506,  -504,  -541,
   -3302, -2806, -3027, -2769, -2348,   137, -3302, -3302, -3302,   239,
   -3302, -1215, -3302, -3302,  1889, -1068, -3302,  -571, -3302, -3302,
   -3302, -2846, -3302,  1463,  -310, -3302,   113, -3302, -3302, -3302,
   -3302, -3302, -3302, -2816, -3302, -1145, -3302,   379, -2307,   833,
   -3302, -3302, -3302,  1916, -3302, -3302, -3302, -3302, -1257, -3302,
   -3302, -1207, -3302,  1308,   722, -3302, -3302, -3302,  -558,  -618,
    -607, -3302, -3026,   -22,   -20, -3302, -3302, -3302, -3302,  -775,
   -3302,   750, -2386,  -719, -3302, -3302,   783, -3302, -3302, -3302,
    -516,  -203,  1945, -3302,  -445, -3302, -3302, -3302,  -200, -3302,
   -3302, -3302, -3302, -3302, -3302, -1352,  -119,  -698, -3302, -3302,
   -3302, -3302, -1504, -3302,  3229,  1453,  1220, -1201, -3302,   -30,
      45,  2343,  -883, -2024,   213,  -322, -3302, -1388, -3302, -3302,
   -3302, -1940, -3302, -3302, -3302, -3302, -2656, -1198, -3302, -3302,
   -3302,   277, -3302, -3260, -2992, -3189, -2668, -3302, -3302,  -847,
   -3302, -3302, -3302, -1077,  1484, -1123, -3302, -1730,   281, -2855,
    -573, -2464, -3302, -2787,  -390, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302,  -841,  -492, -3302, -3302,  2732, -3302, -2701, -3302,
   -3302, -3302, -3302,   834, -3302,   183, -3302, -3302, -3302, -3302,
    -652, -3302, -3302, -3302,  -500,  -575, -3302, -3302, -3302,   138,
   -3302, -3302, -3302, -3302,  1918,  -729,  -596,  2618, -1197,  -227,
   -3302, -3302, -3302, -3302, -2308, -3302, -3302, -3302, -3302, -3302,
   -3302, -3302, -1202, -3302, -3302, -3302, -3302, -3302, -3302, -3302,
    1592,  1594,    49,   -14, -3302, -3302, -1018, -3302,  -441, -3302,
    1890, -3302, -3302, -3302, -3302, -3302,   139,   314, -3302,     2,
   -3302, -3302,   668, -1889,     3, -3302, -3302, -3302, -3302,  -428,
       4, -3302,  1044, -3302, -3302, -1584, -3302,   142,   181, -3302,
   -3302,     1,     0,   -40,   -36,    -5, -3302,  2613,  2205, -3302,
   -3302,   -15,  1342, -3302,  -685,  -144, -3302,  1039,  -527,  1573,
    2197,  2201, -3302,  1032, -3302, -3302,  1040, -3302, -3302, -3302,
    -501,  1580, -3302,  2200,  1603, -3302,  1630,  1093, -1908,  1327,
   -1870,   746,  -449,   -37,    33,  2655,  2783, -3302, -3301,  1078,
   -2654,   351,  -458,  1415, -1238, -3302, -3302,  -867,  6683, -3302,
   -3302, -3302,  7591,  7795, -3302, -3302,  7807,  8482, -3302,  -752,
     618,  8780,  4502,  -941, -1471,  -829,  7272,  -769,  -791, -1279,
   -3302, -3302, -3302,  -234,   630,   412, -3302, -3302, -3302,  -411,
   -2112,  -410, -3302, -3302, -3302,  -414, -2671, -1413, -3302,  -170,
   -3302,  9323,  1079, -3302,  -823, -2021, -2095,  -893, -1402, -3302,
   -3302, -3302, -3302, -3302, -3302, -3302, -1206, -2510,  -439,  1159,
   -3302, -3302,  1250, -3302, -3302, -3302, -1004,  -682, -1534,  1164,
   -1543, -3302,  -672,  1285,  1798,  -629,  -147,  -470,  4859,  -421,
   -1737,  -974,  -942, -3302,  -136, -3302,    16,    -9,   -81,    -6,
    3000,  6334, -1025,  6000, -1029,  -979, -2334
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2009
static const yytype_int16 yytable[] =
{
     157,   156,   151,   152,   154,   639,   752,  1360,   545,   684,
    1111,   503,  1421,   915,   916,   693,   604,   616,   920,  1042,
    1368,   157,   604,   816,  1813,  1113,  1398,   737,   669,  1120,
     721,  1786,  1753,   757,  1445,  2028,   734,  2052,   603,  1672,
    1116,   766,  1243,  1670,   603,   841,   528,  1913,   726,   683,
    1330,   731,  1186,  2165,  1503,  2323,  2325,  1456,  1391,  1055,
    2095,  1795,  1232,  2633,   861,  1853,  1675,   763,   610,  1994,
     578,  2810,  1860,  1861,  1967,   666,  1695,  1784,   672,  2558,
     640,  1153,  2131,  1266,   856,  3001,  2366,   806,   864,  1673,
    1672,  1944,   735,  2848,  1670,  2850,  2242,   755,   876,  1476,
    1477,  3162,  1945,  1305,  1190,  1205,   765,  1215,  1309,  2580,
    1946,  1228,  1675,  2750,  1237,  1315,  1947,  2957,  1492,  1948,
    1949,  2617,  2572,  2574,  1332,   695,  2024,  1351,  2747,   851,
    2907,   570,   687,  3171,   884,  1848,    66,    75,   128,   149,
    1673,  2210,   155,  3340,  1794,  1733,  3431,   657,  2252, -1368,
    1128, -1163,  2247, -1785,  1049,  3313,   696,  3300, -1819, -1166,
    1151,   694,  3343,  2664,   501,  1105, -1839,  1176, -1869,  2907,
    3322,  1329, -1720,  3090,  1520,  2929,  2930,  2931,  2932,  2933,
    2934,   586,   586,  1352,  2992, -1698,  3439,  1233,   491,  1518,
    1797,  1108,  1676, -1698,   896,   535,  1965,  2500,  2068,  3644,
    2745,  2746,  2170,  3189,  1470,  1471,  1260,  1131, -1675, -1699,
    1759,  2522, -2008, -1353, -1358,   759,  1747, -1699,     3,     4,
   -2008, -1569,   674, -1358, -1325,   941,  2435, -1338, -1569,  1489,
    1804,  1748, -1163,  2170,  2186,  2088, -1365,  3665,   541,  1527,
   -1166,  1556,   541,   541,  2219,  3645,   541,   541, -1788,  3594,
    3595,  2049,  3646,  2811,  1184,  2045,  2306,   586,  1174,  2631,
    1972,   586,  2811,   586,  1530, -1353, -1358,   586,  2951,  3261,
     900,  3661,   833,  2587,  2916,  2589,  3798,   541,  3166,  1374,
    2458,  -328,  3647,  1672,  1220,   541,  3207,  1937,  1749,  1747,
    1389,  3527,  2919,   690,  1254,  3518,   541,   541,  3829,  3528,
     586,  1972,  1885,   592,  1750,   828, -1163,  3711,   592, -1368,
    1132,   918,   541,  1714, -1166,  2069,   592,  1101,   592,  1400,
     768,  1562,   592,   593,  -111,  1221,  1243,  3257,   593,  -111,
    2917,  1216,  1577,  1673,   829,   496,   593,  1527,   593,  1800,
    3262,  1075,   593,  1076,  3190,   752,  1290,  1503,    34,  1352,
     773,  3648,  1570,  1174,   541,   800,  1561,   498,   586,  2187,
    1217,  1749,  1530,  2188,  1218,  1819,  1487,  1488,   802,  3354,
     586,  3356,  3258,  1231,  1578,   830,  1046,  1750,  1185,   541,
    1386,  1563,  -143,  1103,  3279,   919,   752,  1921,  3208,  1219,
    1801,   807,  1369,    38,  3442,  3276,  3281,  1978,   592,  2189,
    2456,  3263,  1527,  1891,   537,  2308,   825,  -143,  1476,  1477,
     846,  3283,   769,  1895,  1677,  2952,  1492,   854,   593,  2204,
    2046,  2664, -1838,    42, -1585,  1921,  2205,  1530,  2642,   834,
    2812, -1585,   811,  1353,  3761,  1751,   818,  3830,  1973,  2812,
    3198,  3191,  3712,  3167,  3192,  1156,   827,  1123,  1434,  2047,
    3529,  1402, -1163,  1571,  1133,  2813,  3799,  2092,    47,  1447,
   -1166, -1325,   541,  1730,  2813,  3141,   921,  1352,  3625,  1444,
      48,  1457,  3168,  3774,  2050,  3165,  1851,  1125,  1222,  3507,
    1855,   932,  1557,  1574,   835,  2446,  2459,  1585,  1585,  2070,
     799,  1911,  2907,  2993,  1966,  3653,  1844,   675,  1846,  3749,
    1672,  1043,  1805,    49,  2168,   919,  3839,  2071,  1751,  1362,
    2171,  3499,  1134,  1884,  1806,  3649,  2041, -2009,  1065,  3522,
    2190,  1470,  1471,  2436,  2244,  1821,  3800,  1752,  1888, -1569,
    1489,  2620,  1812,   842,   545, -1325,   684,  1280,  1498,   919,
    1094,  2725,  1913,  1521, -1163,  1441,  3245,    49,  1157,  3801,
    1673,  1112, -1166,  3537,  1568,  3026,  1499,  1675,  2792,  1572,
    1907,  3378,  1223,  1388,   892,  1807,  1312,  1764,   948,   672,
    1500,  2664,  3695,  1769,  2676,   157,   683,  1077, -1163,  1775,
   -1163,   893, -1785,   898,  1723,   902, -1166, -1819, -1166,   598,
     599,   906,  2807,  1465,  2808, -1839,  3688, -1869,  2914,  1353,
    1752, -1720,  1465,   603,  1926,   603, -1698,   603,   883,  1831,
    1724,   797,   926,   603,   907,   908,   752,  2310,  3275,  1693,
    1834,  1179,  1180,  1837,  1838,   887,  2705,  1067, -1838, -1675,
   -1699,  1068,   942, -2008, -1353, -1358,  3146,  2091,  1039,  2094,
    1247,  1048,   842,  1050, -1358,  1475,  3589,  1250,  1481,  2102,
    1550,   922,  2105,   538,  3597,  3013,  1444, -1365,  3154,  3017,
    2117,  2118,  2322,  1523,  1559,   598,   599,  2233,  3754,   598,
     599,   598,  1175,  2135,  2137,   598,   599, -1788,  2260,  1259,
    1892,  1333,  1335,  1336,  2151, -1838,   157,   156,   151,   152,
     154,  1827,  3635,  3666,  2098,  1310,  1311,  1340,  1498,  3762,
   -1838,  3548,   922,  2764,  2130,  1672,  2875,  2876,  1994,  1670,
    1261,  1262,  1337,  1125,  2131,  2131,  1499,  1353,  2749,  2131,
    1917,  1158,  1959,  1825,  1080,  3792,  1440,  2206,  2982,  1362,
    1502,   539, -1585,   540,  2904,  2121,  2122,  -111,  -111,  1364,
    1366,  1191,  1975,  1545,  1546,  1547,  1548,  1549,  1550,  3643,
    1352,  2666,   541,  1057,  1177,  1673,   739,  1045,  2131,  2131,
    2280,  1053,  2000,  2757,  3677,  1755,   598,  1175,  2622,   541,
    1043,  2006,  2624,  2904,  1240,  1343,  2330,  1322,  3714,  2014,
    2015,  3202,   909,  1672,  1918,   768,   911,  2355,  3223,  1192,
    1889,  3623,  1264,  1043,  1436,  1756,  1960,  2027,  1702,  3847,
    2056,  2057,  2287,  2357,  3819,  1917,  1526,  1444,  3734,  1527,
    1547,  1548,  1549,  1550,  2667,   644,   690,  2999,  1323,  3294,
    1672,  2359,    66,    75,   128,   149,  1741,  1344,   155,  2673,
    2674,  2675,  2676,  1673,  1530,  2106,  1742,   541,  2342,  1531,
    1919,  1376,  3523,  1920, -1325, -1672,  1898,  3051,  2935,  1930,
    3003,  1743,   536,  3699,  3524, -1325,  1786,  1475, -1325,  1119,
    2415, -1325,  2833,  2936,  2208,  1193,  2416,  2358,   842,  1918,
    1673,  1941,  2288,   624,  3160,  2013,  3001,   769,  3261,  3295,
    1759,   842,  1377,  3203,  3729,  1703,  3296,  1899,   592,  2343,
    2256,  2007,   157,  2937,  3715,  2938,  3610,  2716,  2001,  2717,
    2016,  3315,  1848,  1812,  1756,  3776,   603,  1393,   593,   645,
    1394,  1194,  2023,  1195,  1345,  1443,  2312,  1589,  1241,  3710,
    2718,   157,  1439,  1847,  3004,  1919,  3691,  3692,  1920,  1757,
    3686,  2107,   912,  3820,  2870,  1921,  2002,  2873,  2874,  3224,
    1994,  2877,  3678,   948,   542,  1942,  2664,  3775,   625,  1342,
    1463,  2884,  2033,  2048,  1095,  3716,  2053,  1197,  2055,  1058,
    2623,  2058,  1346,  2417,  2625,  2834,  2939,  3204,  1533,  1479,
    2257,  1324,   684,  2668,  2669,  2670,  1961,  2671,  2672,  2673,
    2674,  2675,  2676,  2209,  1744,  2752,  1441,  1962,  2753,  1534,
    1535,  1181,  1199,  3611,  3504,  2108,  2826,   512,  2313,  1506,
    1353,  2124,  2767,   688,  3807,  1519,    38,  2843,  3525,  2360,
    3263,  2827,  1516,   752,  1760,  1524,  1059,  1067,   690,  1808,
    1921,  1068,  1242,  3297,  2719,  1560,  1201,  2940,  1922,  2720,
    1362,   937,  2941,  3419,  3316,  1378,    42,  2306,  3187,  1538,
    1900,  2626,   842,  3423,  1347,  1576,  3154,  1923,  1096,   842,
     842,  2109,  1539,   514,  2110,  1325,  2664,  3005,  3422,  2479,
     689,  1696,  1697,  1206,  1701,  3601,  3777,  2942,  1689,  2166,
     603,    47,  2307,  2361,   603,   603,  1404,  1866,  1406,  2943,
    1408,  3790,  1410,    48,  1412,  1413,  1414,  1761,  2422,  2241,
    1705,  1416,   696,   696,  3598,   696,  2904,   694,   694,  1887,
     694,  1862,  1863,  1864,  1865,   613,  3347,  2418,  2627,  2835,
    3817,  3351,  2391,  1922,  3353,  3006,  1437,  2907,  3373,  1379,
     626,   627,  1101,  1672,  1901,  2344,  2666,  2697,  1672,  1839,
    1706,   690,  2702,  1893,  1894,   809,  2419,   810,  2836,  1903,
    3344,   948,  1770,  2721,  2664,  3380,  2111,  3381,  1873,   507,
     948,  3627,  2722,  2664,   603,  2420,   828,  2391,  2585,  2944,
     603,   742,   743,   744,  2802,   745,   746,   747,   748,   749,
     750,  1896,  2590,  1673,  3853,   541,  2345,  3159,  1673,  1707,
    2510,  2511,  2512,  2513,  2421,  2960,  2308,  3358,  1103,  2667,
    2753,   908,   521,  1797,   522,  1839,   163,   752,  1786,  1852,
    1206,  1802,  2083,  1955,  1956,  1957,  1958,   603,  1809,  1207,
     603,   603,  1995,   499,  1999,  1545,  1546,  1547,  1548,  1549,
    1550,  3047,  1706,  2005,  1771,  2018,   830,  3484,  2295,   512,
    2765,  1104,  1897,   164,  2022,  1940,  2666,  3062,  3074,  2112,
    3075,  3689,   691,  2092,  2806,  2032,   641,  1770,  -769,  3694,
    1873,  1840,  2131,  1841,    15,  2131,  2131,  2131,  2131,  2131,
    2131,  2131,  2131,  2131,  2131,  2394,  3636,   603,  3490,  2029,
    3001,  1707,  2664,  2397,  2640,  2399,  1362,  3382,  -775,  1944,
    2581,  3519,  1043,  1043,  1994,   514,   635,  3485,  1994,   734,
    1945,   617,   663,  3637,   163,  3362,  3491,  3363,  1946,   812,
    1880,   813,  1873,  2665,  1947,  3578,  3579,  1948,  1949,  1950,
    1881,   512,  2131,  2131,  2577,  2282,  1312,  1840,  1527,  1841,
    3520,  2329,  2691,   752,  2666,  3722,   623,   163,    24,  1771,
    1208,   164,  2506,  2666,  1882,  1737,  2130,  2130,  2331,   677,
    3040,  2130,    15,  1530,  1939,  3745,  2935,  1803,  1988,   664,
    3556,  2714,  2671,  2672,  2673,  2674,  2675,  2676,  2662,  2663,
    3076,  1968,    38,  2678,   164,  1983,  1984,   514,  3236,  3746,
    3077,  1672,  1672,  1672,  3239,  3240,  3241,  3242,  3243,  3244,
    2130,  2130,  3727,  2060,  3808,    29,  1518,  2667,  2177,  2983,
    2178,  2937,    42,   157,  1854,  1856,  2667,   684,  2796,  1117,
    1326,  3050,  2711,  2712,  3585,  1878,  3587,  2371,  1067,  2217,
    1051,  2179,  1068,  1230,  3609,  2584,    24,    34,  2231,  1327,
    1362,  1673,  1673,  1673,   521,  2085,   522,    47,  1118,  2592,
    2593,  1566,  1672,  2595,  1879,   524,  2888,   683,  3051,  2599,
     685,  2565,  1231,   887,  3545,   526,   157,  2082,  2079,  2080,
    2081,  1362, -2009,  3273,  3071,  2481,  2470,    38,   697,  2831,
    2479,    38,  2671,  2672,  2673,  2674,  2675,  2676,  1498,  2566,
    3684,  2115,    49,  1672,  2073,   601,  1383,  1937,  3091,  2268,
    2269,   601,  1673,  2610,  3019,  2553,  1499,    42,  2832,  2103,
    2104,    42, -1230, -1230,  2568,  1498,  1384,  2116,  2809,  2084,
    2635,  2119,  2120,  1475,   730,  1734,   521,  2482,   522,  2564,
    2180,   686,  1125,  1499,  3177,  2181,  2141,   761,  2142,    45,
    2182,   738,    47,  1673,  2131,  3497,    47,  1500,   732,  2598,
    2941,  1101, -1206,  2175,    48,  1102, -1206,  2163,    48,  2164,
    2248,  1845,  2251,  1121,  -348,   801,  2668,  2669,  2670,    38,
    2671,  2672,  2673,  2674,  2675,  2676, -2009, -2009,  1188,  2671,
    2672,  2673,  2674,  2675,  2676,  2942,  2234,    49,  1462,  2515,
      49,  3809,  1122,  1675,  2516,  2565,    34,  2943,  1814,    42,
    2608,   767,  2483,  2484,  2035,  1814,  2036,  1189,  2037,  3225,
    2038,   804,  2039,  1123,  2570,  2485,  2040,  1103, -1206,   805,
    2637,  1124,  1202,  2566,  1214,  2031,   808,    45,  1123,  3226,
    1225,  1236,  2638,  2962,    47,   817,  2092,  2639,  2567,  2629,
    1498,  2805,  2564,  1815,  1816,  1475,    48,  1119,  2568,   948,
    1815,  1816,  2664,   823,  2183,  2775,  2755,   831,  1499,  1226,
    1104, -1206,  3397,  2184,  2918,  2920,  2921,  2486,  3185,  3115,
    2278,  2569,  1502,  1475,  2281,  1734,  1812,  2944,  1687,    49,
    1123,  1688,  2350,  1812,  1585,  2925,  3188,  3193,  1227,  1672,
    2516,  1125,  1067,  3101, -1675,   848,  1068,  2302,  2671,  2672,
    2673,  2674,  2675,  2676,   948,  2314,  1727,  2664,  2565,  3255,
    3256,  2535,  2536,  3259,  2254,  3260,   832,  1690,  2262,  2731,
    1691,  2092,  2131,  2131,  3116,  2690,   852,  2692,  2693,  2328,
     862,  2797,  2289,    15,  2292,  1728,  2566,   871,  2889,  1673,
     603,  2904,  3234,  2395,  3789,  1857,  2770,  2771,  2570,  2351,
    2487,  2567,  2488,  3469,  3470,  1994,  1123,  1080,   877,  2030,
    1994,  2568,  2031,  1994,  1729,   586,  3092,  3093,  2372,  3059,
    2817,  2392,  2819,   948,   924,  2042,  2664,  2855,  2043,  3268,
    3269,  2890,  1814,  1050,  2569,  1450,  1451,  2044,  3633,  2408,
    2043,  2440,   948,  3403,  1475,  2664,  1734,  2413,  2449,  2450,
    2451,  2452,  2453,  2454,   881,  2891,  2426,    24,  2735,  3348,
    2736,  2504,  3404,  2430,  2076,   913,  1672,  2077,  1672,  2737,
    2355,  2738,  3199,  3662,  2892,   927,  1877,  1815,  1816,   897,
     899,   901,  2666,   917,   903,   904,   905,  2784,  2785,  2253,
    2787,  2893,  1362,  1672,   910,  2274,  2320,   929,  2077,  2321,
    3122,  1526,  2368,   934,  1527,  2369,  2894,  2776,  2777,  2465,
    1812,  2570,  2466,  1814,    29,   937,  1673,  2501,  1673,   936,
    2502,  1995,   603,  2524,  2602,  2618,   935,  2043,  2619,  1530,
     603,   938,   603,  2636,  1531,   939,  2031,  2666,  1786,   940,
    1054,  3098,  3396,  1673,  2130,  2667,  3320,  2130,  2130,  2130,
    2130,  2130,  2130,  2130,  2130,  2130,  2130,  2448,  1815,  1816,
    2586,   943,  2588,  3179,  3180,  2448,  3073,   944,  1056,  3078,
    3079,  3080,  3081,  3082,  3083,  3084,  3085,  3086,  3087,  2837,
    2958,  2839,  2646,  3349,  2649,  2031,  1060,  2031,  2895,  2846,
      38,  1812,  2156,   190,  2653,  2159,  2896,  2031,   500,  2654,
    2667,   688,  2031,  1061,  2130,  2130,  2666,   572,  2479,  2478,
    2680,  2696, -1207,  2031,  2031,  2509, -1207,   684,  2699,  1062,
      42,  2700,  2713,  3583,   642,  2666,  3124,  3125,  2897,  2760,
    2824,  1066,  2761,  2825,  3614,  2851,  2131,  2539,  2852,  1074,
    1081,   157,  2523,   842,  2968,  2507,  2980,  2969,    45,  2981,
    2990,  2871,  3851,  2991,  3852,    47,  1088,  2557,   689, -2009,
    2131,  2131,  3028,  1533,  1089,  1099,  3031,    48,  3033,  2667,
    3035,  3036,  3063,  3099,  3106,  2031,  3100,  3107, -1207,  3041,
    3118,  1091,  1092,  2031,  1534,  1535,  3181,   842,  2667,  2043,
    1091,   752, -1163,  2950,  3252,  2953,  1243,  1114,   574, -2009,
      49,  1098,  1136,  1100,  2668,  2669,  2670,  1154,  2671,  2672,
    2673,  2674,  2675,  2676,  3060,  3248,  1181,  1119,  3249,  2996,
      14, -1207,  1526,  1183,  3402,  1527,    15,  2077,  1224,   690,
    3142,  3144,  2970,  1239,  1538,  3433,  2739,  1229,  3434,  3440,
     603,  3441,  2043,  1994,  2043,  3515,  2331,  1539,  3516,  3542,
    1530,    20,  1362,  1995,  2754,  1531,  1244,  1246,  2768,  2668,
    2669,  2670,  1248,  2671,  2672,  2673,  2674,  2675,  2676,  1251,
    1256,  3547,  3620,  3183,  2969,  3549,  3562,  3564,  2969,  3563,
    2031,  3570,  3617,  1403,  2077,  3618,  1405,  1043,  1407,  3018,
    1409,  3021,  1411,  1258,  3029,  3631,  1415,  1265,  3632,  3663,
      24,  1268,  3664,  3668,   684,  3670,  1362,  3046,  2969,  3674,
    3728,  3732,  2077,  1565,  3733,  2131,  2130,  1125,  3737,  3738,
   -2009,  1362,  2077,  1306,  3739,  3177, -1925,  2700,  2668,  2669,
    2670,  3058,  2671,  2672,  2673,  2674,  2675,  2676,  3293,  3740,
     691,  1308,  2031,  3755,  1516,  1312,  2077,  2668,  2669,  2670,
    1316,  2671,  2672,  2673,  2674,  2675,  2676,  3067,  2175,  3757,
    3758,  1318,  2077,  2077,  2779,  3849,  -160,  1320,  3850,  2740,
    2741,  3860,  1331,  1338,  3850,   177,  3072,  2734,  1348,  1160,
    1532,  1350,  1355,  1357,  1533,  1161,  3533,  1356,  1358,  1988,
    1672,  1359,  1361,  1362,  2888,  3341,   842,  1367,  3401,  1370,
    1371,  3094,  1372,  1373,  1375,  1534,  1535, -1925,  1380,  1381,
    1545,  1546,  1547,  1548,  1549,  1550,  1382,  1387,  1392,  2756,
    1536,   603,  3177, -1927,  1162,  1417,  1446,  3704,  1452,  3706,
    1448,  1454,  1455,    38,  1460,  1444, -1329, -1336,  1469,  1472,
    1673,  1473,  1672,  1474,  2782,  1478,    49,  3387, -1326,  1480,
    1483, -1327,  2830,  1484, -1175,  1538, -1925,  1485,  1527,  2840,
    1486,  1491,  1493,    42,  2768, -1175,  1494, -1925,  1539, -1175,
    1495, -1925, -1330,  1496, -1328,  1163, -1925,  1497,  1504,  1505,
    1507, -1925,  1164,  1530, -1925,  1165, -1925,  3254,  1508,  1509,
    1510,    45,  1673,  1511,  2130,  2130,  1512,  1513,    47,  1554,
    1580,  1569,  1588,  2768, -1927,  1565,  1694,  1102,  1104,  1721,
      48, -1175,  1731, -1925,  1732,  1734,  3398,  3399,  1735,  1736,
    1758,  1737,  2868,  1763,  1765,  1766,  1767,  3481,  1768,  1790,
    1791, -1175,  1797, -1925,  1809,  1799,  1166,  1810,  2963,  1811,
    1812,  1541,  1818,    49,  1820,  1123,  1828,  2844,  2977,  1829,
    1822,  1823,  1832, -1927,  1826,  1833,  1835,  3474,  1842,  1843,
    1849,  1850,  1206,  2989, -1927,  1869,  1858,  2854, -1927,  1859,
    1890,  1867,  1868, -1927, -1175,  1874, -1925,  1876, -1927,  1902,
    1904, -1927, -1175, -1927, -1925,  1905,  1912,  3320,  1465,  1914,
    1915,  1167,  1475,  1481,  1928,   509,  1934,  1995,  1938,  2448,
    1954,  1995,  2448,  2448,  1208,  1976,  2448,  1971,  1979,  1981,
   -1927,  3361,  1982,  1986,  3037,  1997,  2448,  3038,  3364,  3365,
    2009,  1264,     3,     4,  3177,  2906,  1168, -1925, -2009, -2009,
   -1927,  1545,  1546,  1547,  1548,  1549,  1550,  2010,  1534,  1535,
    2011,  2025,  2012,   734,  2054,  2026,  2059,  3370,  2062,  2066,
     603,  3302,  3303,  2074,  2087,  1043,  3425,  2913,  2915,  1170,
    3560,  2097,  2922,  2098,  2906,  2139,  1116,  3304,  2140,  2152,
    1527,  2161,   617, -1927,  2157,  2162,  2169,   574,  2967,  1137,
    2219, -1927,  2954,  2235,  1171,  2239,  1873,  2193,  1538,   603,
    2232,  2240,  2263, -1175,   689, -1925,  2174,  2264,  2191,    14,
    2275,  3049,  2236,  2273,  2246,    15,  2995,   842,   157,  2987,
    1138,  3533,  2276,  3471,  2277,  2285, -1925,  2290, -1925, -1925,
    2293,  2283,  2295,  3061, -1927,  2255,   157,  3009,  2267,  2297,
      20,  2298,  2301,  1988,  2299,  2304,  2311,  1988,  2316,  2318,
    2363,  1137,  2367,  3367,  3368,  3369,  2370,  2423,  3619,  2424,
   -1925,  1091,  2425, -1925, -1925, -1925,  2429,  2433,  2130,  2437,
    2434,  3574,  2438,  3136,  3137,  2439,  2441,  1139,  2442,   617,
    2443,  2445,  1138,  1672,  2444,  2455,  3449,  3450,  2468,    24,
    3557,  2461,  2130,  2130,  2457,  2464,  2473,  2471,   157,  3054,
    2472,  2474, -1927,  2475,  2476,  2499,  3806,  2477,  1140,  2503,
    2508,  2514,  2517,  2521,  3571,  3572,  2538,  2540,  2552,  2554,
    2555,  2556,  2563, -1927,  2576, -1927, -1927,  2582,  2583,  2591,
    2594,   166,  2596,  1673,  2597,  2601,  2768,  1995,  2604,  1139,
    2605,  2606,  2609,  1444,  2607,  2616,  3673,  2088,  2628,  3426,
    2632,  2634,   919,  2647,  2648,  2650,  2651, -1927,  2652,  2655,
   -1927, -1927, -1927,  2656,  2658,  2661,  2679,  2715,  2749,  2723,
    1140,  2685,  2751,   684,  1545,  1546,  1547,  1548,  1549,  1550,
    3113,  2686,  2031,  2710,  2730,  3500,  -813,  2733,   167,  3697,
    2743,  2687,  2783,  3702,  3703,  2786,  2688,  2788,  3182,  2789,
    3132,  3133,  3134,  3135,  2798,  2695,  2799,  2793,   168,  2708,
    2709,  2803,  2794,  1516,   169,  2748,  3448,  2795,  2804,  2816,
    3676,  2818,    38,  3152,  2828,  2829,  3456,  2841,  2842,   170,
    2845,  2847,  3463,  3464,  3474,  3466,  3698,  2857,    34,  2856,
    1773,  2858,  1143,  3701,  2872,  2860,  2878,  2130,  1144,  2859,
    2879,  3550,    42,  3551,  3552,  1774,  2861,   171,  3274,  3227,
    2862,  3229,   172,  1231,  3555,  2863,  2864,  1141,   173,  3672,
    2865,  1147,  2866,  2880,  2881,  2908,  3299,  2911,  2882,  1148,
      45,  2883,  2912,   174,  2923,  2926,  1921,    47,  2924,  1160,
    2948,   575,  2927,  3306,  2955,  1211,  1142,  2906,  2961,    48,
      34,  2959,  2975,  2979,  1143,  2973,  2985,  2978,   175,  2988,
    1144,  2984,  3008,  3217,  3014,  3216,  3218,  1145,  3219,  3010,
    3027,  3012,   603,  3015,  3022,  1146,  3032,  3025,  1149,  3043,
    3034,  3053,   576,  1147,  1162,  3044,  3056,   603,  3045,  3744,
    3057,  1148,  1462,  2448,  3066,  3048,  2682,  1557,  2664,  2448,
    2448,  2448,  2448,  2448,  2448,  3541,  2681,  3095,  1995,   842,
    3096,  3097,  2754,  1995,   176,  3541,  1995,  3108,  1520,  3120,
    3121,  3139,  3652,  3129,  3164,  3145,  3683,  3158,  3155,  2970,
    3170,  3184,  3156,  3213,   603,  1163,  3222,  3186,  3161,  3237,
    1149,   177,  1164,  3200,  3214,  1165,   907,   908,  3201,  3278,
    3280,  3282,  3284,  3194,  3211,  1444,  3212,  3267,  3291,  1526,
    3215,  3235,  1527,  3238,  3272,   178,  3298,  3270,  3305,  3271,
    2043,   179,  3301,  3592,  3277,  3000,  3308,   180,  3826,  3311,
     181,  3307,  3324,  3328,  3310,  3342,  3329,  1530,  3331,  3338,
    3339,  3345,  1531,  3604,  3352,  3355,  1166,  3671,  3366,  3371,
    3360,  1526,  3374,  3376,  1527,  3379,   182,  3383,   183,  3333,
    3388,  3389,   184,  3384,  3414,  3410,  3411,  3412,  3413,  3394,
     185,   752,  3415,  3390,  3417,   186,  3418,  3430,  3687,  1530,
    3428,  3443,  3435,  3444,  1531,   187,  3445,  3451,  3467,  3468,
    3472,  3457,  3479,  3262,  1988,  3460,  3486,   188,  3489,  1988,
    1160,  1167,  1988,   612,  3492,   614,  1161,  3493,  3501,   620,
    3505,  3509,  3511,   630,   636,   612,  3514,   643,  3517,   636,
     636,  3521,   668,  1526,   671,   668,  1527,  3530,  3531,  3539,
    3554,  3544,  3558,  3559,  3561,  3566,  1168,  3567,  3437,  3437,
    3568,  3569,  3576,  3586,   603,  1162,  3580,  3596,  3599,  3582,
    3612,  1530,  3613,  3606,  3669,  1526,  1531,  3607,  1527,  3621,
    3584,  3297,  3628,  3639,  3630,  1212,  3640,  1532,  3654,  1170,
    3642,  1533,  2724,  3655,  3657,  3656,  3658,  3682,   690,  3753,
    3690,  1444,  3713,  1530,  3717,  3465,  1123,  3721,  1531,  3723,
    3726,  3730,  1534,  1535,  1213,  3731,  1163,  3742,  3736,  3452,
    3741,  3743,  3748,  1164,  3750,  3699,  1165,  1536,  1388, -2009,
    3461,  3759,  3760,  1533,  3763,  3765,  3769,  3772,  3147,  3791,
    3429,  3788,  3793,  3708,  1444,  3762,  3828,  3424,  1444,  1444,
    3797,  3761,  3805,  3818,  1534,  1535,  3845,  3848,  3854,  3427,
    1875,  3858,  1538,  2505,  3126,  1160,   722,   727,   729, -2009,
     727,  1161,   722,   736,   668,  1539,   754,  1166,   736,  1093,
     668,   603,   668,  2758,  3197,  3446,   727,   736,   668,  1587,
    2362,  2885,  1135,  3615,  3473,  3538,  3127,  3641,  3752,  3709,
    3823, -2009,  3326,  3498,  1538,  1533,  3651,   603,  2791,  2603,
    1162,  3794,  3590,  3825,  3766,  3764,  1995,  1539,  3454,  3455,
    3327,  3803,  1970,  3458,  3459,  2309,  1534,  1535,  2448,  2448,
    3667,  3220,  1167, -2009,  2849,  1951,  2480,  1533,  2964,  3827,
    3859, -2009,   842,  3855,  3488,  3487,  3477,  3478,  1541,  2909,
    3482,  3483,  2956,  3804,  3605,  1933,  3756,   619,  1534,  1535,
    3608,  1163,  1435,  3685,  3372,   752,  3334,  1168,  1164,  3495,
    2324,  1165,  3335, -2009,  3735,   844,  1538,  3856,  3811,  3634,
    2249,  2768,  1063,  2250,  2034,   752,  3314,  3055,  2762,  1539,
   -2009,   603,  1087,  1692,  2766,  2545,  1169,  2272,  1995,  2778,
    1170,  2774,  3513,  2271,  1718,   157,  3506,  1717,  1538,  1722,
    2266,  2245,  2742,  1137,  2559,  3020,  3546,  3593,  3603,   840,
    3312,  1539,  1166,  2763,  1071,  1171,  3112,  3675,  2469,  3532,
    3102,  3779,  3787,  3780,  1542,  1543,  1544,  2769,  1545,  1546,
    1547,  1548,  1549,  1550,  1138,  1526,  3624,  2728,  1527,  2643,
    2726,  2621,  1988,     0,   734,  2218,     0,     0,     0,     0,
       0,     0, -2009,     0,     0,  1528,     0,     0,     0,     0,
       0,     0,     0,  1530,  1043,     0,     0,  1167,  1531,     0,
    1545,  1546,  1547,  1548,  1549,  1550,     0,     0,     0,     0,
       0,     0,     0,     0, -2009,  1995,     0,     0,     0,     0,
       0,  1139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3659,  1168,     0,     0,     0,     0,     0,     0,     0,
    1160,     0,     0,     0,     0,     0,  1161,     0,     0,     0,
       0,     0,  1140,     0,     0,     0,     0,     0,     0,     0,
       0,  1234,  2906,     0,     0,  1170,     0,     0,     0,  3693,
    1191,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,  2448,
       0,  2546,  1123,  3616,     0,  1162,     0,   603,     0,  3437,
    1235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1545,  1546,  1547,  1548,  1549,  1550,
       0,  3705,     0,  3707,     0,     0,     0,   775,  1192,     0,
       0,     0,   668,  1532,   722,     0,     0,  1533,   729,     0,
     727,     0,     0,   736,     0,   754,  1163,   736,   820,     0,
     752,     0,     0,  1164,     0,   727,  1165,   736,  1534,  1535,
       0,     0,     0,     0,     0,     0,   668,     0,     0,     0,
       0,     0,   843,  1536,     0,     0,   722,     0,     0,     0,
     729,     0,     0,   722,     0,     0,   754,     0,     0,     0,
       0,     0,    34,     0,     0,     0,  1143,     0,     0,     0,
       0,   727,  1144,     0,  1193,  1537,   891,  1166,  1538,  1774,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,     0,
    3771,  1539,     0,     0,  1540,  1147,     0,  1995,     0,     0,
       0,     0,     0,  1148,  3768,     0,     0,     0,     0,   842,
       0,     0,     0,   668,     0,     0,     0,     0,   668,  3795,
    1194,     0,  1195,     0,     0,     0,     0,     0,   668,   933,
       0,     0,  1196,     0,     0,     0,     0,     0,     0,     0,
    3796,     0,     0,     0,     0,     0,  1038,     0,   668,   636,
       0,   843,  1149,   636,     0,     0,  2548,  3000,     0,     0,
       0,     0,     0,     0,  1541,   668,  1197,  1168,     0,   668,
       0,     0,  1073,     0,     0,     0,     0,  1038,  1526,     0,
       0,  1527,     0,     0,     0,  2545,     0,   668,     0,     0,
       0,     0,     0,     0,     0,     0,  1198,     0,  1528,     0,
    1170,  1199,     0,  1137,     0,     0,  1530,     0,     0,  1526,
       0,  1531,  1527,     0,     0,     0,     0,  1123,  3857,     0,
       0,     0,     0,     0,     0,  1200,     0,     0,     0,  1528,
       0,     0,     0,     0,  1138,  1201,     0,  1530,     0,     0,
     727,   727,  1531,     0,     0,     0,     0,     0,     0,     0,
    1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,
       0,     0,  2237,     0,     0,     0,     0,  1526,  2238,  3844,
    1527,     0,     0,     0,     0,     0,   722,     0,   157,  3816,
    3813,  3814,  3815,   722,     0,     0,   754,     0,     0,     0,
       0,  1139,     0,     0,     0,  1530,  3837,     0,   727,     0,
    1531,     0,     0,     0,     0,     0,     0,     0,     0,  3843,
    3816,  3813,  3814,  3815,   727,   727,     0,     0,     0,     0,
       0,  3836,  1140,     0,     0,     0,     0,     0,   668,   668,
     668,   727,     0,   722,     0,     0,  1532,     0,     0,     0,
    1533,  3837,     0,     0,     0,     0,     0,     0,     0,  3837,
       0,  2546,   157,  3816,  3813,  3814,  3815,     0,   727,   727,
       0,  1534,  1535,     0,     0,     0,  3836,  1532,     0,     0,
       0,  1533,     0,     0,  3836,     0,  1536,   843,     0,     0,
       0,  1038,     0,     0,     0,     0,     0,     0,  3130,     0,
     843,     0,  1534,  1535,     0,  1526,     0,     0,  1527,     0,
       0,     0,     0,     0,     0,     0,     0,  1536,  1537,     0,
       0,  1538,  1420,  1420,     0,  1528,     0,   668,     0,   612,
       0,     0,     0,  1530,  1539, -2009,     0,  1540,  1531,  1533,
       0,     0,     0,     0,     0,     0,     0,  1453,     0,  1537,
     668,     0,  1538,  1459,     0,     0,     0,     0,     0,     0,
    1534,  1535,    34,     0,  1038,  1539,  2547,     0,  1540,     0,
       0,     0,  1144,     0,     0, -2009,     0,     0,     0,  1774,
       0,     0,     0,     0,     0,     0,     0,  1231,     0,     0,
       0,     0,  1038,     0,     0,  1147,     0,     0,     0,     0,
       0,     0,  2373,  1148,     0,     0,     0,  1541,     0,     0,
    1538,  2374,  2375,  2376,     0,     0,     0,     0,     0,  1038,
    1038,     0,  1038,  1539,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1541,  1038,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1149,     0,     0,  2377,  2548,     0,     0,     0,
       0,   843,     0,  1532,     0,     0,     0,  1533,   843,   843,
       0,     0,     0,     0,   668,     0,     0,  1038,     0,     0,
       0,     0,  1679,     0,  1686,     0,     0,     0,  1534,  1535,
       0,     0,     0,  1542,  1543,  1544, -2009,  1545,  1546,  1547,
    1548,  1549,  1550,  1536,  2378,     0,     0,     0,     0,  1038,
    2657,     0,     0,  1038,  1038,  1526,     0,     0,  1527,     0,
       0,     0,     0,     0,  1542,  1543,  1544,     0,  1545,  1546,
    1547,  1548,  1549,  1550,   636,  1537,     0,     0,  1538,     0,
       0,  2703,     0,  1530,  2379,     0,     0,     0,  1531,     0,
       0,  1539,     0,     0,  1540,     0,   636,     0,     0,     0,
    2380,  2381,  2382,  2383,  2384,     0,  2385,     0,     0,     0,
    1796,     0,     0,     0,     0,  1525,   668,     0,     0,     0,
    1526,     0,     0,  1527,     0,     0,  1545,  1546,  1547,  1548,
    1549,  1550,  1526,   754,     0,  1527,     0,     0,  2386,     0,
    1528,     0,     0,  1529,     0,     0,     0,     0,  1530,     0,
       0,     0,  1528,  1531,     0,     0,     0,     0,     0,     0,
    1530,     0,     0,     0,  1541,  1531,     0,     0,     0,     0,
     727,   727,   727,   727,   668,     0,  3407,     0,     0,   736,
       0,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1886,     0,   668,     0,     0,     0,
       0,     0,   727,   727,     0,     0,     0,     0,   727,     0,
       0,  2387,     0, -2009,     0,     0,     0,  1533,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2388,  1534,  1535,
       0,     0,     0,     0,  2389,     0,     0,  2390,     0,     0,
    1542,  1543,  1544, -2009,  1545,  1546,  1547,  1548,  1549,  1550,
       0,     0,     0,     0,  2160,     0,   736,     0,     0,     0,
       0,     0,   727,   727,   727,   727,     0,     0,  1532,     0,
       0,   736,  1533,     0,     0,     0,     0,  2545,  1538,  1886,
    1532,     0,     0,     0,  1533,     0,     0,     0,  1996,     0,
     722,  1539,     0,  1534,  1535,  1137,     0,   729,     0,   722,
       0,     0,     0,     0,     0,  1534,  1535,   754,  1536,     0,
       0,     0,   668,     0,     0,     0,     0,     0,     0,     0,
    1536,   668,     0,   736,     0,     0,  1138,   727,   727,   776,
       0,     0,   668,     0,   891,     0,     0,     0,     0,     0,
    1537,     0,     0,  1538,     0,     0,     0,     0,     0,     0,
       0,     0,  1537,     0,     0,  1538,  1539,  1420,     0,  1540,
       0,   777,     0,     0, -2009,   722,     0,     0,  1539,   668,
     668,  1540,     0,     0,   778,     0,     0,  2065,     0,     0,
       0,   668,   779,  1139,     0,     0,   780,     0,     0,     0,
       0,     0,     0,     0,   612,   612,     0,     0,  2090,     0,
    1038,     0,  1038,     0,     0,     0,   781,     0,     0,  1038,
       0,     0,  1038,     0,  1140,  1038,     0,     0,     0,     0,
       0,     0,     0,  1038,  1038,     0,     0,   782,     0,  1541,
       0,  1038,     0,   754,  1038,  1038,  1038,  1038,     0,     0,
       0,  1541,     0,  2546,  1038,  1038,     0,  1038,     0,  1038,
       0,     0,  1038,     0,  1545,  1546,  1547,  1548,  1549,  1550,
     783,     0,     0,     0,     0,     0,     0,     0,  1038,     0,
       0,     0,  1038,     0,  1526,     0,  1038,  1527,     0,     0,
    1038,   784,  1038,  1038,  1038,  1038,  1038,  1038,  1038,  1038,
    1038,     0,  1038,     0,  1528,     0,   668,  1038,     0,  1038,
       0,     0,  1530,     0,     0,   668,   785,  1531,     0,     0,
       0,     0,     0,     0,     0,  1542,  1543,  1544,     0,  1545,
    1546,  1547,  1548,  1549,  1550,     0,     0,  1542,  1543,  1544,
       0,  1545,  1546,  1547,  1548,  1549,  1550,     0,     0,     0,
       0,  2910,     0,     0,    34,     0,     0,     0,  1143,     0,
    1526,     0,     0,  1527,  1144,     0,     0,     0,     0,     0,
       0,  1774,   786,     0,     0,     0,     0,     0,     0,  1231,
    1528,     0,     0,     0,     0,     0,     0,  1147,  1530,     0,
       0,     0,     0,  1531,     0,  1148,     0,     0,     0,   177,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1526,     0,     0,  1527,     0,     0,     0,     0,
       0,     0,     0,   787,     0,     0,     0,   788,     0,   789,
    1686,     0,  1528,     0,     0,   790,     0,   668,     0,   668,
    1530,  1038,  1532,     0,  1149,  1531,  1533,     0,  2548,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,   792,  1534,  1535,     0,
     793,     0,     0,     0,     0,     0,     0,     0,   794,     0,
       0,   736,  1536,   795,     0,   736,   729,     0,     0,     0,
       0,     0,   612,     0,   612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   796,     0,     0,   736,  1038,
       0,     0,     0,     0,  1537,     0,   736,  1538,  1532,     0,
       0,     0,  1533,     0,     0,     0,     0,     0,     0,     0,
    1539,     0,     0,  1540,     0,     0,     0,     0,     0,     0,
     736,     0,  1796,  1534,  1535,     0,     0,     0,  2332,     0,
       0,     0,     0,  2341,     0,     0,     0,     0,  1536,   668,
     736,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1532,     0,  2365,  2365,  1533,     0,     0,     0,   729,   736,
       0,     0,   736,     0,     0,     0,     0,     0,     0,     0,
    1537,     0,   727,  1538,     0,  1534,  1535,     0,     0,     0,
     736,     0,     0,  1541,  2409,     0,  1539,     0,   736,  1540,
    1536,     0,     0,     0,     0,     0,   492,   736,     0,     0,
       0,     0,   534,   492,   736,     0,     0,     0,     0,   573,
       0,   492,     0,     0,     0,     0,     0,   492,     0,   622,
     727,     0,  1537,     0,     0,  1538,     0,   727,   727,   727,
     727,   727,   727,     0,     0,     0,     0,   682,  1539,     0,
       0,  1540,  1038,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1541,
       0,     0,     0,     0,  2365,     0,     0,     0,   668,  1542,
    1543,  1544,   612,  1545,  1546,  1547,  1548,  1549,  1550,     0,
       0,     0,     0,  3111,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2520,     0,     0,     0,
       0,     0,   727,  2534,     0,     0,     0,     0,     0,     0,
       0,  1541,   843,     0,     0,     0,     0,  1996,  2562,     0,
       0,     0,  2562,  2575,     0,     0,     0,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   727,
    2365,   727,  2365,     0,     0,  1542,  1543,  1544,     0,  1545,
    1546,  1547,  1548,  1549,  1550,     0,   843,     0,     0,  3163,
       0,  1038,     0,     0,     0,     0,     0,     0,   756,     0,
     758,     0,   760,  1420,   762,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1526,   736,
       0,  1527,     0,     0,     0,     0,  1038,  1542,  1543,  1544,
       0,  1545,  1546,  1547,  1548,  1549,  1550,     0,  1528,     0,
       0,  3172,     0,     0,     0,  1526,  1530,   736,  1527,     0,
       0,  1531,     0,     0,     0,     0,  1526,  1038,  1038,  1527,
       0,     0,     0,     0,     0,  1528,     0,     0,     0,     0,
       0,     0,     0,  1530,     0,     0,  1528,     0,  1531,     0,
       0,     0,     0,     0,  1530,     0,     0,  1038,  1038,  1531,
       0,     0,  1038,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1038,  1038,  1038,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,  1038,     0,     0,  1038,
       0,  1038,  2707,     0,     0,     0,     0,     0,     0,     0,
       0,  1038,  1038,     0,  1038,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1038,     0,  1038,
       0,   754,     0,  1038,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1038,
       0,     0,     0,   668,     0,     0,  1532,     0,     0,  1996,
    1533,  1038,  1038,  1038,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   843,     0,     0,  1038,     0,
       0,  1534,  1535,  1532,  1686,     0,  1038,  1533,     0,     0,
       0,     0,     0,     0,  1532,  1038,  1536,     0,  1533,     0,
    1038,     0,     0,     0,   668,     0,     0,  1038,  1534,  1535,
       0,     0,     0,     0,     0,   736,     0,     0,     0,  1534,
    1535,     0,     0,  1536,     0,     0,     0,     0,  1537,     0,
       0,  1538,     0,  1038,  1536,  2365,     0,     0,     0,  1420,
       0,     0,     0,     0,  1539,     0,  1301,  1540,     0,     0,
       0,     0,     0,     0,     0,  1537,     0,     0,  1538,     0,
       0,     0,     0,     0,     0,     0,  1537,     0,     0,  1538,
       0,  1539,     0,     0,  1540,     0,     0,     0,     0,     0,
       0,     0,  1539,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   736,   803,     0,     0,     0,     0,     0,
     736,     0,  2493,     0,     0,     0,     0,  1541,   821,   822,
       0,     0,     0,   824,     0,     0,     0,     0,     0,     0,
       0,     0,   838,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,   847,     0,     0,     0,
       0,     0,     0,     0,     0,  1541,     0,     0,   866,     0,
       0,   868,     0,   870,     0,   873,  2373,     0,     0,  1301,
       0,     0,     0,   736,     0,  2374,  2375,  2376,     0,     0,
       0,     0,     0,  2365,  2365,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     492,     0,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,  3377,     0,  2377,
       0,     0,     0,   930,     0,   931,     0,     0,     0,     0,
    1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,
       0,  1542,  1543,  1544,  3409,  1545,  1546,  1547,  1548,  1549,
    1550,     0,     0,  3157,  1420,   668,     0,     0,     0,     0,
       0,     0,     0,  2494,     0,   668,     0,     0,  2378,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   682,     0,
     668,     0,     0,     0,     0,     0,   843,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1575,  2562,     0,     0,
    3011,     0,     0,  1996,     0,     0,     0,  1996,  2379,     0,
       0,     0,     0,  3024,     0,     0,  1038,     0,     0,     0,
       0,     0,     0,     0,  2380,  2381,  2382,  2383,  2384,     0,
    2385,   668,     0,     0,   668,     0,     0,   736,     0,     0,
       0,  3042,     0,     0,     0,     0,     0,     0,     0,   722,
       0,     0,   736,     0,     0,     0,  1301,     0,     0,  2065,
       0,     0,  2386,     0,     0,     0,  1238,     0,     0,     0,
       0,     0,   668,     0,   736,     0,     0,     0,  1249,     0,
       0,     0,  1038,     0,     0,     0,     0,  1255,     0,     0,
       0,  1038,     0,  1257,     0,     0,  1301,  1038,  2495,  1038,
       0,     0,     0,     0,  1304,  1038,     0,     0,  1038,  1038,
    1038,  1038,  1038,  1038,  1038,  1038,  1038,  1038,     0,     0,
       0,  1038,  1038,  1301,  1526,     0,     0,  1527,     0,     0,
       0,     0,     0,  1341,  1038,  2387,     0,  2496,     0,     0,
    1038,     0,     0,     0,  1528,     0,     0,     0,     0,     0,
    1038,     0,  1530,  1038,     0,  1038,     0,  1531,     0,     0,
       0,  2388,     0,     0,  1038,  1038,  1038,     0,  2389,     0,
    1038,  2390,     0,  1038,     0,     0,     0,     0,     0,     0,
     668,   668,     0,  1038,     0,     0,     0,     0,     0,  3149,
    1301,  1038,     0,  1038,   492,     0,   492,     0,   492,     0,
     492,  1686,   492,   492,   492,     0,     0,  1301,     0,   492,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1301,     0,     0,
       0,     0,     0,  3178,  1420,  1420,     0,     0,     0,   736,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1301,
       0,     0,     0,     0,     0,     0,     0,     0,  3196,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1532,     0,     0,     0,  1533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1301,     0,
     736,     0,   736,     0,     0,     0,     0,  1534,  1535,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1536,     0,     0,     0,     0,     0,   843,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1537,     0,     0,  1538,     0,     0,
       0,     0,     0,     0,     0,   668,     0,     0,     0,     0,
    1539,     0,     0,  1540,     0,     0,     0,  1038,     0,     0,
       0,     0,     0,   668,     0,     0,     0,   682,     0,     0,
       0,     0,     0,     0,     0,     0,  1526,     0,     0,  1527,
     668,     0,     0,     0,     0,     0,     0,     0,     0,  2520,
       0,     0,     0,     0,     0,  3321,  1528,     0,     0,  1796,
       0,  3042,     0,     0,  1530,     0,     0,     0,     0,  1531,
       0,     0,  1038,  1038,     0,  1762,     0,     0,     0,     0,
       0,     0,     0,  1541,     0,     0,     0,     0,     0,     0,
    2562,     0,     0,     0,  1996,     0,     0,     0,     0,  1996,
       0,     0,  1996,  2520,     0,  3357,     0,     0,     0,  1301,
       0,     0,  2365,     0,  2365,     0,     0,     0,     0,  1526,
       0,     0,  1527,     0,     0,     0,     0,     0,     0,     0,
       0,   736,     0,     0,     0,     0,     0,     0,     0,  1528,
       0,     0,     0,     0,  1038,     0,     0,  1530,     0,     0,
       0,     0,  1531,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1542,
    1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,
    1038,     0,     0,  3565,     0,     0,     0,  1038,  1038,     0,
       0,     0,     0,     0,  1532,  1038,  1038,     0,  1533,     0,
    1038,     0,     0,     0,     0,     0,  1038,  1038,     0,     0,
    1038,     0,   668,   668,   668,   668,     0,     0,     0,  1534,
    1535,  1038,     0,     0,     0,     0,     0,  3421,     0,     0,
       0,     0,     0,  1038,  1536,     0,     0,     0,     0,     0,
       0,   754,     0,     0,     0,     0,   724,  1931,     0,     0,
     612,     0,   724,  1038,     0,     0,     0,   727,   727,  1953,
       0,     0,     0,     0,     0,     0,  1537,     0,     0,  1538,
       0,     0,  3447,     0,     0,     0,     0,  1532,     0,     0,
     736,  1533,  1539,     0,     0,  1540,     0,     0,     0,     0,
       0,   736,     0,     0,     0,     0,     0,  2004,     0,     0,
       0,  2008,  1534,  1535,   727,     0,     0,     0,     0,     0,
    2017,     0,  2019,     0,  2020,     0,     0,  1536,     0,  2021,
       0,     0,     0,  1526,     0,     0,  1527,     0,     0,     0,
       0,   843,     0,     0,     0,     0,     0,     0,  1420,     0,
       0,     0,   492,  1528,   492,     0,   492,     0,   492,  1537,
     492,  1530,  1538,     0,   492,  1541,  1531,     0,     0,     0,
       0,     0,  1301,     0,     0,  1539,     0,  1301,  1301,     0,
       0,  1038,     0,     0,     0,     0,     0,     0,  1301,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   668,     0,     0,     0,     0,     0,  1038,     0,
       0,     0,  1996,     0,     0,  3357,  1526,     0,  1541,  1527,
       0,  1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,
    1550,     0,     0,     0,   736,  3588,  1528,     0,     0,  1038,
       0,     0,     0,     0,  1530,     0,     0,     0,     0,  1531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1532,     0,  1038,  1038,  1533,     0,  1038,     0,     0,
       0,     0,     0,     0,  1038,  1038,  1301,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1534,  1535,   736,     0,
     736,     0,     0,     0,  3178,   754,   727,     0,     0,     0,
       0,  1536,     0,     0,  1542,  1543,  1544,     0,  1545,  1546,
    1547,  1548,  1549,  1550,   722,   754,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1537,     0,     0,  1538,     0,     0,  1420,
       0,  1301,     0,     0,     0,     0,     0,     0,     0,  1539,
     722,     0,  1540,   668,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   724,  2365,     0,  1796,     0,     0,
    1526,     0,     0,  1527,  1532,     0,  3321,     0,  1533,     0,
       0,   668,     0,     0,     0,     0,     0,     0,     0,     0,
     727,  3178,     0,     0,     0,     0,     0,     0,  1530,  1534,
    1535,     0,     0,  1531,     0,     0,   724,     0,     0,     0,
       0,     0,     0,   724,  1536,     0,     0,     0,  1038,     0,
       0,  1038,  1541,  1038,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3681,     0,     0,  1301,
       0,     0,     0,     0,     0,     0,  1537,     0,   727,  1538,
       0,  2279,     0,     0,     0,     0,   668,  2284,     0,  1038,
       0,     0,  1539,     0,     0,  1540,     0,  2294,     0,   727,
     727,   727,   727,     0,  2300,     0,     0,     0,   843,     0,
    2305,     0,     0,     0,     0,     0,  2315,     0,     0,     0,
       0,  2317,     0,     0,     0,     0,     0,     0,     0,  1038,
       0,     0,     0,     0,     0,     0,   724,     0,  1542,  1543,
    1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,  2333,  2334,
    2337,  2339,  3626,     0,     0,  2346,  2349,     0,  1532,     0,
    2352,     0,  1533,  2356,     0,  1541,     0,   724,     0,     0,
       0,     0,  1038,     0,     0,     0,     0,     0,     0,     0,
     754,     0,  2393,  1534,  1535,     0,     0,     0,     0,     0,
       0,     0,  2396,     0,  2398,     0,     0,     0,  1536,     0,
       0,     0,     0,     0,  2410,  2411,  2412,     0,  2414,     0,
       0,     0,     0,   727,     0,     0,   722,  2427,  2428,     0,
       0,     0,     0,  3178,     0,  2431,  2432,     0,     0,     0,
    1537,     0,  3681,  1538,     0,  1038,  1038,     0,   736,     0,
       0,  1526,     0,     0,  1527,   722,  1539,     0,     0,   727,
       0,  1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,
    1550,  1528,     0,     0,     0,  3770,   724,     0,     0,  1530,
       0,  1038,     0,   724,  1531,     0,     0,     0,     0,     0,
       0,  1038,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1303,  3838,     0,     0,     0,     0,
    1526,     0,     0,  1527,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1301,  1301,     0,  1301,     0,     0,  1541,
    1528,     0,     0,   724,  2256,     0,     0,     0,  1530,     0,
       0,     0,     0,  1531,     0,  1038,     0,     0,     0,     0,
    3838,     0,     0,     0,   722,     0,     0,     0,  3838,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1301,
       0,  1301,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1532,
       0,     0,     0,  1533,  2257,  1542,  1543,  1544,     0,  1545,
    1546,  1547,  1548,  1549,  1550,     0,     0,  1303,     0,     0,
       0,     0,     0,     0,  1534,  1535,     0,     0,     0,     0,
       0,  1301,  2630,     0,     0,     0,     0,     0,     0,  1536,
       0,     0,     0,     0,   724,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1301,     0,  1532,     0,
       0,     0,  1533,     0,     0,     0,     0,     0,     0,     0,
       0,  1537,   724,     0,  1538,     0,     0,     0,     0,     0,
       0,     0,     0,  1534,  1535,     0,     0,  1539,     0,     0,
    1540,     0,     0,     0,     0,  1301,     0,     0,  1536,   724,
     724,     0,   724,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1301,     0,     0,     0,     0,     0,     0,   724,
       0,     0,     0,     0,     0,     0,  1301,     0,     0,     0,
    1537,     0,     0,  1538,     0,     0,     0,     0,   546,  1301,
       0,     0,     0,     0,     0,     0,  1539,     0,     0,  1540,
     547,     0,     0,     0,     0,     0,     0,   724,  1671,     0,
    1541,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     548,     0,     0,     0,  1301,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   724,
       0,     0,     0,   724,   724,   549,     0,     0,     0,     0,
       0,     0,  1526,     0,  1303,  1527,     0,     0,     0,  1671,
       0,     0,     0,     0,     0,   550,     0,     0,     0,  1541,
       0,     0,  1528,     0,     0,  2780,  2781,     0,  1302,     0,
    1530,     0,     0,     0,     0,  1531,   551,  1301,     0,     0,
       0,     0,     0,     0,  1303,     0,  1542,  1543,  1544,     0,
    1545,  1546,  1547,  1548,  1549,  1550,  1301,  2801,     0,     0,
    3846,     0,     0,     0,   552,     0,     0,     0,  2258,   553,
       0,  1303,     0,     0,     0,   554,     0,     0,     0,     0,
       0,  1301,     0,     0,     0,     0,     0,     0,     0,     0,
     555,  2820,  2821,  2822,  2823,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1542,  1543,  1544,     0,  1545,
    1546,  1547,  1548,  1549,  1550,  1301,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1526,     0,     0,  1527,     0,  1303,  2681,
       0,     0,     0,     0,  2682,     0,     0,     0,     0,     0,
       0,  1302,     0,  1528,     0,  1303,     0,     0,     0,     0,
    1532,  1530,     0,     0,  1533,     0,  1531,     0,     0,     0,
       0,   556,     0,     0,     0,  1303,     0,     0,  2867,     0,
       0,   557,     0,  2869,     0,  1534,  1535,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1303,   177,     0,
    1536,     0,  1671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1301,     0,
       0,     0,   558,     0,     0,     0,   559,     0,   560,     0,
       0,     0,  1537,     0,   561,  1538,     0,   562,   724,     0,
     724,     0,     0,     0,     0,     0,  1303,     0,  1539,   724,
       0,  1540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   563,     0,   564,     0,     0,     0,   565,
    2971,  2972,     0,     0,     0,     0,     0,   566,     0,     0,
       0,     0,   567,     0,     0,     0,     0,     0,     0,     0,
       0,  1532,   568,     0,     0,  1533,     0,     0,     0,     0,
       0,     0,     0,     0,   569,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   724,  1534,  1535,     0,     0,
       0,  1541,     0,  1526,     0,     0,  1527,     0,     0,     0,
       0,  1536,  3030,     0,     0,     0,     0,     0,  1302,     0,
       0,     0,     0,  1528,     0,  3039,     0,  1301,     0,     0,
     724,  1530,   724,     0,     0,     0,  1531,     0,     0,   724,
       0,     0,   724,  1537,     0,   724,  1538,     0,     0,     0,
       0,     0,     0,   724,   724,     0,     0,  1293,  1789,  1539,
       0,   724,  1540,  1301,   724,   724,   724,   724,     0,     0,
       0,     0,     0,     0,   724,   724,     0,   724,     0,   724,
    3103,     0,   724,     0,     0,  1302,     0,  1542,  1543,  1544,
       0,  1545,  1546,  1547,  1548,  1549,  1550,  1303,   724,  1671,
       0,     0,   724,     0,     0,     0,   724,     0,     0,     0,
     724,     0,   724,   724,   724,   724,   724,   724,   724,   724,
     724,     0,   724,     0,     0,     0,     0,   724,     0,   724,
       0,     0,  1541,     0,     0,     0,     0,     0,     0,  3821,
       0,     0,     0,     0,     0,  3104,     0,     0,     0,     0,
       0,     0,  1302,     0,     0,     0,     0,     0,     0,     0,
       0,  1532,     0,     0,     0,  1533,     0,     0,     0,  1302,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1293,     0,  1301,     0,     0,     0,  1534,  1535,     0,  1302,
       0,     0,     0,  1301,     0,     0,     0,     0,     0,     0,
       0,  1536,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1302,     0,     0,     0,     0,     0,     0,  1542,  1543,
    1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,     0,
       0,     0,     0,  1537,     0,     0,  1538,     0,     0,     0,
       0,     0,     0,     0,  1526,  3195,     0,  1527,     0,  1539,
       0,     0,  1540,     0,     0,     0,     0,     0,     0,     0,
    1302,   724,     0,     0,  1528,     0,  1301,  2645,  3822,     0,
       0,     0,  1530,     0,     0,     0,  1301,  1531,     0,     0,
       0,     0,     0,     0,     0,  3221,     0,     0,     0,     0,
    3228,     0,  3230,  3231,  3232,  3233,     0,     0,     0,     0,
       0,     0,     0,     0,  1671,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1541,     0,     0,     0,     0,     0,     0,   724,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1303,     0,     0,     0,     0,  1303,  1303,     0,     0,     0,
       0,  3286,  3288,  3290,     0,  3292,  1303,  1293,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1532,     0,     0,     0,  1533,  1293,  1542,  1543,
    1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,  1671,
       0,     0,     0,     0,     0,     0,     0,  1534,  1535,  1301,
       0,  1302,     0,     0,  1293,     0,     0,  2801,     0,     0,
       0,     0,  1536,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1301,  3359,     0,     0,     0,
       0,     0,     0,  2230,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1537,     0,     0,  1538,     0,     0,
       0,     0,   724,     0,  1303,     0,     0,     0,  1025,     0,
    1539,     0,     0,  1540,     0,     0,     0,     0,     0,     0,
       0,  1293,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1293,  1084,
       0,     0,     0,  1301,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1293,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1303,
       0,     0,     0,     0,     0,     0,     0,   724,     0,     0,
    1293,     0,     0,  1541,     0,     0,     0,   724,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,  1301,     0,  1528,     0,  1293,
       0,     0,     0,     0,     0,  1530,     0,     0,     0,     0,
    1531,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3453,  1301,     0,     0,     0,     0,   724,     0,     0,     0,
       0,  3462,     0,     0,     0,     0,     0,  1303,     0,  1542,
    1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,
       0,     0,     0,     0,     0,     0,     0,   724,   724,     0,
       0,     0,     0,     0,  1301,     0,     0,     0,  1301,  1301,
       0,     0,     0,     0,  2319,     0,     0,     0,     0,  1789,
    2326,     0,     0,     0,     0,     0,     0,   724,   724,     0,
    1302,     0,   724,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   724,   724,   724,   724,     0,     0,
       0,     0,  1671,     0,     0,     0,   724,  1671,     0,   724,
       0,   724,     0,     0,     0,     0,  3508,     0,     0,     0,
       0,   724,   724,     0,   724,  1532,     0,     0,     0,  1533,
       0,     0,     0,     0,     0,     0,     0,   724,  3526,   724,
       0,     0,     0,   724,     0,     0,     0,     0,     0,     0,
    1534,  1535,     0,     0,     0,     0,     0,     0,  1526,   724,
    1293,  1527,     0,     0,     0,  1536,     0,     0,     0,   724,
       0,   724,   724,   724,     0,  3553,  1467,     0,  1528,     0,
       0,  2689,     0,     0,     0,     0,  1530,     0,   724,     0,
       0,  1531,     0,     0,     0,     0,   724,  1537,  1302,     0,
    1538,     0,     0,     0,  1490,   724,     0,     0,     0,     0,
     724,     0,     0,  1539,     0,     0,  1540,   724,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2659,
       0,  1514,  1515,     0,  1517,     0,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,     0,     0,     0,
       0,  1555,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1789,     0,     0,     0,     0,     0,     0,
       0,  1303,  1303,     0,  1303,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1541,     0,     0,  1590,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1532,  1303,     0,  1303,
    1533,  1700,     0,     0,     0,  1710,  1713,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1534,  1535,     0,     0,  1295,     0,     0,  2801,     0,
    1671,  1671,  1671,     0,     0,     0,  1536,     0,     0,     0,
       0,  1302,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,
    1549,  1550,     0,     0,     0,     0,     0,     0,  1537,  1303,
       0,  1538,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1539,     0,     0,  1540,     0,     0,
       0,  1671,     0,  1293,  1303,     0,     0,     0,  1293,  1293,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1293,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,  1303,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1295,     0,
    1303,     0,     0,     0,     0,     0,     0,  1541,     0,     0,
       0,     0,     0,     0,  1303,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1303,     0,     0,
       0,     0,     0,     0,     0,  2230,  2230,  2230,     0,     0,
       0,     0,     0,   724,     0,     0,     0,   724,     0,     0,
       0,     0,     0,     0,     0,     0,   724,     0,     0,     0,
    3767,     0,  1303,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1293,     0,  1296,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   724,
       0,  1298,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   724,     0,     0,  1303,     0,     0,     0,     0,
       0,   724,     0,     0,     0,  1789,  2326,   724,  2326,   724,
       0,     0,  1293,     0,  1303,   724,     0,     0,   724,   724,
     724,   724,   724,   724,   724,   724,   724,   724,     0,     0,
       0,   724,   724,     0,     0,     0,     0,     0,     0,  1303,
       0,     0,     0,     0,   724,     0,     0,     0,  1671,     0,
     724,  1302,     0,  1302,     0,  1295,     0,     0,     0,     0,
     724,     0,     0,   724,     0,   724,     0,     0,     0,     0,
       0,     0,  1296,  1303,   724,   724,   724,     0,     0,     0,
     724,     0,     0,   724,  1298,     0,     0,     0,     0,     0,
       0,  2101,     0,   724,     0,  1295,     0,     0,     0,     0,
       0,   724,     0,   724,     0,     0,     0,     0,     0,     0,
    1293,     0,     0,  2123,     0,     0,  2125,     0,     0,  2136,
       0,     0,  1295,  1302,     0,     0,  2143,  2148,     0,     0,
       0,  2153,     0,     0,  2158,     0,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,     0,  2326,     0,
    2167,     0,     0,     0,  2173,     0,     0,     0,  2185,     0,
       0,     0,  2192,     0,  2194,  2195,  2196,  2197,  2198,  2199,
    2200,  2201,  2202,     0,  2203,  1671,  1303,  1671,     0,  1025,
       0,  2227,     0,     0,     0,     0,     0,  2326,     0,  1295,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,     0,  1302,     0,  1295,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1302,     0,
       0,     0,     0,     0,     0,     0,  1295,     0,     0,     0,
       0,  2326,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1296,
    2230,     0,     0,     0,     0,     0,  1302,     0,     0,     0,
       0,  1298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   724,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1295,     0,  1296,
       0,     0,     0,     0,     0,  1303,     0,     0,     0,     0,
       0,  1298,     0,  1084,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1296,     0,     0,  1302,
       0,     0,     0,     0,     0,     0,     0,     0,  1298,     0,
       0,  1303,   724,   724,     0,     0,     0,     0,  1302,     0,
       0,     0,     0,     0,  1293,  1293,     0,  1293,     0,     0,
       0,     0,     0,     0,   724,     0,     0,     0,     0,   724,
       0,     0,   724,  1302,     0,     0,     0,     0,     0,     0,
       0,  2303,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1296,     0,     0,     0,     0,     0,     0,
    1293,     0,  1293,     0,     0,  1298,     0,  1302,     0,     0,
    1296,     0,     0,     0,   724,     0,     0,     0,     0,     0,
       0,     0,  1298,     0,     0,     0,     0,     0,     0,     0,
    1296,     0,     0,     0,     0,     0,     0,  2230,     0,     0,
       0,     0,  1298,     0,     0,     0,     0,     0,     0,     0,
     724,     0,  1296,     0,     0,     0,     0,   724,   724,     0,
    1303,     0,     0,     0,  1298,   724,   724,     0,  1295,     0,
     724,  1303,  1293,     0,     0,     0,   724,   724,     0,     0,
     724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,     0,     0,  1293,     0,     0,
       0,  1296,     0,   724,     0,     0,     0,     0,     0,     0,
    2326,     0,     0,  1298,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2467,     0,  1293,     0,     0,     0,
       0,     0,     0,     0,  1303,     0,     0,     0,     0,     0,
       0,     0,     0,  1293,  1303,     0,     0,  1526,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,  1293,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1528,     0,     0,
    1293,     0,     0,     0,     0,  1530,     0,     0,     0,     0,
    1531,     0,     0,     0,     0,     0,     0,     0,     0,  1671,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1293,     0,     0,     0,  2579,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1299,     0,     0,  1302,
       0,   724,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1671,     0,  2600,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1296,     0,     0,  1789,     0,     0,  1293,     0,
       0,     0,     0,     0,  1298,     0,     0,     0,  1025,  1303,
       0,     0,     0,     0,     0,     0,     0,  1293,   724,  2694,
       0,     0,   724,     0,     0,     0,     0,  1303,     0,     0,
       0,     0,     0,     0,     0,  1532,     0,     0,     0,  1533,
    2641,  1295,  1293,     0,     0,     0,  1295,  1295,     0,   724,
       0,     0,     0,  1303,     0,     0,     0,  1295,     0,     0,
    1534,  1535,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,   724,  1536,  1293,   724,     0,  1299,
       0,     0,     0,     0,   724,   724,  2148,     0,  2148,  2148,
       0,     0,     0,     0,     0,     0,     0,     0,  2701,     0,
       0,  2704,     0,  2706,   724,     0,     0,  1537,     0,     0,
    1538,     0,     0,     0,  1302,     0,  1526,     0,     0,  1527,
       0,  1303,     0,  1539,   724,  1302,  1540,     0,     0,  2727,
       0,  2729,     0,     0,     0,  2732,  1528,     0,     0,  2698,
       0,     0,     0,     0,  1530,  2230,     0,     0,     0,  1531,
       0,     0,     0,     0,     0,     0,     0,  2230,     0,     0,
     724,     0,     0,  2227,  2227,  2227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1295,     0,     0,     0,  1293,
    2759,     0,     0,     0,     0,     0,     0,     0,  1084,     0,
       0,     0,     0,     0,     0,     0,  1541,  1700,  1302,     0,
       0,   724,  2773,  1303,     0,     0,     0,     0,  1302,  1713,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   724,  1303,
       0,   724,     0,   724,     0,  2790,     0,     0,     0,     0,
    1295,     0,     0,     0,     0,  1296,     0,     0,     0,     0,
    1296,  1296,     0,     0,  1300,     0,     0,  1298,     0,     0,
       0,  1296,  1298,  1298,     0,     0,  1299,     0,     0,   724,
       0,     0,  1303,  1298,  1532,     0,  1303,  1303,  1533,     0,
       0,     0,  1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,
    1549,  1550,     0,     0,     0,     0,     0,     0,     0,  1534,
    1535,     0,  1671,     0,     0,     0,  1299,     0,  1293,   724,
       0,     0,     0,     0,  1536,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1299,  1303,     0,     0,     0,  1295,     0,
       0,     0,     0,  3536,  1293,     0,  1537,     0,     0,  1538,
       0,     0,   724,     0,     0,     0,     0,     0,     0,     0,
       0,  1302,  1539,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1300,     0,  1296,
       0,     0,     0,     0,     0,     0,     0,  1302,     0,     0,
       0,  1298,     0,     0,     0,     0,   724,     0,     0,     0,
    1299,     0,     0,   724,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   724,   724,  1299,     0,     0,
       0,     0,     0,     0,     0,   724,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1541,     0,  1299,     0,     0,
       0,     0,     0,     0,  1296,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,  2326,  1298,     0,     0,  1299,
       0,   724,     0,  1293,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1293,     0,     0,     0,  1526,     0,
       0,  1527,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
       0,     0,     0,     0,     0,     0,  1530,     0,  1299,     0,
       0,  1531,     0,     0,     0,   724,     0,     0,  2227,     0,
       0,  1542,  1543,  1544,   724,  1545,  1546,  1547,  1548,  1549,
    1550,     0,     0,     0,     0,     0,     0,  2326,     0,     0,
       0,     0,  1296,     0,     0,     0,     0,  1293,     0,     0,
       0,     0,     0,     0,  1298,     0,     0,  1293,     0,     0,
       0,     0,     0,  1302,  1300,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1295,  1295,  3065,  1295,     0,     0,     0,     0,
       0,     0,     0,  3068,     0,     0,     0,     0,     0,  3069,
       0,  3070,     0,     0,  1300,     0,  1302,     0,     0,     0,
    1302,  1302,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3088,  3089,     0,  1526,     0,  1295,  1527,
    1295,  1300,     0,     0,     0,     0,  1532,     0,     0,     0,
    1533,     0,  2153,     0,     0,     0,  1528,     0,     0,  3110,
       0,     0,  3114,     0,  1530,  3117,     0,  3119,     0,  1531,
       0,  1534,  1535,     0,     0,     0,  3123,     0,  3536,     0,
       0,     0,  3128,     0,     0,  3131,  1536,     0,     0,  1299,
       0,     0,     0,     0,     0,  3138,     0,     0,     0,     0,
       0,     0,     0,  3150,     0,  2227,     0,     0,  1300,     0,
    1295,     0,     0,     0,     0,     0,     0,     0,  1537,     0,
    1293,  1538,     0,     0,     0,  1300,     0,     0,     0,     0,
       0,     0,     0,     0,  1539,  1295,     0,  1540,     0,     0,
       0,     0,     0,     0,     0,  1300,  1293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1300,     0,     0,
       0,     0,     0,     0,  1295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1295,     0,     0,  1532,     0,  1296,  1296,  1533,  1296,
       0,     0,     0,     0,     0,  1295,     0,  1541,  1298,  1298,
       0,  1298,     0,     0,  1293,     0,  1300,     0,  1295,  1534,
    1535,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3064,  1536,     0,     0,     0,     0,     0,
       0,     0,  1296,     0,  1296,     0,     0,     0,     0,     0,
       0,     0,     0,  1295,  1298,     0,  1298,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1537,     0,     0,  1538,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1539,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,  1542,  1543,  1544,  1293,  1545,  1546,  1547,
    1548,  1549,  1550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1296,     0,  1295,     0,     0,     0,
       0,     0,  1293,     0,     0,     0,  1298,     0,     0,     0,
       0,     0,     0,  1526,     0,  1295,  1527,     0,     0,  1296,
       0,     0,  1299,     0,  3336,  3337,     0,  1299,  1299,     0,
       0,  1298,     0,  1528,     0,  1541,     0,     0,  1299,     0,
    1295,  1530,     0,     0,     0,  1293,  1531,     0,     0,  1293,
    1293,     0,     0,     0,     0,     0,     0,     0,  1296,     0,
       0,     0,     0,     0,     0,     0,     0,  1300,     0,     0,
    1298,     0,     0,     0,  1295,  1296,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1298,     0,  1296,
       0,     0,     0,     0,     0,     0,  3375,     0,     0,     0,
       0,  1298,  1296,     0,     0,     0,     0,     0,  1552,     0,
       0,     0,     0,     0,  1298,     0,     0,     0,     0,     0,
       0,  1542,  1543,  1544,     0,  1545,  1546,  1547,  1548,  1549,
    1550,     0,     0,     0,     0,     0,     0,  1296,     0,  3391,
    3393,     0,     0,     0,     0,     0,     0,     0,     0,  1298,
       0,     0,  3400,     0,     0,     0,  1299,     0,  3405,  3406,
       0,     0,  3408,     0,     0,     0,     0,  1552,     0,     0,
       0,  1532,   504,  2227,     0,  1533,     0,  1295,     0,     0,
       0,     0,     0,     0,   505,  2227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1534,  1535,     0,     0,
    1296,     0,     0,     0,   506,  3432,     0,     0,     0,     0,
       0,  1536,  1298,     0,     0,     0,     0,     0,     0,  1296,
       0,  1299,     0,     0,     0,   507,     0,     0,     0,  -616,
       0,  1298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1537,  1296,     0,  1538,     0,     0,   508,
       0,     0,     0,     0,     0,   509,  1298,     0,     0,  1539,
       0,     0,  1540,     0,     0,     0,     0,     0,     0,     0,
     510,     0,     0,     0,     0,     0,     0,     0,  1296,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1298,     0,     0,     0,     0,     0,     0,     0,   511,     0,
       0,     0,     0,     0,     0,   512,  1295,     0,     0,   513,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1299,
    1300,     0,     0,  3496,  -769,  1300,  1300,     0,     0,     0,
       0,     0,  1541,     0,     0,     0,  1300,     0,     0,     0,
       0,     0,  1295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   514,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3543,  1296,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1298,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   515,     0,     0,   516,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1542,  1543,
    1544,     0,  1545,  1546,  1547,  1548,  1549,  1550,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3573,
       0,     0,     0,     0,     0,     0,     0,  3575,     0,     0,
       0,     0,     0,     0,  1300,     0,   517,     0,     0,     0,
       0,  1295,   518,     0,     0,     0,     0,     0,  -348,     0,
       0,   519,  1295,  1552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -348,     0,   520,
     521,     0,   522,   523,     0,     0,     0,     0,     0,     0,
    1296,   524,     0,     0,     0,     0,   525,     0,     0,  1300,
       0,   526,  1298,     0,     0,     0,   527,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -348,     0,
       0,     0,     0,     0,     0,  1295,  1296,     0,     0,     0,
    1552,     0,     0,     0,     0,  1295,     0,     0,  1298,     0,
       0,     0,     0,  1299,  1299,     0,  1299,     0,     0,     0,
       0,     0,     0,  1552,     0,     0,     0,     0,  2132,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2153,     0,     0,     0,  1552,  1552,     0,
    1552,     0,     0,     0,     0,     0,     0,     0,     0,  1299,
       0,  1299,     0,     0,     0,     0,     0,  1300,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3696,     0,     0,     0,     0,     0,     0,  1552,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1296,     0,     0,     0,     0,
       0,  3725,     0,  1552,     0,     0,  1296,  1298,     0,     0,
       0,  1299,     0,     0,     0,     0,     0,     0,  1298,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1299,     0,  1295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1299,     0,     0,     0,  1296,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1296,
       0,  1298,  1299,     0,     0,     0,     0,     0,     0,     0,
       0,  1298,     0,     0,     0,     0,  1299,  3784,  3784,     0,
       0,     0,     0,  1552,     0,     0,     0,     0,     0,  1299,
       0,     0,     0,  1552,     0,     0,  1552,     0,     0,     0,
       0,     0,  1295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3784,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3824,  1299,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1300,  1300,     0,  1300,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3784,     0,     0,
       0,     0,     0,     0,  1295,     0,     0,  1299,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1299,  1300,     0,  1300,
    1295,     0,  1296,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1298,     0,     0,     0,     0,     0,
       0,  1299,     0,     0,     0,     0,     0,     0,  1296,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1298,     0,     0,  1295,     0,     0,     0,  1295,  1295,     0,
       0,     0,     0,     0,     0,  1299,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1300,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1300,     0,  1296,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1298,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1300,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1300,     0,     0,     0,     0,     0,     0,     0,  1299,     0,
       0,     0,     0,     0,  1300,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1300,  1296,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1298,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1296,     0,     0,     0,     0,     0,
       0,     0,  1300,     0,     0,     0,  1298,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1296,     0,     0,
       0,  1296,  1296,     0,     0,     0,     0,     0,     0,  1298,
       0,     0,     0,  1298,  1298,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1552,  1300,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1299,     0,     0,
       0,     0,     0,     0,  1300,     0,  1552,     0,  1552,     0,
    2132,  2132,  2677,     0,     0,  2132,     0,     0,     0,  1552,
       0,     0,     0,     0,     0,     0,  1552,     0,     0,  1300,
       0,  1552,     0,  1299,     0,     0,  1552,     0,     0,     0,
       0,  1552,     0,     0,     0,     0,     0,     0,     0,     0,
    1552,     0,     0,     0,  2132,  2132,  1552,     0,     0,     0,
       0,     0,     0,  1300,     0,     0,     0,     0,  1552,     0,
       0,     0,     0,     0,     0,  1552,     0,  1552,  1552,  1552,
    1552,  1552,  1552,  1552,  1552,  1552,  1552,     0,     0,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     2,
       0,     3,     4,     0,     0,     0,     0,     0,     0,     0,
    1552,     0,     0,     0,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     0,     7,     8,     0,
       0,     0,     9,     0,    10,     0,     0,     0,     0,     0,
       0,     0,  1299,     0,    11,     0,    12,     0,     0,     0,
       0,     0,     0,  1299,     0,     0,  1300,     0,     0,     0,
       0,     0,     0,     0,     0,    13,     0,     0,    14,     0,
       0,     0,     0,     0,    15,     0,  1552,     0,     0,     0,
      16,     0,    17,     0,     0,     0,    18,     0,     0,     0,
       0,     0,    19,     0,     0,     0,     0,     0,     0,    20,
       0,    21,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,  1299,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1299,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,    26,     0,     0,     0,     0,    27,
       0,     0,     0,     0,     0,  1300,     0,     0,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    29,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1300,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1552,    30,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    31,     0,     0,     0,    32,     0,    33,     0,
       0,     0,     0,    34,     0,     0,     0,     0,    35,     0,
       0,    36,     0,     0,     0,    37,     0,     0,     0,     0,
       0,    38,     0,     0,     0,     0,     0,     0,    39,  1299,
       0,    40,     0,     0,     0,     0,     0,     0,    41,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,  1299,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,     0,     0,    44,     0,    45,
    1300,     0,    46,     0,     0,     0,    47,     0,     0,     0,
       0,  1300,  1552,     0,     0,     0,     0,     0,    48,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1299,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1552,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1300,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1300,  2677,  2677,     0,  2132,     0,
       0,  2132,  2132,  2132,  2132,  2132,  2132,  2132,  2132,  2132,
    2132,  2677,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1299,     0,     0,     0,     0,
       0,     0,     0,     0,  1552,     0,     0,  1552,     0,  1552,
       0,     0,     0,     0,  2677,  2677,     0,     0,     0,     0,
       0,  1299,     0,     0,     0,     0,     0,     0,  2132,  2132,
    1552,     0,  1552,     0,     0,  1552,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1552,     0,  1299,     0,     0,     0,  1299,  1299,
       0,     0,     0,     0,     0,     0,  1552,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1300,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1300,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1300,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2132,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1300,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1300,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1300,     0,     0,     0,  1300,  1300,  1552,     0,
       0,  1552,  1552,  1552,     0,     0,  2677,     0,     0,     0,
       0,  2677,  2677,  2677,  2677,  2677,  2677,  2677,  2677,  2677,
    2677,  1552,  1552,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1552,  2132,  2132,
    1552,     0,  1552,     0,     0,     0,  1552,  2677,  2677,     0,
       0,  1552,     0,     0,  1552,     0,     0,     0,     0,     0,
       0,  1552,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1552,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1552,
    1552,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1552,     0,
       0,     0,  2132,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1552,     0,  1552,     0,     0,     0,
       0,  2677,  2677,  1552,     0,     0,  2132,  2132,  1552,  1552,
       0,  1552,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1552,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1552,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1552,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2677,  2132,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2677,  2677,  1552,     0,  1552,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,  2677,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,  1552,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,  1552,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,  1552,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,  1552,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
       0,     0,     0,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,  3436,   464,   465,   466,
     467,   468,   469,     0,   470,     0,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1067,     0,     0,     0,  1068,   698,
     945,   541,   946,   947,   948,   586,   949,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,  2221,   201,
     202,   203,     0,     0,     0,     0,   950,     0,     0,   204,
     205,     0,   206,   699,   207,   208,   209,   210,   951,   700,
     952,   953,     0,   214,   215,   216,   217,   218,   954,   955,
     219,   220,   956,   957,   223,     0,   224,   225,   226,   227,
     958,     0,     0,   229,   230,   231,   232,   701,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   702,   244,   245,   959,   960,   961,   962,   963,   964,
     965,   246,   247,   248,   249,   250,   251,   966,   967,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,  2222,     0,   264,   265,   968,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   969,   279,   280,   970,   971,   282,     0,   283,   972,
     285,     0,   286,     0,   287,   704,     0,   705,   288,   289,
     290,     0,   291,   973,     0,   293,     0,   294,   295,   296,
     297,   298,   706,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   707,   309,   310,   311,   312,
     313,   974,   975,     0,   976,     0,   317,   708,   709,   318,
     710,   319,   320,   321,   322,   323,   324,   325,     0,   977,
     711,   327,   712,     0,   328,   329,   330,   978,   979,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   980,   713,   981,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   982,   355,   356,   714,   357,   983,
     984,   359,   985,   361,   362,   363,     0,   364,     0,     0,
     986,   366,   367,     0,     0,   368,   715,   716,   717,   987,
     370,   371,   372,   373,   374,   375,     0,   376,   988,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   989,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
     718,   406,   407,   990,   409,   410,   411,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,   991,   422,
     423,   424,   425,   719,   426,   992,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   993,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     994,   995,     0,     0,   450,   996,   452,   997,   998,   454,
     455,   456,   457,   458,   459,     0,   999,   460,   461,   462,
     463,  1000,     0,   464,   465,   466,   467,   468,  1001,  2223,
     470,   720,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,   488,   489,   490,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  2224,     0,     0,     0,     0,
       0,     0,  1012,  2225,   698,   945,   541,   946,   947,   948,
     586,   949,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,   950,     0,     0,   204,   205,     0,   206,   699,   207,
     208,   209,   210,   951,   700,   952,   953,     0,   214,   215,
     216,   217,   218,   954,   955,   219,   220,   956,   957,   223,
       0,   224,   225,   226,   227,   958,     0,     0,   229,   230,
     231,   232,   701,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   702,   244,   245,   959,
     960,   961,   962,   963,   964,   965,   246,   247,   248,   249,
     250,   251,   966,   967,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   968,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   969,   279,   280,   970,
     971,   282,     0,   283,   972,   285,     0,   286,     0,   287,
     704,     0,   705,   288,   289,   290,     0,   291,   973,     0,
     293,     0,   294,   295,   296,   297,   298,   706,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     707,   309,   310,   311,   312,   313,   974,   975,     0,   976,
       0,   317,   708,   709,   318,   710,   319,   320,   321,   322,
     323,   324,   325,     0,   977,   711,   327,   712,     0,   328,
     329,   330,   978,   979,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   980,   713,   981,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   982,
     355,   356,   714,   357,   983,   984,   359,   985,   361,   362,
     363,     0,   364,     0,     0,   986,   366,   367,     0,     0,
     368,   715,   716,   717,   987,   370,   371,   372,   373,   374,
     375,     0,   376,   988,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   989,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,   718,   406,   407,   990,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,   991,   422,   423,   424,   425,   719,   426,
     992,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   993,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   994,   995,     0,     0,   450,
     996,   452,   997,   998,   454,   455,   456,   457,   458,   459,
       0,   999,   460,   461,   462,   463,  1000,     0,   464,   465,
     466,   467,   468,  1001,     0,   470,   720,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,   488,   489,
     490,     0,     0,     0,     0,     0,     0,     0,  1009,  1010,
     191,     0,     0,     0,     0,     0,     0,  1012,  2134,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,  2560,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243, -1262,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0, -1262,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308, -1262,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318, -1262,   319,   320,   321,   322,   323,   324,   325,     0,
     326, -1262,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344, -1262,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405, -1262,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,     0,
       0,     0,     0,     0,  1269,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1091,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,   699,   207,
     208,   209,     0,  1270,   700,  1271,  1272,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,  1273,  1274,   223,
       0,   224,   225,   226,   227,     0,     0,     0,   229,   230,
     231,   232,   701,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   702,   244,   245,     0,
       0,     0,   703,     0,     0,     0,   246,   247,   248,   249,
     250,   251,  1275,  1276,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   968,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,     0,   279,   280,     0,
       0,   282,     0,   283,  1277,   285,     0,   286,     0,   287,
     704,     0,   705,   288,   289,   290,     0,   291,     0,     0,
     293,     0,   294,   295,   296,   297,   298,   706,   299,   300,
     301,  1777,   302,   303,   304,   305,   306,   307,     0,   308,
     707,  1778,   310,   311,   312,   313,  1278,  1279,     0,  1280,
       0,   317,   708,   709,   318,   710,   319,   320,   321,   322,
     323,   324,   325,     0,     0,   711,   327,   712,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1281,   713,  1282,
     346,   347,   348,   349,   350,   351,   352,     0,   354,     0,
     355,   356,   714,   357,     0,     0,   359,  1283,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
    1779,   715,   716,   717,     0,   370,   371,   372,   373,   374,
     375,     0,   376,     0,   378,     0,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,  1284,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,   718,   406,   407,     0,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,  1780,   424,   425,   719,   426,
    1286,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,  1287,  1288,     0,     0,   450,
       0,   452,     0,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,     0,  1289,  1781,   470,   720,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
    1269,     0,     0,     0,     0,     0,     0,     0,   488,   489,
     490,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,  1782,     0,
     204,   205,     0,   206,   699,   207,   208,   209,     0,  1270,
     700,  1271,  1272,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,  1273,  1274,   223,     0,   224,   225,   226,
     227,     0,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,     0,     0,     0,   703,     0,
       0,     0,   246,   247,   248,   249,   250,   251,  1275,  1276,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   968,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,     0,   279,   280,     0,     0,   282,     0,   283,
    1277,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,     0,     0,   293,     0,   294,   295,
     296,   297,   298,   706,   299,   300,   301,  1777,   302,   303,
     304,   305,   306,   307,     0,   308,   707,  1778,   310,   311,
     312,   313,  1278,  1279,     0,  1280,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
       0,   711,   327,   712,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1281,   713,  1282,   346,   347,   348,   349,
     350,   351,   352,     0,   354,     0,   355,   356,   714,   357,
       0,     0,   359,  1283,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,  1779,   715,   716,   717,
       0,   370,   371,   372,   373,   374,   375,     0,   376,     0,
     378,     0,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,  1284,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,     0,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,  1780,   424,   425,   719,   426,  1286,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,  1287,  1288,     0,     0,   450,     0,   452,     0,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,     0,  1289,
    1781,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   698,   945,   541,   946,
     947,   948,   586,   949,   488,   489,   490,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,   950,  2541,     0,   204,   205,     0,   206,
     699,   207,   208,   209,   210,   951,   700,   952,   953,  2144,
     214,   215,   216,   217,   218,   954,   955,   219,   220,   956,
     957,   223,     0,   224,   225,   226,   227,   958,     0,     0,
     229,   230,   231,   232,   701,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   702,   244,
     245,   959,   960,   961,   962,   963,   964,   965,   246,   247,
     248,   249,   250,   251,   966,   967,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   968,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   969,   279,
     280,   970,   971,   282,     0,   283,   972,   285,     0,   286,
       0,   287,   704,  2145,   705,   288,   289,   290,     0,   291,
     973,     0,   293,     0,   294,   295,   296,   297,   298,   706,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   707,   309,   310,   311,   312,   313,   974,   975,
       0,   976,     0,   317,   708,   709,   318,   710,   319,   320,
     321,   322,   323,   324,   325,  2146,   977,   711,   327,   712,
       0,   328,   329,   330,   978,   979,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   980,
     713,   981,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   982,   355,   356,   714,   357,   983,   984,   359,   985,
     361,   362,   363,     0,   364,     0,     0,   986,   366,   367,
       0,     0,   368,   715,   716,   717,   987,   370,   371,   372,
     373,   374,   375,     0,   376,   988,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   989,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,   718,   406,   407,
     990,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,   991,   422,   423,   424,   425,
     719,   426,   992,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   993,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   994,   995,     0,
    2147,   450,   996,   452,   997,   998,   454,   455,   456,   457,
     458,   459,     0,   999,   460,   461,   462,   463,  1000,     0,
     464,   465,   466,   467,   468,  1001,     0,   470,   720,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
     488,   489,   490,     0,     0,     0,     0,     0,     0,     0,
    1009,  1010,     0,     0,     0,     0,     0,     0,     0,  1012,
     698,   945,   541,   946,   947,   948,   586,   949,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,   950,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,   210,   951,
     700,   952,   953,     0,   214,   215,   216,   217,   218,   954,
     955,   219,   220,   956,   957,   223,     0,   224,   225,   226,
     227,   958,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,   959,   960,   961,   962,   963,
     964,   965,   246,   247,   248,   249,   250,   251,   966,   967,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   968,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   969,   279,   280,   970,   971,   282,     0,   283,
     972,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,   973,     0,   293,     0,   294,   295,
     296,   297,   298,   706,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,   309,   310,   311,
     312,   313,   974,   975,     0,   976,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
     977,   711,   327,   712,     0,   328,   329,   330,   978,   979,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   980,   713,   981,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   982,   355,   356,   714,   357,
     983,   984,   359,   985,   361,   362,   363,     0,   364,     0,
       0,   986,   366,   367,     0,     0,   368,   715,   716,   717,
     987,   370,   371,   372,   373,   374,   375,     0,   376,   988,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   989,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,   990,   409,   410,   411,   412,   413,
     414,   415,   416,    38,   417,   418,   419,   420,   421,   991,
     422,   423,   424,   425,   719,   426,   992,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   993,   439,
       0,   440,   441,    42,   442,   443,   444,   445,   446,   447,
       0,   994,   995,     0,     0,   450,   996,   452,   997,   998,
     454,   455,   456,   457,   458,   459,     0,   999,   460,   461,
     462,   463,  1000,     0,   464,   465,   466,   467,   885,  1001,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
      48,   475,   476,   477,   478,   479,   480,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,   488,   489,   490,     0,     0,     0,
       0,     0,     0,     0,  1009,  1010,     0,     0,     0,     0,
       0,     0,     0,  1012,   698,   945,   541,   946,   947,   948,
     586,   949,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,   950,     0,     0,   204,   205,     0,   206,   699,   207,
     208,   209,   210,   951,   700,   952,   953,     0,   214,   215,
     216,   217,   218,   954,   955,   219,   220,   956,   957,   223,
       0,   224,   225,   226,   227,   958,     0,     0,   229,   230,
     231,   232,   701,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   702,   244,   245,   959,
     960,   961,   962,   963,   964,   965,   246,   247,   248,   249,
     250,   251,   966,   967,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   968,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   969,   279,   280,   970,
     971,   282,     0,   283,   972,   285,     0,   286,     0,   287,
     704,     0,   705,   288,   289,   290,     0,   291,   973,     0,
     293,     0,   294,   295,   296,   297,   298,   706,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     707,   309,   310,   311,   312,   313,   974,   975,     0,   976,
       0,   317,   708,   709,   318,   710,   319,   320,   321,   322,
     323,   324,   325,     0,   977,   711,   327,   712,     0,   328,
     329,   330,   978,   979,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   980,   713,   981,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   982,
     355,   356,   714,   357,   983,   984,   359,   985,   361,   362,
     363,     0,   364,     0,     0,   986,   366,   367,     0,     0,
     368,   715,   716,   717,   987,   370,   371,   372,   373,   374,
     375,     0,   376,   988,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   989,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,   718,   406,   407,   990,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,   991,   422,   423,   424,   425,   719,   426,
     992,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   993,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   994,   995,     0,     0,   450,
     996,   452,   997,   998,   454,   455,   456,   457,   458,   459,
       0,   999,   460,   461,   462,   463,  1000,     0,   464,   465,
     466,   467,   468,  1001,     0,   470,   720,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,   488,   489,
     490,     0,     0,     0,     0,     0,     0,     0,  1009,  1010,
       0,     0,     0,     0,     0,  1462,  2093,  1012,   698,   945,
     541,   946,   947,   948,   586,   949,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,   950,     0,     0,   204,   205,
       0,   206,   699,   207,   208,   209,   210,   951,   700,   952,
     953,     0,   214,   215,   216,   217,   218,   954,   955,   219,
     220,   956,   957,   223,     0,   224,   225,   226,   227,   958,
       0,     0,   229,   230,   231,   232,   701,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     702,   244,   245,   959,   960,   961,   962,   963,   964,   965,
     246,   247,   248,   249,   250,   251,   966,   967,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   968,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     969,   279,   280,   970,   971,   282,     0,   283,   972,   285,
       0,   286,     0,   287,   704,     0,   705,   288,   289,   290,
       0,   291,   973,     0,   293,     0,   294,   295,   296,   297,
     298,   706,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   707,   309,   310,   311,   312,   313,
     974,   975,     0,   976,     0,   317,   708,   709,   318,   710,
     319,   320,   321,   322,   323,   324,   325,     0,   977,   711,
     327,   712,     0,   328,   329,   330,   978,   979,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   980,   713,   981,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   982,   355,   356,   714,   357,   983,   984,
     359,   985,   361,   362,   363,     0,   364,     0,     0,   986,
     366,   367,     0,     0,   368,   715,   716,   717,   987,   370,
     371,   372,   373,   374,   375,     0,   376,   988,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   989,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,   718,
     406,   407,   990,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,   991,   422,   423,
     424,   425,   719,   426,   992,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   993,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   994,
     995,     0,     0,   450,   996,   452,   997,   998,   454,   455,
     456,   457,   458,   459,     0,   999,   460,   461,   462,   463,
    1000,     0,   464,   465,   466,   467,   468,  1001,     0,   470,
     720,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,   488,   489,   490,     0,     0,     0,     0,     0,
       0,     0,  1009,  1010,  1011,     0,     0,     0,     0,     0,
       0,  1012,   698,   945,   541,   946,   947,   948,   586,   949,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,   950,
       0,     0,   204,   205,     0,   206,   699,   207,   208,   209,
     210,   951,   700,   952,   953,     0,   214,   215,   216,   217,
     218,   954,   955,   219,   220,   956,   957,   223,     0,   224,
     225,   226,   227,   958,     0,     0,   229,   230,   231,   232,
     701,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   702,   244,   245,   959,   960,   961,
     962,   963,   964,   965,   246,   247,   248,   249,   250,   251,
     966,   967,   254,  1083,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   968,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   969,   279,   280,   970,   971,   282,
       0,   283,   972,   285,     0,   286,     0,   287,   704,     0,
     705,   288,   289,   290,     0,   291,   973,     0,   293,     0,
     294,   295,   296,   297,   298,   706,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   707,   309,
     310,   311,   312,   313,   974,   975,     0,   976,     0,   317,
     708,   709,   318,   710,   319,   320,   321,   322,   323,   324,
     325,     0,   977,   711,   327,   712,     0,   328,   329,   330,
     978,   979,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   980,   713,   981,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   982,   355,   356,
     714,   357,   983,   984,   359,   985,   361,   362,   363,     0,
     364,     0,     0,   986,   366,   367,     0,     0,   368,   715,
     716,   717,   987,   370,   371,   372,   373,   374,   375,     0,
     376,   988,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   989,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,   718,   406,   407,   990,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,   991,   422,   423,   424,   425,   719,   426,   992,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     993,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   994,   995,     0,     0,   450,   996,   452,
     997,   998,   454,   455,   456,   457,   458,   459,     0,   999,
     460,   461,   462,   463,  1000,     0,   464,   465,   466,   467,
     468,  1001,     0,   470,   720,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,   488,   489,   490,     0,
       0,     0,     0,     0,     0,     0,  1009,  1010,     0,     0,
       0,     0,     0,     0,     0,  1012,   698,   945,   541,   946,
     947,   948,   586,   949,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,  1708,   201,   202,   203,     0,
       0,     0,     0,   950,     0,     0,   204,   205,     0,   206,
     699,   207,   208,   209,   210,   951,   700,   952,   953,     0,
     214,   215,   216,   217,   218,   954,   955,   219,   220,   956,
     957,   223,     0,   224,   225,   226,   227,   958,     0,     0,
     229,   230,   231,   232,   701,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   702,   244,
     245,   959,   960,   961,   962,   963,   964,   965,   246,   247,
     248,   249,   250,   251,   966,   967,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   968,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   969,   279,
     280,   970,   971,   282,     0,   283,   972,   285,     0,   286,
       0,   287,   704,     0,   705,   288,   289,   290,     0,   291,
     973,     0,   293,     0,   294,   295,   296,   297,   298,   706,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   707,   309,   310,   311,   312,   313,   974,   975,
       0,   976,     0,   317,   708,   709,   318,   710,   319,   320,
     321,   322,   323,   324,   325,     0,   977,   711,   327,   712,
       0,   328,   329,   330,   978,   979,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   980,
     713,   981,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   982,   355,   356,   714,   357,   983,   984,   359,   985,
     361,   362,   363,     0,   364,     0,     0,   986,   366,   367,
       0,     0,   368,   715,   716,   717,   987,   370,   371,   372,
     373,   374,   375,     0,   376,   988,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   989,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,   718,   406,   407,
     990,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,   991,   422,   423,   424,   425,
     719,   426,   992,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   993,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   994,   995,     0,
       0,   450,   996,   452,   997,   998,   454,   455,   456,   457,
     458,   459,     0,   999,   460,   461,   462,   463,  1000,     0,
     464,   465,   466,   467,   468,  1001,     0,   470,   720,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
     488,   489,   490,     0,     0,     0,     0,     0,     0,     0,
    1009,  1010,     0,     0,     0,     0,     0,     0,     0,  1012,
     698,   945,   541,   946,   947,   948,   586,   949,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,   950,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,   210,   951,
     700,   952,   953,     0,   214,   215,   216,   217,   218,   954,
     955,   219,   220,   956,   957,   223,     0,   224,   225,   226,
     227,   958,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,   959,   960,   961,   962,   963,
     964,   965,   246,   247,   248,   249,   250,   251,   966,   967,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   968,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   969,   279,   280,   970,   971,   282,     0,   283,
     972,   285,     0,   286,     0,   287,   704,  2145,   705,   288,
     289,   290,     0,   291,   973,     0,   293,     0,   294,   295,
     296,   297,   298,   706,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,   309,   310,   311,
     312,   313,   974,   975,     0,   976,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
     977,   711,   327,   712,     0,   328,   329,   330,   978,   979,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   980,   713,   981,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   982,   355,   356,   714,   357,
     983,   984,   359,   985,   361,   362,   363,     0,   364,     0,
       0,   986,   366,   367,     0,     0,   368,   715,   716,   717,
     987,   370,   371,   372,   373,   374,   375,     0,   376,   988,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   989,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,   990,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,   991,
     422,   423,   424,   425,   719,   426,   992,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   993,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   994,   995,     0,     0,   450,   996,   452,   997,   998,
     454,   455,   456,   457,   458,   459,     0,   999,   460,   461,
     462,   463,  1000,     0,   464,   465,   466,   467,   468,  1001,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,   488,   489,   490,     0,     0,     0,
       0,     0,     0,     0,  1009,  1010,     0,     0,     0,     0,
       0,     0,     0,  1012,   698,   945,   541,   946,   947,   948,
     586,   949,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,   950,     0,     0,   204,   205,     0,   206,   699,   207,
     208,   209,   210,   951,   700,   952,   953,     0,   214,   215,
     216,   217,   218,   954,   955,   219,   220,   956,   957,   223,
       0,   224,   225,   226,   227,   958,     0,     0,   229,   230,
     231,   232,   701,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   702,   244,   245,   959,
     960,   961,   962,   963,   964,   965,   246,   247,   248,   249,
     250,   251,   966,   967,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   968,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   969,   279,   280,   970,
     971,   282,     0,   283,   972,   285,     0,   286,     0,   287,
     704,     0,   705,   288,   289,   290,     0,   291,   973,     0,
     293,     0,   294,   295,   296,   297,   298,   706,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     707,   309,   310,   311,   312,   313,   974,   975,     0,   976,
       0,   317,   708,   709,   318,   710,   319,   320,   321,   322,
     323,   324,   325,     0,   977,   711,   327,   712,     0,   328,
     329,   330,   978,   979,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   980,   713,   981,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   982,
     355,   356,   714,   357,   983,   984,   359,   985,   361,   362,
     363,     0,   364,     0,     0,   986,   366,   367,     0,     0,
     368,   715,   716,   717,   987,   370,   371,   372,   373,   374,
     375,     0,   376,   988,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   989,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,   718,   406,   407,   990,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,   991,   422,   423,   424,   425,   719,   426,
     992,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   993,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   994,   995,     0,     0,   450,
     996,   452,   997,   998,   454,   455,   456,   457,   458,   459,
       0,   999,   460,   461,   462,   463,  1000,     0,   464,   465,
     466,   467,   468,  1001,  3153,   470,   720,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,   488,   489,
     490,     0,     0,     0,     0,     0,     0,     0,  1009,  1010,
       0,     0,     0,     0,     0,     0,     0,  1012,   698,   945,
     541,   946,   947,   948,   586,   949,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,   950,     0,     0,   204,   205,
       0,   206,   699,   207,   208,   209,   210,   951,   700,   952,
     953,     0,   214,   215,   216,   217,   218,   954,   955,   219,
     220,   956,   957,   223,     0,   224,   225,   226,   227,   958,
       0,     0,   229,   230,   231,   232,   701,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     702,   244,   245,   959,   960,   961,   962,   963,   964,   965,
     246,   247,   248,   249,   250,   251,   966,   967,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   968,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     969,   279,   280,   970,   971,   282,     0,   283,   972,   285,
       0,   286,     0,   287,   704,     0,   705,   288,   289,   290,
       0,   291,   973,     0,   293,     0,   294,   295,   296,   297,
     298,   706,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   707,   309,   310,   311,   312,   313,
     974,   975,     0,   976,     0,   317,   708,   709,   318,   710,
     319,   320,   321,   322,   323,   324,   325,     0,   977,   711,
     327,   712,     0,   328,   329,   330,   978,   979,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   980,   713,   981,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   982,   355,   356,   714,   357,   983,   984,
     359,   985,   361,   362,   363,     0,   364,     0,     0,   986,
     366,   367,     0,     0,   368,   715,   716,   717,   987,   370,
     371,   372,   373,   374,   375,     0,   376,   988,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   989,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,   718,
     406,   407,   990,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,   991,   422,   423,
     424,   425,   719,   426,   992,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   993,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   994,
     995,     0,     0,   450,   996,   452,   997,   998,   454,   455,
     456,   457,   458,   459,     0,   999,   460,   461,   462,   463,
    1000,     0,   464,   465,   466,   467,   468,  1001,     0,   470,
     720,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,   488,   489,   490,     0,     0,     0,     0,     0,
       0,     0,  1009,  1010,     0,     0,     0,     0,     0,     0,
       0,  1012,   698,   945,   541,   946,   947,   948,   586,   949,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,   950,
       0,     0,   204,   205,     0,   206,   699,   207,   208,   209,
     210,   951,   700,   952,   953,     0,   214,   215,   216,   217,
     218,   954,   955,   219,   220,   956,   957,   223,     0,   224,
     225,   226,   227,   958,     0,     0,   229,   230,   231,   232,
     701,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   702,   244,  2578,   959,   960,   961,
     962,   963,   964,   965,   246,   247,   248,   249,   250,   251,
     966,   967,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   968,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   969,   279,   280,   970,   971,   282,
       0,   283,   972,   285,     0,   286,     0,   287,   704,     0,
     705,   288,   289,   290,     0,   291,   973,     0,   293,     0,
     294,   295,   296,   297,   298,   706,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   707,   309,
     310,   311,   312,   313,   974,   975,     0,   976,     0,   317,
     708,   709,   318,   710,   319,   320,   321,   322,   323,   324,
     325,     0,   977,   711,   327,   712,     0,   328,   329,   330,
     978,   979,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   980,   713,   981,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   982,   355,   356,
     714,   357,   983,   984,   359,   985,   361,   362,   363,     0,
     364,     0,     0,   986,   366,   367,     0,     0,   368,   715,
     716,   717,   987,   370,   371,   372,   373,   374,   375,     0,
     376,   988,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   989,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,   718,   406,   407,   990,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,   991,   422,   423,   424,   425,   719,   426,   992,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     993,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   994,   995,     0,     0,   450,   996,   452,
     997,   998,   454,   455,   456,   457,   458,   459,     0,   999,
     460,   461,   462,   463,  1000,     0,   464,   465,   466,   467,
     468,  1001,     0,   470,   720,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,   488,   489,   490,     0,
       0,     0,     0,     0,     0,     0,  1009,  1010,     0,     0,
       0,     0,     0,     0,     0,  1012,   698,   945,   541,   946,
     947,   948,   586,   949,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,   950,     0,     0,   204,   205,     0,   206,
     699,   207,   208,   209,   210,   951,   700,   952,   953,     0,
     214,   215,   216,   217,   218,   954,   955,   219,   220,   956,
     957,   223,     0,   224,   225,   226,   227,   958,     0,     0,
     229,   230,   231,   232,   701,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   702,   244,
     245,   959,   960,   961,   962,   963,   964,   965,   246,   247,
     248,   249,   250,   251,   966,   967,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   968,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   969,   279,
     280,   970,   971,   282,     0,   283,   972,   285,     0,   286,
       0,   287,   704,     0,   705,   288,   289,   290,     0,   291,
     973,     0,   293,     0,   294,   295,   296,   297,   298,   706,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   707,   309,   310,   311,   312,   313,   974,   975,
       0,   976,     0,   317,   708,   709,   318,   710,   319,   320,
     321,   322,   323,   324,   325,     0,   977,   711,   327,   712,
       0,   328,   329,   330,   978,   979,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   980,
     713,   981,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   982,   355,   356,   714,   357,   983,   984,   359,   985,
     361,   362,   363,     0,   364,     0,     0,   986,   366,   367,
       0,     0,   368,   715,   716,   717,   987,   370,   371,   372,
     373,   374,   375,     0,   376,   988,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   989,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,   718,   406,   407,
     990,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,   991,   422,   423,   424,   425,
     719,   426,   992,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   993,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   994,   995,     0,
       0,   450,   996,   452,   997,   998,   454,   455,   456,   457,
     458,   459,     0,   999,   460,   461,   462,   463,  1000,     0,
     464,   465,   466,   467,   468,  1001,     0,   470,   720,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,  3385,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
     488,   489,   490,     0,     0,     0,     0,     0,     0,     0,
    1009,  1010,     0,     0,     0,     0,     0,     0,     0,  1012,
     698,   945,   541,   946,   947,   948,   586,   949,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,   950,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,   210,   951,
     700,   952,   953,     0,   214,   215,   216,   217,   218,   954,
     955,   219,   220,   956,   957,   223,     0,   224,   225,   226,
     227,   958,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,   959,   960,   961,   962,   963,
     964,   965,   246,   247,   248,   249,   250,   251,   966,   967,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   968,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   969,   279,   280,   970,   971,   282,     0,   283,
     972,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,   973,     0,   293,     0,   294,   295,
     296,   297,   298,   706,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,   309,   310,   311,
     312,   313,   974,   975,     0,   976,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
     977,   711,   327,   712,     0,   328,   329,   330,   978,   979,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   980,   713,   981,   346,  3392,   348,   349,
     350,   351,   352,   353,   354,   982,   355,   356,   714,   357,
     983,   984,   359,   985,   361,   362,   363,     0,   364,     0,
       0,   986,   366,   367,     0,     0,   368,   715,   716,   717,
     987,   370,   371,   372,   373,   374,   375,     0,   376,   988,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   989,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,   990,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,   991,
     422,   423,   424,   425,   719,   426,   992,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   993,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   994,   995,     0,     0,   450,   996,   452,   997,   998,
     454,   455,   456,   457,   458,   459,     0,   999,   460,   461,
     462,   463,  1000,     0,   464,   465,   466,   467,   468,  1001,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,   488,   489,   490,     0,     0,     0,
       0,     0,     0,     0,  1009,  1010,     0,     0,     0,     0,
       0,     0,     0,  1012,   698,   945,   541,   946,   947,   948,
     586,   949,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,   950,     0,     0,   204,   205,     0,   206,   699,   207,
     208,   209,  3781,   951,   700,   952,   953,     0,   214,   215,
     216,   217,   218,   954,   955,   219,   220,   956,   957,   223,
       0,   224,   225,   226,   227,   958,     0,     0,   229,   230,
     231,   232,   701,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   702,   244,  3782,   959,
     960,   961,   962,   963,   964,   965,   246,   247,   248,   249,
     250,   251,   966,   967,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   968,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   969,   279,   280,   970,
     971,   282,     0,   283,   972,   285,     0,   286,     0,   287,
     704,     0,   705,   288,   289,   290,     0,   291,   973,     0,
     293,     0,   294,   295,   296,   297,   298,   706,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     707,   309,   310,   311,   312,   313,   974,   975,     0,   976,
       0,   317,   708,   709,   318,   710,   319,   320,   321,   322,
     323,   324,   325,     0,   977,   711,   327,   712,     0,   328,
     329,   330,   978,   979,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   980,   713,   981,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   982,
     355,   356,   714,   357,   983,   984,   359,   985,   361,   362,
     363,     0,   364,     0,     0,   986,   366,   367,     0,     0,
     368,   715,   716,   717,   987,   370,   371,   372,   373,   374,
     375,     0,   376,   988,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   989,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,   718,   406,   407,   990,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,   991,   422,   423,   424,   425,   719,   426,
     992,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   993,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   994,   995,     0,     0,   450,
     996,   452,   997,   998,   454,   455,   456,  3783,   458,   459,
       0,   999,   460,   461,   462,   463,  1000,     0,   464,   465,
     466,   467,   468,  1001,     0,   470,   720,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,   488,   489,
     490,     0,     0,     0,     0,     0,     0,     0,  1009,  1010,
       0,     0,     0,     0,     0,     0,     0,  1012,   698,   945,
     541,   946,   947,   948,   586,   949,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,   950,     0,     0,   204,   205,
       0,   206,   699,   207,   208,   209,   210,   951,   700,   952,
     953,     0,   214,   215,   216,   217,   218,   954,   955,   219,
     220,   956,   957,   223,     0,   224,   225,   226,   227,   958,
       0,     0,   229,   230,   231,   232,   701,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     702,   244,  3782,   959,   960,   961,   962,   963,   964,   965,
     246,   247,   248,   249,   250,   251,   966,   967,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   968,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     969,   279,   280,   970,   971,   282,     0,   283,   972,   285,
       0,   286,     0,   287,   704,     0,   705,   288,   289,   290,
       0,   291,   973,     0,   293,     0,   294,   295,   296,   297,
     298,   706,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   707,   309,   310,   311,   312,   313,
     974,   975,     0,   976,     0,   317,   708,   709,   318,   710,
     319,   320,   321,   322,   323,   324,   325,     0,   977,   711,
     327,   712,     0,   328,   329,   330,   978,   979,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   980,   713,   981,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   982,   355,   356,   714,   357,   983,   984,
     359,   985,   361,   362,   363,     0,   364,     0,     0,   986,
     366,   367,     0,     0,   368,   715,   716,   717,   987,   370,
     371,   372,   373,   374,   375,     0,   376,   988,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   989,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,   718,
     406,   407,   990,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,   991,   422,   423,
     424,   425,   719,   426,   992,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   993,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   994,
     995,     0,     0,   450,   996,   452,   997,   998,   454,   455,
     456,  3783,   458,   459,     0,   999,   460,   461,   462,   463,
    1000,     0,   464,   465,   466,   467,   468,  1001,     0,   470,
     720,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,   488,   489,   490,     0,     0,     0,     0,     0,
       0,     0,  1009,  1010,     0,     0,     0,     0,     0,     0,
       0,  1012,   698,   945,   541,   946,   947,   948,   586,   949,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,   950,
       0,     0,   204,   205,     0,   206,   699,   207,   208,   209,
     210,   951,   700,   952,   953,     0,   214,   215,   216,   217,
     218,   954,   955,   219,   220,   956,   957,   223,     0,   224,
     225,   226,   227,   958,     0,     0,   229,   230,   231,   232,
     701,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,   702,   244,   245,   959,   960,   961,
     962,   963,   964,   965,   246,   247,   248,   249,   250,   251,
     966,   967,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   968,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   969,   279,   280,   970,   971,   282,
       0,   283,   972,   285,     0,   286,     0,   287,   704,     0,
     705,   288,   289,   290,     0,   291,   973,     0,   293,     0,
     294,   295,   296,   297,   298,   706,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,   707,   309,
     310,   311,   312,   313,   974,   975,     0,   976,     0,   317,
     708,   709,   318,   710,   319,   320,   321,   322,   323,   324,
     325,     0,   977,   711,   327,   712,     0,   328,   329,   330,
     978,   979,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   980,   713,   981,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
     714,   357,   983,   984,   359,   985,   361,   362,   363,     0,
     364,     0,     0,   986,   366,   367,     0,     0,   368,   715,
     716,   717,   987,   370,   371,   372,   373,   374,   375,     0,
     376,   988,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   989,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,   718,   406,   407,   990,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,   991,   422,   423,   424,   425,   719,   426,   992,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     993,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   994,   995,     0,     0,   450,   996,   452,
     997,   998,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,  1000,     0,   464,   465,   466,   467,
     468,  1001,     0,   470,   720,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,   488,   489,   490,     0,
       0,     0,     0,     0,     0,     0,  2127,  2128,     0,     0,
       0,     0,     0,     0,     0,  1012,   698,   945,   541,   946,
     947,   948,   586,   949,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,   950,     0,     0,   204,   205,     0,   206,
     699,   207,   208,   209, -2009,   951,   700,   952,   953,     0,
     214,   215,   216,   217,   218,   954,   955,   219,   220,   956,
     957,   223,     0,   224,   225,   226,   227,   958,     0,     0,
     229,   230,   231,   232,   701,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   702,   244,
    3782,   959,   960,   961,   962,   963,   964,   965,   246,   247,
     248,   249,   250,   251,   966,   967,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   968,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   969,   279,
     280,   970,   971,   282,     0,   283,   972,   285,     0,   286,
       0,   287,   704,     0,   705,   288,   289,   290,     0,   291,
     973,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   707,   309,   310,   311,   312,   313,   974,   975,
       0,   976,     0,   317,   708,   709,   318,   710,   319,   320,
     321,   322,   323,   324,   325,     0,   977,   711,   327,     0,
       0,   328,   329,   330,   978,   979,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   980,
     713,   981,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,   714,   357,   983,   984,   359,   985,
     361,   362,   363,     0,   364,     0,     0,   986,   366,   367,
       0,     0,   368,   715,   716,   717,   987,   370,   371,   372,
     373,   374,   375,     0,   376,   988,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   989,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,   718,   406,   407,
     990,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,   991,   422,   423,   424,   425,
       0,   426,   992,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   993,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   994,   995,     0,
       0,   450,   996,   452,   997,   998,   454,   455,   456,  3783,
     458,   459,     0,   999,   460,   461,   462,   463,  1000,     0,
     464,   465,   466,   467,   468,  1001,     0,   470,   720,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
     488,   489,   490,     0,     0,     0,     0,     0,     0,     0,
    1009,  1010,     0,     0,     0,     0,     0,     0,     0,  1012,
     698,   945,   541,   946,   947,   948,   586,   949,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,   950,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,     0,   951,
     700,   952,   953,     0,   214,   215,   216,   217,   218,   954,
     955,   219,   220,   956,   957,   223,     0,   224,   225,   226,
     227,   958,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,   959,   960,   961,   962,   963,
     964,   965,   246,   247,   248,   249,   250,   251,   966,   967,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   968,   267,   268,
       0,   269,   270,   271,     0,   272,     0,     0,   274,   275,
     276,   277,   969,   279,   280,   970,   971,   282,     0,   283,
     972,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,   973,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,   309,   310,   311,
     312,   313,   974,   975,     0,   976,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
     977,   711,   327,     0,     0,   328,   329,   330,   978,   979,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   980,   713,   981,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,   714,   357,
     983,   984,   359,   985,   361,   362,   363,     0,   364,     0,
       0,   986,   366,   367,     0,     0,   368,   715,   716,   717,
     987,   370,   371,   372,   373,   374,   375,     0,   376,   988,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   989,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,   990,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,   991,
     422,   423,   424,   425,     0,   426,   992,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   993,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   994,   995,     0,     0,   450,   996,   452,   997,   998,
     454,   455,   456,   457,   458,   459,     0,   999,   460,   461,
     462,   463,  1000,     0,   464,   465,   466,   467,   468,  1001,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,   488,   489,   490,     0,     0,     0,
       0,     0,     0,     0,  1009,  1010,     0,     0,     0,     0,
       0,     0,     0,  1012,   698,   945,   541,   946,   947,   948,
     586,   949,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,   950,     0,     0,   204,   205,     0,   206,   699,   207,
     208,   209,     0,   951,   700,   952,   953,     0,   214,   215,
     216,   217,   218,   954,   955,   219,   220,   956,   957,   223,
       0,   224,   225,   226,   227,   958,     0,     0,   229,   230,
     231,   232,   701,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   702,   244,   245,   959,
     960,   961,   962,   963,   964,   965,   246,   247,   248,   249,
     250,   251,   966,   967,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   968,   267,   268,     0,   269,   270,   271,     0,   272,
       0,     0,   274,   275,   276,   277,   969,   279,   280,   970,
     971,   282,     0,   283,   972,   285,     0,   286,     0,   287,
     704,     0,   705,   288,   289,   290,     0,   291,   973,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     707,   309,   310,   311,   312,   313,   974,   975,     0,   976,
       0,   317,   708,   709,   318,   710,   319,   320,   321,   322,
     323,   324,   325,     0,   977,   711,   327,     0,     0,   328,
     329,   330,   978,   979,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   980,   713,   981,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,   714,   357,   983,   984,   359,   985,   361,   362,
     363,     0,   364,     0,     0,   986,   366,   367,     0,     0,
     368,   715,   716,   717,   987,   370,   371,   372,   373,   374,
     375,     0,   376,   988,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   989,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,   718,   406,   407,   990,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,   991,   422,   423,   424,   425,     0,   426,
     992,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   993,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   994,   995,     0,     0,   450,
     996,   452,   997,   998,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,  1000,     0,   464,   465,
     466,   467,   468,  1001,     0,   470,   720,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,  1002,  1003,  1004,  1005,  1006,  1007,  1008,   488,   489,
     490,     0,     0,     0,     0,     0,     0,   698,  2127,  2128,
       0,     0,     0,     0,     0,     0,     0,  1012,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,   699,   207,   208,   209,   210,   211,   700,   212,   213,
       0,   214,   215,   216,   217,   218,     0,   955,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   958,     0,
       0,   229,   230,   231,   232,   701,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   702,
     244,   245,   959,   960,   961,   962,   963,   964,   965,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   970,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,   704,     0,   705,   288,   289,   290,     0,
     291,   973,     0,   293,     0,   294,   295,   296,   297,   298,
     706,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   707,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   708,   709,   318,   710,   319,
     320,   321,   322,   323,   324,   325,     0,   977,   711,   327,
     712,     0,   328,   329,   330,   978,   979,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   713,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,   714,   357,     0,   984,   359,
     360,   361,   362,   363,     0,   364,     0,   665,   365,   366,
     367,     0,     0,   368,   715,   716,   717,   987,   370,   371,
     372,   373,   374,   375,     0,   376,   988,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,   718,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
      38,   417,   418,   419,   420,   421,   991,   422,   423,   424,
     425,   719,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   993,   439,     0,   440,   441,
      42,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,     0,   450,   996,   452,   997,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,  1000,
       0,   464,   465,   466,   467,   885,   469,     0,   470,   720,
     471,   472,   473,     0,     0,   474,     0,    48,   475,   476,
     477,   478,   479,   480,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,   488,   489,   490,     0,     0,     0,     0,     0,     0,
     698,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1987,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,   210,   211,
     700,   212,   213,     0,   214,   215,   216,   217,   218,     0,
     955,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   958,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,   959,   960,   961,   962,   963,
     964,   965,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   970,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,   973,     0,   293,     0,   294,   295,
     296,   297,   298,   706,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
     977,   711,   327,   712,     0,   328,   329,   330,   978,   979,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   713,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,   714,   357,
       0,   984,   359,   360,   361,   362,   363,     0,   364,     0,
     665,   365,   366,   367,     0,     0,   368,   715,   716,   717,
     987,   370,   371,   372,   373,   374,   375,     0,   376,   988,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,   991,
     422,   423,   424,   425,   719,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   993,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   996,   452,   997,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,  1000,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,   488,   489,   490,     0,     0,     0,
       0,     0,     0,   698,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1987,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   699,   207,   208,
     209,   210,   211,   700,   212,   213,     0,   214,   215,   216,
     217,   218,     0,   955,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   958,     0,     0,   229,   230,   231,
     232,   701,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   702,   244,   245,   959,   960,
     961,   962,   963,   964,   965,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   970,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,   704,
       0,   705,   288,   289,   290,     0,   291,   973,     0,   293,
       0,   294,   295,   296,   297,   298,   706,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   707,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   708,   709,   318,   710,   319,   320,   321,   322,   323,
     324,   325,     0,   977,   711,   327,   712,     0,   328,   329,
     330,   978,   979,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   713,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,   714,   357,     0,   984,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
     715,   716,   717,   987,   370,   371,   372,   373,   374,   375,
       0,   376,   988,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,   718,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,   991,   422,   423,   424,   425,   719,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   993,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   996,
     452,   997,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,  1000,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   720,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,   488,   489,   490,
       0,     0,     0,     0,     0,     0,   698,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3173,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     699,   207,   208,   209,   210,   211,   700,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   701,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   702,   244,
     245,     0,     0,     0,   703,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,   704,     0,   705,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,   706,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   707,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   708,   709,   318,   710,   319,   320,
     321,   322,   323,   324,   325,     0,   326,   711,   327,   712,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     713,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,   714,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,   715,   716,   717,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,   718,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
     719,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   720,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,     0,     0,     0,     0,     0,     0,   191,
    1174,   541,     0,     0,     0,   586,     0,     0,     0,  3602,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,  1395,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,  1396,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,     0,   450,   451,   452,   453,  1397,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,     0,     0,     0,     0,
       0,     0,   191,   598,  1175,  3250,     0,     0,     0,     0,
       0,     0,  3251,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     3,     4,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,   363,     0,
     364,     0,     0,   365,   366,   367,     0,     0,   368,     0,
       0,     0,   369,   370,   371,   372,   373,   374,   375,     0,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,    38,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,     0,   440,   441,    42,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,     0,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     885,   469,     0,   470,   886,   471,   472,   473,     0,     0,
     474,     0,    48,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
       0,     0,     0,     0,     0,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,    38,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,    42,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,     0,
     450,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   885,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,    48,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,     0,     0,     0,     0,     0,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,     0,     0,     0,     0,     0,
       0,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1064,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,     0,     0,
       0,     0,     0,     0,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1680,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,     0,     0,     0,     0,     0,     0,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3023,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,   368,     0,     0,     0,   369,   370,   371,
     372,   373,   374,   375,     0,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,     0,   450,   451,   452,   453,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,     0,   470,     0,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,     0,     0,     0,     0,     0,     0,
    1269,  1174,   541,     0,     0,   739,   586,     0,     0,     0,
    3147,   192,   193,   194,   195,   196,   197,   198,   199,  1592,
     201,   202,   203,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
     204,   205,  1600,   206,   699,   207,   208,   209,     0,  1270,
     700,  1271,  1272,  1601,   214,   215,   216,   217,   218,  1602,
    1603,   219,   220,  1273,  1274,   223,  1604,   224,   225,   226,
     227,     0,  1605,  1606,   229,   230,   231,   232,   701,   233,
     234,  1607,   235,   236,   237,   238,   239,   240,  1608,   241,
     242,   243,   702,   244,   245,  1609,  1610,  1611,   703,  1612,
    1613,  1614,   246,   247,   248,   249,   250,   251,  1275,  1276,
     254,  1615,   255,  1616,   256,   257,   258,   259,   260,  1617,
     261,   262,   263,  1618,  1619,   264,   265,   968,   267,   268,
    1620,   269,   270,   271,  1621,   272,   273,  1622,   274,   275,
     276,   277,     0,   279,   280,     0,  1623,   282,  1624,   283,
    1277,   285,  1625,   286,  1626,   287,   704,  1627,   705,   288,
     289,   290,  1628,   291,     0,  1629,   293,  1630,   294,   295,
     296,   297,   298,   706,   299,   300,   301,  1631,   302,   303,
     304,   305,   306,   307,  1632,   308,   707,     0,   310,   311,
     312,   313,  1278,  1279,  1633,  1280,  1634,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,  1635,
       0,   711,   327,   712,  1636,   328,   329,   330,  1637,  1638,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1281,   713,  1282,   346,   347,   348,   349,
     350,   351,   352,     0,   354,  1639,   355,   356,   714,   357,
    1640,     0,   359,  1283,   361,   362,   363,  1641,   364,  1642,
    1643,  2899,   366,   367,  1644,  1645,     0,   715,   716,   717,
       0,   370,   371,   372,   373,   374,   375,  1646,   376,     0,
     378,     0,   380,   381,   382,  1647,   383,   384,   385,   386,
     387,   388,   389,  1284,   391,   392,   393,  1648,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,  1649,   404,
     405,   718,   406,   407,     0,   409,   410,   411,   412,   413,
     414,   415,   416,  1650,   417,   418,   419,   420,   421,  1651,
     422,  1780,   424,   425,   719,   426,  1286,  1652,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   439,
    1653,   440,   441,  1654,   442,   443,   444,   445,   446,   447,
    1655,  1287,  1288,  1656,  1657,   450,     0,   452,     0,  1658,
     454,   455,   456,   457,   458,   459,  1659,  1660,   460,   461,
     462,   463,  1661,  1662,   464,   465,   466,   467,     0,  1289,
    1663,   470,   720,   471,   472,   473,  1664,  1665,   474,  1666,
    1667,   475,   476,   477,   478,   479,     0,     0,     0,     0,
       0,     0,     0,     0,   488,   489,   490,     0,     0,     0,
     742,   743,   744,     0,  2900,  2901,   747,   748,   749,   750,
     191,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   740,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   741,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,     0,
     742,   743,   744,     0,   745,   746,   747,   748,   749,   750,
     191,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   814,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   815,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,     0,
     742,   743,   744,     0,   745,   746,   747,   748,   749,   750,
     191,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   858,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   859,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   860,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,     0,
     742,   743,   744,     0,   745,   746,   747,   748,   749,   750,
     191,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,  1252,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,  1253,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,     0,
     742,   743,   744,     0,   745,   746,   747,   748,   749,   750,
     191,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,     0,
     742,   743,   744,     0,   745,   746,   747,   748,   749,   750,
     191,     0,     0,     0,     0,   739,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,  3591,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,     0,     0,  1591,
     742,   743,   744,     0,   745,   746,   747,   748,   749,   750,
     192,   193,   194,   195,   196,   197,   198,   199,  1592,   201,
     202,   203,  1593,  1594,  1595,  1596,  1597,  1598,  1599,   204,
     205,  1600,   206,   699,   207,   208,   209,   210,   211,   700,
     212,   213,  1601,   214,   215,   216,   217,   218,  1602,  1603,
     219,   220,   221,   222,   223,  1604,   224,   225,   226,   227,
     228,  1605,  1606,   229,   230,   231,   232,   701,   233,   234,
    1607,   235,   236,   237,   238,   239,   240,  1608,   241,   242,
     243,   702,   244,   245,  1609,  1610,  1611,   703,  1612,  1613,
    1614,   246,   247,   248,   249,   250,   251,   252,   253,   254,
    1615,   255,  1616,   256,   257,   258,   259,   260,  1617,   261,
     262,   263,  1618,  1619,   264,   265,   266,   267,   268,  1620,
     269,   270,   271,  1621,   272,   273,  1622,   274,   275,   276,
     277,   278,   279,   280,   281,  1623,   282,  1624,   283,   284,
     285,  1625,   286,  1626,   287,   704,  1627,   705,   288,   289,
     290,  1628,   291,   292,  1629,   293,  1630,   294,   295,   296,
     297,   298,   706,   299,   300,   301,  1631,   302,   303,   304,
     305,   306,   307,  1632,   308,   707,   309,   310,   311,   312,
     313,   314,   315,  1633,   316,  1634,   317,   708,   709,   318,
     710,   319,   320,   321,   322,   323,   324,   325,  1635,   326,
     711,   327,   712,  1636,   328,   329,   330,  1637,  1638,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   713,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,  1639,   355,   356,   714,   357,  1640,
     358,   359,   360,   361,   362,   363,  1641,   364,  1642,  1643,
     365,   366,   367,  1644,  1645,   368,   715,   716,   717,   369,
     370,   371,   372,   373,   374,   375,  1646,   376,   377,   378,
     379,   380,   381,   382,  1647,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,  1648,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,  1649,   404,   405,
     718,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,  1650,   417,   418,   419,   420,   421,  1651,   422,
     423,   424,   425,   719,   426,   427,  1652,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1653,
     440,   441,  1654,   442,   443,   444,   445,   446,   447,  1655,
     448,   449,  1656,  1657,   450,   451,   452,   453,  1658,   454,
     455,   456,   457,   458,   459,  1659,  1660,   460,   461,   462,
     463,  1661,  1662,   464,   465,   466,   467,   468,   469,  1663,
     470,   720,   471,   472,   473,  1664,  1665,   474,  1666,  1667,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,     0,     0,
       0,     0,     0,     0,     0,  1668,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   191,     0,     0,     0,     0,     0,     0,
       0,     0,   670,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
       0,     0,     0,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,     0,   470,     0,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
    1269,     0,     0,     0,     0,     0,     0,     0,     0,  3480,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,     0,  1270,
     700,  1271,  1272,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,  1273,  1274,   223,     0,   224,   225,   226,
     227,     0,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,     0,     0,     0,   703,     0,
       0,     0,   246,   247,   248,   249,   250,   251,  1275,  1276,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   968,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,     0,   279,   280,     0,     0,   282,     0,   283,
    1277,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,     0,     0,   293,     0,   294,   295,
     296,   297,   298,   706,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,     0,   310,   311,
     312,   313,  1278,  1279,     0,  1280,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
       0,   711,   327,   712,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1281,   713,  1282,   346,   347,   348,   349,
     350,   351,   352,     0,   354,     0,   355,   356,   714,   357,
       0,     0,   359,  1283,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,     0,   715,   716,   717,
       0,   370,   371,   372,   373,   374,   375,     0,   376,     0,
     378,     0,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,  1284,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,     0,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,  1285,   424,   425,   719,   426,  1286,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,  1287,  1288,     0,     0,   450,     0,   452,     0,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,     0,  1289,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,     0,  1908,     0,     0,
       0,     0,     0,     0,   488,   489,   490,     0,   192,   193,
     194,   195,   196,   197,   198,   199,  1725,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,   699,   207,   208,   209,     0,  1270,   700,  1271,  1272,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
    1273,  1274,   223,     0,   224,   225,   226,   227,     0,     0,
       0,   229,   230,   231,   232,   701,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,   702,
     244,   245,     0,     0,     0,   703,     0,     0,     0,   246,
     247,   248,   249,   250,   251,  1275,  1276,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   968,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,     0,
     279,   280,     0,     0,   282,     0,   283,  1277,   285,     0,
     286,     0,   287,   704,     0,   705,   288,   289,   290,     0,
     291,     0,     0,   293,     0,   294,   295,   296,   297,   298,
     706,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,   707,     0,   310,   311,   312,   313,  1278,
    1279,     0,  1280,     0,   317,   708,   709,   318,   710,   319,
     320,   321,   322,   323,   324,   325,     0,     0,   711,   327,
     712,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1281,   713,  1282,   346,   347,   348,   349,   350,   351,   352,
       0,   354,     0,   355,   356,   714,   357,     0,     0,   359,
    1283,   361,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,     0,   715,   716,   717,     0,   370,   371,
     372,   373,   374,   375,     0,   376,     0,   378,     0,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
    1284,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,   718,   406,
     407,     0,   409,   410,   411,   412,   413,   414,   415,   416,
       0,   417,   418,   419,   420,   421,     0,   422,  1285,   424,
     425,   719,   426,  1286,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,     0,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,  1287,  1288,
       0,     0,   450,     0,   452,     0,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,     0,  1289,     0,   470,   720,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   479,     0,   191,  1174,   541,     0,     0,     0,
     586,   488,   489,   490,     0,   192,   193,   194,   195,   196,
     197,   198,   199,  1725,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,  1581,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
    1395,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,  1396,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,  1397,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   191,  1174,   541,     0,     0,     0,   586,   598,  1175,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,  1586,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,  1395,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
    1396,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
    1397,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   191,  1174,
     541,     0,     0,     0,   586,   598,  1175,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,  1395,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,  1396,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,  1397,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   191,     0,     0,     0,     0,
       0,   586,   598,  1175,     0,     0,   192,   587,   194,   195,
     196,   197,   198,   199,   588,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     589,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   590,   284,   285,     0,   286,     0,
     591,     0,   592,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   593,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   594,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   595,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
       0,   596,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   597,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,     0,
     450,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,  1591,     0,     0,     0,     0,     0,     0,   598,
     599,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,  1592,   201,   202,   203,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,   204,   205,  1600,   206,   699,   207,   208,   209,
     210,   211,   700,   212,   213,  1601,   214,   215,   216,   217,
     218,  1602,  1603,   219,   220,   221,   222,   223,  1604,   224,
     225,   226,   227,   228,  1605,  1606,   229,   230,   231,   232,
     701,   233,   234,  1607,   235,   236,   237,   238,   239,   240,
    1608,   241,   242,   243,   702,   244,   245,  1609,  1610,  1611,
     703,  1612,  1613,  1614,   246,   247,   248,   249,   250,   251,
     252,   253,   254,  1615,   255,  1616,   256,   257,   258,   259,
     260,  1617,   261,   262,   263,  1618,  1619,   264,   265,   266,
     267,   268,  1620,   269,   270,   271,  1621,   272,   273,  1622,
     274,   275,   276,   277,   278,   279,   280,   281,  1623,   282,
    1624,   283,   284,   285,  1625,   286,  1626,   287,   704,  1627,
     705,   288,   289,   290,  1628,   291,   292,  1629,   293,  1630,
     294,   295,   296,   297,   298,   706,   299,   300,   301,  1631,
     302,   303,   304,   305,   306,   307,  1632,   308,   707,   309,
     310,   311,   312,   313,   314,   315,  1633,   316,  1634,   317,
     708,   709,   318,   710,   319,   320,   321,   322,   323,   324,
     325,  1635,   326,   711,   327,   712,  1636,   328,   329,   330,
    1637,  1638,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   713,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,  1639,   355,   356,
     714,   357,  1640,   358,   359,   360,   361,   362,   363,  1641,
     364,  1642,  1643,   365,   366,   367,  1644,  1645,   368,   715,
     716,   717,   369,   370,   371,   372,   373,   374,   375,  1646,
     376,   377,   378,   379,   380,   381,   382,  1647,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,  1648,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
    1649,   404,   405,   718,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,  1650,   417,   418,   419,   420,
     421,  1651,   422,   423,   424,   425,   719,   426,   427,  1652,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,  1653,   440,   441,  1654,   442,   443,   444,   445,
     446,   447,  1655,   448,   449,  1656,  1657,   450,   451,   452,
     453,  1658,   454,   455,   456,   457,   458,   459,  1659,  1660,
     460,   461,   462,   463,  1661,  1662,   464,   465,   466,   467,
     468,   469,  1663,   470,   720,   471,   472,   473,  1664,  1665,
     474,  1666,  1667,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,  1591,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,  2400,   197,   198,   199,  1592,   201,
     202,   203,  1593,  1594,  1595,  1596,  1597,  1598,  1599,   204,
     205,  1600,   206,   699,   207,   208,   209,   210,   211,   700,
     212,   213,  1601,   214,   215,   216,   217,   218,  1602,  1603,
     219,   220,   221,   222,   223,  1604,   224,   225,   226,   227,
     228,  1605,  1606,   229,   230,   231,   232,   701,   233,   234,
    1607,   235,   236,   237,   238,   239,   240,  1608,   241,   242,
     243,   702,   244,   245,  1609,  1610,  1611,   703,  1612,  1613,
    1614,   246,   247,   248,   249,   250,   251,   252,   253,   254,
    1615,   255,  1616,   256,   257,   258,   259,   260,  1617,   261,
     262,   263,  1618,  1619,   264,   265,   266,  2401,   268,  1620,
     269,   270,   271,  1621,   272,   273,  1622,   274,   275,   276,
     277,   278,   279,   280,   281,  1623,   282,  1624,   283,   284,
     285,  1625,   286,  1626,   287,   704,  1627,   705,   288,   289,
     290,  1628,   291,   292,  1629,   293,  1630,   294,   295,   296,
     297,   298,   706,   299,   300,   301,  1631,   302,   303,   304,
     305,   306,   307,  1632,   308,   707,   309,   310,   311,   312,
     313,   314,   315,  1633,   316,  1634,   317,   708,   709,   318,
     710,   319,   320,   321,   322,   323,   324,   325,  1635,   326,
     711,   327,   712,  1636,   328,   329,   330,  1637,  1638,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   713,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,  1639,   355,   356,   714,   357,  1640,
     358,   359,   360,   361,   362,   363,  1641,   364,  1642,  1643,
     365,   366,   367,  1644,  1645,   368,   715,   716,   717,   369,
     370,   371,   372,   373,   374,   375,  1646,   376,   377,   378,
     379,   380,   381,   382,  1647,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,  1648,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,  1649,   404,   405,
     718,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,  1650,   417,   418,   419,   420,   421,  1651,  2402,
     423,   424,   425,   719,   426,   427,  1652,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,  1653,
     440,   441,  1654,   442,   443,   444,   445,   446,   447,  1655,
     448,   449,  1656,  1657,   450,   451,   452,   453,  1658,   454,
     455,   456,   457,   458,   459,  1659,  1660,   460,   461,   462,
     463,  1661,  1662,   464,   465,   466,   467,   468,   469,  1663,
     470,   720,   471,   472,   473,  1664,  1665,   474,  1666,  1667,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   698,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     699,   207,   208,   209,   210,   211,   700,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   701,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   702,   244,
     245,     0,     0,     0,   703,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,   704,     0,   705,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,   706,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   707,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   708,   709,   318,   710,   319,   320,
     321,   322,   323,   324,   325,     0,   326,   711,   327,   712,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     713,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,   714,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,   715,   716,   717,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,   718,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
     719,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   720,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   698,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   699,   207,   208,
     209,   210,   211,   700,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,   701,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   702,   244,   245,     0,     0,
       0,   703,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,   704,
       0,   705,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   845,   706,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   707,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   708,   709,   318,   710,   319,   320,   321,   322,   323,
     324,   325,     0,   326,   711,   327,   712,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   713,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,   714,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
     715,   716,   717,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,   718,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,   719,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   720,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     698,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,   210,   211,
     700,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,     0,     0,     0,   703,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   853,   706,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
     326,   711,   327,   712,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   713,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,   714,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,   715,   716,   717,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,   719,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,  1747,   224,   225,   226,   227,   228,     0,
    1792,   229,   230,   231,   232,     0,   233,   234,  1748,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,  1793,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,  1750,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,   368,     0,     0,     0,   369,   370,   371,
     372,   373,   374,   375,     0,   376,   377,   378,   379,   380,
     381,   382,  1751,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,     0,   450,   451,   452,   453,     0,   454,   455,   456,
     457,   458,   459,     0,  1752,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,     0,   470,     0,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
    1747,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,  1748,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,  1793,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,  1750,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,  2525,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,  1751,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   458,   459,
       0,  1752,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   637,   198,   199,
     605,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,   606,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,   638,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   607,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   608,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,   605,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,   606,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
    2291,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   607,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   608,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,  1747,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,  1748,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,  1793,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,  1750,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
    1751,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,     0,
     450,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,  1752,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   191,  3831,   541,  3832,  3833,     0,   586,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,   363,     0,
     364,     0,     0,   365,   366,   367,     0,     0,   368,     0,
       0,     0,   369,   370,   371,   372,   373,   374,   375,     0,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,     0,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,     0,   470,     0,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,   605,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,   606,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   607,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   608,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,     0,   450,   451,   452,   453,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,   541,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,  1395,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,  1396,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,  1397,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,  1422,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,  1423,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,  1424,   287,     0,
       0,     0,  1425,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,  1426,  1427,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
       0,     0,     0,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,   408,   409,   410,
     411,  1428,   413,   414,   415,   416,     0,  1429,   418,   419,
     420,   421,     0,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,  1430,   442,  1431,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,     0,   470,     0,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,   606,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   607,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   608,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       3,     4,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,   368,     0,     0,     0,   369,   370,   371,
     372,   373,   374,   375,     0,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,     0,   450,   451,   452,   453,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   886,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   191,     0,   541,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,  1567,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,  1870,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,  1871,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     3,     4,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,  2335,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,     0,
     450,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,  2336,     0,   464,
     465,   466,   467,   468,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,  2347,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,   363,     0,
     364,     0,     0,   365,   366,   367,     0,     0,   368,     0,
       0,     0,   369,   370,   371,   372,   373,   374,   375,     0,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,     0,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,  2348,     0,   464,   465,   466,   467,
     468,   469,     0,   470,     0,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,     0,   450,   451,   452,   453,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,   532,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   533,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,   631,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
       0,     0,     0,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   632,     0,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   633,   449,     0,     0,   634,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,     0,   470,     0,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,   659,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   660,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   661,   449,     0,     0,   662,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,   363,     0,   364,     0,   665,   365,   366,
     367,     0,     0,   368,     0,     0,     0,   369,   370,   371,
     372,   373,   374,   375,     0,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,     0,   450,   451,   452,   453,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,     0,   470,     0,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,   837,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   191,     0,   541,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,  1040,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,  1051,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   647,   220,   221,   222,
    1052,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   650,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   651,   407,   408,
     409,   410,   411,   652,   413,   414,   415,   416,     0,   417,
     418,   419,   420,  1044,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,   654,   449,     0,     0,
     655,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     656,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   191,     0,   541,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,  1385,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,   363,     0,
     364,     0,     0,   365,   366,   367,     0,     0,   368,     0,
       0,     0,   369,   370,   371,   372,   373,   374,   375,     0,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,     0,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,     0,   470,     0,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
    2211,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,  2212,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,  2213,   442,   443,  2214,   445,  2215,   447,     0,
     448,   449,     0,     0,   450,   451,   452,   453,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,  2560,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,  2573,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
       0,     0,     0,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,     0,   470,     0,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,  2612,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,  3285,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,   368,     0,     0,     0,   369,   370,   371,
     372,   373,   374,   375,     0,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,     0,   450,   451,   452,   453,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,     0,   470,     0,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,  3287,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,  3289,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     298,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,  3436,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,     0,
     450,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,   363,     0,
     364,     0,     0,   365,   366,   367,     0,     0,   368,     0,
       0,     0,   369,   370,   371,   372,   373,   374,   375,     0,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,     0,   621,   451,   452,
     453,     0,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,     0,   470,     0,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,   408,   409,   410,   629,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,     0,   450,   451,   452,   453,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   647,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   648,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   298,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   649,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   650,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   651,   407,
     408,   409,   410,   411,   652,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   653,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   654,   449,     0,
       0,   655,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   656,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   298,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
       0,     0,     0,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   679,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,     0,   470,     0,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   298,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   764,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   219,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     826,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,   368,     0,     0,     0,   369,   370,   371,
     372,   373,   374,   375,     0,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
       0,   417,   418,   419,   420,   421,     0,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,     0,   450,   451,   452,   453,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,     0,   470,     0,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   850,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   855,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
     863,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   865,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,     0,
     450,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   219,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   867,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,   363,     0,
     364,     0,     0,   365,   366,   367,     0,     0,   368,     0,
       0,     0,   369,   370,   371,   372,   373,   374,   375,     0,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,     0,   417,   418,   419,   420,
     421,     0,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,     0,   440,   441,     0,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,     0,   450,   451,   452,
     453,     0,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,     0,   470,     0,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   869,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,     0,   450,   451,   452,   453,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,   872,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,     0,   207,   208,
     209,   210,   211,     0,   212,   213,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,   221,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,   249,   250,
     251,   252,   253,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     266,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,   278,   279,   280,   281,     0,
     282,     0,   283,   284,   285,     0,   286,     0,   287,     0,
       0,     0,   288,   289,   290,     0,   291,   292,     0,   293,
       0,   294,   295,   296,   297,   874,     0,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,     0,
     309,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,     0,     0,   318,     0,   319,   320,   321,   322,   323,
     324,   325,     0,   326,     0,   327,     0,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   875,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,     0,   355,
     356,     0,   357,     0,   358,   359,   360,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,   368,
       0,     0,     0,   369,   370,   371,   372,   373,   374,   375,
       0,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,     0,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,     0,   450,   451,
     452,   453,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,     0,   470,     0,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,     0,   207,   208,   209,   210,   211,
       0,   212,   213,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,   221,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,     0,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   266,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,   278,   279,   280,   281,     0,   282,     0,   283,
     284,   285,     0,   286,     0,   287,     0,     0,     0,   288,
     289,   290,     0,   291,   292,     0,   293,     0,   294,   295,
     296,   297,   878,     0,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,     0,   309,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,     0,     0,
     318,     0,   319,   320,   321,   322,   323,   324,   325,     0,
     326,     0,   327,     0,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,     0,   355,   356,     0,   357,
       0,   358,   359,   360,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,   368,     0,     0,     0,
     369,   370,   371,   372,   373,   374,   375,     0,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,     0,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,     0,   450,   451,   452,   453,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
       0,   470,     0,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   192,   193,
     194,   195,   196,   197,   198,   199,     0,   201,   202,   203,
       0,     0,     0,     0,     0,     0,     0,   204,   205,     0,
     206,     0,   207,   208,   209,   210,   211,     0,   212,   213,
       0,   214,   215,   216,   217,   218,     0,     0,   647,   220,
     221,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,   240,     0,   241,   242,   243,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     0,   255,
       0,   256,   257,   258,   259,   260,     0,   261,   262,   263,
       0,     0,   264,   265,   266,   267,   268,     0,   269,   270,
     271,     0,   272,   273,     0,   274,   275,   276,   277,   278,
     279,   280,   281,     0,   282,     0,   283,   284,   285,     0,
     286,     0,   287,     0,     0,     0,   288,   289,   290,     0,
     291,   292,     0,   293,     0,   294,   295,   296,   297,   298,
       0,   299,   300,   301,     0,   302,   303,   304,   305,   306,
     307,     0,   308,     0,   309,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,     0,     0,   318,     0,   319,
     320,   321,   322,   323,   324,   325,     0,   326,     0,   327,
       0,     0,   328,   329,   330,     0,     0,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   650,
     344,     0,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,     0,   355,   356,     0,   357,     0,   358,   359,
     360,   361,   362,   363,     0,   364,     0,     0,   365,   366,
     367,     0,     0,   368,     0,     0,     0,   369,   370,   371,
     372,   373,   374,   375,     0,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,     0,   404,   405,     0,   651,
     407,   408,   409,   410,   411,   652,   413,   414,   415,   416,
       0,   417,   418,   419,   420,  1044,     0,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,     0,   440,   441,
       0,   442,   443,   444,   445,   446,   447,     0,   654,   449,
       0,     0,   655,   451,   452,   453,     0,   454,   455,   456,
     457,   458,   459,     0,     0,   460,   461,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,     0,   470,     0,
     471,   472,   473,     0,     0,   474,     0,     0,   475,   476,
     477,   478,   656,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,  1072,     0,   204,   205,     0,   206,     0,   207,
     208,   209,   210,   211,     0,   212,   213,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,   221,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,     0,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,   249,
     250,   251,   252,   253,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   266,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,   278,   279,   280,   281,
       0,   282,     0,   283,   284,   285,     0,   286,     0,   287,
       0,     0,     0,   288,   289,   290,     0,   291,   292,     0,
     293,     0,   294,   295,   296,   297,   298,     0,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
       0,   309,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,     0,     0,   318,     0,   319,   320,   321,   322,
     323,   324,   325,     0,   326,     0,   327,     0,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,     0,
     355,   356,     0,   357,     0,   358,   359,   360,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
     368,     0,     0,     0,   369,   370,   371,   372,   373,   374,
     375,     0,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,     0,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,     0,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,     0,   450,
     451,   452,   453,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,     0,   470,     0,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,  1363,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,   374,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,     0,   207,   208,   209,   210,   211,     0,   212,
     213,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,   221,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
       0,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   266,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
     278,   279,   280,   281,     0,   282,     0,   283,   284,   285,
       0,   286,     0,   287,     0,     0,     0,   288,   289,   290,
       0,   291,   292,     0,   293,     0,   294,   295,   296,   297,
    1365,     0,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,     0,   309,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,     0,     0,   318,     0,
     319,   320,   321,   322,   323,   324,   325,     0,   326,     0,
     327,     0,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   355,   356,     0,   357,     0,   358,
     359,   360,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,   368,     0,     0,     0,   369,   370,
     371,   372,   373,   374,   375,     0,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,     0,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,     0,   450,   451,   452,   453,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,     0,   470,
       0,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,     0,
     207,   208,   209,   210,   211,     0,   212,   213,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,   221,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
     249,   250,   251,   252,   253,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   266,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,   278,   279,   280,
     281,     0,   282,     0,   283,   284,   285,     0,   286,     0,
     287,     0,     0,     0,   288,   289,   290,     0,   291,   292,
       0,   293,     0,   294,   295,   296,   297,   298,     0,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,     0,   309,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,     0,     0,   318,     0,   319,   320,   321,
     322,   323,   324,   325,     0,   326,     0,   327,     0,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
       0,   355,   356,     0,   357,     0,   358,   359,   360,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,   368,     0,     0,     0,   369,   370,   371,   372,   373,
     374,   375,     0,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,     0,   406,   407,   408,
     409,   410,  1458,   412,   413,   414,   415,   416,     0,   417,
     418,   419,   420,   421,     0,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,     0,
     450,   451,   452,   453,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,     0,   470,     0,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   194,   195,   196,   197,   198,
     199,     0,   201,   202,   203,     0,     0,     0,     0,     0,
       0,     0,   204,   205,     0,   206,     0,   207,   208,   209,
     210,   211,     0,   212,   213,     0,   214,   215,   216,   217,
     218,     0,     0,   647,   220,   221,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,   240,
       0,   241,   242,   243,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,   249,   250,   251,
     252,   253,   254,     0,   255,     0,   256,   257,   258,   259,
     260,     0,   261,   262,   263,     0,     0,   264,   265,   266,
     267,   268,     0,   269,   270,   271,     0,   272,   273,     0,
     274,   275,   276,   277,   278,   279,   280,   281,     0,   282,
       0,   283,   284,   285,     0,   286,     0,   287,     0,     0,
       0,   288,   289,   290,     0,   291,   292,     0,   293,     0,
     294,   295,   296,   297,   298,     0,   299,   300,   301,     0,
     302,   303,   304,   305,   306,   307,     0,   308,     0,   309,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
       0,     0,   318,     0,   319,   320,   321,   322,   323,   324,
     325,     0,   326,     0,   327,     0,     0,   328,   329,   330,
       0,     0,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   650,   344,     0,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   355,   356,
       0,   357,     0,   358,   359,   360,   361,   362,   363,     0,
     364,     0,     0,   365,   366,   367,     0,     0,   368,     0,
       0,     0,   369,   370,   371,   372,   373,   374,   375,     0,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
       0,   404,   405,     0,   651,   407,   408,   409,   410,   411,
     652,   413,   414,   415,   416,     0,   417,   418,   419,   420,
    1044,     0,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,     0,   440,   441,     0,   442,  1738,   444,   445,
     446,   447,     0,   654,   449,     0,     0,   655,   451,   452,
     453,     0,   454,   455,   456,   457,   458,   459,     0,     0,
     460,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,     0,   470,     0,   471,   472,   473,     0,     0,
     474,     0,     0,   475,   476,   477,   478,   656,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     647,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,   298,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   650,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   651,   407,   408,   409,   410,   411,  1772,   413,   414,
     415,   416,     0,   417,   418,   419,   420,  1044,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     654,   449,     0,     0,   655,   451,   452,   453,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   656,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,  2003,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,  1269,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   699,   207,   208,
     209,     0,  1270,   700,  1271,  1272,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,  1273,  1274,   223,     0,
     224,   225,   226,   227,     0,     0,     0,   229,   230,   231,
     232,   701,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   702,   244,   245,     0,     0,
       0,   703,     0,     0,     0,   246,   247,   248,   249,   250,
     251,  1275,  1276,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     968,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,     0,   279,   280,     0,     0,
     282,     0,   283,  1277,   285,     0,   286,     0,   287,   704,
       0,   705,   288,   289,   290,     0,   291,     0,     0,   293,
       0,   294,   295,   296,   297,   298,   706,   299,   300,   301,
    1777,   302,   303,   304,   305,   306,   307,     0,   308,   707,
    1778,   310,   311,   312,   313,  1278,  1279,     0,  1280,     0,
     317,   708,   709,   318,   710,   319,   320,   321,   322,   323,
     324,   325,     0,     0,   711,   327,   712,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,  1281,   713,  1282,   346,
     347,   348,   349,   350,   351,   352,     0,   354,     0,   355,
     356,   714,   357,     0,     0,   359,  1283,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,  1779,
     715,   716,   717,     0,   370,   371,   372,   373,   374,   375,
       0,   376,     0,   378,     0,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,  1284,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,   718,   406,   407,     0,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,  1780,   424,   425,   719,   426,  1286,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   439,     0,   440,   441,     0,   442,   443,   444,
     445,   446,   447,     0,  1287,  1288,     0,     0,   450,     0,
     452,     0,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,     0,  1289,  1781,   470,   720,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,   191,
       0,     0,     0,     0,     0,     0,     0,   488,   489,   490,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,     0,   207,   208,   209,   210,   211,     0,
     212,   213,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,   221,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,   249,   250,   251,   252,   253,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   266,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,   278,   279,   280,   281,     0,   282,     0,   283,   284,
     285,     0,   286,     0,   287,     0,     0,     0,   288,   289,
     290,     0,   291,   292,     0,   293,     0,   294,   295,   296,
     297,  2338,     0,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,     0,   309,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,     0,     0,   318,
       0,   319,   320,   321,   322,   323,   324,   325,     0,   326,
       0,   327,     0,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,     0,   355,   356,     0,   357,     0,
     358,   359,   360,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,   368,     0,     0,     0,   369,
     370,   371,   372,   373,   374,   375,     0,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
       0,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,     0,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,     0,   450,   451,   452,   453,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,     0,
     470,     0,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
       0,   207,   208,   209,   210,   211,     0,   212,   213,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,   221,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,   249,   250,   251,   252,   253,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,   278,   279,
     280,   281,     0,   282,     0,   283,   284,   285,     0,   286,
       0,   287,     0,     0,     0,   288,   289,   290,     0,   291,
     292,     0,   293,     0,   294,   295,   296,   297,  2340,     0,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,     0,   309,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,     0,     0,   318,     0,   319,   320,
     321,   322,   323,   324,   325,     0,   326,     0,   327,     0,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,     0,   355,   356,     0,   357,     0,   358,   359,   360,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,   368,     0,     0,     0,   369,   370,   371,   372,
     373,   374,   375,     0,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,     0,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
       0,   450,   451,   452,   453,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,     0,   470,     0,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,  1269,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,   197,
     198,   199,     0,   201,   202,   203,     0,     0,     0,     0,
       0,     0,     0,   204,   205,     0,   206,   699,   207,   208,
     209,     0,  1270,   700,  1271,  1272,     0,   214,   215,   216,
     217,   218,     0,     0,   219,   220,  1273,  1274,   223,     0,
     224,   225,   226,   227,     0,     0,     0,   229,   230,   231,
     232,   701,   233,   234,     0,   235,   236,   237,   238,   239,
     240,     0,   241,   242,   243,   702,   244,   245,     0,     0,
       0,   703,     0,     0,     0,   246,   247,   248,   249,   250,
     251,  1275,  1276,   254,     0,   255,     0,   256,   257,   258,
     259,   260,     0,   261,   262,   263,     0,     0,   264,   265,
     968,   267,   268,     0,   269,   270,   271,     0,   272,   273,
       0,   274,   275,   276,   277,     0,   279,   280,     0,     0,
     282,     0,   283,  1277,   285,     0,   286,     0,   287,   704,
       0,   705,   288,   289,   290,     0,   291,     0,     0,   293,
       0,   294,   295,   296,   297,   298,   706,   299,   300,   301,
       0,   302,   303,   304,   305,   306,   307,     0,   308,   707,
       0,   310,   311,   312,   313,  1278,  1279,     0,  1280,     0,
     317,   708,   709,   318,   710,   319,   320,   321,   322,   323,
     324,   325,     0,     0,   711,   327,   712,     0,   328,   329,
     330,     0,     0,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,  1281,   713,  1282,   346,
     347,   348,   349,   350,   351,   352,     0,   354,     0,   355,
     356,   714,   357,  1768,     0,   359,  1283,   361,   362,   363,
       0,   364,     0,     0,   365,   366,   367,     0,     0,     0,
     715,   716,   717,     0,   370,   371,   372,   373,   374,   375,
       0,   376,     0,   378,     0,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,  1284,   391,   392,   393,
       0,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,     0,   404,   405,   718,   406,   407,     0,   409,   410,
     411,   412,   413,   414,   415,   416,     0,   417,   418,   419,
     420,   421,     0,   422,  1780,   424,   425,   719,   426,  1286,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   439,     0,   440,   441,  2997,   442,   443,   444,
     445,   446,   447,     0,  1287,  1288,     0,     0,   450,     0,
     452,     0,     0,   454,   455,   456,   457,   458,   459,     0,
       0,   460,   461,   462,   463,     0,     0,   464,   465,   466,
     467,     0,  1289,     0,   470,   720,   471,   472,   473,     0,
       0,   474,     0,     0,   475,   476,   477,   478,   479,  1269,
       0,     0,     0,     0,     0,     0,     0,   488,   489,   490,
     192,   193,   194,   195,   196,   197,   198,   199,     0,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,   204,
     205,     0,   206,   699,   207,   208,   209,     0,  1270,   700,
    1271,  1272,     0,   214,   215,   216,   217,   218,     0,     0,
     219,   220,  1273,  1274,   223,     0,   224,   225,   226,   227,
       0,     0,     0,   229,   230,   231,   232,   701,   233,   234,
       0,   235,   236,   237,   238,   239,   240,     0,   241,   242,
     243,   702,   244,   245,     0,     0,     0,   703,     0,     0,
       0,   246,   247,   248,   249,   250,   251,  1275,  1276,   254,
       0,   255,     0,   256,   257,   258,   259,   260,     0,   261,
     262,   263,     0,     0,   264,   265,   968,   267,   268,     0,
     269,   270,   271,     0,   272,   273,     0,   274,   275,   276,
     277,     0,   279,   280,     0,     0,   282,     0,   283,  1277,
     285,     0,   286,     0,   287,   704,     0,   705,   288,   289,
     290,     0,   291,     0,     0,   293,     0,   294,   295,   296,
     297,   298,   706,   299,   300,   301,     0,   302,   303,   304,
     305,   306,   307,     0,   308,   707,     0,   310,   311,   312,
     313,  1278,  1279,     0,  1280,     0,   317,   708,   709,   318,
     710,   319,   320,   321,   322,   323,   324,   325,     0,     0,
     711,   327,   712,     0,   328,   329,   330,     0,     0,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,  1281,   713,  1282,   346,   347,   348,   349,   350,
     351,   352,  1824,   354,     0,   355,   356,   714,   357,     0,
       0,   359,  1283,   361,   362,   363,     0,   364,     0,     0,
     365,   366,   367,     0,     0,     0,   715,   716,   717,     0,
     370,   371,   372,   373,   374,   375,     0,   376,     0,   378,
       0,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,  1284,   391,   392,   393,     0,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,     0,   404,   405,
     718,   406,   407,     0,   409,   410,   411,   412,   413,   414,
     415,   416,     0,   417,   418,   419,   420,   421,     0,   422,
    1285,   424,   425,   719,   426,  1286,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,     0,   439,     0,
     440,   441,     0,   442,   443,   444,   445,   446,   447,     0,
    1287,  1288,     0,     0,   450,     0,   452,     0,     0,   454,
     455,   456,   457,   458,   459,     0,     0,   460,   461,   462,
     463,     0,     0,   464,   465,   466,   467,     0,  1289,     0,
     470,   720,   471,   472,   473,     0,     0,   474,     0,     0,
     475,   476,   477,   478,   479,  1269,     0,     0,     0,     0,
       0,     0,     0,   488,   489,   490,   192,   193,   194,   195,
     196,   197,   198,   199,     0,   201,   202,   203,     0,     0,
       0,     0,     0,     0,     0,   204,   205,     0,   206,   699,
     207,   208,   209,     0,  1270,   700,  1271,  1272,     0,   214,
     215,   216,   217,   218,     0,     0,   219,   220,  1273,  1274,
     223,     0,   224,   225,   226,   227,     0,     0,     0,   229,
     230,   231,   232,   701,   233,   234,     0,   235,   236,   237,
     238,   239,   240,     0,   241,   242,   243,   702,   244,   245,
       0,     0,     0,   703,     0,     0,     0,   246,   247,   248,
     249,   250,   251,  1275,  1276,   254,     0,   255,     0,   256,
     257,   258,   259,   260,     0,   261,   262,   263,     0,     0,
     264,   265,   968,   267,   268,     0,   269,   270,   271,     0,
     272,   273,     0,   274,   275,   276,   277,     0,   279,   280,
       0,     0,   282,     0,   283,  1277,   285,     0,   286,     0,
     287,   704,     0,   705,   288,   289,   290,     0,   291,     0,
       0,   293,     0,   294,   295,   296,   297,   298,   706,   299,
     300,   301,     0,   302,   303,   304,   305,   306,   307,     0,
     308,   707,     0,   310,   311,   312,   313,  1278,  1279,     0,
    1280,     0,   317,   708,   709,   318,   710,   319,   320,   321,
     322,   323,   324,   325,     0,     0,   711,   327,   712,     0,
     328,   329,   330,     0,     0,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,  1281,   713,
    1282,   346,   347,   348,   349,   350,   351,   352,  2838,   354,
       0,   355,   356,   714,   357,     0,     0,   359,  1283,   361,
     362,   363,     0,   364,     0,     0,   365,   366,   367,     0,
       0,     0,   715,   716,   717,     0,   370,   371,   372,   373,
     374,   375,     0,   376,     0,   378,     0,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,  1284,   391,
     392,   393,     0,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,     0,   404,   405,   718,   406,   407,     0,
     409,   410,   411,   412,   413,   414,   415,   416,     0,   417,
     418,   419,   420,   421,     0,   422,  1285,   424,   425,   719,
     426,  1286,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,     0,   439,     0,   440,   441,     0,   442,
     443,   444,   445,   446,   447,     0,  1287,  1288,     0,     0,
     450,     0,   452,     0,     0,   454,   455,   456,   457,   458,
     459,     0,     0,   460,   461,   462,   463,     0,     0,   464,
     465,   466,   467,     0,  1289,     0,   470,   720,   471,   472,
     473,     0,     0,   474,     0,     0,   475,   476,   477,   478,
     479,   191,     0,     0,     0,     0,     0,     0,     0,   488,
     489,   490,   192,   193,   194,   195,   196,   197,   198,   199,
       0,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,   204,   205,     0,   206,     0,   207,   208,   209,   210,
     211,     0,   212,   213,     0,   214,   215,   216,   217,   218,
       0,     0,   219,   220,   221,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,   240,     0,
     241,   242,   243,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,   249,   250,   251,   252,
     253,   254,     0,   255,     0,   256,   257,   258,   259,   260,
       0,   261,   262,   263,     0,     0,   264,   265,   266,   267,
     268,     0,   269,   270,   271,     0,   272,   273,     0,   274,
     275,   276,   277,   278,   279,   280,   281,     0,   282,     0,
     283,   284,   285,     0,   286,     0,   287,     0,     0,     0,
     288,   289,   290,     0,   291,   292,     0,   293,     0,   294,
     295,   296,   297,   298,     0,   299,   300,   301,     0,   302,
     303,   304,   305,   306,   307,     0,   308,     0,   309,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,     0,
       0,   318,     0,   319,   320,   321,   322,   323,   324,   325,
       0,   326,     0,   327,     0,     0,   328,   329,   330,     0,
       0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,     0,   355,   356,     0,
     357,     0,   358,   359,   360,   361,   362,   363,     0,   364,
       0,     0,   365,   366,   367,     0,     0,   368,     0,     0,
       0,   369,   370,   371,   372,   373,     0,   375,     0,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,     0,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,     0,
     404,   405,     0,   406,   407,   408,     0,   410,   411,   412,
     413,   414,   415,   416,     0,   417,   418,   419,   420,   421,
       0,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,     0,   440,   441,     0,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,     0,   450,   451,   452,   453,
       0,   454,   455,   456,   457,   458,   459,     0,     0,   460,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,     0,   470,     0,   471,   472,   473,     0,     0,   474,
       0,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,  1269,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   201,   202,
     203,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,   206,   699,   207,   208,   209,     0,  1270,   700,  1271,
    1272,     0,   214,   215,   216,   217,   218,     0,     0,   219,
     220,  1273,  1274,   223,     0,   224,   225,   226,   227,     0,
       0,     0,   229,   230,   231,   232,   701,   233,   234,     0,
     235,   236,   237,   238,   239,   240,     0,   241,   242,   243,
     702,   244,   245,     0,     0,     0,   703,     0,     0,     0,
     246,   247,   248,   249,   250,   251,  1275,  1276,   254,     0,
     255,     0,   256,   257,   258,   259,   260,     0,   261,   262,
     263,     0,     0,   264,   265,   968,   267,   268,     0,   269,
     270,   271,     0,   272,   273,     0,   274,   275,   276,   277,
       0,   279,   280,     0,     0,   282,     0,   283,  1277,   285,
       0,   286,     0,   287,   704,     0,   705,   288,   289,   290,
       0,   291,     0,     0,   293,     0,   294,   295,   296,   297,
     298,   706,   299,   300,   301,     0,   302,   303,   304,   305,
     306,   307,     0,   308,   707,     0,   310,   311,   312,   313,
    1278,  1279,     0,  1280,     0,   317,   708,   709,   318,   710,
     319,   320,   321,   322,   323,   324,   325,     0,     0,   711,
     327,   712,     0,   328,   329,   330,     0,     0,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,  1281,   713,  1282,   346,   347,   348,   349,   350,   351,
     352,     0,   354,     0,   355,   356,   714,   357,     0,     0,
     359,  1283,   361,   362,   363,     0,   364,     0,     0,   365,
     366,   367,     0,     0,     0,   715,   716,   717,     0,   370,
     371,   372,   373,   374,   375,     0,   376,     0,   378,     0,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,  1284,   391,   392,   393,     0,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,     0,   404,   405,   718,
     406,   407,     0,   409,   410,   411,   412,   413,   414,   415,
     416,     0,   417,   418,   419,   420,   421,     0,   422,  1285,
     424,   425,   719,   426,  1286,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   439,     0,   440,
     441,     0,   442,   443,   444,   445,   446,   447,     0,  1287,
    1288,     0,     0,   450,     0,   452,     0,     0,   454,   455,
     456,   457,   458,   459,     0,     0,   460,   461,   462,   463,
       0,     0,   464,   465,   466,   467,     0,  1289,     0,   470,
     720,   471,   472,   473,     0,     0,   474,     0,     0,   475,
     476,   477,   478,   479,  1269,     0,     0,     0,     0,     0,
       0,     0,   488,   489,   490,   192,   193,   194,   195,   196,
     197,   198,   199,     0,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   204,   205,     0,   206,   699,   207,
     208,   209,     0,  1270,   700,  1271,  1272,     0,   214,   215,
     216,   217,   218,     0,     0,   219,   220,  1273,  1274,   223,
       0,   224,   225,   226,   227,     0,     0,     0,   229,   230,
     231,   232,   701,   233,   234,     0,   235,   236,   237,   238,
     239,   240,     0,   241,   242,   243,   702,   244,   245,     0,
       0,     0,   703,     0,     0,     0,   246,   247,   248,   249,
     250,   251,  1275,  1276,   254,     0,   255,     0,   256,   257,
     258,   259,   260,     0,   261,   262,   263,     0,     0,   264,
     265,   968,   267,   268,     0,   269,   270,   271,     0,   272,
     273,     0,   274,   275,   276,   277,     0,   279,   280,     0,
       0,   282,     0,   283,  1277,   285,     0,   286,     0,   287,
     704,     0,   705,   288,   289,   290,     0,   291,     0,     0,
     293,     0,   294,   295,   296,   297,   298,   706,   299,   300,
     301,     0,   302,   303,   304,   305,   306,   307,     0,   308,
     707,     0,   310,   311,   312,   313,  1278,  1279,     0,  1280,
       0,   317,   708,   709,   318,   710,   319,   320,   321,   322,
     323,   324,   325,     0,     0,   711,   327,   712,     0,   328,
     329,   330,     0,     0,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,  1281,   713,  1282,
     346,   347,   348,   349,   350,   351,   352,     0,   354,     0,
     355,   356,   714,   357,     0,     0,   359,  1283,   361,   362,
     363,     0,   364,     0,     0,   365,   366,   367,     0,     0,
       0,   715,   716,   717,     0,   370,   371,   372,   373,   374,
     375,     0,   376,     0,   378,     0,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,  1284,   391,   392,
     393,     0,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,     0,   404,   405,   718,   406,   407,     0,   409,
     410,   411,   412,   413,   414,   415,   416,     0,   417,   418,
     419,   420,   421,     0,   422,  1780,   424,   425,   719,   426,
    1286,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   439,     0,   440,   441,     0,   442,   443,
     444,   445,   446,   447,     0,  1287,  1288,     0,     0,   450,
       0,   452,     0,     0,   454,   455,   456,   457,   458,   459,
       0,     0,   460,   461,   462,   463,     0,     0,   464,   465,
     466,   467,     0,  1289,     0,   470,   720,   471,   472,   473,
       0,     0,   474,     0,     0,   475,   476,   477,   478,   479,
    1269,     0,     0,     0,     0,     0,     0,     0,   488,   489,
     490,   192,   193,   194,   195,   196,   197,   198,   199,     0,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
     204,   205,     0,   206,   699,   207,   208,   209,     0,  1270,
     700,  1271,  1272,     0,   214,   215,   216,   217,   218,     0,
       0,   219,   220,  1273,  1274,   223,     0,   224,   225,   226,
     227,     0,     0,     0,   229,   230,   231,   232,   701,   233,
     234,     0,   235,   236,   237,   238,   239,   240,     0,   241,
     242,   243,   702,   244,   245,     0,     0,     0,   703,     0,
       0,     0,   246,   247,   248,   249,   250,   251,  1275,  1276,
     254,     0,   255,     0,   256,   257,   258,   259,   260,     0,
     261,   262,   263,     0,     0,   264,   265,   968,   267,   268,
       0,   269,   270,   271,     0,   272,   273,     0,   274,   275,
     276,   277,     0,   279,   280,     0,     0,   282,     0,   283,
    1277,   285,     0,   286,     0,   287,   704,     0,   705,   288,
     289,   290,     0,   291,     0,     0,   293,     0,   294,   295,
     296,   297,   298,   706,   299,   300,   301,     0,   302,   303,
     304,   305,   306,   307,     0,   308,   707,     0,   310,   311,
     312,   313,  1278,  1279,     0,  1280,     0,   317,   708,   709,
     318,   710,   319,   320,   321,   322,   323,   324,   325,     0,
       0,   711,   327,   712,     0,   328,   329,   330,     0,     0,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1281,   713,  1282,   346,   347,   348,   349,
     350,   351,   352,     0,   354,     0,   355,   356,   714,   357,
       0,     0,   359,  1283,   361,   362,   363,     0,   364,     0,
       0,   365,   366,   367,     0,     0,     0,   715,   716,   717,
       0,   370,   371,   372,   373,   374,   375,     0,   376,     0,
     378,     0,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,  1284,   391,   392,   393,     0,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,     0,   404,
     405,   718,   406,   407,     0,   409,   410,   411,   412,   413,
     414,   415,   416,     0,   417,   418,   419,   420,   421,     0,
     422,     0,   424,   425,   719,   426,  1286,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   439,
       0,   440,   441,     0,   442,   443,   444,   445,   446,   447,
       0,  1287,  1288,     0,     0,   450,     0,   452,     0,     0,
     454,   455,   456,   457,   458,   459,     0,     0,   460,   461,
     462,   463,     0,     0,   464,   465,   466,   467,     0,  1289,
       0,   470,   720,   471,   472,   473,     0,     0,   474,     0,
       0,   475,   476,   477,   478,   479,  1269,     0,     0,     0,
       0,     0,     0,     0,   488,   489,   490,   192,   193,   194,
     195,   196,   197,   198,   199,     0,   201,   202,   203,     0,
       0,     0,     0,     0,     0,     0,   204,   205,     0,   206,
     699,   207,   208,   209,     0,     0,   700,     0,     0,     0,
     214,   215,   216,   217,   218,     0,     0,   219,   220,     0,
       0,   223,     0,   224,   225,   226,   227,     0,     0,     0,
     229,   230,   231,   232,   701,   233,   234,     0,   235,   236,
     237,   238,   239,   240,     0,   241,   242,   243,   702,   244,
     245,     0,     0,     0,   703,     0,     0,     0,   246,   247,
     248,   249,   250,   251,     0,     0,   254,     0,   255,     0,
     256,   257,   258,   259,   260,     0,   261,   262,   263,     0,
       0,   264,   265,   266,   267,   268,     0,   269,   270,   271,
       0,   272,   273,     0,   274,   275,   276,   277,     0,   279,
     280,     0,     0,   282,     0,   283,     0,   285,     0,   286,
       0,   287,   704,     0,   705,   288,   289,   290,     0,   291,
       0,     0,   293,     0,   294,   295,   296,   297,   298,   706,
     299,   300,   301,     0,   302,   303,   304,   305,   306,   307,
       0,   308,   707,     0,   310,   311,   312,   313,     0,     0,
       0,     0,     0,   317,   708,   709,   318,   710,   319,   320,
     321,   322,   323,   324,   325,     0,     0,   711,   327,   712,
       0,   328,   329,   330,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     713,     0,   346,   347,   348,   349,   350,   351,   352,     0,
     354,     0,   355,   356,   714,   357,     0,     0,   359,     0,
     361,   362,   363,     0,   364,     0,     0,   365,   366,   367,
       0,     0,     0,   715,   716,   717,     0,   370,   371,   372,
     373,   374,   375,     0,   376,     0,   378,     0,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,     0,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,     0,   404,   405,   718,   406,   407,
       0,   409,   410,   411,   412,   413,   414,   415,   416,     0,
     417,   418,   419,   420,   421,     0,   422,     0,   424,   425,
     719,   426,     0,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   439,     0,   440,   441,     0,
     442,   443,   444,   445,   446,   447,     0,     0,     0,     0,
       0,   450,     0,   452,     0,     0,   454,   455,   456,   457,
     458,   459,     0,     0,   460,   461,   462,   463,     0,     0,
     464,   465,   466,   467,     0,     0,     0,   470,   720,   471,
     472,   473,     0,     0,   474,     0,     0,   475,   476,   477,
     478,   479,     0,     0,     0,     0,     0,     0,     0,     0,
     488,   489,   490
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,    35,   176,   854,    17,    49,
     695,    11,   913,   607,   608,   159,    22,    26,   612,   648,
     861,    21,    28,   515,  1170,   697,   890,   174,    43,   727,
     166,  1154,  1131,   180,   927,  1387,   172,  1425,    22,  1068,
     722,   188,   771,  1068,    28,   542,    12,  1285,   167,    49,
     825,   170,   755,  1524,   995,  1785,  1786,   940,   881,   655,
    1462,  1160,   765,  2087,   556,  1210,  1070,   186,    23,  1348,
      21,  2331,  1218,  1219,  1331,    42,  1094,  1154,    45,  1987,
      35,   733,  1495,   802,   554,  2549,  1823,   508,   558,  1068,
    1119,  1317,   173,  2400,  1119,  2402,  1680,   178,   568,   966,
     967,  2769,  1317,   806,   756,   757,   187,   759,   811,  1998,
    1317,   763,  1116,  2225,   766,   818,  1317,  2503,   985,  1317,
    1317,  2061,  1992,  1993,   827,   161,  1383,   846,  2223,   550,
    2464,    18,   146,  2789,   575,  1203,     0,     0,     0,     0,
    1119,  1554,     0,  2998,  1160,  1119,  3172,    39,  1691,     5,
     728,     0,  1686,     0,   651,  2971,   161,  2944,     0,     0,
     733,   161,  3008,    11,    43,   692,     0,   738,     0,  2503,
    2976,    31,     0,  2683,    57,  2483,  2484,  2485,  2486,  2487,
    2488,     9,     9,    50,   104,     5,  3178,   765,     7,  1012,
      66,   692,    77,    13,    22,    14,   128,  1934,    16,    22,
    2221,  2222,    35,    97,   956,   957,   800,    18,     5,     5,
     104,   134,     5,     5,     5,   182,    59,    13,    26,    27,
      13,    22,   151,     5,     5,   150,    70,     5,    29,   981,
      25,    74,    81,    35,    41,   156,     5,  3538,     5,    11,
      81,   189,     5,     5,   150,    68,     5,     5,     0,  3438,
    3439,    97,    75,   121,   170,   153,   230,     9,     4,   150,
     248,     9,   121,     9,    36,    57,    57,     9,   158,   106,
      22,  3531,   152,  2010,   163,  2012,    50,     5,   153,   868,
     150,   111,   105,  1312,    72,     5,   152,  1312,   131,    59,
     879,    51,   219,   258,   786,  3322,     5,     5,   104,    59,
       9,   248,  1244,   150,   147,   317,   155,    34,   150,     5,
     121,   356,     5,  1104,   155,   133,   150,   141,   150,   890,
     193,   107,   150,   170,     4,   113,  1055,   238,   170,     9,
     219,   265,    76,  1312,   346,   385,   170,    11,   170,   309,
     177,   149,   170,   151,   238,   515,   804,  1288,   298,    50,
     497,   174,     3,     4,     5,   502,  1038,   252,     9,   166,
     294,   131,    36,   170,   298,     4,    56,    57,   504,  3023,
       9,  3025,   283,   323,   118,   387,   104,   147,   294,     5,
     877,   167,   298,   207,   104,   430,   556,   314,   254,   323,
     360,   510,   862,   316,  3181,   104,   104,  1339,   150,   206,
    1904,   238,    11,  1250,    22,   379,   525,   323,  1275,  1276,
     546,   104,   285,  1254,   299,   305,  1283,   553,   170,    22,
     318,    11,   150,   346,    22,   314,    29,    36,   123,   309,
     298,    29,   513,   300,   109,   278,   517,   243,   426,   298,
    2826,   335,   169,   318,   338,    18,   527,   315,   918,   347,
     210,   892,   301,   104,   265,   323,   230,  1461,   381,   929,
     301,    30,     5,  1115,   323,   430,   613,    50,  3494,   927,
     393,   941,   347,  3733,   320,  2783,   243,   393,   266,   426,
     356,   628,   430,  1054,   364,   243,   356,  1058,  1059,   307,
     499,  1266,  2826,   413,   426,  3522,  1199,   426,  1201,  3688,
    1529,   648,   297,   426,  1529,   430,  3807,   325,   278,   430,
     343,  3298,   323,  1242,   309,   338,  1417,   191,   665,  3325,
     327,  1273,  1274,   367,   430,  1177,   300,   370,  1247,   330,
    1282,  2065,   426,   542,   543,   104,   576,   188,   394,   430,
     687,   343,  1780,   426,   393,   430,   376,   426,   121,   323,
    1529,   695,   393,  3340,  1051,  2576,   412,  1561,  2295,   210,
    1263,  3071,   350,   430,   578,   360,   426,  1138,     8,   536,
     426,    11,  3598,  1144,   422,   575,   576,   385,   427,  1152,
     429,   587,   429,   589,  1111,   591,   427,   429,   429,   417,
     418,   597,  2322,   384,  2324,   429,  3588,   429,   425,   300,
     370,   429,   384,   587,  1302,   589,   426,   591,   574,  1187,
    1111,   498,   621,   597,   598,   599,   786,  1762,  2926,  1089,
    1191,   740,   741,  1194,  1195,   576,  2160,   424,   356,   426,
     426,   428,   641,   426,   426,   426,  2748,  1460,   647,  1462,
     776,   650,   651,   652,   426,   426,  3433,   783,   426,  1472,
     422,   618,  1475,   271,  3441,  2563,  1114,   426,  2753,  2567,
    1483,  1484,  1785,   426,   426,   417,   418,   426,  3694,   417,
     418,   417,   418,  1496,  1497,   417,   418,   429,   426,   798,
    1251,   828,   829,   830,  1507,   413,   686,   686,   686,   686,
     686,  1183,  3508,  3539,   389,   814,   815,   833,   394,   374,
     428,  3355,   669,  2246,  1495,  1734,  2443,  2444,  1987,  1734,
     336,   337,   831,   393,  2127,  2128,   412,   300,   261,  2132,
      99,   294,   109,  1181,   675,  3751,   170,   330,   251,   430,
     426,   349,   330,   351,  2464,  1487,  1488,   417,   418,   858,
     859,    48,  1336,   417,   418,   419,   420,   421,   422,  3518,
      50,   191,     5,   150,   738,  1734,     8,   649,  2171,  2172,
    1734,   653,  1351,  2234,   230,    74,   417,   418,   133,     5,
     917,  1360,   133,  2503,   253,    43,  1792,    72,   151,  1368,
    1369,   152,   601,  1812,   163,   193,   280,  1812,   145,    96,
    1248,  3492,   801,   940,   104,   104,   183,  1386,   142,  3825,
    1429,  1430,   305,   251,   144,    99,     8,  1265,  3663,    11,
     419,   420,   421,   422,   254,    22,   258,  2547,   113,   107,
    1849,    63,   686,   686,   686,   686,   145,    95,   686,   419,
     420,   421,   422,  1812,    36,     3,   155,     5,   309,    41,
     219,    72,   109,   222,   413,   252,    72,   430,    59,  1307,
     109,   170,   150,   288,   121,   424,  1979,   426,   427,   428,
      18,   430,    18,    74,   307,   172,    24,   315,   877,   163,
    1849,    81,   375,    98,  2763,  1367,  3340,   285,   106,   167,
     104,   890,   113,   254,  3653,   229,   106,   113,   150,   360,
      32,  1361,   892,   104,   267,   106,   296,   116,  1356,   118,
    1370,    97,  1970,   426,   104,    23,   890,   427,   170,   116,
     430,   218,  1382,   220,   182,   924,   108,  1064,   397,  3620,
     139,   921,   921,   230,   183,   219,  3594,  3595,   222,   238,
    3586,    99,   426,   273,  2438,   314,  1357,  2441,  2442,   296,
    2219,  2445,   408,     8,   197,   155,    11,  3734,   173,   836,
     950,  2455,  1393,  1423,    22,   328,  1426,   264,  1428,   356,
     325,  1431,   230,   121,   325,   121,   177,   338,   170,   969,
     112,   266,  1012,   413,   414,   415,   363,   417,   418,   419,
     420,   421,   422,   426,   303,   427,   430,   374,   430,   191,
     192,   426,   299,   393,  3301,   163,   413,   154,   190,   999,
     300,  1493,   254,   130,  3773,  1014,   316,   243,   275,   251,
     238,   428,  1012,  1183,   238,  1024,   413,   424,   258,  1166,
     314,   428,   430,   243,   243,  1034,   333,   238,   407,   248,
     430,   428,   243,  3145,   230,   266,   346,   230,   238,   241,
     266,   307,  1051,  3155,   312,  1054,  3141,   426,   116,  1058,
    1059,   219,   254,   210,   222,   350,    11,   316,  3153,  1926,
     187,  1097,  1098,   256,  1100,  3451,   184,   278,  1082,  1527,
    1054,   381,   265,   315,  1058,  1059,   895,  1224,   897,   290,
     899,  3749,   901,   393,   903,   904,   905,   311,  1863,  1678,
     285,   910,  1097,  1098,  3442,  1100,  2826,  1097,  1098,  1246,
    1100,  1220,  1221,  1222,  1223,   189,  3014,   265,   374,   265,
    3781,  3019,  1830,   407,  3022,   374,   426,  3451,  3058,   350,
     345,   346,   141,  2152,   350,   309,   191,  2152,  2157,    96,
     325,   258,  2157,  1252,  1253,   349,   294,   351,   294,  1258,
    3010,     8,   108,   362,    11,   116,   314,   118,  1229,    74,
       8,  3499,   371,    11,  1138,   265,   317,  1875,  2005,   370,
    1144,   413,   414,   415,  2309,   417,   418,   419,   420,   421,
     422,   191,  2013,  2152,  3845,     5,   360,  2761,  2157,   374,
    1955,  1956,  1957,  1958,   294,   346,   379,   427,   207,   254,
     430,  1175,   349,    66,   351,    96,   358,  1367,  2321,  1208,
     256,    74,   356,  1322,  1323,  1324,  1325,  1191,   175,   265,
    1194,  1195,  1348,   277,  1350,   417,   418,   419,   420,   421,
     422,  2609,   325,  1359,   190,  1372,   387,   107,   376,   154,
    2248,   250,   252,   395,  1381,  1316,   191,  2639,   116,   407,
     118,  3589,   369,  2247,  2321,  1392,   277,   108,   173,  3597,
    1331,   218,  2665,   220,   109,  2668,  2669,  2670,  2671,  2672,
    2673,  2674,  2675,  2676,  2677,  1836,   307,  1251,   152,  1388,
    3734,   374,    11,  1844,  2097,  1846,   430,   248,   426,  2505,
    1999,   132,  1429,  1430,  2563,   210,    34,   167,  2567,  1425,
    2505,   346,    40,   334,   358,  3032,   180,  3034,  2505,   349,
     285,   351,  1383,   170,  2505,  3417,  3418,  2505,  2505,  1318,
     295,   154,  2725,  2726,  1996,  1736,   426,   218,    11,   220,
     171,  1791,  2145,  1493,   191,  3632,   264,   358,   183,   190,
     386,   395,   257,   191,   319,   196,  2127,  2128,  1796,   426,
    2597,  2132,   109,    36,  1315,   284,    59,  1164,  1348,   358,
    3374,  2174,   417,   418,   419,   420,   421,   422,  2127,  2128,
     238,  1332,   316,  2132,   395,   393,   394,   210,  2872,   308,
     248,  2400,  2401,  2402,  2878,  2879,  2880,  2881,  2882,  2883,
    2171,  2172,  3642,   393,   239,   240,  2209,   254,   116,  2535,
     118,   104,   346,  1393,  1211,  1212,   254,  1437,  2299,   265,
      20,   393,  2171,  2172,  3428,   265,  3430,  1828,   424,  1556,
      37,   139,   428,   294,   393,  2004,   183,   298,  1565,    39,
     430,  2400,  2401,  2402,   349,  1455,   351,   381,   294,  2018,
    2019,    58,  2461,  2022,   294,   360,  2461,  1437,   430,  2028,
       0,   151,   323,  1394,  3352,   370,  1446,  1446,  1446,  1446,
    1446,   430,   191,  2924,  2660,    73,  1914,   316,   430,   265,
    2327,   316,   417,   418,   419,   420,   421,   422,   394,   179,
    3582,  1480,   426,  2502,  1441,    22,   145,  2502,  2684,   307,
     308,    28,  2461,  2054,   194,  1982,   412,   346,   294,  1473,
    1474,   346,   307,   308,   204,   394,   165,  1481,   421,  1454,
    2089,  1485,  1486,   426,   280,   428,   349,   125,   351,    85,
     238,   429,   393,   412,  2793,   243,  1500,   313,  1502,   374,
     248,   247,   381,  2502,  2937,   238,   381,   426,    97,  2026,
     243,   141,   141,  1533,   393,   145,   145,  1521,   393,  1523,
    1687,   311,  1689,   265,   387,   356,   413,   414,   415,   316,
     417,   418,   419,   420,   421,   422,   414,   415,   265,   417,
     418,   419,   420,   421,   422,   278,  1575,   426,   424,   252,
     426,   426,   294,  2577,   257,   151,   298,   290,   348,   346,
    2050,   197,   200,   201,  1403,   348,  1405,   294,  1407,   145,
    1409,   426,  1411,   315,   304,   213,  1415,   207,   207,   360,
     425,   323,   757,   179,   759,   430,    97,   374,   315,   165,
     265,   766,   425,  2514,   381,   296,  2620,   430,   194,  2077,
     394,  2319,    85,   393,   394,   426,   393,   428,   204,     8,
     393,   394,    11,   313,   362,  2264,  2232,    78,   412,   294,
     250,   250,  3113,   371,  2473,  2474,  2475,   265,   421,    28,
    1731,   227,   426,   426,  1735,   428,   426,   370,   427,   426,
     315,   430,  1809,   426,  2235,   252,  2812,  2813,   323,  2698,
     257,   393,   424,  2698,   426,   165,   428,  1758,   417,   418,
     419,   420,   421,   422,     8,  1766,   265,    11,   151,  2891,
    2892,   393,   394,  2895,  1694,  2897,   173,   427,  1704,  2191,
     430,  2705,  3115,  3116,    28,  2144,    97,  2146,  2147,  1790,
      47,  2300,  1742,   109,  1744,   294,   179,   313,    43,  2698,
    1704,  3451,  2867,  1842,  3748,   311,   410,   411,   304,  1810,
     348,   194,   350,  3237,  3238,  3014,   315,  1688,   197,   427,
    3019,   204,   430,  3022,   323,     9,  2687,  2688,  1829,  2632,
    2339,  1832,  2341,     8,   430,   427,    11,  2409,   430,   393,
     394,    86,   348,  1772,   227,   931,   932,   427,  3505,  1850,
     430,  1890,     8,    28,   426,    11,   428,  1858,  1897,  1898,
    1899,  1900,  1901,  1902,   426,   110,  1867,   183,   349,   252,
     351,  1938,    28,  1874,   427,   426,  2825,   430,  2827,   349,
    2825,   351,  2827,  3533,   129,   426,   311,   393,   394,   589,
     590,   591,   191,   252,   594,   595,   596,  2287,  2288,   427,
    2290,   146,   430,  2852,   604,   427,   427,    47,   430,   430,
    2723,     8,   427,    37,    11,   430,   161,  2265,  2266,   427,
     426,   304,   430,   348,   240,   428,  2825,   427,  2827,   193,
     430,  1987,  1836,  1972,   427,   427,   409,   430,   430,    36,
    1844,   255,  1846,   427,    41,   255,   430,   191,  2991,   252,
     409,  2694,  3110,  2852,  2665,   254,  2975,  2668,  2669,  2670,
    2671,  2672,  2673,  2674,  2675,  2676,  2677,  1896,   393,   394,
    2009,   356,  2011,  2794,  2795,  1904,  2665,   252,   255,  2668,
    2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,  2367,
    2504,  2369,   427,   376,   427,   430,    37,   430,   243,  2389,
     316,   426,  1510,     5,   427,  1513,   251,   430,    10,   427,
     254,   130,   430,   409,  2725,  2726,   191,    19,  2805,  1923,
     427,   427,   141,   430,   430,  1954,   145,  1987,   427,   193,
     346,   430,   129,  3424,    36,   191,  2725,  2726,   283,   427,
     427,   419,   430,   430,  3468,   427,  3379,  1976,   430,   323,
     149,  1971,  1971,  1982,   427,  1941,   427,   430,   374,   430,
     427,  2439,   427,   430,   429,   381,   430,  1987,   187,   166,
    3403,  3404,  2581,   170,   426,    47,  2585,   393,  2587,   254,
    2589,  2590,   427,   427,   427,   430,   430,   430,   207,  2598,
     427,   427,   427,   430,   191,   192,   427,  2026,   254,   430,
     427,  2191,   429,  2493,  2888,  2495,  2755,   426,    81,   206,
     426,   689,   396,   691,   413,   414,   415,   426,   417,   418,
     419,   420,   421,   422,  2633,   427,   426,   428,   430,  2546,
     103,   250,     8,   428,   427,    11,   109,   430,   252,   258,
    2745,  2746,  2520,   205,   241,   427,  2213,   145,   430,   427,
    2054,   427,   430,  3352,   430,   427,  2534,   254,   430,   427,
      36,   134,   430,  2219,  2228,    41,   376,   252,  2258,   413,
     414,   415,   426,   417,   418,   419,   420,   421,   422,   247,
     313,   427,  3490,  2801,   430,   427,   427,   427,   430,   430,
     430,   427,   427,   893,   430,   430,   896,  2264,   898,  2568,
     900,  2570,   902,   197,  2582,   427,   906,   426,   430,   427,
     183,    59,   430,   427,  2174,   427,   430,  2607,   430,   427,
     427,   427,   430,   430,   430,  3558,  2937,   393,   427,   427,
     327,   430,   430,    31,   427,  3434,     0,   430,   413,   414,
     415,  2631,   417,   418,   419,   420,   421,   422,  2937,   427,
     369,   396,   430,   427,  2174,   426,   430,   413,   414,   415,
      37,   417,   418,   419,   420,   421,   422,  2645,  2188,   427,
     427,   365,   430,   430,  2275,   427,    37,   265,   430,  2214,
    2215,   427,   145,    71,   430,   281,  2664,  2207,   376,    18,
     166,   135,   135,   135,   170,    24,  3339,   426,   396,  2219,
    3249,   135,   135,   430,  3249,  3000,  2235,   135,  3121,   135,
     135,  2689,   252,   135,   135,   191,   192,    81,   135,   252,
     417,   418,   419,   420,   421,   422,   135,   135,   346,  2233,
     206,  2235,  3531,     0,    63,   426,    31,  3609,   205,  3611,
     146,   145,   145,   316,   426,  2723,     5,     5,   426,   426,
    3249,   426,  3301,   426,  2283,   274,   426,  3100,     5,   426,
     426,     5,  2363,   426,   130,   241,   130,   426,    11,  2370,
     426,   426,   426,   346,  2464,   141,   426,   141,   254,   145,
     426,   145,     5,   426,     5,   114,   150,   426,   426,   426,
     426,   155,   121,    36,   158,   124,   160,  2888,   426,   426,
     426,   374,  3301,   426,  3115,  3116,   426,   426,   381,   262,
      87,    31,   205,  2503,    81,   430,    31,   145,   250,   145,
     393,   187,   356,   187,   356,   428,  3115,  3116,   356,   356,
     356,   196,  2433,   252,   315,   356,   356,  3258,   243,   356,
     375,   207,    66,   207,   175,   252,   175,   356,  2515,   356,
     426,   327,   430,   426,   265,   315,    98,  2386,  2525,   356,
     376,   376,   356,   130,   265,   356,    47,  3251,    47,   356,
     426,   356,   256,  2540,   141,   311,   356,  2406,   145,   356,
     252,   356,   356,   150,   250,   356,   250,   356,   155,   252,
     191,   158,   258,   160,   258,   393,   426,  3516,   384,    31,
      30,   230,   426,   426,    20,   104,   376,  2563,   387,  2438,
     213,  2567,  2441,  2442,   386,   145,  2445,    31,   426,    31,
     187,  3030,   197,   312,  2591,   390,  2455,  2594,  3037,  3038,
     135,  2460,    26,    27,  3733,  2464,   265,   301,   414,   415,
     207,   417,   418,   419,   420,   421,   422,   376,   191,   192,
     135,   135,   376,  2609,   247,   135,   356,  3048,   381,   301,
    2464,  2951,  2952,   242,   150,  2632,  3158,  2471,  2472,   298,
    3383,   426,  2476,   389,  2503,   354,  3178,  2955,   409,   224,
      11,   430,   346,   250,   224,   323,   354,    81,  2517,    49,
     150,   258,  2496,   430,   323,   164,  2597,   356,   241,  2503,
     358,   164,   253,   369,   187,   369,   426,   248,   426,   103,
     356,  2612,   427,   427,   413,   109,  2545,  2546,  2538,  2538,
      80,  3664,   356,  3246,   311,    73,   390,   311,   392,   393,
     426,   356,   376,  2634,   301,   430,  2556,  2556,   430,   195,
     134,   195,   243,  2563,   426,   243,   243,  2567,   252,   259,
     356,    49,   430,  3043,  3044,  3045,   356,   294,  3479,   294,
     424,   427,   294,   427,   428,   429,   320,   356,  3379,   285,
     356,  3414,   191,  2740,  2741,    31,   191,   137,   191,   346,
     376,   191,    80,  3632,   376,   191,  3195,  3196,    30,   183,
    3379,   426,  3403,  3404,   251,   413,   356,   424,  2618,  2618,
     424,   356,   369,   356,   426,   145,  3772,   356,   168,   413,
     147,   248,   426,   320,  3403,  3404,    31,   252,   252,   162,
     162,   145,   430,   390,   426,   392,   393,    31,   135,   252,
     252,    21,   320,  3632,   145,   426,  2826,  2793,   170,   137,
     170,   170,   430,  3121,   396,    19,  3559,   156,   221,  3161,
     252,    47,   430,   427,   427,   427,   150,   424,   427,   427,
     427,   428,   429,   427,   427,   427,   427,   150,   261,   426,
     168,   427,    13,  2733,   417,   418,   419,   420,   421,   422,
    2709,   409,   430,   409,   356,  3299,    13,   426,    78,  3602,
     390,   427,   207,  3606,  3607,   252,   427,   255,  2799,   252,
    2735,  2736,  2737,  2738,   379,   427,   356,   426,    98,   427,
     427,   181,   426,  2733,   104,   427,  3194,   426,   243,   135,
    3563,   135,   316,  2752,   196,   196,  3204,   207,   269,   119,
     269,   373,  3222,  3223,  3618,  3225,  3603,   216,   298,   356,
     300,   216,   302,  3604,   191,   356,   191,  3558,   308,   216,
     191,  3360,   346,  3362,  3363,   315,   356,   147,  2925,  2860,
     356,  2862,   152,   323,  3373,   356,   356,   265,   158,  3558,
     356,   331,   356,   191,   191,     3,  2943,   424,   191,   339,
     374,   191,   427,   173,   222,   207,   314,   381,   427,    18,
     256,   385,   413,  2960,   365,    24,   294,  2826,    97,   393,
     298,   296,   426,   430,   302,   393,   252,   427,   198,   356,
     308,   251,   159,  2842,   194,  2841,  2845,   315,  2847,   427,
     248,   426,  2826,   260,   194,   323,   376,   426,   388,   311,
     376,   255,   426,   331,    63,   311,   133,  2841,   311,  3682,
     133,   339,   424,  2872,   127,   430,   150,   430,    11,  2878,
    2879,  2880,  2881,  2882,  2883,  3345,   145,   427,  3014,  2888,
     427,   427,  3026,  3019,   254,  3355,  3022,   386,    57,   150,
     426,   158,  3521,   427,   253,   427,  3581,   413,   427,  3357,
     145,   181,   427,   427,  2888,   114,   145,   365,   426,   191,
     388,   281,   121,   356,   427,   124,  2900,  2901,   356,  2928,
    2929,  2930,  2931,   365,   356,  3383,   356,  2911,   426,     8,
     427,   427,    11,   191,   427,   305,   195,   425,    31,   425,
     430,   311,   426,  3435,  2928,   393,   145,   317,  3795,   430,
     320,   396,   176,    69,   427,   356,   348,    36,   393,   430,
     426,   426,    41,  3455,   194,   426,   175,  3556,   320,   155,
     427,     8,   150,   427,    11,   150,   346,   426,   348,  2988,
     391,   391,   352,   427,    47,  3132,  3133,  3134,  3135,   430,
     360,  3161,   160,   427,   427,   365,   427,   150,  3587,    36,
     356,   365,   393,   243,    41,   375,   243,   413,   135,   191,
     111,   430,   243,   177,  3014,   430,   106,   387,   425,  3019,
      18,   230,  3022,    23,   152,    25,    24,   150,   376,    29,
     376,   122,   389,    33,    34,    35,    97,    37,   393,    39,
      40,   426,    42,     8,    44,    45,    11,   150,   426,   178,
     255,   426,   150,   426,   426,   380,   265,   332,  3177,  3178,
     427,   427,   392,   252,  3048,    63,   268,   290,   376,   427,
     393,    36,   145,   426,  3544,     8,    41,   426,    11,    31,
     427,   243,   217,   426,   173,   294,   134,   166,   308,   298,
     256,   170,   129,   308,   255,    59,    59,    47,   258,  3693,
     426,  3559,   145,    36,   252,  3224,   315,   348,    41,   140,
     282,   255,   191,   192,   323,   255,   114,   430,   117,  3200,
     380,    31,   150,   121,   390,   288,   124,   206,   430,   166,
    3211,   393,   122,   170,   252,   252,    31,   393,   426,   426,
    3170,   427,   427,  3613,  3602,   374,    17,  3156,  3606,  3607,
     307,   109,   426,   307,   191,   192,    28,   134,   282,  3165,
    1232,   426,   241,  1940,   129,    18,   166,   167,   168,   206,
     170,    24,   172,   173,   174,   254,   176,   175,   178,   686,
     180,  3165,   182,  2235,  2825,  3191,   186,   187,   188,  1059,
    1818,  2460,   731,  3471,  3249,  3342,   129,  3516,  3690,  3618,
    3789,   166,  2979,  3292,   241,   170,  3520,  3191,  2294,  2043,
      63,  3753,  3434,  3794,  3720,  3719,  3352,   254,  3202,  3203,
    2981,  3762,  1333,  3207,  3208,  1762,   191,   192,  3237,  3238,
    3540,  2852,   230,   166,  2401,  1319,  1928,   170,  2516,  3797,
    3858,   206,  3251,  3850,  3266,  3265,  3255,  3256,   327,  2466,
    3259,  3260,  2502,  3769,  3457,  1310,  3701,    28,   191,   192,
    3460,   114,   919,  3585,  3051,  3435,  2989,   265,   121,  3275,
    1786,   124,  2991,   206,  3664,   543,   241,  3852,  3778,  3506,
    1688,  3451,   664,  1689,  1394,  3455,  2972,  2619,  2244,   254,
     327,  3275,   679,  1088,  2255,    31,   294,  1724,  3434,  2267,
     298,  2261,  3311,  1723,  1107,  3305,  3305,  1106,   241,  1109,
    1707,  1681,  2219,    49,  1987,  2569,  3353,  3436,  3454,   536,
    2969,   254,   175,  2245,   669,   323,  2708,  3561,  1913,  3338,
    2700,  3742,  3746,  3743,   413,   414,   415,  2258,   417,   418,
     419,   420,   421,   422,    80,     8,  3493,  2188,    11,  2099,
    2186,  2066,  3352,    -1,  3490,  1557,    -1,    -1,    -1,    -1,
      -1,    -1,   327,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,  3521,    -1,    -1,   230,    41,    -1,
     417,   418,   419,   420,   421,   422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   327,  3531,    -1,    -1,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3530,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   294,  3451,    -1,    -1,   298,    -1,    -1,    -1,  3596,
      48,    -1,   417,   418,   419,   420,   421,   422,    -1,  3468,
      -1,   197,   315,  3472,    -1,    63,    -1,  3451,    -1,  3588,
     323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,   419,   420,   421,   422,
      -1,  3610,    -1,  3612,    -1,    -1,    -1,   497,    96,    -1,
      -1,    -1,   502,   166,   504,    -1,    -1,   170,   508,    -1,
     510,    -1,    -1,   513,    -1,   515,   114,   517,   518,    -1,
    3690,    -1,    -1,   121,    -1,   525,   124,   527,   191,   192,
      -1,    -1,    -1,    -1,    -1,    -1,   536,    -1,    -1,    -1,
      -1,    -1,   542,   206,    -1,    -1,   546,    -1,    -1,    -1,
     550,    -1,    -1,   553,    -1,    -1,   556,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,   302,    -1,    -1,    -1,
      -1,   571,   308,    -1,   172,   238,   576,   175,   241,   315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
    3726,   254,    -1,    -1,   257,   331,    -1,  3733,    -1,    -1,
      -1,    -1,    -1,   339,  3723,    -1,    -1,    -1,    -1,  3618,
      -1,    -1,    -1,   613,    -1,    -1,    -1,    -1,   618,  3755,
     218,    -1,   220,    -1,    -1,    -1,    -1,    -1,   628,   629,
      -1,    -1,   230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3759,    -1,    -1,    -1,    -1,    -1,   646,    -1,   648,   649,
      -1,   651,   388,   653,    -1,    -1,   392,   393,    -1,    -1,
      -1,    -1,    -1,    -1,   327,   665,   264,   265,    -1,   669,
      -1,    -1,   672,    -1,    -1,    -1,    -1,   677,     8,    -1,
      -1,    11,    -1,    -1,    -1,    31,    -1,   687,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   294,    -1,    28,    -1,
     298,   299,    -1,    49,    -1,    -1,    36,    -1,    -1,     8,
      -1,    41,    11,    -1,    -1,    -1,    -1,   315,  3854,    -1,
      -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    80,   333,    -1,    36,    -1,    -1,
     740,   741,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,    -1,   425,    -1,    -1,    -1,    -1,     8,   431,  3809,
      11,    -1,    -1,    -1,    -1,    -1,   776,    -1,  3778,  3778,
    3778,  3778,  3778,   783,    -1,    -1,   786,    -1,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    36,  3805,    -1,   798,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3809,
    3809,  3809,  3809,  3809,   814,   815,    -1,    -1,    -1,    -1,
      -1,  3805,   168,    -1,    -1,    -1,    -1,    -1,   828,   829,
     830,   831,    -1,   833,    -1,    -1,   166,    -1,    -1,    -1,
     170,  3850,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3858,
      -1,   197,  3852,  3852,  3852,  3852,  3852,    -1,   858,   859,
      -1,   191,   192,    -1,    -1,    -1,  3850,   166,    -1,    -1,
      -1,   170,    -1,    -1,  3858,    -1,   206,   877,    -1,    -1,
      -1,   881,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,
     890,    -1,   191,   192,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,   238,    -1,
      -1,   241,   912,   913,    -1,    28,    -1,   917,    -1,   919,
      -1,    -1,    -1,    36,   254,   166,    -1,   257,    41,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   937,    -1,   238,
     940,    -1,   241,   943,    -1,    -1,    -1,    -1,    -1,    -1,
     191,   192,   298,    -1,   954,   254,   302,    -1,   257,    -1,
      -1,    -1,   308,    -1,    -1,   206,    -1,    -1,    -1,   315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
      -1,    -1,   982,    -1,    -1,   331,    -1,    -1,    -1,    -1,
      -1,    -1,    73,   339,    -1,    -1,    -1,   327,    -1,    -1,
     241,    82,    83,    84,    -1,    -1,    -1,    -1,    -1,  1009,
    1010,    -1,  1012,   254,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,  1029,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   388,    -1,    -1,   126,   392,    -1,    -1,    -1,
      -1,  1051,    -1,   166,    -1,    -1,    -1,   170,  1058,  1059,
      -1,    -1,    -1,    -1,  1064,    -1,    -1,  1067,    -1,    -1,
      -1,    -1,  1072,    -1,  1074,    -1,    -1,    -1,   191,   192,
      -1,    -1,    -1,   413,   414,   415,   327,   417,   418,   419,
     420,   421,   422,   206,   175,    -1,    -1,    -1,    -1,  1099,
     430,    -1,    -1,  1103,  1104,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,  1124,   238,    -1,    -1,   241,    -1,
      -1,   430,    -1,    36,   215,    -1,    -1,    -1,    41,    -1,
      -1,   254,    -1,    -1,   257,    -1,  1146,    -1,    -1,    -1,
     231,   232,   233,   234,   235,    -1,   237,    -1,    -1,    -1,
    1160,    -1,    -1,    -1,    -1,     3,  1166,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,   417,   418,   419,   420,
     421,   422,     8,  1183,    -1,    11,    -1,    -1,   269,    -1,
      28,    -1,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    28,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,   327,    41,    -1,    -1,    -1,    -1,
    1220,  1221,  1222,  1223,  1224,    -1,   129,    -1,    -1,  1229,
      -1,  1231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1244,    -1,  1246,    -1,    -1,    -1,
      -1,    -1,  1252,  1253,    -1,    -1,    -1,    -1,  1258,    -1,
      -1,   342,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   368,   191,   192,
      -1,    -1,    -1,    -1,   375,    -1,    -1,   378,    -1,    -1,
     413,   414,   415,   206,   417,   418,   419,   420,   421,   422,
      -1,    -1,    -1,    -1,   427,    -1,  1316,    -1,    -1,    -1,
      -1,    -1,  1322,  1323,  1324,  1325,    -1,    -1,   166,    -1,
      -1,  1331,   170,    -1,    -1,    -1,    -1,    31,   241,  1339,
     166,    -1,    -1,    -1,   170,    -1,    -1,    -1,  1348,    -1,
    1350,   254,    -1,   191,   192,    49,    -1,  1357,    -1,  1359,
      -1,    -1,    -1,    -1,    -1,   191,   192,  1367,   206,    -1,
      -1,    -1,  1372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     206,  1381,    -1,  1383,    -1,    -1,    80,  1387,  1388,    21,
      -1,    -1,  1392,    -1,  1394,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,   241,   254,  1417,    -1,   257,
      -1,    53,    -1,    -1,   327,  1425,    -1,    -1,   254,  1429,
    1430,   257,    -1,    -1,    66,    -1,    -1,  1437,    -1,    -1,
      -1,  1441,    74,   137,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1454,  1455,    -1,    -1,  1458,    -1,
    1460,    -1,  1462,    -1,    -1,    -1,    98,    -1,    -1,  1469,
      -1,    -1,  1472,    -1,   168,  1475,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1483,  1484,    -1,    -1,   119,    -1,   327,
      -1,  1491,    -1,  1493,  1494,  1495,  1496,  1497,    -1,    -1,
      -1,   327,    -1,   197,  1504,  1505,    -1,  1507,    -1,  1509,
      -1,    -1,  1512,    -1,   417,   418,   419,   420,   421,   422,
     152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1528,    -1,
      -1,    -1,  1532,    -1,     8,    -1,  1536,    11,    -1,    -1,
    1540,   173,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,    -1,  1552,    -1,    28,    -1,  1556,  1557,    -1,  1559,
      -1,    -1,    36,    -1,    -1,  1565,   198,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,    -1,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,    -1,    -1,
      -1,   427,    -1,    -1,   298,    -1,    -1,    -1,   302,    -1,
       8,    -1,    -1,    11,   308,    -1,    -1,    -1,    -1,    -1,
      -1,   315,   254,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      28,    -1,    -1,    -1,    -1,    -1,    -1,   331,    36,    -1,
      -1,    -1,    -1,    41,    -1,   339,    -1,    -1,    -1,   281,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   305,    -1,    -1,    -1,   309,    -1,   311,
    1680,    -1,    28,    -1,    -1,   317,    -1,  1687,    -1,  1689,
      36,  1691,   166,    -1,   388,    41,   170,    -1,   392,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   346,    -1,   348,   191,   192,    -1,
     352,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,    -1,
      -1,  1731,   206,   365,    -1,  1735,  1736,    -1,    -1,    -1,
      -1,    -1,  1742,    -1,  1744,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,  1758,  1759,
      -1,    -1,    -1,    -1,   238,    -1,  1766,   241,   166,    -1,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     254,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,
    1790,    -1,  1792,   191,   192,    -1,    -1,    -1,  1798,    -1,
      -1,    -1,    -1,  1803,    -1,    -1,    -1,    -1,   206,  1809,
    1810,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     166,    -1,  1822,  1823,   170,    -1,    -1,    -1,  1828,  1829,
      -1,    -1,  1832,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     238,    -1,  1842,   241,    -1,   191,   192,    -1,    -1,    -1,
    1850,    -1,    -1,   327,  1854,    -1,   254,    -1,  1858,   257,
     206,    -1,    -1,    -1,    -1,    -1,     7,  1867,    -1,    -1,
      -1,    -1,    13,    14,  1874,    -1,    -1,    -1,    -1,    20,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,
    1890,    -1,   238,    -1,    -1,   241,    -1,  1897,  1898,  1899,
    1900,  1901,  1902,    -1,    -1,    -1,    -1,    48,   254,    -1,
      -1,   257,  1912,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,
      -1,    -1,    -1,    -1,  1934,    -1,    -1,    -1,  1938,   413,
     414,   415,  1942,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1966,    -1,    -1,    -1,
      -1,    -1,  1972,  1973,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   327,  1982,    -1,    -1,    -1,    -1,  1987,  1988,    -1,
      -1,    -1,  1992,  1993,    -1,    -1,    -1,  1997,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2009,
    2010,  2011,  2012,    -1,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,    -1,  2026,    -1,    -1,   427,
      -1,  2031,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
     181,    -1,   183,  2043,   185,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,  2059,
      -1,    11,    -1,    -1,    -1,    -1,  2066,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,    -1,    28,    -1,
      -1,   427,    -1,    -1,    -1,     8,    36,  2087,    11,    -1,
      -1,    41,    -1,    -1,    -1,    -1,     8,  2097,  2098,    11,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    28,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,  2127,  2128,    41,
      -1,    -1,  2132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2144,  2145,  2146,  2147,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2156,    -1,    -1,  2159,
      -1,  2161,  2162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2171,  2172,    -1,  2174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2187,    -1,  2189,
      -1,  2191,    -1,  2193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2209,
      -1,    -1,    -1,  2213,    -1,    -1,   166,    -1,    -1,  2219,
     170,  2221,  2222,  2223,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2235,    -1,    -1,  2238,    -1,
      -1,   191,   192,   166,  2244,    -1,  2246,   170,    -1,    -1,
      -1,    -1,    -1,    -1,   166,  2255,   206,    -1,   170,    -1,
    2260,    -1,    -1,    -1,  2264,    -1,    -1,  2267,   191,   192,
      -1,    -1,    -1,    -1,    -1,  2275,    -1,    -1,    -1,   191,
     192,    -1,    -1,   206,    -1,    -1,    -1,    -1,   238,    -1,
      -1,   241,    -1,  2293,   206,  2295,    -1,    -1,    -1,  2299,
      -1,    -1,    -1,    -1,   254,    -1,   804,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   241,
      -1,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2363,   505,    -1,    -1,    -1,    -1,    -1,
    2370,    -1,    19,    -1,    -1,    -1,    -1,   327,   519,   520,
      -1,    -1,    -1,   524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   327,    -1,   547,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,   559,    -1,
      -1,   562,    -1,   564,    -1,   566,    73,    -1,    -1,   927,
      -1,    -1,    -1,  2433,    -1,    82,    83,    84,    -1,    -1,
      -1,    -1,    -1,  2443,  2444,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     601,    -1,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,   427,    -1,   126,
      -1,    -1,    -1,   624,    -1,   626,    -1,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      -1,   413,   414,   415,   427,   417,   418,   419,   420,   421,
     422,    -1,    -1,   425,  2514,  2515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   170,    -1,  2525,    -1,    -1,   175,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   679,    -1,
    2540,    -1,    -1,    -1,    -1,    -1,  2546,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1054,  2557,    -1,    -1,
    2560,    -1,    -1,  2563,    -1,    -1,    -1,  2567,   215,    -1,
      -1,    -1,    -1,  2573,    -1,    -1,  2576,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   231,   232,   233,   234,   235,    -1,
     237,  2591,    -1,    -1,  2594,    -1,    -1,  2597,    -1,    -1,
      -1,  2601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2609,
      -1,    -1,  2612,    -1,    -1,    -1,  1114,    -1,    -1,  2619,
      -1,    -1,   269,    -1,    -1,    -1,   767,    -1,    -1,    -1,
      -1,    -1,  2632,    -1,  2634,    -1,    -1,    -1,   779,    -1,
      -1,    -1,  2642,    -1,    -1,    -1,    -1,   788,    -1,    -1,
      -1,  2651,    -1,   794,    -1,    -1,  1154,  2657,   305,  2659,
      -1,    -1,    -1,    -1,   805,  2665,    -1,    -1,  2668,  2669,
    2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,    -1,    -1,
      -1,  2681,  2682,  1181,     8,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,   834,  2694,   342,    -1,   344,    -1,    -1,
    2700,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
    2710,    -1,    36,  2713,    -1,  2715,    -1,    41,    -1,    -1,
      -1,   368,    -1,    -1,  2724,  2725,  2726,    -1,   375,    -1,
    2730,   378,    -1,  2733,    -1,    -1,    -1,    -1,    -1,    -1,
    2740,  2741,    -1,  2743,    -1,    -1,    -1,    -1,    -1,  2749,
    1248,  2751,    -1,  2753,   895,    -1,   897,    -1,   899,    -1,
     901,  2761,   903,   904,   905,    -1,    -1,  1265,    -1,   910,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1285,    -1,    -1,
      -1,    -1,    -1,  2793,  2794,  2795,    -1,    -1,    -1,  2799,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2818,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1356,    -1,
    2860,    -1,  2862,    -1,    -1,    -1,    -1,   191,   192,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,  2888,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,   241,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2925,    -1,    -1,    -1,    -1,
     254,    -1,    -1,   257,    -1,    -1,    -1,  2937,    -1,    -1,
      -1,    -1,    -1,  2943,    -1,    -1,    -1,  1088,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
    2960,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2969,
      -1,    -1,    -1,    -1,    -1,  2975,    28,    -1,    -1,  2979,
      -1,  2981,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,
      -1,    -1,  2992,  2993,    -1,  1136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,
    3010,    -1,    -1,    -1,  3014,    -1,    -1,    -1,    -1,  3019,
      -1,    -1,  3022,  3023,    -1,  3025,    -1,    -1,    -1,  1527,
      -1,    -1,  3032,    -1,  3034,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3051,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,  3064,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
    3100,    -1,    -1,   427,    -1,    -1,    -1,  3107,  3108,    -1,
      -1,    -1,    -1,    -1,   166,  3115,  3116,    -1,   170,    -1,
    3120,    -1,    -1,    -1,    -1,    -1,  3126,  3127,    -1,    -1,
    3130,    -1,  3132,  3133,  3134,  3135,    -1,    -1,    -1,   191,
     192,  3141,    -1,    -1,    -1,    -1,    -1,  3147,    -1,    -1,
      -1,    -1,    -1,  3153,   206,    -1,    -1,    -1,    -1,    -1,
      -1,  3161,    -1,    -1,    -1,    -1,   166,  1308,    -1,    -1,
    3170,    -1,   172,  3173,    -1,    -1,    -1,  3177,  3178,  1320,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   241,
      -1,    -1,  3192,    -1,    -1,    -1,    -1,   166,    -1,    -1,
    3200,   170,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,
      -1,  3211,    -1,    -1,    -1,    -1,    -1,  1358,    -1,    -1,
      -1,  1362,   191,   192,  3224,    -1,    -1,    -1,    -1,    -1,
    1371,    -1,  1373,    -1,  1375,    -1,    -1,   206,    -1,  1380,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,  3251,    -1,    -1,    -1,    -1,    -1,    -1,  3258,    -1,
      -1,    -1,  1403,    28,  1405,    -1,  1407,    -1,  1409,   238,
    1411,    36,   241,    -1,  1415,   327,    41,    -1,    -1,    -1,
      -1,    -1,  1780,    -1,    -1,   254,    -1,  1785,  1786,    -1,
      -1,  3291,    -1,    -1,    -1,    -1,    -1,    -1,  1796,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3342,    -1,    -1,    -1,    -1,    -1,  3348,    -1,
      -1,    -1,  3352,    -1,    -1,  3355,     8,    -1,   327,    11,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    -1,    -1,    -1,  3374,   427,    28,    -1,    -1,  3379,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    -1,  3403,  3404,   170,    -1,  3407,    -1,    -1,
      -1,    -1,    -1,    -1,  3414,  3415,  1914,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,   192,  3428,    -1,
    3430,    -1,    -1,    -1,  3434,  3435,  3436,    -1,    -1,    -1,
      -1,   206,    -1,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,  3454,  3455,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,   241,    -1,    -1,  3479,
      -1,  1979,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
    3490,    -1,   257,  3493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   504,  3505,    -1,  3507,    -1,    -1,
       8,    -1,    -1,    11,   166,    -1,  3516,    -1,   170,    -1,
      -1,  3521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3530,  3531,    -1,    -1,    -1,    -1,    -1,    -1,    36,   191,
     192,    -1,    -1,    41,    -1,    -1,   546,    -1,    -1,    -1,
      -1,    -1,    -1,   553,   206,    -1,    -1,    -1,  3558,    -1,
      -1,  3561,   327,  3563,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3576,    -1,    -1,  2077,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,  3588,   241,
      -1,  1732,    -1,    -1,    -1,    -1,  3596,  1738,    -1,  3599,
      -1,    -1,   254,    -1,    -1,   257,    -1,  1748,    -1,  3609,
    3610,  3611,  3612,    -1,  1755,    -1,    -1,    -1,  3618,    -1,
    1761,    -1,    -1,    -1,    -1,    -1,  1767,    -1,    -1,    -1,
      -1,  1772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3639,
      -1,    -1,    -1,    -1,    -1,    -1,   646,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,  1799,  1800,
    1801,  1802,   427,    -1,    -1,  1806,  1807,    -1,   166,    -1,
    1811,    -1,   170,  1814,    -1,   327,    -1,   677,    -1,    -1,
      -1,    -1,  3682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3690,    -1,  1833,   191,   192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1843,    -1,  1845,    -1,    -1,    -1,   206,    -1,
      -1,    -1,    -1,    -1,  1855,  1856,  1857,    -1,  1859,    -1,
      -1,    -1,    -1,  3723,    -1,    -1,  3726,  1868,  1869,    -1,
      -1,    -1,    -1,  3733,    -1,  1876,  1877,    -1,    -1,    -1,
     238,    -1,  3742,   241,    -1,  3745,  3746,    -1,  3748,    -1,
      -1,     8,    -1,    -1,    11,  3755,   254,    -1,    -1,  3759,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    28,    -1,    -1,    -1,   427,   776,    -1,    -1,    36,
      -1,  3781,    -1,   783,    41,    -1,    -1,    -1,    -1,    -1,
      -1,  3791,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   804,  3805,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2321,  2322,    -1,  2324,    -1,    -1,   327,
      28,    -1,    -1,   833,    32,    -1,    -1,    -1,    36,    -1,
      -1,    -1,    -1,    41,    -1,  3845,    -1,    -1,    -1,    -1,
    3850,    -1,    -1,    -1,  3854,    -1,    -1,    -1,  3858,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2367,
      -1,  2369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,   170,   112,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,    -1,    -1,   927,    -1,    -1,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,  2439,  2083,    -1,    -1,    -1,    -1,    -1,    -1,   206,
      -1,    -1,    -1,    -1,   954,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2464,    -1,   166,    -1,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   238,   982,    -1,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,   192,    -1,    -1,   254,    -1,    -1,
     257,    -1,    -1,    -1,    -1,  2503,    -1,    -1,   206,  1009,
    1010,    -1,  1012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2520,    -1,    -1,    -1,    -1,    -1,    -1,  1029,
      -1,    -1,    -1,    -1,    -1,    -1,  2534,    -1,    -1,    -1,
     238,    -1,    -1,   241,    -1,    -1,    -1,    -1,    21,  2547,
      -1,    -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,   257,
      33,    -1,    -1,    -1,    -1,    -1,    -1,  1067,  1068,    -1,
     327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      53,    -1,    -1,    -1,  2582,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1099,
      -1,    -1,    -1,  1103,  1104,    78,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,  1114,    11,    -1,    -1,    -1,  1119,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   327,
      -1,    -1,    28,    -1,    -1,  2276,  2277,    -1,   804,    -1,
      36,    -1,    -1,    -1,    -1,    41,   119,  2645,    -1,    -1,
      -1,    -1,    -1,    -1,  1154,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,  2664,  2308,    -1,    -1,
     427,    -1,    -1,    -1,   147,    -1,    -1,    -1,   376,   152,
      -1,  1181,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,
      -1,  2689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173,  2342,  2343,  2344,  2345,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,  2723,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,  1248,   145,
      -1,    -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,    -1,
      -1,   927,    -1,    28,    -1,  1265,    -1,    -1,    -1,    -1,
     166,    36,    -1,    -1,   170,    -1,    41,    -1,    -1,    -1,
      -1,   254,    -1,    -1,    -1,  1285,    -1,    -1,  2429,    -1,
      -1,   264,    -1,  2434,    -1,   191,   192,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1307,   281,    -1,
     206,    -1,  1312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2826,    -1,
      -1,    -1,   305,    -1,    -1,    -1,   309,    -1,   311,    -1,
      -1,    -1,   238,    -1,   317,   241,    -1,   320,  1348,    -1,
    1350,    -1,    -1,    -1,    -1,    -1,  1356,    -1,   254,  1359,
      -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   346,    -1,   348,    -1,    -1,    -1,   352,
    2521,  2522,    -1,    -1,    -1,    -1,    -1,   360,    -1,    -1,
      -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,   375,    -1,    -1,   170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1425,   191,   192,    -1,    -1,
      -1,   327,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,   206,  2583,    -1,    -1,    -1,    -1,    -1,  1114,    -1,
      -1,    -1,    -1,    28,    -1,  2596,    -1,  2955,    -1,    -1,
    1460,    36,  1462,    -1,    -1,    -1,    41,    -1,    -1,  1469,
      -1,    -1,  1472,   238,    -1,  1475,   241,    -1,    -1,    -1,
      -1,    -1,    -1,  1483,  1484,    -1,    -1,   804,  1154,   254,
      -1,  1491,   257,  2991,  1494,  1495,  1496,  1497,    -1,    -1,
      -1,    -1,    -1,    -1,  1504,  1505,    -1,  1507,    -1,  1509,
     275,    -1,  1512,    -1,    -1,  1181,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,  1527,  1528,  1529,
      -1,    -1,  1532,    -1,    -1,    -1,  1536,    -1,    -1,    -1,
    1540,    -1,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,    -1,  1552,    -1,    -1,    -1,    -1,  1557,    -1,  1559,
      -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,   144,
      -1,    -1,    -1,    -1,    -1,   340,    -1,    -1,    -1,    -1,
      -1,    -1,  1248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,  1265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     927,    -1,  3110,    -1,    -1,    -1,   191,   192,    -1,  1285,
      -1,    -1,    -1,  3121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1307,    -1,    -1,    -1,    -1,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,   241,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,  2816,    -1,    11,    -1,   254,
      -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1356,  1691,    -1,    -1,    28,    -1,  3194,    31,   273,    -1,
      -1,    -1,    36,    -1,    -1,    -1,  3204,    41,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2856,    -1,    -1,    -1,    -1,
    2861,    -1,  2863,  2864,  2865,  2866,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1734,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,  1759,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1780,    -1,    -1,    -1,    -1,  1785,  1786,    -1,    -1,    -1,
      -1,  2932,  2933,  2934,    -1,  2936,  1796,  1114,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   166,    -1,    -1,    -1,   170,  1154,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,  1849,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,  3357,
      -1,  1527,    -1,    -1,  1181,    -1,    -1,  3008,    -1,    -1,
      -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3383,  3027,    -1,    -1,    -1,
      -1,    -1,    -1,  1559,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,   241,    -1,    -1,
      -1,    -1,  1912,    -1,  1914,    -1,    -1,    -1,   646,    -1,
     254,    -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1265,   677,
      -1,    -1,    -1,  3451,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1979,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1987,    -1,    -1,
    1307,    -1,    -1,   327,    -1,    -1,    -1,  1997,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2031,    -1,    -1,    -1,  3533,    -1,    28,    -1,  1356,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3201,  3559,    -1,    -1,    -1,    -1,  2066,    -1,    -1,    -1,
      -1,  3212,    -1,    -1,    -1,    -1,    -1,  2077,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2097,  2098,    -1,
      -1,    -1,    -1,    -1,  3602,    -1,    -1,    -1,  3606,  3607,
      -1,    -1,    -1,    -1,  1780,    -1,    -1,    -1,    -1,  1785,
    1786,    -1,    -1,    -1,    -1,    -1,    -1,  2127,  2128,    -1,
    1796,    -1,  2132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2144,  2145,  2146,  2147,    -1,    -1,
      -1,    -1,  2152,    -1,    -1,    -1,  2156,  2157,    -1,  2159,
      -1,  2161,    -1,    -1,    -1,    -1,  3307,    -1,    -1,    -1,
      -1,  2171,  2172,    -1,  2174,   166,    -1,    -1,    -1,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2187,  3329,  2189,
      -1,    -1,    -1,  2193,    -1,    -1,    -1,    -1,    -1,    -1,
     191,   192,    -1,    -1,    -1,    -1,    -1,    -1,     8,  2209,
    1527,    11,    -1,    -1,    -1,   206,    -1,    -1,    -1,  2219,
      -1,  2221,  2222,  2223,    -1,  3366,   954,    -1,    28,    -1,
      -1,    31,    -1,    -1,    -1,    -1,    36,    -1,  2238,    -1,
      -1,    41,    -1,    -1,    -1,    -1,  2246,   238,  1914,    -1,
     241,    -1,    -1,    -1,   982,  2255,    -1,    -1,    -1,    -1,
    2260,    -1,    -1,   254,    -1,    -1,   257,  2267,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   270,
      -1,  1009,  1010,    -1,  1012,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2293,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1029,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1979,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2321,  2322,    -1,  2324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,  1067,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   166,  2367,    -1,  2369,
     170,  1099,    -1,    -1,    -1,  1103,  1104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,   804,    -1,    -1,  3539,    -1,
    2400,  2401,  2402,    -1,    -1,    -1,   206,    -1,    -1,    -1,
      -1,  2077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,    -1,    -1,    -1,    -1,    -1,    -1,   238,  2439,
      -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,    -1,
      -1,  2461,    -1,  1780,  2464,    -1,    -1,    -1,  1785,  1786,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1796,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2502,  2503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   927,    -1,
    2520,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,
      -1,    -1,    -1,    -1,  2534,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2547,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2221,  2222,  2223,    -1,    -1,
      -1,    -1,    -1,  2563,    -1,    -1,    -1,  2567,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2576,    -1,    -1,    -1,
    3721,    -1,  2582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1914,    -1,   804,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2609,
      -1,   804,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2642,    -1,    -1,  2645,    -1,    -1,    -1,    -1,
      -1,  2651,    -1,    -1,    -1,  2321,  2322,  2657,  2324,  2659,
      -1,    -1,  1979,    -1,  2664,  2665,    -1,    -1,  2668,  2669,
    2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,    -1,    -1,
      -1,  2681,  2682,    -1,    -1,    -1,    -1,    -1,    -1,  2689,
      -1,    -1,    -1,    -1,  2694,    -1,    -1,    -1,  2698,    -1,
    2700,  2367,    -1,  2369,    -1,  1114,    -1,    -1,    -1,    -1,
    2710,    -1,    -1,  2713,    -1,  2715,    -1,    -1,    -1,    -1,
      -1,    -1,   927,  2723,  2724,  2725,  2726,    -1,    -1,    -1,
    2730,    -1,    -1,  2733,   927,    -1,    -1,    -1,    -1,    -1,
      -1,  1469,    -1,  2743,    -1,  1154,    -1,    -1,    -1,    -1,
      -1,  2751,    -1,  2753,    -1,    -1,    -1,    -1,    -1,    -1,
    2077,    -1,    -1,  1491,    -1,    -1,  1494,    -1,    -1,  1497,
      -1,    -1,  1181,  2439,    -1,    -1,  1504,  1505,    -1,    -1,
      -1,  1509,    -1,    -1,  1512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2793,    -1,    -1,    -1,    -1,  2464,    -1,
    1528,    -1,    -1,    -1,  1532,    -1,    -1,    -1,  1536,    -1,
      -1,    -1,  1540,    -1,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,    -1,  1552,  2825,  2826,  2827,    -1,  1557,
      -1,  1559,    -1,    -1,    -1,    -1,    -1,  2503,    -1,  1248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2852,    -1,  2520,    -1,  1265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2534,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1285,    -1,    -1,    -1,
      -1,  2547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1307,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1114,
    2576,    -1,    -1,    -1,    -1,    -1,  2582,    -1,    -1,    -1,
      -1,  1114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2937,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1356,    -1,  1154,
      -1,    -1,    -1,    -1,    -1,  2955,    -1,    -1,    -1,    -1,
      -1,  1154,    -1,  1691,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1181,    -1,    -1,  2645,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1181,    -1,
      -1,  2991,  2992,  2993,    -1,    -1,    -1,    -1,  2664,    -1,
      -1,    -1,    -1,    -1,  2321,  2322,    -1,  2324,    -1,    -1,
      -1,    -1,    -1,    -1,  3014,    -1,    -1,    -1,    -1,  3019,
      -1,    -1,  3022,  2689,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1759,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1248,    -1,    -1,    -1,    -1,    -1,    -1,
    2367,    -1,  2369,    -1,    -1,  1248,    -1,  2723,    -1,    -1,
    1265,    -1,    -1,    -1,  3064,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1285,    -1,    -1,    -1,    -1,    -1,    -1,  2753,    -1,    -1,
      -1,    -1,  1285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3100,    -1,  1307,    -1,    -1,    -1,    -1,  3107,  3108,    -1,
    3110,    -1,    -1,    -1,  1307,  3115,  3116,    -1,  1527,    -1,
    3120,  3121,  2439,    -1,    -1,    -1,  3126,  3127,    -1,    -1,
    3130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3141,    -1,    -1,    -1,    -1,    -1,  2464,    -1,    -1,
      -1,  1356,    -1,  3153,    -1,    -1,    -1,    -1,    -1,    -1,
    2826,    -1,    -1,  1356,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1912,    -1,  2503,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2520,  3204,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,  2534,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
    2547,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3249,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2582,    -1,    -1,    -1,  1997,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   804,    -1,    -1,  2955,
      -1,  3291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3301,    -1,  2031,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1527,    -1,    -1,  2991,    -1,    -1,  2645,    -1,
      -1,    -1,    -1,    -1,  1527,    -1,    -1,    -1,  2066,  3339,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2664,  3348,   150,
      -1,    -1,  3352,    -1,    -1,    -1,    -1,  3357,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
    2098,  1780,  2689,    -1,    -1,    -1,  1785,  1786,    -1,  3379,
      -1,    -1,    -1,  3383,    -1,    -1,    -1,  1796,    -1,    -1,
     191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3403,  3404,   206,  2723,  3407,    -1,   927,
      -1,    -1,    -1,    -1,  3414,  3415,  2144,    -1,  2146,  2147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2156,    -1,
      -1,  2159,    -1,  2161,  3434,    -1,    -1,   238,    -1,    -1,
     241,    -1,    -1,    -1,  3110,    -1,     8,    -1,    -1,    11,
      -1,  3451,    -1,   254,  3454,  3121,   257,    -1,    -1,  2187,
      -1,  2189,    -1,    -1,    -1,  2193,    28,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    36,  3141,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3153,    -1,    -1,
    3490,    -1,    -1,  2221,  2222,  2223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1914,    -1,    -1,    -1,  2826,
    2238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   327,  2255,  3194,    -1,
      -1,  3531,  2260,  3533,    -1,    -1,    -1,    -1,  3204,  2267,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3558,  3559,
      -1,  3561,    -1,  3563,    -1,  2293,    -1,    -1,    -1,    -1,
    1979,    -1,    -1,    -1,    -1,  1780,    -1,    -1,    -1,    -1,
    1785,  1786,    -1,    -1,   804,    -1,    -1,  1780,    -1,    -1,
      -1,  1796,  1785,  1786,    -1,    -1,  1114,    -1,    -1,  3599,
      -1,    -1,  3602,  1796,   166,    -1,  3606,  3607,   170,    -1,
      -1,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
     192,    -1,  3632,    -1,    -1,    -1,  1154,    -1,  2955,  3639,
      -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1181,  3664,    -1,    -1,    -1,  2077,    -1,
      -1,    -1,    -1,  3339,  2991,    -1,   238,    -1,    -1,   241,
      -1,    -1,  3682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3357,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   927,    -1,  1914,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3383,    -1,    -1,
      -1,  1914,    -1,    -1,    -1,    -1,  3726,    -1,    -1,    -1,
    1248,    -1,    -1,  3733,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3745,  3746,  1265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3755,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   327,    -1,  1285,    -1,    -1,
      -1,    -1,    -1,    -1,  1979,    -1,    -1,    -1,    -1,    -1,
      -1,  3781,    -1,    -1,    -1,  3451,  1979,    -1,    -1,  1307,
      -1,  3791,    -1,  3110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3121,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,  1356,    -1,
      -1,    41,    -1,    -1,    -1,  3845,    -1,    -1,  2576,    -1,
      -1,   413,   414,   415,  3854,   417,   418,   419,   420,   421,
     422,    -1,    -1,    -1,    -1,    -1,    -1,  3533,    -1,    -1,
      -1,    -1,  2077,    -1,    -1,    -1,    -1,  3194,    -1,    -1,
      -1,    -1,    -1,    -1,  2077,    -1,    -1,  3204,    -1,    -1,
      -1,    -1,    -1,  3559,  1114,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2321,  2322,  2642,  2324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2651,    -1,    -1,    -1,    -1,    -1,  2657,
      -1,  2659,    -1,    -1,  1154,    -1,  3602,    -1,    -1,    -1,
    3606,  3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2681,  2682,    -1,     8,    -1,  2367,    11,
    2369,  1181,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,  2700,    -1,    -1,    -1,    28,    -1,    -1,    31,
      -1,    -1,  2710,    -1,    36,  2713,    -1,  2715,    -1,    41,
      -1,   191,   192,    -1,    -1,    -1,  2724,    -1,  3664,    -1,
      -1,    -1,  2730,    -1,    -1,  2733,   206,    -1,    -1,  1527,
      -1,    -1,    -1,    -1,    -1,  2743,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2751,    -1,  2753,    -1,    -1,  1248,    -1,
    2439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
    3357,   241,    -1,    -1,    -1,  1265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   254,  2464,    -1,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1285,  3383,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1307,    -1,    -1,
      -1,    -1,    -1,    -1,  2503,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2520,    -1,    -1,   166,    -1,  2321,  2322,   170,  2324,
      -1,    -1,    -1,    -1,    -1,  2534,    -1,   327,  2321,  2322,
      -1,  2324,    -1,    -1,  3451,    -1,  1356,    -1,  2547,   191,
     192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   353,   206,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2367,    -1,  2369,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2582,  2367,    -1,  2369,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   254,    -1,    -1,   257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   413,   414,   415,  3533,   417,   418,   419,
     420,   421,   422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2439,    -1,  2645,    -1,    -1,    -1,
      -1,    -1,  3559,    -1,    -1,    -1,  2439,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,  2664,    11,    -1,    -1,  2464,
      -1,    -1,  1780,    -1,  2992,  2993,    -1,  1785,  1786,    -1,
      -1,  2464,    -1,    28,    -1,   327,    -1,    -1,  1796,    -1,
    2689,    36,    -1,    -1,    -1,  3602,    41,    -1,    -1,  3606,
    3607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2503,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1527,    -1,    -1,
    2503,    -1,    -1,    -1,  2723,  2520,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2520,    -1,  2534,
      -1,    -1,    -1,    -1,    -1,    -1,  3064,    -1,    -1,    -1,
      -1,  2534,  2547,    -1,    -1,    -1,    -1,    -1,  1025,    -1,
      -1,    -1,    -1,    -1,  2547,    -1,    -1,    -1,    -1,    -1,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,    -1,    -1,    -1,    -1,    -1,    -1,  2582,    -1,  3107,
    3108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2582,
      -1,    -1,  3120,    -1,    -1,    -1,  1914,    -1,  3126,  3127,
      -1,    -1,  3130,    -1,    -1,    -1,    -1,  1084,    -1,    -1,
      -1,   166,    21,  3141,    -1,   170,    -1,  2826,    -1,    -1,
      -1,    -1,    -1,    -1,    33,  3153,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
    2645,    -1,    -1,    -1,    53,  3173,    -1,    -1,    -1,    -1,
      -1,   206,  2645,    -1,    -1,    -1,    -1,    -1,    -1,  2664,
      -1,  1979,    -1,    -1,    -1,    74,    -1,    -1,    -1,    78,
      -1,  2664,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,  2689,    -1,   241,    -1,    -1,    98,
      -1,    -1,    -1,    -1,    -1,   104,  2689,    -1,    -1,   254,
      -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2723,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2723,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,    -1,
      -1,    -1,    -1,    -1,    -1,   154,  2955,    -1,    -1,   158,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2077,
    1780,    -1,    -1,  3291,   173,  1785,  1786,    -1,    -1,    -1,
      -1,    -1,   327,    -1,    -1,    -1,  1796,    -1,    -1,    -1,
      -1,    -1,  2991,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3348,  2826,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2826,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,   257,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3415,    -1,    -1,
      -1,    -1,    -1,    -1,  1914,    -1,   305,    -1,    -1,    -1,
      -1,  3110,   311,    -1,    -1,    -1,    -1,    -1,   317,    -1,
      -1,   320,  3121,  1390,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,    -1,   348,
     349,    -1,   351,   352,    -1,    -1,    -1,    -1,    -1,    -1,
    2955,   360,    -1,    -1,    -1,    -1,   365,    -1,    -1,  1979,
      -1,   370,  2955,    -1,    -1,    -1,   375,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   387,    -1,
      -1,    -1,    -1,    -1,    -1,  3194,  2991,    -1,    -1,    -1,
    1467,    -1,    -1,    -1,    -1,  3204,    -1,    -1,  2991,    -1,
      -1,    -1,    -1,  2321,  2322,    -1,  2324,    -1,    -1,    -1,
      -1,    -1,    -1,  1490,    -1,    -1,    -1,    -1,  1495,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3561,    -1,    -1,    -1,  1514,  1515,    -1,
    1517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2367,
      -1,  2369,    -1,    -1,    -1,    -1,    -1,  2077,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3599,    -1,    -1,    -1,    -1,    -1,    -1,  1555,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3110,    -1,    -1,    -1,    -1,
      -1,  3639,    -1,  1590,    -1,    -1,  3121,  3110,    -1,    -1,
      -1,  2439,    -1,    -1,    -1,    -1,    -1,    -1,  3121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2464,    -1,  3357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2503,    -1,    -1,    -1,  3194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3204,
      -1,  3194,  2520,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3204,    -1,    -1,    -1,    -1,  2534,  3745,  3746,    -1,
      -1,    -1,    -1,  1700,    -1,    -1,    -1,    -1,    -1,  2547,
      -1,    -1,    -1,  1710,    -1,    -1,  1713,    -1,    -1,    -1,
      -1,    -1,  3451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3781,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3791,  2582,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2321,  2322,    -1,  2324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3845,    -1,    -1,
      -1,    -1,    -1,    -1,  3533,    -1,    -1,  2645,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2664,  2367,    -1,  2369,
    3559,    -1,  3357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3357,    -1,    -1,    -1,    -1,    -1,
      -1,  2689,    -1,    -1,    -1,    -1,    -1,    -1,  3383,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3383,    -1,    -1,  3602,    -1,    -1,    -1,  3606,  3607,    -1,
      -1,    -1,    -1,    -1,    -1,  2723,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2464,    -1,  3451,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3451,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2520,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2826,    -1,
      -1,    -1,    -1,    -1,  2534,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2547,  3533,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3559,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2582,    -1,    -1,    -1,  3559,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,    -1,    -1,
      -1,  3606,  3607,    -1,    -1,    -1,    -1,    -1,    -1,  3602,
      -1,    -1,    -1,  3606,  3607,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2101,  2645,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2955,    -1,    -1,
      -1,    -1,    -1,    -1,  2664,    -1,  2123,    -1,  2125,    -1,
    2127,  2128,  2129,    -1,    -1,  2132,    -1,    -1,    -1,  2136,
      -1,    -1,    -1,    -1,    -1,    -1,  2143,    -1,    -1,  2689,
      -1,  2148,    -1,  2991,    -1,    -1,  2153,    -1,    -1,    -1,
      -1,  2158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2167,    -1,    -1,    -1,  2171,  2172,  2173,    -1,    -1,    -1,
      -1,    -1,    -1,  2723,    -1,    -1,    -1,    -1,  2185,    -1,
      -1,    -1,    -1,    -1,    -1,  2192,    -1,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,    -1,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2227,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    -1,    62,    63,    -1,
      -1,    -1,    67,    -1,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3110,    -1,    79,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,  3121,    -1,    -1,  2826,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,   103,    -1,
      -1,    -1,    -1,    -1,   109,    -1,  2303,    -1,    -1,    -1,
     115,    -1,   117,    -1,    -1,    -1,   121,    -1,    -1,    -1,
      -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,
      -1,   136,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    -1,  3194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   208,   209,    -1,    -1,    -1,    -1,   214,
      -1,    -1,    -1,    -1,    -1,  2955,    -1,    -1,   223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2991,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2467,   276,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   287,    -1,    -1,    -1,   291,    -1,   293,    -1,
      -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,   303,    -1,
      -1,   306,    -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,
      -1,   316,    -1,    -1,    -1,    -1,    -1,    -1,   323,  3357,
      -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   346,    -1,    -1,    -1,  3383,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   372,    -1,   374,
    3110,    -1,   377,    -1,    -1,    -1,   381,    -1,    -1,    -1,
      -1,  3121,  2579,    -1,    -1,    -1,    -1,    -1,   393,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2600,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3451,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2641,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3204,  2662,  2663,    -1,  2665,    -1,
      -1,  2668,  2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,
    2677,  2678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3533,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2701,    -1,    -1,  2704,    -1,  2706,
      -1,    -1,    -1,    -1,  2711,  2712,    -1,    -1,    -1,    -1,
      -1,  3559,    -1,    -1,    -1,    -1,    -1,    -1,  2725,  2726,
    2727,    -1,  2729,    -1,    -1,  2732,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2759,    -1,  3602,    -1,    -1,    -1,  3606,  3607,
      -1,    -1,    -1,    -1,    -1,    -1,  2773,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2790,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3357,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3533,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3559,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3602,    -1,    -1,    -1,  3606,  3607,  3065,    -1,
      -1,  3068,  3069,  3070,    -1,    -1,  3073,    -1,    -1,    -1,
      -1,  3078,  3079,  3080,  3081,  3082,  3083,  3084,  3085,  3086,
    3087,  3088,  3089,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3114,  3115,  3116,
    3117,    -1,  3119,    -1,    -1,    -1,  3123,  3124,  3125,    -1,
      -1,  3128,    -1,    -1,  3131,    -1,    -1,    -1,    -1,    -1,
      -1,  3138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3336,
    3337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3375,    -1,
      -1,    -1,  3379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3391,    -1,  3393,    -1,    -1,    -1,
      -1,  3398,  3399,  3400,    -1,    -1,  3403,  3404,  3405,  3406,
      -1,  3408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3432,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3496,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3543,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3557,  3558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3571,  3572,  3573,    -1,  3575,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,  3672,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,  3696,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,  3725,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,  3784,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,  3824,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,   428,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,   116,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,   426,   427,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
       3,    -1,    -1,    -1,    -1,    -1,    -1,   426,   427,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,    -1,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,    -1,
     239,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
      -1,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,    -1,   382,   383,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,
     409,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,   427,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
      -1,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,    -1,   239,   240,   241,   242,
      -1,    -1,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,     3,     4,     5,     6,
       7,     8,     9,    10,   407,   408,   409,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,   427,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
      -1,    -1,    -1,    -1,    -1,   424,   425,   426,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,   426,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,   370,   371,   372,   373,   374,
     375,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,    -1,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,   375,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,    -1,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,    -1,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
      -1,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,    -1,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,   375,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,     3,   417,   418,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,   253,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,   375,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     426,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
     253,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,   375,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   426,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,   375,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,   426,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,
      -1,    -1,     3,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,   426,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   426,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   426,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    -1,    -1,    -1,
     426,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,    -1,   136,   137,    -1,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
     243,    -1,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,    -1,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   407,   408,   409,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,    -1,     3,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   419,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   419,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
      -1,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,    -1,   239,   240,   241,   242,
      -1,    -1,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,    -1,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,    -1,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,   407,   408,   409,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,   419,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,    -1,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,    -1,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,    -1,    -1,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,    -1,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,    -1,   271,    -1,   273,    -1,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,    -1,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,    -1,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,    -1,     3,     4,     5,    -1,    -1,    -1,
       9,   407,   408,   409,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,   419,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,     4,     5,    -1,    -1,    -1,     9,   417,   418,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,     4,
       5,    -1,    -1,    -1,     9,   417,   418,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,     9,   417,   418,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,   150,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,   370,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,     4,     5,     6,     7,    -1,     9,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,   375,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,   375,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,   253,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    31,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,    -1,   242,    -1,   244,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
      -1,    -1,    -1,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,    -1,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,    -1,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,   239,   240,    -1,   242,
      -1,   244,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,
     263,   264,   265,   266,   267,   268,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,   324,   325,   326,    -1,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,   239,   240,    -1,   242,    -1,   244,   245,
     246,   247,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,    -1,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,   317,   318,   319,   320,   321,    -1,   323,   324,   325,
     326,    -1,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
      -1,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,    -1,    -1,   371,   372,   373,   374,    -1,
      -1,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    33,    34,    -1,    36,    -1,    38,
      39,    40,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    -1,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
     239,   240,    -1,   242,    -1,   244,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,    -1,    -1,    -1,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,    -1,   324,   325,   326,    -1,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,   239,   240,    -1,   242,    -1,   244,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,   264,
     265,   266,   267,   268,   269,    -1,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,    -1,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,    -1,   242,    -1,   244,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,    -1,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,   239,   240,
      -1,   242,    -1,   244,   245,   246,   247,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,
      -1,    -1,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
      -1,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   317,   318,   319,   320,
     321,    -1,   323,   324,   325,   326,    -1,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    -1,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,    -1,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,    -1,    -1,
     371,   372,   373,   374,    -1,    -1,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,    -1,    -1,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,    -1,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,    -1,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,    -1,   242,    -1,
     244,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,    -1,    -1,    -1,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,    -1,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      -1,    38,    39,    40,    41,    42,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    -1,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,    -1,   242,    -1,   244,   245,   246,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,    -1,    -1,    -1,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,   324,   325,   326,
      -1,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,   354,   355,    -1,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,    -1,   245,   246,   247,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,    -1,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
      -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,    -1,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,   317,   318,   319,
     320,   321,    -1,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,    -1,   344,   345,   346,   347,   348,   349,
     350,   351,   352,    -1,   354,   355,    -1,    -1,   358,    -1,
     360,    -1,    -1,   363,   364,   365,   366,   367,   368,    -1,
      -1,   371,   372,   373,   374,    -1,    -1,   377,   378,   379,
     380,    -1,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,    -1,
     204,   205,   206,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,   239,   240,   241,   242,    -1,
      -1,   245,   246,   247,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,    -1,   260,   261,   262,    -1,
     264,   265,   266,   267,   268,   269,    -1,   271,    -1,   273,
      -1,   275,   276,   277,    -1,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,    -1,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,   317,   318,   319,   320,   321,    -1,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,    -1,   342,    -1,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,    -1,
     354,   355,    -1,    -1,   358,    -1,   360,    -1,    -1,   363,
     364,   365,   366,   367,   368,    -1,    -1,   371,   372,   373,
     374,    -1,    -1,   377,   378,   379,   380,    -1,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   407,   408,   409,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,    -1,   204,   205,   206,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,    -1,    -1,   245,   246,   247,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,    -1,   260,   261,   262,    -1,   264,   265,   266,   267,
     268,   269,    -1,   271,    -1,   273,    -1,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,    -1,   302,   303,   304,   305,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,   319,   320,   321,    -1,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,    -1,   342,    -1,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,    -1,    -1,
     358,    -1,   360,    -1,    -1,   363,   364,   365,   366,   367,
     368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,
     378,   379,   380,    -1,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
     408,   409,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,   239,   240,    -1,
     242,    -1,   244,   245,   246,   247,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,    -1,    -1,
      -1,   263,   264,   265,   266,   267,    -1,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,    -1,   279,   280,   281,
     282,   283,    -1,   285,   286,   287,   288,   289,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,    -1,
     302,   303,    -1,   305,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,    -1,   317,   318,   319,   320,   321,
      -1,   323,   324,   325,   326,    -1,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,    -1,   354,   355,    -1,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,    -1,    -1,   371,
     372,   373,   374,    -1,    -1,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,    -1,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,   237,    -1,   239,   240,   241,   242,    -1,    -1,
     245,   246,   247,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,    -1,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,    -1,   271,    -1,   273,    -1,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    -1,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,   317,   318,   319,   320,   321,    -1,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    -1,   342,    -1,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,    -1,   354,
     355,    -1,    -1,   358,    -1,   360,    -1,    -1,   363,   364,
     365,   366,   367,   368,    -1,    -1,   371,   372,   373,   374,
      -1,    -1,   377,   378,   379,   380,    -1,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   407,   408,   409,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,    -1,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,   237,    -1,
     239,   240,   241,   242,    -1,    -1,   245,   246,   247,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
      -1,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,    -1,   271,    -1,   273,    -1,   275,   276,   277,    -1,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,    -1,   302,   303,   304,   305,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,   317,   318,
     319,   320,   321,    -1,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,    -1,   342,    -1,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,    -1,   354,   355,    -1,    -1,   358,
      -1,   360,    -1,    -1,   363,   364,   365,   366,   367,   368,
      -1,    -1,   371,   372,   373,   374,    -1,    -1,   377,   378,
     379,   380,    -1,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,   408,
     409,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
      -1,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,   237,    -1,   239,   240,   241,   242,
      -1,    -1,   245,   246,   247,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,    -1,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,    -1,   271,    -1,
     273,    -1,   275,   276,   277,    -1,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,    -1,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,   317,   318,   319,   320,   321,    -1,
     323,    -1,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,    -1,   342,
      -1,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
      -1,   354,   355,    -1,    -1,   358,    -1,   360,    -1,    -1,
     363,   364,   365,   366,   367,   368,    -1,    -1,   371,   372,
     373,   374,    -1,    -1,   377,   378,   379,   380,    -1,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   407,   408,   409,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    -1,    43,    -1,    -1,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    -1,
      -1,    58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,    -1,    -1,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,    -1,   136,
     137,    -1,    -1,   140,    -1,   142,    -1,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
      -1,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,    -1,   181,   182,   183,   184,    -1,    -1,
      -1,    -1,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,    -1,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,    -1,   229,   230,   231,   232,   233,   234,   235,    -1,
     237,    -1,   239,   240,   241,   242,    -1,    -1,   245,    -1,
     247,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,    -1,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,    -1,   271,    -1,   273,    -1,   275,   276,
     277,    -1,   279,   280,   281,   282,   283,   284,   285,    -1,
     287,   288,   289,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,    -1,   302,   303,   304,   305,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
     317,   318,   319,   320,   321,    -1,   323,    -1,   325,   326,
     327,   328,    -1,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,    -1,   342,    -1,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,    -1,    -1,    -1,    -1,
      -1,   358,    -1,   360,    -1,    -1,   363,   364,   365,   366,
     367,   368,    -1,    -1,   371,   372,   373,   374,    -1,    -1,
     377,   378,   379,   380,    -1,    -1,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,   408,   409
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    40,    60,    62,    63,    67,
      69,    79,    81,   100,   103,   109,   115,   117,   121,   127,
     134,   136,   141,   155,   183,   208,   209,   214,   223,   240,
     276,   287,   291,   293,   298,   303,   306,   310,   316,   323,
     326,   333,   346,   363,   372,   374,   377,   381,   393,   426,
     433,   434,   435,   436,   442,   443,   445,   446,   447,   448,
     449,   450,   451,   453,   454,   458,   468,   470,   471,   474,
     475,   476,   486,   487,   502,   537,   543,   544,   551,   557,
     559,   561,   562,   563,   564,   573,   577,   578,   579,   581,
     582,   583,   597,   598,   599,   600,   611,   617,   618,   621,
     622,   623,   624,   625,   630,   632,   635,   639,   640,   650,
     651,   654,   659,   669,   688,   691,   692,   693,   696,   699,
     701,   703,   706,   709,   710,   711,   713,   720,   721,   723,
     724,   725,   730,   732,   733,   737,   738,   741,   742,   743,
     745,   746,   747,   748,   750,   753,   754,   759,   765,   768,
     770,   771,   776,   778,   782,   789,   793,   794,   795,   796,
     797,   798,   827,   358,   395,   726,    21,    78,    98,   104,
     119,   147,   152,   158,   173,   198,   254,   281,   305,   311,
     317,   320,   346,   348,   352,   360,   365,   375,   387,   558,
     726,     3,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    33,    34,    36,    38,    39,    40,
      41,    42,    44,    45,    47,    48,    49,    50,    51,    54,
      55,    56,    57,    58,    60,    61,    62,    63,    64,    67,
      68,    69,    70,    72,    73,    75,    76,    77,    78,    79,
      80,    82,    83,    84,    86,    87,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   105,   107,   108,   109,   110,
     111,   113,   114,   115,   118,   119,   120,   121,   122,   124,
     125,   126,   128,   129,   131,   132,   133,   134,   135,   136,
     137,   138,   140,   142,   143,   144,   146,   148,   152,   153,
     154,   156,   157,   159,   161,   162,   163,   164,   165,   167,
     168,   169,   171,   172,   173,   174,   175,   176,   178,   180,
     181,   182,   183,   184,   185,   186,   188,   190,   193,   195,
     196,   197,   198,   199,   200,   201,   203,   205,   208,   209,
     210,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   239,   240,   242,   244,   245,
     246,   247,   248,   249,   251,   254,   255,   256,   259,   263,
     264,   265,   266,   267,   268,   269,   271,   272,   273,   274,
     275,   276,   277,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   302,   303,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   317,   318,   319,
     320,   321,   323,   324,   325,   326,   328,   329,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     344,   345,   347,   348,   349,   350,   351,   352,   354,   355,
     358,   359,   360,   361,   363,   364,   365,   366,   367,   368,
     371,   372,   373,   374,   377,   378,   379,   380,   381,   382,
     384,   386,   387,   388,   391,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   790,   930,   942,   945,   946,   385,   755,   252,   277,
     726,    43,   493,   794,    21,    33,    53,    74,    98,   104,
     119,   147,   154,   158,   210,   254,   257,   305,   311,   320,
     348,   349,   351,   352,   360,   365,   370,   375,   503,   614,
     660,   670,    22,   276,   930,   790,   150,    22,   271,   349,
     351,     5,   197,   697,   698,   939,    21,    33,    53,    78,
      98,   119,   147,   152,   158,   173,   254,   264,   305,   309,
     311,   317,   320,   346,   348,   352,   360,   365,   375,   387,
     558,   626,   726,   930,    81,   385,   426,   537,   754,   760,
     768,   771,   776,   782,   789,   793,     9,    15,    22,    38,
     142,   148,   150,   170,   199,   229,   279,   292,   417,   418,
     636,   637,   790,   938,   941,    22,    81,   290,   316,   641,
     642,   643,   942,   189,   942,   935,   939,   346,   803,   636,
     942,   358,   930,   264,    98,   173,   345,   346,   704,   310,
     942,    22,   321,   354,   358,   460,   942,    19,   155,   641,
     642,   277,   726,   942,    22,   116,   805,    54,    75,   210,
     225,   305,   311,   321,   354,   358,   398,   459,   460,    22,
     321,   354,   358,   460,   358,   253,   836,   928,   942,   803,
     419,   942,   836,   838,   151,   426,   756,   426,   924,   289,
     799,   800,   930,   794,   795,     0,   429,   755,   130,   187,
     258,   369,   806,   807,   794,   796,   797,   430,     3,    37,
      43,    71,    85,    91,   149,   151,   166,   179,   191,   192,
     194,   204,   206,   227,   241,   260,   261,   262,   304,   327,
     385,   936,   942,   943,   945,   947,   628,   942,   931,   942,
     280,   628,    97,   649,   936,   940,   942,   928,   247,     8,
      61,   140,   413,   414,   415,   417,   418,   419,   420,   421,
     422,   695,   891,   892,   942,   940,   930,   928,   930,   836,
     930,   313,   930,   628,   216,   940,   928,   197,   193,   285,
     727,   728,   729,   928,   934,   942,    21,    53,    66,    74,
      78,    98,   119,   152,   173,   198,   254,   305,   309,   311,
     317,   346,   348,   352,   360,   365,   387,   558,   633,   939,
     928,   356,   936,   930,   426,   360,   931,   628,    97,   349,
     351,   940,   349,   351,    61,   140,   695,   296,   940,   455,
     942,   930,   930,   313,   930,   628,   216,   940,   317,   346,
     387,    78,   173,   152,   309,   364,   552,    22,   930,   791,
     838,   467,   939,   942,   698,   165,   936,   930,   165,   702,
     165,   931,    97,   165,   936,   165,   929,   930,    61,   140,
     165,   695,    47,   165,   929,   165,   930,   165,   930,   165,
     930,   313,   165,   930,   165,   216,   929,   197,   165,   627,
     628,   426,   769,   503,   760,   381,   385,   754,   761,   762,
     763,   942,   755,   941,   637,   638,    22,   638,   941,   638,
      22,   638,   941,   638,   638,   638,   941,   938,   938,   790,
     638,   280,   426,   426,   521,   521,   521,   252,   356,   430,
     521,   928,   836,   837,   430,   722,   939,   426,   766,    47,
     930,   930,   928,   942,    37,   409,   193,   428,   255,   255,
     252,   150,   939,   356,   252,     4,     6,     7,     8,    10,
      30,    42,    44,    45,    52,    53,    56,    57,    64,    88,
      89,    90,    91,    92,    93,    94,   101,   102,   120,   135,
     138,   139,   143,   157,   185,   186,   188,   203,   211,   212,
     226,   228,   238,   243,   244,   246,   254,   263,   272,   286,
     307,   322,   329,   341,   354,   355,   359,   361,   362,   370,
     375,   382,   400,   401,   402,   403,   404,   405,   406,   417,
     418,   419,   426,   794,   847,   850,   853,   854,   855,   857,
     858,   859,   860,   863,   864,   868,   870,   871,   889,   893,
     912,   917,   925,   926,   936,   937,   938,   939,   942,   939,
      22,   472,   927,   928,   321,   459,   104,   466,   939,   467,
     939,    37,    58,   459,   409,   728,   255,   150,   356,   413,
      37,   409,   193,   729,   426,   928,   419,   424,   428,   918,
     919,   837,    31,   942,   323,   149,   151,   385,   751,   752,
     754,   149,   757,   104,   868,   922,   923,   799,   430,   426,
     758,   427,   427,   435,   928,    22,   116,   804,   804,    47,
     804,   141,   145,   207,   250,   810,   812,   813,   822,   824,
     825,   806,   807,   924,   426,   605,   919,   265,   294,   428,
     629,   265,   294,   315,   323,   393,   437,   468,   469,   712,
     655,    18,   121,   265,   323,   479,   396,    49,    80,   137,
     168,   265,   294,   302,   308,   315,   323,   331,   339,   388,
     469,   682,   689,   712,   426,   671,    18,   121,   294,   452,
      18,    24,    63,   114,   121,   124,   175,   230,   265,   294,
     298,   323,   477,   478,     4,   418,   549,   938,   941,   628,
     628,   426,   694,   428,   170,   294,   437,   444,   265,   294,
     712,    48,    96,   172,   218,   220,   230,   264,   294,   299,
     323,   333,   477,   546,   547,   712,   256,   265,   386,   567,
     575,    24,   294,   323,   477,   712,   265,   294,   298,   323,
      72,   113,   266,   350,   252,   265,   294,   323,   712,   145,
     294,   323,   437,   469,   294,   323,   477,   712,   930,   205,
     253,   397,   430,   727,   376,   749,   252,   936,   426,   930,
     936,   247,    61,   140,   695,   930,   313,   930,   197,   628,
     521,   336,   337,   489,   939,   426,   605,   606,    59,     3,
      42,    44,    45,    56,    57,   101,   102,   143,   185,   186,
     188,   226,   228,   246,   286,   324,   329,   354,   355,   382,
     844,   846,   848,   850,   852,   854,   855,   856,   858,   859,
     863,   864,   943,   945,   930,   437,    31,   744,   396,   437,
     628,   628,   426,   601,   503,   437,    37,   456,   365,   574,
     265,   560,    72,   113,   266,   350,    20,    39,   584,    31,
     601,   145,   437,   928,   538,   928,   928,   628,    71,   661,
     936,   930,   558,    43,    95,   182,   230,   312,   376,   777,
     135,   605,    50,   300,   480,   135,   426,   135,   396,   135,
     671,   135,   430,   165,   628,   165,   628,   135,   694,   929,
     135,   135,   252,   135,   480,   135,    72,   113,   266,   350,
     135,   252,   135,   145,   165,   165,   467,   135,   430,   480,
     868,   896,   346,   427,   430,   139,   252,   362,   464,   467,
     549,   764,   760,   638,   790,   638,   790,   638,   790,   638,
     790,   638,   790,   790,   790,   638,   790,   426,   522,   523,
     942,   522,    22,    98,   147,   152,   197,   198,   311,   317,
     346,   348,   644,   927,   929,   643,   104,   426,   772,   793,
     170,   430,   779,   939,   844,   899,    31,   929,   146,   705,
     705,   705,   205,   942,   145,   145,   644,   929,   310,   942,
     426,   920,   424,   794,   900,   384,   861,   868,   916,   426,
     861,   861,   426,   426,   426,   426,   849,   849,   274,   794,
     426,   426,   851,   426,   426,   426,   426,    56,    57,   861,
     868,   426,   849,   426,   426,   426,   426,   426,   394,   412,
     426,   865,   426,   865,   426,   426,   794,   426,   426,   426,
     426,   426,   426,   426,   868,   868,   794,   868,   896,   939,
      57,   426,   862,   426,   939,     3,     8,    11,    28,    31,
      36,    41,   166,   170,   191,   192,   206,   238,   241,   254,
     257,   327,   413,   414,   415,   417,   418,   419,   420,   421,
     422,   891,   893,   895,   262,   868,   189,   430,   801,   426,
     939,   919,   107,   167,   473,   430,    58,   104,   467,    31,
       3,   104,   210,   465,   549,   864,   939,    76,   118,   877,
      87,   104,   461,   462,   464,   549,   104,   461,   205,   928,
     868,     3,    22,    26,    27,    28,    29,    30,    31,    32,
      35,    46,    52,    53,    59,    65,    66,    74,    81,    88,
      89,    90,    92,    93,    94,   104,   106,   112,   116,   117,
     123,   127,   130,   139,   141,   145,   147,   150,   155,   158,
     160,   170,   177,   187,   189,   202,   207,   211,   212,   238,
     243,   250,   252,   253,   257,   258,   270,   278,   290,   301,
     316,   322,   330,   343,   346,   353,   356,   357,   362,   369,
     370,   375,   376,   383,   389,   390,   392,   393,   419,   933,
     944,   945,   946,   947,   948,   918,    77,   299,   631,   942,
     426,   783,   784,   785,   786,   787,   942,   427,   430,   755,
     427,   430,   800,   929,    31,   758,   796,   796,   808,   809,
     868,   796,   142,   229,   819,   285,   325,   374,    22,   814,
     868,   815,   817,   868,   870,   822,   823,   813,   812,   810,
     811,   145,   825,   810,   822,   419,   899,   265,   294,   323,
     712,   356,   356,   933,   428,   356,   356,   196,   348,   459,
     739,   145,   155,   170,   303,   656,   657,    59,    74,   131,
     147,   278,   370,   519,   520,    74,   104,   238,   356,   104,
     238,   311,   930,   252,   549,   315,   356,   356,   243,   549,
     108,   190,   311,   300,   315,   682,   690,   170,   180,   259,
     324,   383,   427,   672,   675,   676,   677,   679,   844,   943,
     356,   375,    66,   131,   510,   519,   942,    66,   707,   252,
     309,   360,    74,   707,    25,   297,   309,   360,   928,   175,
     356,   356,   426,   482,   348,   393,   394,   482,   430,     4,
     265,   712,   376,   376,   236,   844,   265,   695,    98,   356,
     439,   469,   356,   356,   549,    47,   548,   549,   549,    96,
     218,   220,    47,   356,   437,   311,   437,   230,   547,   426,
     356,   243,   939,   567,   707,   356,   707,   311,   356,   356,
     482,   482,   628,   628,   628,   628,   928,   356,   356,   311,
      94,   375,   580,   940,   356,   439,   356,   311,   265,   294,
     285,   295,   319,   463,   727,   934,   942,   928,   605,   844,
     252,   671,   549,   628,   628,   694,   191,   252,    72,   113,
     266,   350,   252,   628,   191,   393,   494,   437,     3,   607,
     608,   601,   426,   846,    31,    30,   845,    99,   163,   219,
     222,   314,   407,   426,   866,   867,   629,   849,    20,   734,
     844,   930,   438,   614,   376,   602,   603,   944,   387,   438,
     940,    81,   155,   457,   502,   543,   583,   639,   659,   730,
     939,   575,   576,   930,   213,   628,   628,   628,   628,   109,
     183,   363,   374,   585,   586,   128,   426,   580,   438,   545,
     546,    31,   248,   426,   539,   521,   145,   662,   934,   426,
     673,    31,   197,   393,   394,   792,   312,   426,   794,   829,
     830,   831,   836,   839,   871,   936,   942,   390,   841,   936,
     480,   844,   931,   165,   930,   936,   480,   929,   930,   135,
     376,   135,   376,   695,   480,   480,   929,   930,   928,   930,
     930,   930,   928,   929,   580,   135,   135,   480,   627,   628,
     427,   430,   928,   760,   762,   790,   790,   790,   790,   790,
     790,   522,   427,   430,   427,   153,   318,   347,   929,    97,
     320,   648,   649,   929,   247,   929,   927,   927,   929,   356,
     393,   652,   381,   773,   774,   942,   301,   775,    16,   133,
     307,   325,   780,   836,   242,   781,   427,   430,   767,   771,
     776,   782,   793,   356,   642,   641,   642,   150,   156,   653,
     942,   896,   918,   425,   896,   900,   901,   426,   389,   913,
     914,   868,   896,   938,   938,   896,     3,    99,   163,   219,
     222,   314,   407,   902,   903,   939,   938,   896,   896,   938,
     938,   861,   861,   868,   695,   868,   904,   417,   418,   869,
     870,   889,   893,   906,   427,   896,   868,   896,   907,   354,
     409,   938,   938,   868,    46,   150,   202,   357,   868,   896,
     910,   896,   224,   868,   875,   876,   877,   224,   868,   877,
     427,   430,   323,   938,   938,   866,   844,   868,   944,   354,
      35,   343,   921,   868,   426,   794,   911,   116,   118,   139,
     238,   243,   248,   362,   371,   868,    41,   166,   170,   206,
     327,   426,   868,   356,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,    22,    29,   330,   890,   307,   426,
     889,   154,   210,   346,   349,   351,   802,   928,   926,   150,
     828,    22,   116,   383,   419,   427,   677,   868,   897,   898,
     943,   928,   358,   426,   939,   430,   427,   425,   431,   164,
     164,   480,   787,   788,   430,   828,   413,   920,   928,   752,
     753,   928,   922,   427,   794,   430,    32,   112,   376,   667,
     426,   816,   941,   253,   248,   826,   826,   430,   307,   308,
     818,   823,   811,   427,   427,   356,   356,   311,   940,   930,
     933,   940,   931,   356,   930,    73,   740,   305,   375,   641,
     311,   155,   641,   426,   930,   376,   663,   195,   195,   426,
     930,   243,   940,   868,   243,   930,   230,   265,   379,   555,
     567,   243,   108,   190,   940,   930,   252,   930,   259,   943,
     427,   430,   677,   679,   676,   679,   943,   629,   940,   929,
     510,   844,   942,   930,   930,    22,   375,   930,   165,   930,
     165,   942,   309,   360,   309,   360,   930,    22,   375,   930,
     928,   940,   930,   484,   485,   944,   930,   251,   315,    63,
     251,   315,   478,   356,   932,   942,   932,   430,   427,   430,
     356,   931,   940,    73,    82,    83,    84,   126,   175,   215,
     231,   232,   233,   234,   235,   237,   269,   342,   368,   375,
     378,   440,   940,   930,   549,   628,   930,   549,   930,   549,
      18,   121,   323,   568,   569,   570,   571,   944,   940,   942,
     930,   930,   930,   940,   930,    18,    24,   121,   265,   294,
     265,   294,   601,   294,   294,   294,   940,   930,   930,   320,
     940,   930,   930,   356,   356,    70,   367,   285,   191,    31,
     628,   191,   191,   376,   376,   191,   243,   634,   939,   628,
     628,   628,   628,   628,   628,   191,   634,   251,   150,   356,
     488,   426,   490,   491,   413,   427,   430,   868,    30,   845,
     844,   424,   424,   356,   356,   356,   426,   356,   938,   849,
     585,    73,   125,   200,   201,   213,   265,   348,   350,   735,
     512,   555,   556,    19,   170,   305,   344,   440,   441,   145,
     932,   427,   430,   413,   928,   456,   257,   503,   147,   939,
     601,   601,   601,   601,   248,   252,   257,   426,   842,   843,
     942,   320,   134,   793,   628,   206,   504,   506,   508,   510,
     516,   519,   540,   541,   942,   393,   394,   533,    31,   939,
     252,   427,   674,   675,   680,    31,   197,   302,   392,   681,
     682,   683,   252,   467,   162,   162,   145,   794,   830,   831,
      31,   832,   942,   430,    85,   151,   179,   194,   204,   227,
     304,   833,   832,    31,   832,   942,   426,   919,    87,   868,
     775,   605,    31,   135,   480,   671,   628,   932,   628,   932,
     694,   252,   480,   480,   252,   480,   320,   145,   467,   480,
     868,   426,   427,   523,   170,   170,   170,   396,   929,   430,
     549,   550,   158,   645,   646,   940,    19,   653,   427,   430,
     920,   925,   133,   325,   133,   325,   307,   374,   221,   844,
     930,   150,   252,   645,    47,   480,   427,   425,   425,   430,
     896,   868,   123,   914,   915,    31,   427,   427,   427,   427,
     427,   150,   427,   427,   427,   427,   427,   430,   427,   270,
     905,   427,   869,   869,    11,   170,   191,   254,   413,   414,
     415,   417,   418,   419,   420,   421,   422,   893,   869,   427,
     427,   145,   150,   908,   909,   427,   409,   427,   427,    31,
     910,   896,   910,   910,   150,   427,   427,   944,    31,   427,
     430,   868,   944,   430,   868,   920,   868,   942,   427,   427,
     409,   869,   869,   129,   896,   150,   116,   118,   139,   243,
     248,   362,   371,   426,   129,   343,   921,   868,   911,   868,
     356,   695,   868,   426,   794,   349,   351,   349,   351,   928,
     803,   803,   829,   390,   840,   897,   897,   898,   427,   261,
     882,    13,   427,   430,   807,   728,   938,   866,   462,   868,
     427,   430,   784,   841,   922,   758,   809,   254,   891,   894,
     410,   411,   668,   868,   818,   927,   781,   781,   815,   940,
     930,   930,   939,   207,   929,   929,   252,   929,   255,   252,
     868,   520,   932,   426,   426,   426,   522,   480,   379,   356,
     553,   930,   567,   181,   243,   629,   675,   679,   679,   421,
     512,   121,   298,   323,   479,   708,   135,   480,   135,   480,
     930,   930,   930,   930,   427,   430,   413,   428,   196,   196,
     940,   265,   294,    18,   121,   265,   294,   844,   236,   844,
     940,   207,   269,   243,   939,   269,   929,   373,   570,   571,
     570,   427,   430,   572,   939,   712,   356,   216,   216,   216,
     356,   356,   356,   356,   356,   356,   356,   930,   940,   930,
     634,   844,   191,   634,   634,   932,   932,   634,   191,   191,
     191,   191,   191,   191,   634,   489,   497,   498,   944,    43,
      86,   110,   129,   146,   161,   243,   251,   283,   492,   254,
     417,   418,   549,   604,   679,   894,   939,   948,     3,   608,
     427,   424,   427,   938,   425,   938,   163,   219,   867,   219,
     867,   867,   938,   222,   427,   252,   207,   413,   736,   736,
     736,   736,   736,   736,   736,    59,    74,   104,   106,   177,
     238,   243,   278,   290,   370,   513,   514,   515,   256,   565,
     929,   158,   305,   929,   938,   365,   603,   604,   521,   296,
     346,    97,   522,   928,   586,   609,   610,   939,   427,   430,
     844,   930,   930,   393,   542,   426,   505,   928,   427,   430,
     427,   430,   251,   482,   251,   252,   534,   793,   356,   928,
     427,   430,   104,   413,   684,   939,   467,   346,   678,   679,
     393,   683,   685,   109,   183,   316,   374,   718,   159,   793,
     427,   942,   426,   830,   194,   260,   834,   830,   834,   194,
     833,   834,   194,   426,   942,   426,   897,   248,   480,   844,
     930,   480,   376,   480,   376,   480,   480,   928,   928,   930,
     580,   480,   942,   311,   311,   311,   929,   649,   430,   940,
     393,   430,   647,   255,   793,   774,   133,   133,   929,   644,
     480,   940,   900,   427,   353,   868,   127,   844,   868,   868,
     868,   908,   844,   869,   116,   118,   238,   248,   869,   869,
     869,   869,   869,   869,   869,   869,   869,   869,   868,   868,
     909,   908,   865,   865,   844,   427,   427,   427,   896,   427,
     430,   944,   876,   275,   340,   878,   427,   430,   386,   872,
      31,   427,   862,   939,   868,    28,    28,   868,   427,   868,
     150,   426,   899,   868,   869,   869,   129,   129,   868,   427,
     129,   868,   803,   803,   803,   803,   928,   928,   868,   158,
     820,   430,   806,   807,   806,   427,   882,   426,   883,   942,
     868,   882,   939,   383,   898,   427,   427,   425,   413,   787,
     775,   426,   668,   427,   253,   736,   153,   318,   347,   658,
     145,   658,   427,   426,   525,   526,   665,   871,   942,   522,
     522,   427,   940,   629,   181,   421,   365,   238,   482,    97,
     238,   335,   338,   482,   365,   930,   942,   485,   604,   944,
     356,   356,   152,   254,   338,   612,   613,   152,   254,   619,
     620,   356,   356,   427,   427,   427,   941,   939,   939,   939,
     569,   930,   145,   145,   296,   145,   165,   940,   930,   940,
     930,   930,   930,   930,   567,   427,   634,   191,   191,   634,
     634,   634,   634,   634,   634,   376,   495,   496,   427,   430,
     419,   426,   464,   499,   549,   744,   744,   238,   283,   744,
     744,   106,   177,   238,   594,   595,   596,   938,   393,   394,
     425,   425,   427,   866,   928,   736,   104,   938,   939,   104,
     939,   104,   939,   104,   939,   104,   930,   104,   930,   104,
     930,   426,   930,   869,   107,   167,   106,   243,   195,   928,
     685,   426,   929,   929,   844,    31,   928,   396,   145,   587,
     427,   430,   843,   565,   769,    97,   230,   507,   509,   511,
     519,   942,   533,   517,   176,   532,   508,   541,    69,   348,
     535,   393,   731,   939,   663,   680,   868,   868,   430,   426,
     681,   601,   356,   553,   832,   426,   929,   830,   252,   376,
     835,   830,   194,   830,   842,   426,   842,   942,   427,   930,
     427,   480,   932,   932,   480,   480,   320,   929,   929,   929,
     549,   155,   646,   653,   150,   868,   427,   427,   909,   150,
     116,   118,   248,   426,   427,   399,   874,   896,   391,   391,
     427,   868,   230,   868,   430,   873,   846,   866,   869,   869,
     868,   899,   427,    28,    28,   868,   868,   129,   868,   427,
     928,   928,   928,   928,    47,   160,   821,   427,   427,   882,
     884,   942,   898,   882,   939,   924,   695,   941,   356,   641,
     150,   594,   868,   427,   430,   393,   376,   628,   666,   666,
     427,   427,   685,   365,   243,   243,   941,   942,   844,   480,
     480,   413,   940,   930,   938,   938,   844,   430,   938,   938,
     430,   940,   930,   929,   929,   628,   929,   135,   191,   634,
     634,   437,   111,   498,   464,   500,   501,   939,   939,   243,
     419,   522,   939,   939,   107,   167,   106,   596,   595,   425,
     152,   180,   152,   150,   593,   941,   868,   238,   514,   685,
     521,   376,   536,   566,   570,   376,   793,   426,   930,   122,
     588,   389,   590,   939,    97,   427,   430,   393,   534,   132,
     171,   426,   533,   109,   121,   275,   930,    51,    59,   210,
     150,   426,   939,   677,   686,   687,   943,   685,   928,   178,
     554,   929,   427,   868,   426,   830,   835,   427,   842,   427,
     480,   480,   480,   930,   255,   480,   645,   869,   150,   426,
     899,   426,   427,   430,   427,   427,   380,   332,   427,   427,
     427,   869,   869,   868,   896,   868,   392,   879,   882,   882,
     268,   885,   427,   866,   427,   645,   252,   645,   427,   685,
     526,   254,   695,   628,   667,   667,   290,   685,   536,   376,
     481,   604,   426,   936,   695,   613,   426,   426,   620,   393,
     296,   393,   393,   145,   634,   490,   939,   427,   430,   522,
     649,    31,   700,   700,   928,   594,   427,   536,   217,   524,
     173,   427,   430,   932,   731,   565,   307,   334,   589,   426,
     134,   509,   256,   535,    22,    68,    75,   105,   174,   338,
     518,   518,   927,   534,   308,   308,    59,   255,    59,   628,
     664,   665,   679,   427,   430,   840,   553,   556,   427,   929,
     427,   480,   869,   899,   427,   875,   896,   230,   408,   880,
     881,   942,    47,   806,   882,   647,   658,   480,   666,   536,
     426,   668,   668,   928,   536,   594,   868,   899,   671,   288,
     616,   694,   899,   899,   627,   628,   627,   628,   929,   501,
     700,    34,   169,   145,   151,   267,   328,   252,   528,   529,
     530,   348,   570,   140,   615,   868,   282,   512,   427,   535,
     255,   255,   427,   430,   681,   686,   117,   427,   427,   427,
     427,   380,   430,    31,   896,   284,   308,   886,   150,   667,
     390,   527,   695,   521,   594,   427,   616,   427,   427,   393,
     122,   109,   374,   252,   530,   252,   529,   930,   628,    31,
     427,   936,   393,   483,   665,   685,    23,   184,   719,   881,
     883,    41,    87,   366,   868,   887,   888,   887,   427,   645,
     668,   426,   594,   427,   524,   936,   628,   307,    50,   230,
     300,   323,   531,   531,   612,   426,   482,   535,   239,   426,
     714,   716,   721,   771,   776,   782,   793,   888,   307,   144,
     273,   144,   273,   480,   868,   528,   671,   590,    17,   104,
     243,     4,     6,     7,   591,   592,   938,   939,   942,   840,
     715,   716,   717,   794,   795,    28,   427,   594,   134,   427,
     430,   427,   429,   888,   282,   592,   717,   936,   426,   591,
     427
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (core_yyscan_t yyscanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 626 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 633 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 640 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 753 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 764 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 774 "gram.y"
    {;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 775 "gram.y"
    {;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 784 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 785 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 789 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 790 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 795 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 800 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 804 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 809 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 814 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 818 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 822 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 826 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 830 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 834 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 838 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 842 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 846 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 851 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 855 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 859 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 863 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 867 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 872 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 878 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 881 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 885 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 889 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 893 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 897 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 911 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 929 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 939 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 940 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 945 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 963 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 975 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 996 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 1003 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 1022 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 1029 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 1046 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 1064 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 1074 "gram.y"
    { (yyval.ival) = +1; ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 1075 "gram.y"
    { (yyval.ival) = -1; ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 1088 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 1095 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 1112 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 1124 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 1135 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 1136 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 1140 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 1141 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1169 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1175 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1181 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1190 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1198 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1206 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1213 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1220 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1228 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1239 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1247 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1255 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1263 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 1271 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1282 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1290 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1298 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1305 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1314 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1316 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1322 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1323 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1327 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1329 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1332 "gram.y"
    { (yyval.str) = "read uncommitted"; ;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1333 "gram.y"
    { (yyval.str) = "read committed"; ;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1334 "gram.y"
    { (yyval.str) = "repeatable read"; ;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1335 "gram.y"
    { (yyval.str) = "serializable"; ;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1339 "gram.y"
    { (yyval.str) = "true"; ;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1340 "gram.y"
    { (yyval.str) = "false"; ;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1341 "gram.y"
    { (yyval.str) = "on"; ;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1347 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1360 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1364 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1368 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1383 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1405 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1406 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1407 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1411 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1412 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1413 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1417 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1418 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1423 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1430 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1437 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1444 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1451 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1460 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); ;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1461 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1467 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 222:

/* Line 1464 of yacc.c  */
#line 1473 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1479 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1485 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1491 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1501 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1510 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1511 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1515 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1516 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1525 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1540 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 1546 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1552 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1558 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1576 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1584 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 1592 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 1600 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 1610 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 1611 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 1617 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 1625 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 1633 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 1642 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 246:

/* Line 1464 of yacc.c  */
#line 1650 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 247:

/* Line 1464 of yacc.c  */
#line 1658 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 1667 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 1676 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 1685 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 1694 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 1704 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 1717 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (7)].str);
					n->def = (Node *) (yyvsp[(6) - (7)].typnam);
					n->transform = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 1727 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 1735 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 1745 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 1755 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 1762 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 1769 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddSecLabel;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 1776 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropSecLabel;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 261:

/* Line 1464 of yacc.c  */
#line 1783 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 262:

/* Line 1464 of yacc.c  */
#line 1791 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 263:

/* Line 1464 of yacc.c  */
#line 1799 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 1807 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 265:

/* Line 1464 of yacc.c  */
#line 1815 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 266:

/* Line 1464 of yacc.c  */
#line 1823 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 1830 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 1837 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 269:

/* Line 1464 of yacc.c  */
#line 1845 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 1852 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 271:

/* Line 1464 of yacc.c  */
#line 1859 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 1867 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 1875 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 1883 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 1891 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 1899 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 1907 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 1915 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 1923 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 1931 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 281:

/* Line 1464 of yacc.c  */
#line 1940 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); ;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 1941 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 1945 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; ;}
    break;

  case 284:

/* Line 1464 of yacc.c  */
#line 1946 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; ;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 1947 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ ;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 1951 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 1952 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 1956 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 1959 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 1960 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 1964 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 1965 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 1971 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 1975 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 1979 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 1984 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 1999 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 2005 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 2033 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 2054 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 2067 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 2068 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 2077 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 2078 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 2079 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 2082 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 2083 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 2088 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 2089 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 2094 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 2098 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 2102 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 2106 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 2110 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 2114 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 2118 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 2122 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 2126 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 2130 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				;}
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 2134 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				;}
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 2143 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 2146 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 2151 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 2154 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 2159 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 2162 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 2166 "gram.y"
    {;}
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 2167 "gram.y"
    {;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 2173 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 2177 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 2184 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 2190 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 2191 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 2192 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); ;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 2193 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); ;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 2194 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 2199 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 2203 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 2210 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 2223 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->istemp = (yyvsp[(2) - (11)].boolean);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 2237 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->istemp = (yyvsp[(2) - (10)].boolean);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 2259 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 2260 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 2261 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 2262 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 2263 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 2264 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 2265 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 2269 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 2270 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 2274 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 2275 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 2280 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 2284 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 355:

/* Line 1464 of yacc.c  */
#line 2291 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 356:

/* Line 1464 of yacc.c  */
#line 2295 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 357:

/* Line 1464 of yacc.c  */
#line 2301 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 358:

/* Line 1464 of yacc.c  */
#line 2302 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 359:

/* Line 1464 of yacc.c  */
#line 2303 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 360:

/* Line 1464 of yacc.c  */
#line 2307 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 361:

/* Line 1464 of yacc.c  */
#line 2308 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 362:

/* Line 1464 of yacc.c  */
#line 2312 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->constraints = (yyvsp[(3) - (3)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 363:

/* Line 1464 of yacc.c  */
#line 2323 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->constraints = (yyvsp[(4) - (4)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 364:

/* Line 1464 of yacc.c  */
#line 2333 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 365:

/* Line 1464 of yacc.c  */
#line 2334 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 366:

/* Line 1464 of yacc.c  */
#line 2339 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 367:

/* Line 1464 of yacc.c  */
#line 2346 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 368:

/* Line 1464 of yacc.c  */
#line 2347 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 369:

/* Line 1464 of yacc.c  */
#line 2367 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 370:

/* Line 1464 of yacc.c  */
#line 2374 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 371:

/* Line 1464 of yacc.c  */
#line 2381 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 372:

/* Line 1464 of yacc.c  */
#line 2391 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 373:

/* Line 1464 of yacc.c  */
#line 2401 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (4)]);
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 374:

/* Line 1464 of yacc.c  */
#line 2410 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 375:

/* Line 1464 of yacc.c  */
#line 2419 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 376:

/* Line 1464 of yacc.c  */
#line 2448 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 377:

/* Line 1464 of yacc.c  */
#line 2455 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 378:

/* Line 1464 of yacc.c  */
#line 2462 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 379:

/* Line 1464 of yacc.c  */
#line 2469 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 380:

/* Line 1464 of yacc.c  */
#line 2488 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 381:

/* Line 1464 of yacc.c  */
#line 2497 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 382:

/* Line 1464 of yacc.c  */
#line 2498 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); ;}
    break;

  case 383:

/* Line 1464 of yacc.c  */
#line 2499 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 384:

/* Line 1464 of yacc.c  */
#line 2503 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; ;}
    break;

  case 385:

/* Line 1464 of yacc.c  */
#line 2504 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; ;}
    break;

  case 386:

/* Line 1464 of yacc.c  */
#line 2505 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; ;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 2506 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; ;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 2507 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; ;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 2508 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; ;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 2518 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 2525 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 392:

/* Line 1464 of yacc.c  */
#line 2530 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					if ((yyvsp[(5) - (5)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CHECK constraints cannot be deferred"),
								 parser_errposition((yylsp[(5) - (5)]))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 2545 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexspace = (yyvsp[(6) - (7)].str);
					n->deferrable = ((yyvsp[(7) - (7)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(7) - (7)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 394:

/* Line 1464 of yacc.c  */
#line 2558 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexspace = (yyvsp[(7) - (8)].str);
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 2572 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					n->deferrable		= ((yyvsp[(9) - (9)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(9) - (9)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 396:

/* Line 1464 of yacc.c  */
#line 2587 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 397:

/* Line 1464 of yacc.c  */
#line 2605 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 398:

/* Line 1464 of yacc.c  */
#line 2606 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 399:

/* Line 1464 of yacc.c  */
#line 2610 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 400:

/* Line 1464 of yacc.c  */
#line 2611 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 401:

/* Line 1464 of yacc.c  */
#line 2615 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				;}
    break;

  case 402:

/* Line 1464 of yacc.c  */
#line 2621 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 2625 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			;}
    break;

  case 404:

/* Line 1464 of yacc.c  */
#line 2633 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 405:

/* Line 1464 of yacc.c  */
#line 2637 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 406:

/* Line 1464 of yacc.c  */
#line 2643 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 407:

/* Line 1464 of yacc.c  */
#line 2645 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 408:

/* Line 1464 of yacc.c  */
#line 2649 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			;}
    break;

  case 409:

/* Line 1464 of yacc.c  */
#line 2654 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			;}
    break;

  case 410:

/* Line 1464 of yacc.c  */
#line 2660 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 411:

/* Line 1464 of yacc.c  */
#line 2661 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 412:

/* Line 1464 of yacc.c  */
#line 2672 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 413:

/* Line 1464 of yacc.c  */
#line 2674 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); ;}
    break;

  case 414:

/* Line 1464 of yacc.c  */
#line 2676 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); ;}
    break;

  case 415:

/* Line 1464 of yacc.c  */
#line 2678 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); ;}
    break;

  case 416:

/* Line 1464 of yacc.c  */
#line 2680 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 417:

/* Line 1464 of yacc.c  */
#line 2683 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 418:

/* Line 1464 of yacc.c  */
#line 2686 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 419:

/* Line 1464 of yacc.c  */
#line 2690 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; ;}
    break;

  case 420:

/* Line 1464 of yacc.c  */
#line 2691 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; ;}
    break;

  case 421:

/* Line 1464 of yacc.c  */
#line 2692 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; ;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 2693 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; ;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 2694 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; ;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 2697 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 425:

/* Line 1464 of yacc.c  */
#line 2698 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 426:

/* Line 1464 of yacc.c  */
#line 2703 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 427:

/* Line 1464 of yacc.c  */
#line 2704 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); ;}
    break;

  case 428:

/* Line 1464 of yacc.c  */
#line 2705 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); ;}
    break;

  case 429:

/* Line 1464 of yacc.c  */
#line 2706 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 430:

/* Line 1464 of yacc.c  */
#line 2709 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; ;}
    break;

  case 431:

/* Line 1464 of yacc.c  */
#line 2710 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; ;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 2711 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 2712 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; ;}
    break;

  case 434:

/* Line 1464 of yacc.c  */
#line 2715 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 2716 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 2719 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 437:

/* Line 1464 of yacc.c  */
#line 2720 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 438:

/* Line 1464 of yacc.c  */
#line 2731 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(6) - (7)].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO"),
								 parser_errposition(exprLocation((Node *) n->intoClause))));
					(yyvsp[(4) - (7)].into)->rel->istemp = (yyvsp[(2) - (7)].boolean);
					n->intoClause = (yyvsp[(4) - (7)].into);
					/* Implement WITH NO DATA by forcing top-level LIMIT 0 */
					if (!(yyvsp[(7) - (7)].boolean))
						((SelectStmt *) (yyvsp[(6) - (7)].node))->limitCount = makeIntConst(0, -1);
					(yyval.node) = (yyvsp[(6) - (7)].node);
				;}
    break;

  case 439:

/* Line 1464 of yacc.c  */
#line 2756 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
				;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 2767 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 2768 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 2772 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 2773 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 2778 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 2793 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 2794 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 2795 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 2809 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->istemp = (yyvsp[(2) - (5)].boolean);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 449:

/* Line 1464 of yacc.c  */
#line 2821 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 2829 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 451:

/* Line 1464 of yacc.c  */
#line 2830 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 452:

/* Line 1464 of yacc.c  */
#line 2833 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 453:

/* Line 1464 of yacc.c  */
#line 2834 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 454:

/* Line 1464 of yacc.c  */
#line 2838 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 455:

/* Line 1464 of yacc.c  */
#line 2842 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				;}
    break;

  case 456:

/* Line 1464 of yacc.c  */
#line 2846 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 2850 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 458:

/* Line 1464 of yacc.c  */
#line 2854 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 459:

/* Line 1464 of yacc.c  */
#line 2858 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 460:

/* Line 1464 of yacc.c  */
#line 2862 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				;}
    break;

  case 461:

/* Line 1464 of yacc.c  */
#line 2866 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				;}
    break;

  case 462:

/* Line 1464 of yacc.c  */
#line 2870 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 2874 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 464:

/* Line 1464 of yacc.c  */
#line 2878 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				;}
    break;

  case 465:

/* Line 1464 of yacc.c  */
#line 2882 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 466:

/* Line 1464 of yacc.c  */
#line 2887 "gram.y"
    {;}
    break;

  case 467:

/* Line 1464 of yacc.c  */
#line 2888 "gram.y"
    {;}
    break;

  case 468:

/* Line 1464 of yacc.c  */
#line 2892 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); ;}
    break;

  case 469:

/* Line 1464 of yacc.c  */
#line 2894 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				;}
    break;

  case 470:

/* Line 1464 of yacc.c  */
#line 2898 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); ;}
    break;

  case 471:

/* Line 1464 of yacc.c  */
#line 2901 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 472:

/* Line 1464 of yacc.c  */
#line 2902 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 473:

/* Line 1464 of yacc.c  */
#line 2915 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			;}
    break;

  case 474:

/* Line 1464 of yacc.c  */
#line 2928 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			;}
    break;

  case 475:

/* Line 1464 of yacc.c  */
#line 2941 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 476:

/* Line 1464 of yacc.c  */
#line 2942 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 477:

/* Line 1464 of yacc.c  */
#line 2950 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 478:

/* Line 1464 of yacc.c  */
#line 2951 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 479:

/* Line 1464 of yacc.c  */
#line 2955 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 2956 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 481:

/* Line 1464 of yacc.c  */
#line 2960 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 482:

/* Line 1464 of yacc.c  */
#line 2961 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 483:

/* Line 1464 of yacc.c  */
#line 2965 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 484:

/* Line 1464 of yacc.c  */
#line 2966 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 485:

/* Line 1464 of yacc.c  */
#line 2971 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 486:

/* Line 1464 of yacc.c  */
#line 2979 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 487:

/* Line 1464 of yacc.c  */
#line 2989 "gram.y"
    {;}
    break;

  case 488:

/* Line 1464 of yacc.c  */
#line 2990 "gram.y"
    {;}
    break;

  case 489:

/* Line 1464 of yacc.c  */
#line 3001 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 490:

/* Line 1464 of yacc.c  */
#line 3010 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 491:

/* Line 1464 of yacc.c  */
#line 3011 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 492:

/* Line 1464 of yacc.c  */
#line 3025 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 493:

/* Line 1464 of yacc.c  */
#line 3032 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 494:

/* Line 1464 of yacc.c  */
#line 3048 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 495:

/* Line 1464 of yacc.c  */
#line 3065 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 496:

/* Line 1464 of yacc.c  */
#line 3073 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(7) - (8)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 497:

/* Line 1464 of yacc.c  */
#line 3090 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->change_validator = true;
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 498:

/* Line 1464 of yacc.c  */
#line 3099 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->validator = (yyvsp[(6) - (6)].list);
					n->change_validator = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 499:

/* Line 1464 of yacc.c  */
#line 3107 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 500:

/* Line 1464 of yacc.c  */
#line 3117 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 501:

/* Line 1464 of yacc.c  */
#line 3118 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 502:

/* Line 1464 of yacc.c  */
#line 3123 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 503:

/* Line 1464 of yacc.c  */
#line 3127 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 504:

/* Line 1464 of yacc.c  */
#line 3134 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 505:

/* Line 1464 of yacc.c  */
#line 3139 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 506:

/* Line 1464 of yacc.c  */
#line 3143 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 507:

/* Line 1464 of yacc.c  */
#line 3150 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 508:

/* Line 1464 of yacc.c  */
#line 3154 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				;}
    break;

  case 509:

/* Line 1464 of yacc.c  */
#line 3159 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				;}
    break;

  case 510:

/* Line 1464 of yacc.c  */
#line 3164 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 3171 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 512:

/* Line 1464 of yacc.c  */
#line 3177 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 513:

/* Line 1464 of yacc.c  */
#line 3182 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 514:

/* Line 1464 of yacc.c  */
#line 3194 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 515:

/* Line 1464 of yacc.c  */
#line 3206 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 516:

/* Line 1464 of yacc.c  */
#line 3207 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 517:

/* Line 1464 of yacc.c  */
#line 3212 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 518:

/* Line 1464 of yacc.c  */
#line 3213 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 519:

/* Line 1464 of yacc.c  */
#line 3217 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 520:

/* Line 1464 of yacc.c  */
#line 3218 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 521:

/* Line 1464 of yacc.c  */
#line 3229 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 522:

/* Line 1464 of yacc.c  */
#line 3237 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(5) - (6)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 523:

/* Line 1464 of yacc.c  */
#line 3254 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 524:

/* Line 1464 of yacc.c  */
#line 3263 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 525:

/* Line 1464 of yacc.c  */
#line 3271 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 526:

/* Line 1464 of yacc.c  */
#line 3287 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 527:

/* Line 1464 of yacc.c  */
#line 3298 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 528:

/* Line 1464 of yacc.c  */
#line 3299 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 529:

/* Line 1464 of yacc.c  */
#line 3300 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); ;}
    break;

  case 530:

/* Line 1464 of yacc.c  */
#line 3311 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 531:

/* Line 1464 of yacc.c  */
#line 3319 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 532:

/* Line 1464 of yacc.c  */
#line 3336 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 533:

/* Line 1464 of yacc.c  */
#line 3357 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->before = (yyvsp[(4) - (15)].boolean);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 534:

/* Line 1464 of yacc.c  */
#line 3378 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->before = FALSE;
					n->row = TRUE;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (20)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (20)].ival) & 2) != 0;
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 535:

/* Line 1464 of yacc.c  */
#line 3398 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 536:

/* Line 1464 of yacc.c  */
#line 3399 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 537:

/* Line 1464 of yacc.c  */
#line 3404 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 538:

/* Line 1464 of yacc.c  */
#line 3406 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				;}
    break;

  case 539:

/* Line 1464 of yacc.c  */
#line 3428 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); ;}
    break;

  case 540:

/* Line 1464 of yacc.c  */
#line 3430 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); ;}
    break;

  case 541:

/* Line 1464 of yacc.c  */
#line 3432 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); ;}
    break;

  case 542:

/* Line 1464 of yacc.c  */
#line 3434 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 543:

/* Line 1464 of yacc.c  */
#line 3436 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); ;}
    break;

  case 544:

/* Line 1464 of yacc.c  */
#line 3441 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				;}
    break;

  case 545:

/* Line 1464 of yacc.c  */
#line 3445 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				;}
    break;

  case 546:

/* Line 1464 of yacc.c  */
#line 3455 "gram.y"
    {;}
    break;

  case 547:

/* Line 1464 of yacc.c  */
#line 3456 "gram.y"
    {;}
    break;

  case 548:

/* Line 1464 of yacc.c  */
#line 3460 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 549:

/* Line 1464 of yacc.c  */
#line 3461 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 550:

/* Line 1464 of yacc.c  */
#line 3465 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 551:

/* Line 1464 of yacc.c  */
#line 3466 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 552:

/* Line 1464 of yacc.c  */
#line 3470 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 553:

/* Line 1464 of yacc.c  */
#line 3471 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 554:

/* Line 1464 of yacc.c  */
#line 3472 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 555:

/* Line 1464 of yacc.c  */
#line 3477 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				;}
    break;

  case 556:

/* Line 1464 of yacc.c  */
#line 3482 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 557:

/* Line 1464 of yacc.c  */
#line 3483 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 558:

/* Line 1464 of yacc.c  */
#line 3484 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 559:

/* Line 1464 of yacc.c  */
#line 3485 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 560:

/* Line 1464 of yacc.c  */
#line 3486 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 561:

/* Line 1464 of yacc.c  */
#line 3490 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 562:

/* Line 1464 of yacc.c  */
#line 3491 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 563:

/* Line 1464 of yacc.c  */
#line 3496 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 564:

/* Line 1464 of yacc.c  */
#line 3498 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 565:

/* Line 1464 of yacc.c  */
#line 3507 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				;}
    break;

  case 566:

/* Line 1464 of yacc.c  */
#line 3514 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 567:

/* Line 1464 of yacc.c  */
#line 3523 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 568:

/* Line 1464 of yacc.c  */
#line 3527 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 569:

/* Line 1464 of yacc.c  */
#line 3528 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 570:

/* Line 1464 of yacc.c  */
#line 3532 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 571:

/* Line 1464 of yacc.c  */
#line 3533 "gram.y"
    { (yyval.ival) = 2; ;}
    break;

  case 572:

/* Line 1464 of yacc.c  */
#line 3539 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 573:

/* Line 1464 of yacc.c  */
#line 3549 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 574:

/* Line 1464 of yacc.c  */
#line 3572 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 575:

/* Line 1464 of yacc.c  */
#line 3590 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 576:

/* Line 1464 of yacc.c  */
#line 3613 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 577:

/* Line 1464 of yacc.c  */
#line 3623 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 578:

/* Line 1464 of yacc.c  */
#line 3634 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 579:

/* Line 1464 of yacc.c  */
#line 3644 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 580:

/* Line 1464 of yacc.c  */
#line 3654 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 581:

/* Line 1464 of yacc.c  */
#line 3665 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list))),
											parser_errposition((yylsp[(3) - (7)]))));
							break;
					}
					r->location = (yylsp[(3) - (7)]);
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 582:

/* Line 1464 of yacc.c  */
#line 3701 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 583:

/* Line 1464 of yacc.c  */
#line 3708 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 584:

/* Line 1464 of yacc.c  */
#line 3717 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 585:

/* Line 1464 of yacc.c  */
#line 3726 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 586:

/* Line 1464 of yacc.c  */
#line 3735 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 587:

/* Line 1464 of yacc.c  */
#line 3745 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 588:

/* Line 1464 of yacc.c  */
#line 3748 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 589:

/* Line 1464 of yacc.c  */
#line 3749 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 590:

/* Line 1464 of yacc.c  */
#line 3753 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 591:

/* Line 1464 of yacc.c  */
#line 3757 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 592:

/* Line 1464 of yacc.c  */
#line 3763 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); ;}
    break;

  case 593:

/* Line 1464 of yacc.c  */
#line 3764 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 594:

/* Line 1464 of yacc.c  */
#line 3765 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); ;}
    break;

  case 595:

/* Line 1464 of yacc.c  */
#line 3766 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); ;}
    break;

  case 596:

/* Line 1464 of yacc.c  */
#line 3767 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 597:

/* Line 1464 of yacc.c  */
#line 3770 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 598:

/* Line 1464 of yacc.c  */
#line 3771 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 599:

/* Line 1464 of yacc.c  */
#line 3774 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 600:

/* Line 1464 of yacc.c  */
#line 3777 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 601:

/* Line 1464 of yacc.c  */
#line 3778 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 602:

/* Line 1464 of yacc.c  */
#line 3787 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 603:

/* Line 1464 of yacc.c  */
#line 3793 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 604:

/* Line 1464 of yacc.c  */
#line 3794 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 605:

/* Line 1464 of yacc.c  */
#line 3798 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 606:

/* Line 1464 of yacc.c  */
#line 3800 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 607:

/* Line 1464 of yacc.c  */
#line 3818 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 608:

/* Line 1464 of yacc.c  */
#line 3831 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 609:

/* Line 1464 of yacc.c  */
#line 3832 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 610:

/* Line 1464 of yacc.c  */
#line 3837 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 611:

/* Line 1464 of yacc.c  */
#line 3846 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->number = (yyvsp[(2) - (5)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 612:

/* Line 1464 of yacc.c  */
#line 3855 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 613:

/* Line 1464 of yacc.c  */
#line 3864 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 614:

/* Line 1464 of yacc.c  */
#line 3874 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 615:

/* Line 1464 of yacc.c  */
#line 3882 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 616:

/* Line 1464 of yacc.c  */
#line 3883 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 617:

/* Line 1464 of yacc.c  */
#line 3886 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 618:

/* Line 1464 of yacc.c  */
#line 3887 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 619:

/* Line 1464 of yacc.c  */
#line 3891 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				;}
    break;

  case 620:

/* Line 1464 of yacc.c  */
#line 3904 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 621:

/* Line 1464 of yacc.c  */
#line 3910 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 622:

/* Line 1464 of yacc.c  */
#line 3920 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 623:

/* Line 1464 of yacc.c  */
#line 3929 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 624:

/* Line 1464 of yacc.c  */
#line 3940 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 625:

/* Line 1464 of yacc.c  */
#line 3941 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 626:

/* Line 1464 of yacc.c  */
#line 3946 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 627:

/* Line 1464 of yacc.c  */
#line 3954 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 628:

/* Line 1464 of yacc.c  */
#line 3966 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 629:

/* Line 1464 of yacc.c  */
#line 3975 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 630:

/* Line 1464 of yacc.c  */
#line 3987 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 631:

/* Line 1464 of yacc.c  */
#line 3996 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 632:

/* Line 1464 of yacc.c  */
#line 4017 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 633:

/* Line 1464 of yacc.c  */
#line 4027 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 634:

/* Line 1464 of yacc.c  */
#line 4045 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 635:

/* Line 1464 of yacc.c  */
#line 4054 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 636:

/* Line 1464 of yacc.c  */
#line 4065 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 637:

/* Line 1464 of yacc.c  */
#line 4066 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 638:

/* Line 1464 of yacc.c  */
#line 4067 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 639:

/* Line 1464 of yacc.c  */
#line 4068 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 640:

/* Line 1464 of yacc.c  */
#line 4069 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 641:

/* Line 1464 of yacc.c  */
#line 4070 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; ;}
    break;

  case 642:

/* Line 1464 of yacc.c  */
#line 4071 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 643:

/* Line 1464 of yacc.c  */
#line 4072 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 644:

/* Line 1464 of yacc.c  */
#line 4073 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; ;}
    break;

  case 645:

/* Line 1464 of yacc.c  */
#line 4074 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; ;}
    break;

  case 646:

/* Line 1464 of yacc.c  */
#line 4075 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; ;}
    break;

  case 647:

/* Line 1464 of yacc.c  */
#line 4076 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; ;}
    break;

  case 648:

/* Line 1464 of yacc.c  */
#line 4080 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 649:

/* Line 1464 of yacc.c  */
#line 4081 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 650:

/* Line 1464 of yacc.c  */
#line 4084 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 651:

/* Line 1464 of yacc.c  */
#line 4085 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 652:

/* Line 1464 of yacc.c  */
#line 4089 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); ;}
    break;

  case 653:

/* Line 1464 of yacc.c  */
#line 4091 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 654:

/* Line 1464 of yacc.c  */
#line 4104 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 655:

/* Line 1464 of yacc.c  */
#line 4114 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 656:

/* Line 1464 of yacc.c  */
#line 4115 "gram.y"
    { (yyval.boolean) = true; ;}
    break;

  case 657:

/* Line 1464 of yacc.c  */
#line 4116 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 658:

/* Line 1464 of yacc.c  */
#line 4142 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 659:

/* Line 1464 of yacc.c  */
#line 4151 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 660:

/* Line 1464 of yacc.c  */
#line 4160 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 661:

/* Line 1464 of yacc.c  */
#line 4169 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 662:

/* Line 1464 of yacc.c  */
#line 4178 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 663:

/* Line 1464 of yacc.c  */
#line 4187 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 664:

/* Line 1464 of yacc.c  */
#line 4196 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 665:

/* Line 1464 of yacc.c  */
#line 4206 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 666:

/* Line 1464 of yacc.c  */
#line 4215 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 667:

/* Line 1464 of yacc.c  */
#line 4224 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 668:

/* Line 1464 of yacc.c  */
#line 4233 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 669:

/* Line 1464 of yacc.c  */
#line 4242 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 670:

/* Line 1464 of yacc.c  */
#line 4251 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 671:

/* Line 1464 of yacc.c  */
#line 4260 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 672:

/* Line 1464 of yacc.c  */
#line 4268 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 673:

/* Line 1464 of yacc.c  */
#line 4276 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 674:

/* Line 1464 of yacc.c  */
#line 4284 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 675:

/* Line 1464 of yacc.c  */
#line 4294 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; ;}
    break;

  case 676:

/* Line 1464 of yacc.c  */
#line 4295 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; ;}
    break;

  case 677:

/* Line 1464 of yacc.c  */
#line 4296 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 678:

/* Line 1464 of yacc.c  */
#line 4297 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 679:

/* Line 1464 of yacc.c  */
#line 4298 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 680:

/* Line 1464 of yacc.c  */
#line 4299 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 681:

/* Line 1464 of yacc.c  */
#line 4300 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 682:

/* Line 1464 of yacc.c  */
#line 4301 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 683:

/* Line 1464 of yacc.c  */
#line 4302 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 684:

/* Line 1464 of yacc.c  */
#line 4303 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 685:

/* Line 1464 of yacc.c  */
#line 4304 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; ;}
    break;

  case 686:

/* Line 1464 of yacc.c  */
#line 4305 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; ;}
    break;

  case 687:

/* Line 1464 of yacc.c  */
#line 4309 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 688:

/* Line 1464 of yacc.c  */
#line 4310 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 689:

/* Line 1464 of yacc.c  */
#line 4321 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 690:

/* Line 1464 of yacc.c  */
#line 4327 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 691:

/* Line 1464 of yacc.c  */
#line 4335 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 692:

/* Line 1464 of yacc.c  */
#line 4343 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 693:

/* Line 1464 of yacc.c  */
#line 4351 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 694:

/* Line 1464 of yacc.c  */
#line 4359 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 695:

/* Line 1464 of yacc.c  */
#line 4367 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 696:

/* Line 1464 of yacc.c  */
#line 4375 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 697:

/* Line 1464 of yacc.c  */
#line 4383 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 698:

/* Line 1464 of yacc.c  */
#line 4391 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 699:

/* Line 1464 of yacc.c  */
#line 4399 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 700:

/* Line 1464 of yacc.c  */
#line 4407 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 701:

/* Line 1464 of yacc.c  */
#line 4415 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 702:

/* Line 1464 of yacc.c  */
#line 4423 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 703:

/* Line 1464 of yacc.c  */
#line 4431 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 704:

/* Line 1464 of yacc.c  */
#line 4439 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 705:

/* Line 1464 of yacc.c  */
#line 4447 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 706:

/* Line 1464 of yacc.c  */
#line 4455 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 707:

/* Line 1464 of yacc.c  */
#line 4464 "gram.y"
    {;}
    break;

  case 708:

/* Line 1464 of yacc.c  */
#line 4465 "gram.y"
    {;}
    break;

  case 709:

/* Line 1464 of yacc.c  */
#line 4468 "gram.y"
    {;}
    break;

  case 710:

/* Line 1464 of yacc.c  */
#line 4469 "gram.y"
    {;}
    break;

  case 711:

/* Line 1464 of yacc.c  */
#line 4481 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 712:

/* Line 1464 of yacc.c  */
#line 4497 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 713:

/* Line 1464 of yacc.c  */
#line 4511 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 714:

/* Line 1464 of yacc.c  */
#line 4536 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 715:

/* Line 1464 of yacc.c  */
#line 4538 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 716:

/* Line 1464 of yacc.c  */
#line 4540 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 717:

/* Line 1464 of yacc.c  */
#line 4542 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 718:

/* Line 1464 of yacc.c  */
#line 4549 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 719:

/* Line 1464 of yacc.c  */
#line 4557 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); ;}
    break;

  case 720:

/* Line 1464 of yacc.c  */
#line 4558 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); ;}
    break;

  case 721:

/* Line 1464 of yacc.c  */
#line 4562 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 722:

/* Line 1464 of yacc.c  */
#line 4569 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 723:

/* Line 1464 of yacc.c  */
#line 4576 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 724:

/* Line 1464 of yacc.c  */
#line 4583 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 725:

/* Line 1464 of yacc.c  */
#line 4597 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 726:

/* Line 1464 of yacc.c  */
#line 4605 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 727:

/* Line 1464 of yacc.c  */
#line 4613 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 728:

/* Line 1464 of yacc.c  */
#line 4621 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 729:

/* Line 1464 of yacc.c  */
#line 4629 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 730:

/* Line 1464 of yacc.c  */
#line 4637 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 731:

/* Line 1464 of yacc.c  */
#line 4645 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 732:

/* Line 1464 of yacc.c  */
#line 4653 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 733:

/* Line 1464 of yacc.c  */
#line 4661 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 734:

/* Line 1464 of yacc.c  */
#line 4669 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 735:

/* Line 1464 of yacc.c  */
#line 4677 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 736:

/* Line 1464 of yacc.c  */
#line 4685 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 737:

/* Line 1464 of yacc.c  */
#line 4693 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 738:

/* Line 1464 of yacc.c  */
#line 4701 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 739:

/* Line 1464 of yacc.c  */
#line 4712 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 740:

/* Line 1464 of yacc.c  */
#line 4713 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 741:

/* Line 1464 of yacc.c  */
#line 4717 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 742:

/* Line 1464 of yacc.c  */
#line 4727 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 743:

/* Line 1464 of yacc.c  */
#line 4740 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 744:

/* Line 1464 of yacc.c  */
#line 4741 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 745:

/* Line 1464 of yacc.c  */
#line 4745 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); ;}
    break;

  case 746:

/* Line 1464 of yacc.c  */
#line 4747 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); ;}
    break;

  case 747:

/* Line 1464 of yacc.c  */
#line 4752 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				;}
    break;

  case 748:

/* Line 1464 of yacc.c  */
#line 4768 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 749:

/* Line 1464 of yacc.c  */
#line 4781 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 750:

/* Line 1464 of yacc.c  */
#line 4791 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 751:

/* Line 1464 of yacc.c  */
#line 4802 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 752:

/* Line 1464 of yacc.c  */
#line 4803 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 753:

/* Line 1464 of yacc.c  */
#line 4806 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 754:

/* Line 1464 of yacc.c  */
#line 4807 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 755:

/* Line 1464 of yacc.c  */
#line 4818 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 756:

/* Line 1464 of yacc.c  */
#line 4827 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 757:

/* Line 1464 of yacc.c  */
#line 4828 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 758:

/* Line 1464 of yacc.c  */
#line 4833 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 759:

/* Line 1464 of yacc.c  */
#line 4837 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 760:

/* Line 1464 of yacc.c  */
#line 4841 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 761:

/* Line 1464 of yacc.c  */
#line 4853 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 762:

/* Line 1464 of yacc.c  */
#line 4866 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 763:

/* Line 1464 of yacc.c  */
#line 4880 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 764:

/* Line 1464 of yacc.c  */
#line 4895 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; ;}
    break;

  case 765:

/* Line 1464 of yacc.c  */
#line 4896 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; ;}
    break;

  case 766:

/* Line 1464 of yacc.c  */
#line 4897 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; ;}
    break;

  case 767:

/* Line 1464 of yacc.c  */
#line 4912 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 768:

/* Line 1464 of yacc.c  */
#line 4928 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 769:

/* Line 1464 of yacc.c  */
#line 4929 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 770:

/* Line 1464 of yacc.c  */
#line 4933 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 771:

/* Line 1464 of yacc.c  */
#line 4934 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 772:

/* Line 1464 of yacc.c  */
#line 4938 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 773:

/* Line 1464 of yacc.c  */
#line 4939 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 774:

/* Line 1464 of yacc.c  */
#line 4943 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 775:

/* Line 1464 of yacc.c  */
#line 4944 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; ;}
    break;

  case 776:

/* Line 1464 of yacc.c  */
#line 4947 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); ;}
    break;

  case 777:

/* Line 1464 of yacc.c  */
#line 4948 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); ;}
    break;

  case 778:

/* Line 1464 of yacc.c  */
#line 4957 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (4)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 779:

/* Line 1464 of yacc.c  */
#line 4967 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (4)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 780:

/* Line 1464 of yacc.c  */
#line 4977 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (6)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(4) - (6)].list);
					(yyval.ielem)->ordering = (yyvsp[(5) - (6)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(6) - (6)].ival);
				;}
    break;

  case 781:

/* Line 1464 of yacc.c  */
#line 4988 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 782:

/* Line 1464 of yacc.c  */
#line 4989 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 783:

/* Line 1464 of yacc.c  */
#line 4990 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 784:

/* Line 1464 of yacc.c  */
#line 4993 "gram.y"
    { (yyval.ival) = SORTBY_ASC; ;}
    break;

  case 785:

/* Line 1464 of yacc.c  */
#line 4994 "gram.y"
    { (yyval.ival) = SORTBY_DESC; ;}
    break;

  case 786:

/* Line 1464 of yacc.c  */
#line 4995 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; ;}
    break;

  case 787:

/* Line 1464 of yacc.c  */
#line 4998 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; ;}
    break;

  case 788:

/* Line 1464 of yacc.c  */
#line 4999 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; ;}
    break;

  case 789:

/* Line 1464 of yacc.c  */
#line 5000 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; ;}
    break;

  case 790:

/* Line 1464 of yacc.c  */
#line 5018 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 791:

/* Line 1464 of yacc.c  */
#line 5030 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 792:

/* Line 1464 of yacc.c  */
#line 5043 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 793:

/* Line 1464 of yacc.c  */
#line 5056 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 794:

/* Line 1464 of yacc.c  */
#line 5057 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 795:

/* Line 1464 of yacc.c  */
#line 5060 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 796:

/* Line 1464 of yacc.c  */
#line 5061 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 797:

/* Line 1464 of yacc.c  */
#line 5065 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 798:

/* Line 1464 of yacc.c  */
#line 5066 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 799:

/* Line 1464 of yacc.c  */
#line 5074 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 800:

/* Line 1464 of yacc.c  */
#line 5075 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 801:

/* Line 1464 of yacc.c  */
#line 5079 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 802:

/* Line 1464 of yacc.c  */
#line 5081 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 803:

/* Line 1464 of yacc.c  */
#line 5096 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 804:

/* Line 1464 of yacc.c  */
#line 5105 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 805:

/* Line 1464 of yacc.c  */
#line 5114 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 806:

/* Line 1464 of yacc.c  */
#line 5123 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 807:

/* Line 1464 of yacc.c  */
#line 5132 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 808:

/* Line 1464 of yacc.c  */
#line 5143 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; ;}
    break;

  case 809:

/* Line 1464 of yacc.c  */
#line 5144 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; ;}
    break;

  case 810:

/* Line 1464 of yacc.c  */
#line 5145 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 811:

/* Line 1464 of yacc.c  */
#line 5146 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 812:

/* Line 1464 of yacc.c  */
#line 5147 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; ;}
    break;

  case 814:

/* Line 1464 of yacc.c  */
#line 5158 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 815:

/* Line 1464 of yacc.c  */
#line 5172 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 816:

/* Line 1464 of yacc.c  */
#line 5174 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				;}
    break;

  case 817:

/* Line 1464 of yacc.c  */
#line 5180 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				;}
    break;

  case 818:

/* Line 1464 of yacc.c  */
#line 5190 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
			    ;}
    break;

  case 819:

/* Line 1464 of yacc.c  */
#line 5194 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 820:

/* Line 1464 of yacc.c  */
#line 5199 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 821:

/* Line 1464 of yacc.c  */
#line 5208 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 822:

/* Line 1464 of yacc.c  */
#line 5209 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 823:

/* Line 1464 of yacc.c  */
#line 5217 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				;}
    break;

  case 824:

/* Line 1464 of yacc.c  */
#line 5221 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 825:

/* Line 1464 of yacc.c  */
#line 5225 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 826:

/* Line 1464 of yacc.c  */
#line 5229 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				;}
    break;

  case 827:

/* Line 1464 of yacc.c  */
#line 5233 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				;}
    break;

  case 828:

/* Line 1464 of yacc.c  */
#line 5237 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				;}
    break;

  case 829:

/* Line 1464 of yacc.c  */
#line 5241 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 830:

/* Line 1464 of yacc.c  */
#line 5245 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 831:

/* Line 1464 of yacc.c  */
#line 5249 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 832:

/* Line 1464 of yacc.c  */
#line 5253 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 833:

/* Line 1464 of yacc.c  */
#line 5257 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 834:

/* Line 1464 of yacc.c  */
#line 5261 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 835:

/* Line 1464 of yacc.c  */
#line 5265 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				;}
    break;

  case 836:

/* Line 1464 of yacc.c  */
#line 5273 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 837:

/* Line 1464 of yacc.c  */
#line 5277 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 838:

/* Line 1464 of yacc.c  */
#line 5281 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				;}
    break;

  case 839:

/* Line 1464 of yacc.c  */
#line 5285 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 840:

/* Line 1464 of yacc.c  */
#line 5290 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 841:

/* Line 1464 of yacc.c  */
#line 5292 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 842:

/* Line 1464 of yacc.c  */
#line 5298 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 843:

/* Line 1464 of yacc.c  */
#line 5299 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 844:

/* Line 1464 of yacc.c  */
#line 5303 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 845:

/* Line 1464 of yacc.c  */
#line 5315 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				;}
    break;

  case 846:

/* Line 1464 of yacc.c  */
#line 5319 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				;}
    break;

  case 847:

/* Line 1464 of yacc.c  */
#line 5334 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 848:

/* Line 1464 of yacc.c  */
#line 5344 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 849:

/* Line 1464 of yacc.c  */
#line 5345 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 852:

/* Line 1464 of yacc.c  */
#line 5367 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 853:

/* Line 1464 of yacc.c  */
#line 5377 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 854:

/* Line 1464 of yacc.c  */
#line 5390 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 855:

/* Line 1464 of yacc.c  */
#line 5400 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 856:

/* Line 1464 of yacc.c  */
#line 5413 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 857:

/* Line 1464 of yacc.c  */
#line 5423 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 858:

/* Line 1464 of yacc.c  */
#line 5436 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				;}
    break;

  case 859:

/* Line 1464 of yacc.c  */
#line 5444 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 860:

/* Line 1464 of yacc.c  */
#line 5446 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 861:

/* Line 1464 of yacc.c  */
#line 5448 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); ;}
    break;

  case 862:

/* Line 1464 of yacc.c  */
#line 5453 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 863:

/* Line 1464 of yacc.c  */
#line 5455 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 864:

/* Line 1464 of yacc.c  */
#line 5468 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 865:

/* Line 1464 of yacc.c  */
#line 5476 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 866:

/* Line 1464 of yacc.c  */
#line 5477 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 867:

/* Line 1464 of yacc.c  */
#line 5482 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				;}
    break;

  case 868:

/* Line 1464 of yacc.c  */
#line 5486 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 869:

/* Line 1464 of yacc.c  */
#line 5499 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 870:

/* Line 1464 of yacc.c  */
#line 5510 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 871:

/* Line 1464 of yacc.c  */
#line 5521 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 872:

/* Line 1464 of yacc.c  */
#line 5532 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; ;}
    break;

  case 873:

/* Line 1464 of yacc.c  */
#line 5533 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; ;}
    break;

  case 874:

/* Line 1464 of yacc.c  */
#line 5534 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; ;}
    break;

  case 875:

/* Line 1464 of yacc.c  */
#line 5539 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 876:

/* Line 1464 of yacc.c  */
#line 5549 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 877:

/* Line 1464 of yacc.c  */
#line 5550 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 878:

/* Line 1464 of yacc.c  */
#line 5565 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 879:

/* Line 1464 of yacc.c  */
#line 5573 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 880:

/* Line 1464 of yacc.c  */
#line 5583 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 881:

/* Line 1464 of yacc.c  */
#line 5595 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 882:

/* Line 1464 of yacc.c  */
#line 5596 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 883:

/* Line 1464 of yacc.c  */
#line 5599 "gram.y"
    {  (yyval.boolean) = TRUE; ;}
    break;

  case 884:

/* Line 1464 of yacc.c  */
#line 5600 "gram.y"
    {  (yyval.boolean) = FALSE; ;}
    break;

  case 885:

/* Line 1464 of yacc.c  */
#line 5611 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 886:

/* Line 1464 of yacc.c  */
#line 5620 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 887:

/* Line 1464 of yacc.c  */
#line 5628 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 888:

/* Line 1464 of yacc.c  */
#line 5636 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 889:

/* Line 1464 of yacc.c  */
#line 5645 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 890:

/* Line 1464 of yacc.c  */
#line 5653 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 891:

/* Line 1464 of yacc.c  */
#line 5661 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 892:

/* Line 1464 of yacc.c  */
#line 5670 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 893:

/* Line 1464 of yacc.c  */
#line 5679 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 894:

/* Line 1464 of yacc.c  */
#line 5687 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 895:

/* Line 1464 of yacc.c  */
#line 5696 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 896:

/* Line 1464 of yacc.c  */
#line 5705 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 897:

/* Line 1464 of yacc.c  */
#line 5714 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 898:

/* Line 1464 of yacc.c  */
#line 5723 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 899:

/* Line 1464 of yacc.c  */
#line 5732 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 900:

/* Line 1464 of yacc.c  */
#line 5741 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 901:

/* Line 1464 of yacc.c  */
#line 5749 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 902:

/* Line 1464 of yacc.c  */
#line 5757 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 903:

/* Line 1464 of yacc.c  */
#line 5765 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 904:

/* Line 1464 of yacc.c  */
#line 5774 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 905:

/* Line 1464 of yacc.c  */
#line 5783 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 906:

/* Line 1464 of yacc.c  */
#line 5791 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 907:

/* Line 1464 of yacc.c  */
#line 5799 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 908:

/* Line 1464 of yacc.c  */
#line 5807 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 909:

/* Line 1464 of yacc.c  */
#line 5815 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 910:

/* Line 1464 of yacc.c  */
#line 5824 "gram.y"
    { (yyval.ival) = COLUMN; ;}
    break;

  case 911:

/* Line 1464 of yacc.c  */
#line 5825 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 912:

/* Line 1464 of yacc.c  */
#line 5828 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 913:

/* Line 1464 of yacc.c  */
#line 5829 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 914:

/* Line 1464 of yacc.c  */
#line 5840 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 915:

/* Line 1464 of yacc.c  */
#line 5849 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 916:

/* Line 1464 of yacc.c  */
#line 5857 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 917:

/* Line 1464 of yacc.c  */
#line 5866 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 918:

/* Line 1464 of yacc.c  */
#line 5874 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 919:

/* Line 1464 of yacc.c  */
#line 5882 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 920:

/* Line 1464 of yacc.c  */
#line 5890 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 921:

/* Line 1464 of yacc.c  */
#line 5906 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 922:

/* Line 1464 of yacc.c  */
#line 5915 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 923:

/* Line 1464 of yacc.c  */
#line 5923 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 924:

/* Line 1464 of yacc.c  */
#line 5931 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 925:

/* Line 1464 of yacc.c  */
#line 5939 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 926:

/* Line 1464 of yacc.c  */
#line 5948 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 927:

/* Line 1464 of yacc.c  */
#line 5956 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 928:

/* Line 1464 of yacc.c  */
#line 5964 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 929:

/* Line 1464 of yacc.c  */
#line 5973 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 930:

/* Line 1464 of yacc.c  */
#line 5982 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 931:

/* Line 1464 of yacc.c  */
#line 5991 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 932:

/* Line 1464 of yacc.c  */
#line 5999 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 933:

/* Line 1464 of yacc.c  */
#line 6007 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 934:

/* Line 1464 of yacc.c  */
#line 6015 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 935:

/* Line 1464 of yacc.c  */
#line 6023 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 936:

/* Line 1464 of yacc.c  */
#line 6031 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 937:

/* Line 1464 of yacc.c  */
#line 6039 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 938:

/* Line 1464 of yacc.c  */
#line 6055 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 939:

/* Line 1464 of yacc.c  */
#line 6063 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (4)].str)));
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 940:

/* Line 1464 of yacc.c  */
#line 6071 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 941:

/* Line 1464 of yacc.c  */
#line 6079 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (7)].range);
					n->addname = (yyvsp[(6) - (7)].str);
					n->secLabel = (yyvsp[(7) - (7)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 942:

/* Line 1464 of yacc.c  */
#line 6088 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 943:

/* Line 1464 of yacc.c  */
#line 6096 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (4)].range);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 944:

/* Line 1464 of yacc.c  */
#line 6104 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (4)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (4)].funwithargs)->funcargs;
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 945:

/* Line 1464 of yacc.c  */
#line 6113 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (5)].list);
					n->objarg = (yyvsp[(4) - (5)].list);
					n->secLabel = (yyvsp[(5) - (5)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 946:

/* Line 1464 of yacc.c  */
#line 6122 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
					n->secLabel = (yyvsp[(5) - (5)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 947:

/* Line 1464 of yacc.c  */
#line 6130 "gram.y"
    {
					AlterSecLabelStmt *n = makeNode(AlterSecLabelStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (4)].list);
					n->secLabel = (yyvsp[(4) - (4)].value);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 948:

/* Line 1464 of yacc.c  */
#line 6140 "gram.y"
    {
					(yyval.value) = makeString((yyvsp[(4) - (4)].str));
				;}
    break;

  case 949:

/* Line 1464 of yacc.c  */
#line 6154 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 950:

/* Line 1464 of yacc.c  */
#line 6168 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 951:

/* Line 1464 of yacc.c  */
#line 6169 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 952:

/* Line 1464 of yacc.c  */
#line 6170 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 953:

/* Line 1464 of yacc.c  */
#line 6176 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 954:

/* Line 1464 of yacc.c  */
#line 6182 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				;}
    break;

  case 960:

/* Line 1464 of yacc.c  */
#line 6198 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 961:

/* Line 1464 of yacc.c  */
#line 6199 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 962:

/* Line 1464 of yacc.c  */
#line 6202 "gram.y"
    { (yyval.ival) = CMD_SELECT; ;}
    break;

  case 963:

/* Line 1464 of yacc.c  */
#line 6203 "gram.y"
    { (yyval.ival) = CMD_UPDATE; ;}
    break;

  case 964:

/* Line 1464 of yacc.c  */
#line 6204 "gram.y"
    { (yyval.ival) = CMD_DELETE; ;}
    break;

  case 965:

/* Line 1464 of yacc.c  */
#line 6205 "gram.y"
    { (yyval.ival) = CMD_INSERT; ;}
    break;

  case 966:

/* Line 1464 of yacc.c  */
#line 6209 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 967:

/* Line 1464 of yacc.c  */
#line 6210 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 968:

/* Line 1464 of yacc.c  */
#line 6211 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 969:

/* Line 1464 of yacc.c  */
#line 6217 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 970:

/* Line 1464 of yacc.c  */
#line 6227 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 971:

/* Line 1464 of yacc.c  */
#line 6248 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 972:

/* Line 1464 of yacc.c  */
#line 6257 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 973:

/* Line 1464 of yacc.c  */
#line 6258 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 974:

/* Line 1464 of yacc.c  */
#line 6262 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 975:

/* Line 1464 of yacc.c  */
#line 6271 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 976:

/* Line 1464 of yacc.c  */
#line 6277 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 977:

/* Line 1464 of yacc.c  */
#line 6296 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 978:

/* Line 1464 of yacc.c  */
#line 6303 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 979:

/* Line 1464 of yacc.c  */
#line 6310 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 980:

/* Line 1464 of yacc.c  */
#line 6317 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 981:

/* Line 1464 of yacc.c  */
#line 6324 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 982:

/* Line 1464 of yacc.c  */
#line 6331 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 983:

/* Line 1464 of yacc.c  */
#line 6338 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 984:

/* Line 1464 of yacc.c  */
#line 6346 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 985:

/* Line 1464 of yacc.c  */
#line 6354 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 986:

/* Line 1464 of yacc.c  */
#line 6362 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 987:

/* Line 1464 of yacc.c  */
#line 6370 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 988:

/* Line 1464 of yacc.c  */
#line 6378 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 989:

/* Line 1464 of yacc.c  */
#line 6385 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 990:

/* Line 1464 of yacc.c  */
#line 6392 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 991:

/* Line 1464 of yacc.c  */
#line 6400 "gram.y"
    {;}
    break;

  case 992:

/* Line 1464 of yacc.c  */
#line 6401 "gram.y"
    {;}
    break;

  case 993:

/* Line 1464 of yacc.c  */
#line 6402 "gram.y"
    {;}
    break;

  case 994:

/* Line 1464 of yacc.c  */
#line 6407 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); ;}
    break;

  case 995:

/* Line 1464 of yacc.c  */
#line 6410 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); ;}
    break;

  case 996:

/* Line 1464 of yacc.c  */
#line 6413 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); ;}
    break;

  case 997:

/* Line 1464 of yacc.c  */
#line 6420 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 998:

/* Line 1464 of yacc.c  */
#line 6422 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 999:

/* Line 1464 of yacc.c  */
#line 6424 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1001:

/* Line 1464 of yacc.c  */
#line 6430 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1002:

/* Line 1464 of yacc.c  */
#line 6444 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (yyvsp[(7) - (8)].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1003:

/* Line 1464 of yacc.c  */
#line 6455 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (yyvsp[(9) - (10)].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1004:

/* Line 1464 of yacc.c  */
#line 6468 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1005:

/* Line 1464 of yacc.c  */
#line 6474 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1006:

/* Line 1464 of yacc.c  */
#line 6480 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 1007:

/* Line 1464 of yacc.c  */
#line 6485 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1008:

/* Line 1464 of yacc.c  */
#line 6496 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1009:

/* Line 1464 of yacc.c  */
#line 6512 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1010:

/* Line 1464 of yacc.c  */
#line 6521 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1011:

/* Line 1464 of yacc.c  */
#line 6522 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1012:

/* Line 1464 of yacc.c  */
#line 6527 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1013:

/* Line 1464 of yacc.c  */
#line 6531 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				;}
    break;

  case 1014:

/* Line 1464 of yacc.c  */
#line 6535 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1015:

/* Line 1464 of yacc.c  */
#line 6539 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				;}
    break;

  case 1016:

/* Line 1464 of yacc.c  */
#line 6543 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1017:

/* Line 1464 of yacc.c  */
#line 6547 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				;}
    break;

  case 1018:

/* Line 1464 of yacc.c  */
#line 6551 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1019:

/* Line 1464 of yacc.c  */
#line 6555 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 1020:

/* Line 1464 of yacc.c  */
#line 6559 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				;}
    break;

  case 1021:

/* Line 1464 of yacc.c  */
#line 6563 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1022:

/* Line 1464 of yacc.c  */
#line 6567 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				;}
    break;

  case 1023:

/* Line 1464 of yacc.c  */
#line 6571 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1024:

/* Line 1464 of yacc.c  */
#line 6575 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				;}
    break;

  case 1025:

/* Line 1464 of yacc.c  */
#line 6579 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1026:

/* Line 1464 of yacc.c  */
#line 6583 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1027:

/* Line 1464 of yacc.c  */
#line 6587 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				;}
    break;

  case 1028:

/* Line 1464 of yacc.c  */
#line 6596 "gram.y"
    {;}
    break;

  case 1029:

/* Line 1464 of yacc.c  */
#line 6597 "gram.y"
    {;}
    break;

  case 1030:

/* Line 1464 of yacc.c  */
#line 6609 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1031:

/* Line 1464 of yacc.c  */
#line 6616 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1032:

/* Line 1464 of yacc.c  */
#line 6627 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1033:

/* Line 1464 of yacc.c  */
#line 6637 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1034:

/* Line 1464 of yacc.c  */
#line 6638 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1035:

/* Line 1464 of yacc.c  */
#line 6643 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1036:

/* Line 1464 of yacc.c  */
#line 6657 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1037:

/* Line 1464 of yacc.c  */
#line 6664 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1038:

/* Line 1464 of yacc.c  */
#line 6681 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1039:

/* Line 1464 of yacc.c  */
#line 6693 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1040:

/* Line 1464 of yacc.c  */
#line 6702 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1041:

/* Line 1464 of yacc.c  */
#line 6710 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1042:

/* Line 1464 of yacc.c  */
#line 6718 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1043:

/* Line 1464 of yacc.c  */
#line 6727 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1044:

/* Line 1464 of yacc.c  */
#line 6737 "gram.y"
    {;}
    break;

  case 1045:

/* Line 1464 of yacc.c  */
#line 6738 "gram.y"
    {;}
    break;

  case 1046:

/* Line 1464 of yacc.c  */
#line 6750 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1047:

/* Line 1464 of yacc.c  */
#line 6760 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1048:

/* Line 1464 of yacc.c  */
#line 6770 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1049:

/* Line 1464 of yacc.c  */
#line 6780 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1050:

/* Line 1464 of yacc.c  */
#line 6790 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1051:

/* Line 1464 of yacc.c  */
#line 6800 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1052:

/* Line 1464 of yacc.c  */
#line 6808 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1053:

/* Line 1464 of yacc.c  */
#line 6830 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			;}
    break;

  case 1054:

/* Line 1464 of yacc.c  */
#line 6852 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(3) - (4)].range);
				   n->indexname = (yyvsp[(4) - (4)].str);
				   n->verbose = (yyvsp[(2) - (4)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1055:

/* Line 1464 of yacc.c  */
#line 6860 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   n->verbose = (yyvsp[(2) - (2)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1056:

/* Line 1464 of yacc.c  */
#line 6869 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(5) - (5)].range);
				   n->indexname = (yyvsp[(3) - (5)].str);
				   n->verbose = (yyvsp[(2) - (5)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1057:

/* Line 1464 of yacc.c  */
#line 6879 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 1058:

/* Line 1464 of yacc.c  */
#line 6880 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1059:

/* Line 1464 of yacc.c  */
#line 6893 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1060:

/* Line 1464 of yacc.c  */
#line 6907 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1061:

/* Line 1464 of yacc.c  */
#line 6921 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1062:

/* Line 1464 of yacc.c  */
#line 6933 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1063:

/* Line 1464 of yacc.c  */
#line 6945 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1064:

/* Line 1464 of yacc.c  */
#line 6961 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1065:

/* Line 1464 of yacc.c  */
#line 6962 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 1066:

/* Line 1464 of yacc.c  */
#line 6966 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; ;}
    break;

  case 1067:

/* Line 1464 of yacc.c  */
#line 6967 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; ;}
    break;

  case 1068:

/* Line 1464 of yacc.c  */
#line 6968 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; ;}
    break;

  case 1069:

/* Line 1464 of yacc.c  */
#line 6969 "gram.y"
    { (yyval.ival) = VACOPT_FULL; ;}
    break;

  case 1070:

/* Line 1464 of yacc.c  */
#line 6974 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1071:

/* Line 1464 of yacc.c  */
#line 6986 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1072:

/* Line 1464 of yacc.c  */
#line 7000 "gram.y"
    {;}
    break;

  case 1073:

/* Line 1464 of yacc.c  */
#line 7001 "gram.y"
    {;}
    break;

  case 1074:

/* Line 1464 of yacc.c  */
#line 7005 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1075:

/* Line 1464 of yacc.c  */
#line 7006 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1076:

/* Line 1464 of yacc.c  */
#line 7009 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1077:

/* Line 1464 of yacc.c  */
#line 7010 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1078:

/* Line 1464 of yacc.c  */
#line 7013 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1079:

/* Line 1464 of yacc.c  */
#line 7014 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1080:

/* Line 1464 of yacc.c  */
#line 7018 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1081:

/* Line 1464 of yacc.c  */
#line 7019 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1082:

/* Line 1464 of yacc.c  */
#line 7033 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1083:

/* Line 1464 of yacc.c  */
#line 7040 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1084:

/* Line 1464 of yacc.c  */
#line 7050 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1085:

/* Line 1464 of yacc.c  */
#line 7057 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1093:

/* Line 1464 of yacc.c  */
#line 7077 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 1094:

/* Line 1464 of yacc.c  */
#line 7081 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 1095:

/* Line 1464 of yacc.c  */
#line 7088 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1096:

/* Line 1464 of yacc.c  */
#line 7094 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1097:

/* Line 1464 of yacc.c  */
#line 7095 "gram.y"
    { (yyval.str) = "analyze"; ;}
    break;

  case 1098:

/* Line 1464 of yacc.c  */
#line 7096 "gram.y"
    { (yyval.str) = "verbose"; ;}
    break;

  case 1099:

/* Line 1464 of yacc.c  */
#line 7100 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 1100:

/* Line 1464 of yacc.c  */
#line 7101 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 1101:

/* Line 1464 of yacc.c  */
#line 7102 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1102:

/* Line 1464 of yacc.c  */
#line 7113 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1103:

/* Line 1464 of yacc.c  */
#line 7122 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1104:

/* Line 1464 of yacc.c  */
#line 7123 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1109:

/* Line 1464 of yacc.c  */
#line 7141 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1110:

/* Line 1464 of yacc.c  */
#line 7150 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (8)].str);
					n->params = (yyvsp[(8) - (8)].list);
					(yyvsp[(4) - (8)].into)->rel->istemp = (yyvsp[(2) - (8)].boolean);
					n->into = (yyvsp[(4) - (8)].into);
					if ((yyvsp[(4) - (8)].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1111:

/* Line 1464 of yacc.c  */
#line 7165 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1112:

/* Line 1464 of yacc.c  */
#line 7166 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1113:

/* Line 1464 of yacc.c  */
#line 7177 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1114:

/* Line 1464 of yacc.c  */
#line 7183 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1115:

/* Line 1464 of yacc.c  */
#line 7189 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1116:

/* Line 1464 of yacc.c  */
#line 7195 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1117:

/* Line 1464 of yacc.c  */
#line 7211 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				;}
    break;

  case 1118:

/* Line 1464 of yacc.c  */
#line 7220 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1119:

/* Line 1464 of yacc.c  */
#line 7226 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				;}
    break;

  case 1120:

/* Line 1464 of yacc.c  */
#line 7232 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				;}
    break;

  case 1121:

/* Line 1464 of yacc.c  */
#line 7241 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1122:

/* Line 1464 of yacc.c  */
#line 7243 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1123:

/* Line 1464 of yacc.c  */
#line 7248 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1124:

/* Line 1464 of yacc.c  */
#line 7258 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1125:

/* Line 1464 of yacc.c  */
#line 7259 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1126:

/* Line 1464 of yacc.c  */
#line 7272 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1127:

/* Line 1464 of yacc.c  */
#line 7283 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1128:

/* Line 1464 of yacc.c  */
#line 7284 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1129:

/* Line 1464 of yacc.c  */
#line 7296 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1130:

/* Line 1464 of yacc.c  */
#line 7306 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); ;}
    break;

  case 1131:

/* Line 1464 of yacc.c  */
#line 7307 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1132:

/* Line 1464 of yacc.c  */
#line 7310 "gram.y"
    { (yyval.ival) = AccessShareLock; ;}
    break;

  case 1133:

/* Line 1464 of yacc.c  */
#line 7311 "gram.y"
    { (yyval.ival) = RowShareLock; ;}
    break;

  case 1134:

/* Line 1464 of yacc.c  */
#line 7312 "gram.y"
    { (yyval.ival) = RowExclusiveLock; ;}
    break;

  case 1135:

/* Line 1464 of yacc.c  */
#line 7313 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; ;}
    break;

  case 1136:

/* Line 1464 of yacc.c  */
#line 7314 "gram.y"
    { (yyval.ival) = ShareLock; ;}
    break;

  case 1137:

/* Line 1464 of yacc.c  */
#line 7315 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; ;}
    break;

  case 1138:

/* Line 1464 of yacc.c  */
#line 7316 "gram.y"
    { (yyval.ival) = ExclusiveLock; ;}
    break;

  case 1139:

/* Line 1464 of yacc.c  */
#line 7317 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1140:

/* Line 1464 of yacc.c  */
#line 7320 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1141:

/* Line 1464 of yacc.c  */
#line 7321 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1142:

/* Line 1464 of yacc.c  */
#line 7337 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1143:

/* Line 1464 of yacc.c  */
#line 7349 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1144:

/* Line 1464 of yacc.c  */
#line 7350 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); ;}
    break;

  case 1145:

/* Line 1464 of yacc.c  */
#line 7354 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1146:

/* Line 1464 of yacc.c  */
#line 7355 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1147:

/* Line 1464 of yacc.c  */
#line 7360 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				;}
    break;

  case 1148:

/* Line 1464 of yacc.c  */
#line 7368 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				;}
    break;

  case 1149:

/* Line 1464 of yacc.c  */
#line 7396 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1150:

/* Line 1464 of yacc.c  */
#line 7406 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1151:

/* Line 1464 of yacc.c  */
#line 7407 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); ;}
    break;

  case 1152:

/* Line 1464 of yacc.c  */
#line 7418 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1153:

/* Line 1464 of yacc.c  */
#line 7428 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1154:

/* Line 1464 of yacc.c  */
#line 7431 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1155:

/* Line 1464 of yacc.c  */
#line 7432 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; ;}
    break;

  case 1156:

/* Line 1464 of yacc.c  */
#line 7433 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; ;}
    break;

  case 1157:

/* Line 1464 of yacc.c  */
#line 7434 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; ;}
    break;

  case 1158:

/* Line 1464 of yacc.c  */
#line 7435 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; ;}
    break;

  case 1159:

/* Line 1464 of yacc.c  */
#line 7438 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1160:

/* Line 1464 of yacc.c  */
#line 7439 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; ;}
    break;

  case 1161:

/* Line 1464 of yacc.c  */
#line 7440 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1164:

/* Line 1464 of yacc.c  */
#line 7493 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1165:

/* Line 1464 of yacc.c  */
#line 7494 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1166:

/* Line 1464 of yacc.c  */
#line 7508 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1167:

/* Line 1464 of yacc.c  */
#line 7510 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				;}
    break;

  case 1168:

/* Line 1464 of yacc.c  */
#line 7517 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1169:

/* Line 1464 of yacc.c  */
#line 7525 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1170:

/* Line 1464 of yacc.c  */
#line 7533 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				;}
    break;

  case 1171:

/* Line 1464 of yacc.c  */
#line 7541 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				;}
    break;

  case 1172:

/* Line 1464 of yacc.c  */
#line 7549 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1173:

/* Line 1464 of yacc.c  */
#line 7557 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1174:

/* Line 1464 of yacc.c  */
#line 7567 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1175:

/* Line 1464 of yacc.c  */
#line 7568 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1176:

/* Line 1464 of yacc.c  */
#line 7598 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1177:

/* Line 1464 of yacc.c  */
#line 7610 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1178:

/* Line 1464 of yacc.c  */
#line 7612 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1179:

/* Line 1464 of yacc.c  */
#line 7631 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1180:

/* Line 1464 of yacc.c  */
#line 7635 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1181:

/* Line 1464 of yacc.c  */
#line 7639 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1182:

/* Line 1464 of yacc.c  */
#line 7654 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			;}
    break;

  case 1183:

/* Line 1464 of yacc.c  */
#line 7661 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			;}
    break;

  case 1184:

/* Line 1464 of yacc.c  */
#line 7670 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1185:

/* Line 1464 of yacc.c  */
#line 7671 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1186:

/* Line 1464 of yacc.c  */
#line 7675 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (4)].str);
				n->aliascolnames = (yyvsp[(2) - (4)].list);
				n->ctequery = (yyvsp[(4) - (4)].node);
				n->location = (yylsp[(1) - (4)]);
				(yyval.node) = (Node *) n;
			;}
    break;

  case 1187:

/* Line 1464 of yacc.c  */
#line 7687 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				;}
    break;

  case 1188:

/* Line 1464 of yacc.c  */
#line 7696 "gram.y"
    { (yyval.into) = NULL; ;}
    break;

  case 1189:

/* Line 1464 of yacc.c  */
#line 7705 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1190:

/* Line 1464 of yacc.c  */
#line 7710 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1191:

/* Line 1464 of yacc.c  */
#line 7715 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1192:

/* Line 1464 of yacc.c  */
#line 7720 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1193:

/* Line 1464 of yacc.c  */
#line 7725 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1194:

/* Line 1464 of yacc.c  */
#line 7730 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1195:

/* Line 1464 of yacc.c  */
#line 7735 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1196:

/* Line 1464 of yacc.c  */
#line 7740 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1197:

/* Line 1464 of yacc.c  */
#line 7746 "gram.y"
    {;}
    break;

  case 1198:

/* Line 1464 of yacc.c  */
#line 7747 "gram.y"
    {;}
    break;

  case 1199:

/* Line 1464 of yacc.c  */
#line 7750 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1200:

/* Line 1464 of yacc.c  */
#line 7751 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1201:

/* Line 1464 of yacc.c  */
#line 7752 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1202:

/* Line 1464 of yacc.c  */
#line 7759 "gram.y"
    { (yyval.list) = list_make1(NIL); ;}
    break;

  case 1203:

/* Line 1464 of yacc.c  */
#line 7760 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 1204:

/* Line 1464 of yacc.c  */
#line 7761 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1205:

/* Line 1464 of yacc.c  */
#line 7762 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1206:

/* Line 1464 of yacc.c  */
#line 7766 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);;}
    break;

  case 1207:

/* Line 1464 of yacc.c  */
#line 7767 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1208:

/* Line 1464 of yacc.c  */
#line 7771 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1209:

/* Line 1464 of yacc.c  */
#line 7775 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); ;}
    break;

  case 1210:

/* Line 1464 of yacc.c  */
#line 7776 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); ;}
    break;

  case 1211:

/* Line 1464 of yacc.c  */
#line 7780 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				;}
    break;

  case 1212:

/* Line 1464 of yacc.c  */
#line 7789 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				;}
    break;

  case 1213:

/* Line 1464 of yacc.c  */
#line 7801 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); ;}
    break;

  case 1214:

/* Line 1464 of yacc.c  */
#line 7802 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1215:

/* Line 1464 of yacc.c  */
#line 7803 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); ;}
    break;

  case 1216:

/* Line 1464 of yacc.c  */
#line 7804 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); ;}
    break;

  case 1217:

/* Line 1464 of yacc.c  */
#line 7808 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1218:

/* Line 1464 of yacc.c  */
#line 7809 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); ;}
    break;

  case 1219:

/* Line 1464 of yacc.c  */
#line 7814 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1220:

/* Line 1464 of yacc.c  */
#line 7816 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				;}
    break;

  case 1221:

/* Line 1464 of yacc.c  */
#line 7826 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); ;}
    break;

  case 1222:

/* Line 1464 of yacc.c  */
#line 7831 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1223:

/* Line 1464 of yacc.c  */
#line 7834 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1224:

/* Line 1464 of yacc.c  */
#line 7838 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1225:

/* Line 1464 of yacc.c  */
#line 7840 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1226:

/* Line 1464 of yacc.c  */
#line 7847 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1227:

/* Line 1464 of yacc.c  */
#line 7857 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); ;}
    break;

  case 1228:

/* Line 1464 of yacc.c  */
#line 7858 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1229:

/* Line 1464 of yacc.c  */
#line 7859 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); ;}
    break;

  case 1230:

/* Line 1464 of yacc.c  */
#line 7867 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1231:

/* Line 1464 of yacc.c  */
#line 7871 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1232:

/* Line 1464 of yacc.c  */
#line 7872 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1233:

/* Line 1464 of yacc.c  */
#line 7875 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1234:

/* Line 1464 of yacc.c  */
#line 7876 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1235:

/* Line 1464 of yacc.c  */
#line 7881 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1236:

/* Line 1464 of yacc.c  */
#line 7882 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1237:

/* Line 1464 of yacc.c  */
#line 7886 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1238:

/* Line 1464 of yacc.c  */
#line 7887 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1239:

/* Line 1464 of yacc.c  */
#line 7891 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1240:

/* Line 1464 of yacc.c  */
#line 7892 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1241:

/* Line 1464 of yacc.c  */
#line 7896 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1242:

/* Line 1464 of yacc.c  */
#line 7897 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1243:

/* Line 1464 of yacc.c  */
#line 7901 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1244:

/* Line 1464 of yacc.c  */
#line 7902 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1245:

/* Line 1464 of yacc.c  */
#line 7907 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1246:

/* Line 1464 of yacc.c  */
#line 7915 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1247:

/* Line 1464 of yacc.c  */
#line 7925 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1248:

/* Line 1464 of yacc.c  */
#line 7926 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1249:

/* Line 1464 of yacc.c  */
#line 7932 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1250:

/* Line 1464 of yacc.c  */
#line 7938 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1251:

/* Line 1464 of yacc.c  */
#line 7955 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1252:

/* Line 1464 of yacc.c  */
#line 7956 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1253:

/* Line 1464 of yacc.c  */
#line 7960 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1254:

/* Line 1464 of yacc.c  */
#line 7961 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1255:

/* Line 1464 of yacc.c  */
#line 7972 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1256:

/* Line 1464 of yacc.c  */
#line 7976 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1257:

/* Line 1464 of yacc.c  */
#line 7981 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1258:

/* Line 1464 of yacc.c  */
#line 7988 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1259:

/* Line 1464 of yacc.c  */
#line 7996 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1260:

/* Line 1464 of yacc.c  */
#line 8003 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1261:

/* Line 1464 of yacc.c  */
#line 8013 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1262:

/* Line 1464 of yacc.c  */
#line 8023 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.node) = NULL;
				;}
    break;

  case 1263:

/* Line 1464 of yacc.c  */
#line 8051 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1264:

/* Line 1464 of yacc.c  */
#line 8058 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				;}
    break;

  case 1265:

/* Line 1464 of yacc.c  */
#line 8062 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				;}
    break;

  case 1266:

/* Line 1464 of yacc.c  */
#line 8088 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				;}
    break;

  case 1267:

/* Line 1464 of yacc.c  */
#line 8092 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				;}
    break;

  case 1268:

/* Line 1464 of yacc.c  */
#line 8104 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1269:

/* Line 1464 of yacc.c  */
#line 8117 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1270:

/* Line 1464 of yacc.c  */
#line 8131 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1271:

/* Line 1464 of yacc.c  */
#line 8142 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1272:

/* Line 1464 of yacc.c  */
#line 8157 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				;}
    break;

  case 1273:

/* Line 1464 of yacc.c  */
#line 8163 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				;}
    break;

  case 1274:

/* Line 1464 of yacc.c  */
#line 8168 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				;}
    break;

  case 1275:

/* Line 1464 of yacc.c  */
#line 8174 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 1276:

/* Line 1464 of yacc.c  */
#line 8180 "gram.y"
    { (yyval.jtype) = JOIN_FULL; ;}
    break;

  case 1277:

/* Line 1464 of yacc.c  */
#line 8181 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; ;}
    break;

  case 1278:

/* Line 1464 of yacc.c  */
#line 8182 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; ;}
    break;

  case 1279:

/* Line 1464 of yacc.c  */
#line 8183 "gram.y"
    { (yyval.jtype) = JOIN_INNER; ;}
    break;

  case 1280:

/* Line 1464 of yacc.c  */
#line 8187 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1281:

/* Line 1464 of yacc.c  */
#line 8188 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1282:

/* Line 1464 of yacc.c  */
#line 8200 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); ;}
    break;

  case 1283:

/* Line 1464 of yacc.c  */
#line 8201 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1284:

/* Line 1464 of yacc.c  */
#line 8207 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1285:

/* Line 1464 of yacc.c  */
#line 8214 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1286:

/* Line 1464 of yacc.c  */
#line 8221 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1287:

/* Line 1464 of yacc.c  */
#line 8228 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1288:

/* Line 1464 of yacc.c  */
#line 8238 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1289:

/* Line 1464 of yacc.c  */
#line 8239 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1290:

/* Line 1464 of yacc.c  */
#line 8253 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1291:

/* Line 1464 of yacc.c  */
#line 8257 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1292:

/* Line 1464 of yacc.c  */
#line 8264 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				;}
    break;

  case 1293:

/* Line 1464 of yacc.c  */
#line 8273 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1294:

/* Line 1464 of yacc.c  */
#line 8278 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1295:

/* Line 1464 of yacc.c  */
#line 8279 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1296:

/* Line 1464 of yacc.c  */
#line 8284 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1297:

/* Line 1464 of yacc.c  */
#line 8286 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1298:

/* Line 1464 of yacc.c  */
#line 8293 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1299:

/* Line 1464 of yacc.c  */
#line 8299 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1300:

/* Line 1464 of yacc.c  */
#line 8303 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1301:

/* Line 1464 of yacc.c  */
#line 8309 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typeName = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1302:

/* Line 1464 of yacc.c  */
#line 8330 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1303:

/* Line 1464 of yacc.c  */
#line 8335 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1304:

/* Line 1464 of yacc.c  */
#line 8342 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				;}
    break;

  case 1305:

/* Line 1464 of yacc.c  */
#line 8347 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1306:

/* Line 1464 of yacc.c  */
#line 8353 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				;}
    break;

  case 1307:

/* Line 1464 of yacc.c  */
#line 8358 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1308:

/* Line 1464 of yacc.c  */
#line 8367 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); ;}
    break;

  case 1309:

/* Line 1464 of yacc.c  */
#line 8369 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); ;}
    break;

  case 1310:

/* Line 1464 of yacc.c  */
#line 8371 "gram.y"
    {  (yyval.list) = NIL; ;}
    break;

  case 1311:

/* Line 1464 of yacc.c  */
#line 8375 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1312:

/* Line 1464 of yacc.c  */
#line 8376 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1313:

/* Line 1464 of yacc.c  */
#line 8377 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1314:

/* Line 1464 of yacc.c  */
#line 8378 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1315:

/* Line 1464 of yacc.c  */
#line 8379 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1316:

/* Line 1464 of yacc.c  */
#line 8381 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1317:

/* Line 1464 of yacc.c  */
#line 8386 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				;}
    break;

  case 1318:

/* Line 1464 of yacc.c  */
#line 8415 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1319:

/* Line 1464 of yacc.c  */
#line 8416 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1320:

/* Line 1464 of yacc.c  */
#line 8417 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1321:

/* Line 1464 of yacc.c  */
#line 8418 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1322:

/* Line 1464 of yacc.c  */
#line 8430 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1323:

/* Line 1464 of yacc.c  */
#line 8436 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1324:

/* Line 1464 of yacc.c  */
#line 8443 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1325:

/* Line 1464 of yacc.c  */
#line 8444 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1326:

/* Line 1464 of yacc.c  */
#line 8451 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1327:

/* Line 1464 of yacc.c  */
#line 8456 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1328:

/* Line 1464 of yacc.c  */
#line 8461 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1329:

/* Line 1464 of yacc.c  */
#line 8466 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1330:

/* Line 1464 of yacc.c  */
#line 8471 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1331:

/* Line 1464 of yacc.c  */
#line 8476 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1332:

/* Line 1464 of yacc.c  */
#line 8481 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1333:

/* Line 1464 of yacc.c  */
#line 8486 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1334:

/* Line 1464 of yacc.c  */
#line 8492 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1335:

/* Line 1464 of yacc.c  */
#line 8498 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1336:

/* Line 1464 of yacc.c  */
#line 8504 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1337:

/* Line 1464 of yacc.c  */
#line 8511 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				;}
    break;

  case 1338:

/* Line 1464 of yacc.c  */
#line 8532 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1339:

/* Line 1464 of yacc.c  */
#line 8542 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1340:

/* Line 1464 of yacc.c  */
#line 8546 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1341:

/* Line 1464 of yacc.c  */
#line 8554 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1342:

/* Line 1464 of yacc.c  */
#line 8558 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1343:

/* Line 1464 of yacc.c  */
#line 8566 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1344:

/* Line 1464 of yacc.c  */
#line 8578 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1345:

/* Line 1464 of yacc.c  */
#line 8599 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1346:

/* Line 1464 of yacc.c  */
#line 8603 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1347:

/* Line 1464 of yacc.c  */
#line 8609 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1348:

/* Line 1464 of yacc.c  */
#line 8613 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1349:

/* Line 1464 of yacc.c  */
#line 8626 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1350:

/* Line 1464 of yacc.c  */
#line 8645 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1351:

/* Line 1464 of yacc.c  */
#line 8668 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1352:

/* Line 1464 of yacc.c  */
#line 8670 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1353:

/* Line 1464 of yacc.c  */
#line 8672 "gram.y"
    { (yyval.str) = "varchar"; ;}
    break;

  case 1354:

/* Line 1464 of yacc.c  */
#line 8674 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1355:

/* Line 1464 of yacc.c  */
#line 8676 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1356:

/* Line 1464 of yacc.c  */
#line 8678 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1357:

/* Line 1464 of yacc.c  */
#line 8682 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1358:

/* Line 1464 of yacc.c  */
#line 8683 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1359:

/* Line 1464 of yacc.c  */
#line 8687 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 1360:

/* Line 1464 of yacc.c  */
#line 8688 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1361:

/* Line 1464 of yacc.c  */
#line 8696 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1362:

/* Line 1464 of yacc.c  */
#line 8705 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1363:

/* Line 1464 of yacc.c  */
#line 8713 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1364:

/* Line 1464 of yacc.c  */
#line 8722 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1365:

/* Line 1464 of yacc.c  */
#line 8733 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1366:

/* Line 1464 of yacc.c  */
#line 8740 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1367:

/* Line 1464 of yacc.c  */
#line 8741 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1368:

/* Line 1464 of yacc.c  */
#line 8742 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1369:

/* Line 1464 of yacc.c  */
#line 8747 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1370:

/* Line 1464 of yacc.c  */
#line 8749 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); ;}
    break;

  case 1371:

/* Line 1464 of yacc.c  */
#line 8751 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); ;}
    break;

  case 1372:

/* Line 1464 of yacc.c  */
#line 8753 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1373:

/* Line 1464 of yacc.c  */
#line 8755 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); ;}
    break;

  case 1374:

/* Line 1464 of yacc.c  */
#line 8757 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1375:

/* Line 1464 of yacc.c  */
#line 8759 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				;}
    break;

  case 1376:

/* Line 1464 of yacc.c  */
#line 8764 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				;}
    break;

  case 1377:

/* Line 1464 of yacc.c  */
#line 8769 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1378:

/* Line 1464 of yacc.c  */
#line 8775 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1379:

/* Line 1464 of yacc.c  */
#line 8783 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1380:

/* Line 1464 of yacc.c  */
#line 8788 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1381:

/* Line 1464 of yacc.c  */
#line 8795 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1382:

/* Line 1464 of yacc.c  */
#line 8801 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1383:

/* Line 1464 of yacc.c  */
#line 8806 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				;}
    break;

  case 1384:

/* Line 1464 of yacc.c  */
#line 8810 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				;}
    break;

  case 1385:

/* Line 1464 of yacc.c  */
#line 8839 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1386:

/* Line 1464 of yacc.c  */
#line 8841 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1387:

/* Line 1464 of yacc.c  */
#line 8843 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1388:

/* Line 1464 of yacc.c  */
#line 8865 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1389:

/* Line 1464 of yacc.c  */
#line 8867 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1390:

/* Line 1464 of yacc.c  */
#line 8869 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1391:

/* Line 1464 of yacc.c  */
#line 8871 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1392:

/* Line 1464 of yacc.c  */
#line 8873 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1393:

/* Line 1464 of yacc.c  */
#line 8875 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1394:

/* Line 1464 of yacc.c  */
#line 8877 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1395:

/* Line 1464 of yacc.c  */
#line 8879 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1396:

/* Line 1464 of yacc.c  */
#line 8881 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1397:

/* Line 1464 of yacc.c  */
#line 8883 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1398:

/* Line 1464 of yacc.c  */
#line 8885 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1399:

/* Line 1464 of yacc.c  */
#line 8888 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1400:

/* Line 1464 of yacc.c  */
#line 8890 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1401:

/* Line 1464 of yacc.c  */
#line 8892 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1402:

/* Line 1464 of yacc.c  */
#line 8895 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1403:

/* Line 1464 of yacc.c  */
#line 8897 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1404:

/* Line 1464 of yacc.c  */
#line 8899 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1405:

/* Line 1464 of yacc.c  */
#line 8902 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1406:

/* Line 1464 of yacc.c  */
#line 8904 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1407:

/* Line 1464 of yacc.c  */
#line 8917 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1408:

/* Line 1464 of yacc.c  */
#line 8919 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1409:

/* Line 1464 of yacc.c  */
#line 8932 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1410:

/* Line 1464 of yacc.c  */
#line 8934 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1411:

/* Line 1464 of yacc.c  */
#line 8947 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1412:

/* Line 1464 of yacc.c  */
#line 8949 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1413:

/* Line 1464 of yacc.c  */
#line 8963 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				;}
    break;

  case 1414:

/* Line 1464 of yacc.c  */
#line 8976 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1415:

/* Line 1464 of yacc.c  */
#line 8989 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1416:

/* Line 1464 of yacc.c  */
#line 9002 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				;}
    break;

  case 1417:

/* Line 1464 of yacc.c  */
#line 9025 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1418:

/* Line 1464 of yacc.c  */
#line 9032 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1419:

/* Line 1464 of yacc.c  */
#line 9039 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1420:

/* Line 1464 of yacc.c  */
#line 9046 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1421:

/* Line 1464 of yacc.c  */
#line 9053 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]), yyscanner);
				;}
    break;

  case 1422:

/* Line 1464 of yacc.c  */
#line 9057 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1423:

/* Line 1464 of yacc.c  */
#line 9064 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1424:

/* Line 1464 of yacc.c  */
#line 9071 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1425:

/* Line 1464 of yacc.c  */
#line 9078 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1426:

/* Line 1464 of yacc.c  */
#line 9085 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1427:

/* Line 1464 of yacc.c  */
#line 9092 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1428:

/* Line 1464 of yacc.c  */
#line 9099 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1429:

/* Line 1464 of yacc.c  */
#line 9103 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				;}
    break;

  case 1430:

/* Line 1464 of yacc.c  */
#line 9111 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1431:

/* Line 1464 of yacc.c  */
#line 9115 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1432:

/* Line 1464 of yacc.c  */
#line 9125 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1433:

/* Line 1464 of yacc.c  */
#line 9132 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1434:

/* Line 1464 of yacc.c  */
#line 9139 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1435:

/* Line 1464 of yacc.c  */
#line 9152 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1436:

/* Line 1464 of yacc.c  */
#line 9165 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				;}
    break;

  case 1437:

/* Line 1464 of yacc.c  */
#line 9184 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				;}
    break;

  case 1438:

/* Line 1464 of yacc.c  */
#line 9205 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1439:

/* Line 1464 of yacc.c  */
#line 9215 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				;}
    break;

  case 1440:

/* Line 1464 of yacc.c  */
#line 9222 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				;}
    break;

  case 1441:

/* Line 1464 of yacc.c  */
#line 9238 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1442:

/* Line 1464 of yacc.c  */
#line 9243 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1443:

/* Line 1464 of yacc.c  */
#line 9261 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1444:

/* Line 1464 of yacc.c  */
#line 9263 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1445:

/* Line 1464 of yacc.c  */
#line 9265 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1446:

/* Line 1464 of yacc.c  */
#line 9267 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1447:

/* Line 1464 of yacc.c  */
#line 9269 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1448:

/* Line 1464 of yacc.c  */
#line 9271 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1449:

/* Line 1464 of yacc.c  */
#line 9273 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1450:

/* Line 1464 of yacc.c  */
#line 9275 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1451:

/* Line 1464 of yacc.c  */
#line 9277 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1452:

/* Line 1464 of yacc.c  */
#line 9279 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1453:

/* Line 1464 of yacc.c  */
#line 9281 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1454:

/* Line 1464 of yacc.c  */
#line 9283 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1455:

/* Line 1464 of yacc.c  */
#line 9285 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1456:

/* Line 1464 of yacc.c  */
#line 9287 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1457:

/* Line 1464 of yacc.c  */
#line 9289 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1458:

/* Line 1464 of yacc.c  */
#line 9291 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1459:

/* Line 1464 of yacc.c  */
#line 9293 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1460:

/* Line 1464 of yacc.c  */
#line 9297 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				;}
    break;

  case 1461:

/* Line 1464 of yacc.c  */
#line 9302 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1462:

/* Line 1464 of yacc.c  */
#line 9306 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1463:

/* Line 1464 of yacc.c  */
#line 9310 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1464:

/* Line 1464 of yacc.c  */
#line 9315 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1465:

/* Line 1464 of yacc.c  */
#line 9331 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1466:

/* Line 1464 of yacc.c  */
#line 9332 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1467:

/* Line 1464 of yacc.c  */
#line 9334 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				;}
    break;

  case 1468:

/* Line 1464 of yacc.c  */
#line 9349 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				;}
    break;

  case 1469:

/* Line 1464 of yacc.c  */
#line 9361 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1470:

/* Line 1464 of yacc.c  */
#line 9363 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1471:

/* Line 1464 of yacc.c  */
#line 9365 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1472:

/* Line 1464 of yacc.c  */
#line 9375 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1473:

/* Line 1464 of yacc.c  */
#line 9385 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1474:

/* Line 1464 of yacc.c  */
#line 9395 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1475:

/* Line 1464 of yacc.c  */
#line 9403 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				;}
    break;

  case 1476:

/* Line 1464 of yacc.c  */
#line 9421 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1477:

/* Line 1464 of yacc.c  */
#line 9434 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1478:

/* Line 1464 of yacc.c  */
#line 9447 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1479:

/* Line 1464 of yacc.c  */
#line 9460 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1480:

/* Line 1464 of yacc.c  */
#line 9473 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(3) - (6)].list);
					n->agg_order = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1481:

/* Line 1464 of yacc.c  */
#line 9486 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1482:

/* Line 1464 of yacc.c  */
#line 9503 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1483:

/* Line 1464 of yacc.c  */
#line 9516 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1484:

/* Line 1464 of yacc.c  */
#line 9539 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), -1);
				;}
    break;

  case 1485:

/* Line 1464 of yacc.c  */
#line 9560 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), -1);
				;}
    break;

  case 1486:

/* Line 1464 of yacc.c  */
#line 9570 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1487:

/* Line 1464 of yacc.c  */
#line 9583 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1488:

/* Line 1464 of yacc.c  */
#line 9600 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1489:

/* Line 1464 of yacc.c  */
#line 9613 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), -1);
				;}
    break;

  case 1490:

/* Line 1464 of yacc.c  */
#line 9623 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, -1);
				;}
    break;

  case 1491:

/* Line 1464 of yacc.c  */
#line 9636 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), -1);
				;}
    break;

  case 1492:

/* Line 1464 of yacc.c  */
#line 9646 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1493:

/* Line 1464 of yacc.c  */
#line 9659 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1494:

/* Line 1464 of yacc.c  */
#line 9672 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1495:

/* Line 1464 of yacc.c  */
#line 9685 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1496:

/* Line 1464 of yacc.c  */
#line 9698 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1497:

/* Line 1464 of yacc.c  */
#line 9711 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1498:

/* Line 1464 of yacc.c  */
#line 9724 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1499:

/* Line 1464 of yacc.c  */
#line 9737 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); ;}
    break;

  case 1500:

/* Line 1464 of yacc.c  */
#line 9739 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1501:

/* Line 1464 of yacc.c  */
#line 9752 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1502:

/* Line 1464 of yacc.c  */
#line 9770 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1503:

/* Line 1464 of yacc.c  */
#line 9784 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1504:

/* Line 1464 of yacc.c  */
#line 9800 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1505:

/* Line 1464 of yacc.c  */
#line 9822 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1506:

/* Line 1464 of yacc.c  */
#line 9838 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1507:

/* Line 1464 of yacc.c  */
#line 9851 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1508:

/* Line 1464 of yacc.c  */
#line 9864 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1509:

/* Line 1464 of yacc.c  */
#line 9877 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				;}
    break;

  case 1510:

/* Line 1464 of yacc.c  */
#line 9881 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1511:

/* Line 1464 of yacc.c  */
#line 9888 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1512:

/* Line 1464 of yacc.c  */
#line 9896 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1513:

/* Line 1464 of yacc.c  */
#line 9904 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				;}
    break;

  case 1514:

/* Line 1464 of yacc.c  */
#line 9908 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1515:

/* Line 1464 of yacc.c  */
#line 9912 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				;}
    break;

  case 1516:

/* Line 1464 of yacc.c  */
#line 9916 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				;}
    break;

  case 1517:

/* Line 1464 of yacc.c  */
#line 9920 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				;}
    break;

  case 1518:

/* Line 1464 of yacc.c  */
#line 9924 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				;}
    break;

  case 1519:

/* Line 1464 of yacc.c  */
#line 9928 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				;}
    break;

  case 1520:

/* Line 1464 of yacc.c  */
#line 9937 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1521:

/* Line 1464 of yacc.c  */
#line 9941 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1522:

/* Line 1464 of yacc.c  */
#line 9945 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1523:

/* Line 1464 of yacc.c  */
#line 9950 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1524:

/* Line 1464 of yacc.c  */
#line 9964 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1525:

/* Line 1464 of yacc.c  */
#line 9966 "gram.y"
    { (yyval.node) = makeNullAConst(-1); ;}
    break;

  case 1526:

/* Line 1464 of yacc.c  */
#line 9970 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); ;}
    break;

  case 1527:

/* Line 1464 of yacc.c  */
#line 9972 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); ;}
    break;

  case 1528:

/* Line 1464 of yacc.c  */
#line 9974 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); ;}
    break;

  case 1529:

/* Line 1464 of yacc.c  */
#line 9976 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); ;}
    break;

  case 1530:

/* Line 1464 of yacc.c  */
#line 9979 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1531:

/* Line 1464 of yacc.c  */
#line 9982 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1532:

/* Line 1464 of yacc.c  */
#line 9983 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1533:

/* Line 1464 of yacc.c  */
#line 9987 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1534:

/* Line 1464 of yacc.c  */
#line 9995 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1535:

/* Line 1464 of yacc.c  */
#line 10004 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; ;}
    break;

  case 1536:

/* Line 1464 of yacc.c  */
#line 10005 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; ;}
    break;

  case 1537:

/* Line 1464 of yacc.c  */
#line 10008 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1538:

/* Line 1464 of yacc.c  */
#line 10009 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1539:

/* Line 1464 of yacc.c  */
#line 10010 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1540:

/* Line 1464 of yacc.c  */
#line 10017 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1541:

/* Line 1464 of yacc.c  */
#line 10018 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1542:

/* Line 1464 of yacc.c  */
#line 10022 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); ;}
    break;

  case 1543:

/* Line 1464 of yacc.c  */
#line 10024 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); ;}
    break;

  case 1544:

/* Line 1464 of yacc.c  */
#line 10029 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				;}
    break;

  case 1545:

/* Line 1464 of yacc.c  */
#line 10037 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); ;}
    break;

  case 1546:

/* Line 1464 of yacc.c  */
#line 10039 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				;}
    break;

  case 1547:

/* Line 1464 of yacc.c  */
#line 10052 "gram.y"
    { (yyval.windef) = NULL; ;}
    break;

  case 1548:

/* Line 1464 of yacc.c  */
#line 10057 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				;}
    break;

  case 1549:

/* Line 1464 of yacc.c  */
#line 10082 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1550:

/* Line 1464 of yacc.c  */
#line 10083 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1551:

/* Line 1464 of yacc.c  */
#line 10086 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1552:

/* Line 1464 of yacc.c  */
#line 10087 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1553:

/* Line 1464 of yacc.c  */
#line 10099 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				;}
    break;

  case 1554:

/* Line 1464 of yacc.c  */
#line 10117 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				;}
    break;

  case 1555:

/* Line 1464 of yacc.c  */
#line 10123 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1556:

/* Line 1464 of yacc.c  */
#line 10133 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				;}
    break;

  case 1557:

/* Line 1464 of yacc.c  */
#line 10150 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				;}
    break;

  case 1558:

/* Line 1464 of yacc.c  */
#line 10195 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1559:

/* Line 1464 of yacc.c  */
#line 10203 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1560:

/* Line 1464 of yacc.c  */
#line 10211 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1561:

/* Line 1464 of yacc.c  */
#line 10219 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1562:

/* Line 1464 of yacc.c  */
#line 10227 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1563:

/* Line 1464 of yacc.c  */
#line 10247 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1564:

/* Line 1464 of yacc.c  */
#line 10248 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1565:

/* Line 1464 of yacc.c  */
#line 10249 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); ;}
    break;

  case 1566:

/* Line 1464 of yacc.c  */
#line 10252 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1567:

/* Line 1464 of yacc.c  */
#line 10253 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1568:

/* Line 1464 of yacc.c  */
#line 10254 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; ;}
    break;

  case 1569:

/* Line 1464 of yacc.c  */
#line 10257 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1570:

/* Line 1464 of yacc.c  */
#line 10258 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1571:

/* Line 1464 of yacc.c  */
#line 10261 "gram.y"
    { (yyval.str) = "+"; ;}
    break;

  case 1572:

/* Line 1464 of yacc.c  */
#line 10262 "gram.y"
    { (yyval.str) = "-"; ;}
    break;

  case 1573:

/* Line 1464 of yacc.c  */
#line 10263 "gram.y"
    { (yyval.str) = "*"; ;}
    break;

  case 1574:

/* Line 1464 of yacc.c  */
#line 10264 "gram.y"
    { (yyval.str) = "/"; ;}
    break;

  case 1575:

/* Line 1464 of yacc.c  */
#line 10265 "gram.y"
    { (yyval.str) = "%"; ;}
    break;

  case 1576:

/* Line 1464 of yacc.c  */
#line 10266 "gram.y"
    { (yyval.str) = "^"; ;}
    break;

  case 1577:

/* Line 1464 of yacc.c  */
#line 10267 "gram.y"
    { (yyval.str) = "<"; ;}
    break;

  case 1578:

/* Line 1464 of yacc.c  */
#line 10268 "gram.y"
    { (yyval.str) = ">"; ;}
    break;

  case 1579:

/* Line 1464 of yacc.c  */
#line 10269 "gram.y"
    { (yyval.str) = "="; ;}
    break;

  case 1580:

/* Line 1464 of yacc.c  */
#line 10273 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1581:

/* Line 1464 of yacc.c  */
#line 10275 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1582:

/* Line 1464 of yacc.c  */
#line 10280 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1583:

/* Line 1464 of yacc.c  */
#line 10282 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1584:

/* Line 1464 of yacc.c  */
#line 10287 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1585:

/* Line 1464 of yacc.c  */
#line 10289 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1586:

/* Line 1464 of yacc.c  */
#line 10291 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); ;}
    break;

  case 1587:

/* Line 1464 of yacc.c  */
#line 10293 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); ;}
    break;

  case 1588:

/* Line 1464 of yacc.c  */
#line 10295 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); ;}
    break;

  case 1589:

/* Line 1464 of yacc.c  */
#line 10297 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); ;}
    break;

  case 1590:

/* Line 1464 of yacc.c  */
#line 10309 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1591:

/* Line 1464 of yacc.c  */
#line 10313 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1592:

/* Line 1464 of yacc.c  */
#line 10320 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1593:

/* Line 1464 of yacc.c  */
#line 10324 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1594:

/* Line 1464 of yacc.c  */
#line 10330 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1595:

/* Line 1464 of yacc.c  */
#line 10334 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				;}
    break;

  case 1596:

/* Line 1464 of yacc.c  */
#line 10344 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 1597:

/* Line 1464 of yacc.c  */
#line 10345 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1598:

/* Line 1464 of yacc.c  */
#line 10349 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1599:

/* Line 1464 of yacc.c  */
#line 10353 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1600:

/* Line 1464 of yacc.c  */
#line 10357 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				;}
    break;

  case 1601:

/* Line 1464 of yacc.c  */
#line 10362 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1602:

/* Line 1464 of yacc.c  */
#line 10363 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1603:

/* Line 1464 of yacc.c  */
#line 10369 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1604:

/* Line 1464 of yacc.c  */
#line 10372 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1605:

/* Line 1464 of yacc.c  */
#line 10379 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1606:

/* Line 1464 of yacc.c  */
#line 10380 "gram.y"
    { (yyval.str) = "year"; ;}
    break;

  case 1607:

/* Line 1464 of yacc.c  */
#line 10381 "gram.y"
    { (yyval.str) = "month"; ;}
    break;

  case 1608:

/* Line 1464 of yacc.c  */
#line 10382 "gram.y"
    { (yyval.str) = "day"; ;}
    break;

  case 1609:

/* Line 1464 of yacc.c  */
#line 10383 "gram.y"
    { (yyval.str) = "hour"; ;}
    break;

  case 1610:

/* Line 1464 of yacc.c  */
#line 10384 "gram.y"
    { (yyval.str) = "minute"; ;}
    break;

  case 1611:

/* Line 1464 of yacc.c  */
#line 10385 "gram.y"
    { (yyval.str) = "second"; ;}
    break;

  case 1612:

/* Line 1464 of yacc.c  */
#line 10386 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1613:

/* Line 1464 of yacc.c  */
#line 10397 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1614:

/* Line 1464 of yacc.c  */
#line 10401 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1615:

/* Line 1464 of yacc.c  */
#line 10408 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1616:

/* Line 1464 of yacc.c  */
#line 10414 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1617:

/* Line 1464 of yacc.c  */
#line 10415 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1618:

/* Line 1464 of yacc.c  */
#line 10432 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1619:

/* Line 1464 of yacc.c  */
#line 10436 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				;}
    break;

  case 1620:

/* Line 1464 of yacc.c  */
#line 10441 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1621:

/* Line 1464 of yacc.c  */
#line 10445 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				;}
    break;

  case 1622:

/* Line 1464 of yacc.c  */
#line 10460 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				;}
    break;

  case 1623:

/* Line 1464 of yacc.c  */
#line 10464 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1624:

/* Line 1464 of yacc.c  */
#line 10468 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1625:

/* Line 1464 of yacc.c  */
#line 10471 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1626:

/* Line 1464 of yacc.c  */
#line 10474 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1627:

/* Line 1464 of yacc.c  */
#line 10475 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1628:

/* Line 1464 of yacc.c  */
#line 10476 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1629:

/* Line 1464 of yacc.c  */
#line 10480 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1630:

/* Line 1464 of yacc.c  */
#line 10486 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); ;}
    break;

  case 1631:

/* Line 1464 of yacc.c  */
#line 10497 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1632:

/* Line 1464 of yacc.c  */
#line 10510 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1633:

/* Line 1464 of yacc.c  */
#line 10511 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1634:

/* Line 1464 of yacc.c  */
#line 10516 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				;}
    break;

  case 1635:

/* Line 1464 of yacc.c  */
#line 10526 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1636:

/* Line 1464 of yacc.c  */
#line 10527 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1637:

/* Line 1464 of yacc.c  */
#line 10530 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1638:

/* Line 1464 of yacc.c  */
#line 10531 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1639:

/* Line 1464 of yacc.c  */
#line 10535 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				;}
    break;

  case 1640:

/* Line 1464 of yacc.c  */
#line 10539 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				;}
    break;

  case 1641:

/* Line 1464 of yacc.c  */
#line 10546 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				;}
    break;

  case 1642:

/* Line 1464 of yacc.c  */
#line 10550 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				;}
    break;

  case 1643:

/* Line 1464 of yacc.c  */
#line 10554 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1644:

/* Line 1464 of yacc.c  */
#line 10561 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1645:

/* Line 1464 of yacc.c  */
#line 10570 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1646:

/* Line 1464 of yacc.c  */
#line 10571 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1647:

/* Line 1464 of yacc.c  */
#line 10575 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1648:

/* Line 1464 of yacc.c  */
#line 10576 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1651:

/* Line 1464 of yacc.c  */
#line 10591 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 1652:

/* Line 1464 of yacc.c  */
#line 10593 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1653:

/* Line 1464 of yacc.c  */
#line 10601 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1654:

/* Line 1464 of yacc.c  */
#line 10602 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1655:

/* Line 1464 of yacc.c  */
#line 10610 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1656:

/* Line 1464 of yacc.c  */
#line 10621 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1657:

/* Line 1464 of yacc.c  */
#line 10622 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1658:

/* Line 1464 of yacc.c  */
#line 10626 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1659:

/* Line 1464 of yacc.c  */
#line 10642 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1660:

/* Line 1464 of yacc.c  */
#line 10650 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1661:

/* Line 1464 of yacc.c  */
#line 10658 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1662:

/* Line 1464 of yacc.c  */
#line 10679 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1663:

/* Line 1464 of yacc.c  */
#line 10680 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1664:

/* Line 1464 of yacc.c  */
#line 10692 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
					(yyval.range)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1665:

/* Line 1464 of yacc.c  */
#line 10700 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
					(yyval.range)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1666:

/* Line 1464 of yacc.c  */
#line 10728 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1667:

/* Line 1464 of yacc.c  */
#line 10730 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 1668:

/* Line 1464 of yacc.c  */
#line 10734 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1669:

/* Line 1464 of yacc.c  */
#line 10737 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1670:

/* Line 1464 of yacc.c  */
#line 10740 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1671:

/* Line 1464 of yacc.c  */
#line 10742 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1672:

/* Line 1464 of yacc.c  */
#line 10744 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1673:

/* Line 1464 of yacc.c  */
#line 10746 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1674:

/* Line 1464 of yacc.c  */
#line 10757 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1675:

/* Line 1464 of yacc.c  */
#line 10759 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					;}
    break;

  case 1676:

/* Line 1464 of yacc.c  */
#line 10770 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				;}
    break;

  case 1677:

/* Line 1464 of yacc.c  */
#line 10774 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1678:

/* Line 1464 of yacc.c  */
#line 10778 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1679:

/* Line 1464 of yacc.c  */
#line 10782 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1680:

/* Line 1464 of yacc.c  */
#line 10786 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1681:

/* Line 1464 of yacc.c  */
#line 10795 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				;}
    break;

  case 1682:

/* Line 1464 of yacc.c  */
#line 10802 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[(3) - (5)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
								    (errcode(ERRCODE_SYNTAX_ERROR),
								     errmsg("type modifier cannot have parameter name"),
								     parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				;}
    break;

  case 1683:

/* Line 1464 of yacc.c  */
#line 10827 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				;}
    break;

  case 1684:

/* Line 1464 of yacc.c  */
#line 10831 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 1685:

/* Line 1464 of yacc.c  */
#line 10837 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 1686:

/* Line 1464 of yacc.c  */
#line 10854 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1687:

/* Line 1464 of yacc.c  */
#line 10858 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1688:

/* Line 1464 of yacc.c  */
#line 10862 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1689:

/* Line 1464 of yacc.c  */
#line 10867 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1690:

/* Line 1464 of yacc.c  */
#line 10868 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1691:

/* Line 1464 of yacc.c  */
#line 10869 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1692:

/* Line 1464 of yacc.c  */
#line 10871 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1693:

/* Line 1464 of yacc.c  */
#line 10872 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1694:

/* Line 1464 of yacc.c  */
#line 10873 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1695:

/* Line 1464 of yacc.c  */
#line 10889 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1696:

/* Line 1464 of yacc.c  */
#line 10890 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1697:

/* Line 1464 of yacc.c  */
#line 10891 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1698:

/* Line 1464 of yacc.c  */
#line 10896 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1699:

/* Line 1464 of yacc.c  */
#line 10897 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1700:

/* Line 1464 of yacc.c  */
#line 10898 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1701:

/* Line 1464 of yacc.c  */
#line 10904 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1702:

/* Line 1464 of yacc.c  */
#line 10905 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1703:

/* Line 1464 of yacc.c  */
#line 10906 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1704:

/* Line 1464 of yacc.c  */
#line 10907 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1705:

/* Line 1464 of yacc.c  */
#line 10908 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;



/* Line 1464 of yacc.c  */
#line 33836 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (&yylloc, yyscanner, yymsg);
	  }
	else
	  {
	    yyerror (&yylloc, yyscanner, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc, yyscanner);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 11361 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location, core_yyscan_t yyscanner)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
				 parser_errposition(location)));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
				 parser_errposition(location)));
	n->args = list_concat(largs, rargs);
	n->agg_order = NIL;
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->func_variadic = FALSE;
	n->over = NULL;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->location = location;
	return (Node *) x;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"

